
module MenhirBasics = struct
  
  exception Error = Parsing.Parse_error
  
  let _eRR =
    fun _s ->
      raise Error
  
  type token = 
    | WSTRING_CONSTANT of (
# 262 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 15 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | WRITES
    | WITH
    | VOLATILE
    | VOID
    | VARIANT
    | VALID_READ
    | VALID_RANGE
    | VALID_INDEX
    | VALID_FUNCTION
    | VALID
    | UNSIGNED
    | UNION
    | UNALLOCATED
    | TYPEOF
    | TYPENAME of (
# 257 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 34 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | TYPE
    | TRUE
    | TILDE
    | TERMINATES
    | STRUCT
    | STRING_LITERAL of (
# 258 "src/kernel_internals/parsing/logic_parser.mly"
       (bool*string)
# 44 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | STRING_CONSTANT of (
# 261 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 49 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | STATIC
    | STARHAT
    | STAR
    | SLICE
    | SLASH
    | SIZEOF
    | SIGNED
    | SHORT
    | SEPARATED
    | SEMICOLON
    | RSQUAREPIPE
    | RSQUARE
    | RPAR
    | RETURNS
    | RESULT
    | REQUIRES
    | REGISTER
    | REAL
    | READS
    | RBRACE
    | QUESTION
    | PREDICATE
    | PRAGMA
    | PLUS
    | PIPE
    | PI
    | PERCENT
    | OR
    | OLD
    | OFFSET
    | OBJECT_POINTER
    | NULL
    | NOTHING
    | NOT
    | NE
    | MODULE
    | MODEL
    | MINUS
    | LTLT
    | LT
    | LSQUAREPIPE
    | LSQUARE
    | LPAR
    | LOOP
    | LONG
    | LOGIC
    | LET
    | LEMMA
    | LE
    | LBRACE
    | LAMBDA
    | LABEL
    | INVARIANT
    | INT_CONSTANT of (
# 259 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 107 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | INTER
    | INTEGER
    | INT
    | INITIALIZED
    | INDUCTIVE
    | INCLUDE
    | IN
    | IMPLIES
    | IMPACT
    | IFF
    | IF
    | IDENTIFIER of (
# 257 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 123 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | HATHAT
    | HAT
    | GTGT
    | GT
    | GLOBAL
    | GHOST
    | GE
    | FUNCTION
    | FROM
    | FRESH
    | FREES
    | FREEABLE
    | FORALL
    | FOR
    | FLOAT_CONSTANT of (
# 260 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 142 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | FLOAT
    | FALSE
    | EXT_LET
    | EXT_GLOBAL_BLOCK of (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 150 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | EXT_GLOBAL of (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 155 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | EXT_CONTRACT of (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 160 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | EXT_CODE_ANNOT of (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 165 "src/kernel_internals/parsing/logic_parser.ml"
  )
    | EXT_AT
    | EXITS
    | EXISTS
    | EQUAL
    | EQ
    | EOF
    | ENUM
    | ENSURES
    | EMPTY
    | ELSE
    | DYNAMIC
    | DOUBLE
    | DOTDOTDOT
    | DOTDOT
    | DOT
    | DOLLAR
    | DISJOINT
    | DECREASES
    | DANGLING
    | CONTRACT
    | CONTINUES
    | CONST
    | COMPLETE
    | COMMA
    | COLONCOLON
    | COLON2
    | COLON
    | CHECK_RETURNS
    | CHECK_REQUIRES
    | CHECK_LOOP
    | CHECK_LEMMA
    | CHECK_INVARIANT
    | CHECK_EXITS
    | CHECK_ENSURES
    | CHECK_CONTINUES
    | CHECK_BREAKS
    | CHECK
    | CHAR
    | CASE
    | BSUNION
    | BSTYPE
    | BSGHOST
    | BREAKS
    | BOOLEAN
    | BOOL
    | BLOCK_LENGTH
    | BIMPLIES
    | BIFF
    | BEHAVIORS
    | BEHAVIOR
    | BASE_ADDR
    | AXIOMATIC
    | AXIOM
    | AUTOMATIC
    | AT
    | ASSUMES
    | ASSIGNS
    | ASSERT
    | ARROW
    | AND
    | AMP
    | ALLOCATION
    | ALLOCATES
    | ALLOCABLE
    | ADMIT_RETURNS
    | ADMIT_REQUIRES
    | ADMIT_LOOP
    | ADMIT_LEMMA
    | ADMIT_INVARIANT
    | ADMIT_EXITS
    | ADMIT_ENSURES
    | ADMIT_CONTINUES
    | ADMIT_BREAKS
    | ADMIT
  
end

include MenhirBasics

# 27 "src/kernel_internals/parsing/logic_parser.mly"
  

  open Cil_types
  open Logic_ptree
  open Logic_utils

  let loc (start_pos, end_pos) =
    Cil_datatype.Location.of_lexing_loc
      (start_pos, end_pos)

  let pos pos =
    Cil_datatype.Position.of_lexing_pos pos

  let loc_info lexpr_loc x = { lexpr_node = x; lexpr_loc }
  let loc_start x = fst x.lexpr_loc
  let loc_end x = snd x.lexpr_loc

  let info start_end x = loc_info (loc start_end) x

  (* Normalize p1 && (p2 && p3) into (p1 && p2) && p3 *)
  let rec pland p1 p2 =
    match p2.lexpr_node with
      | PLand (p3,p4) ->
        let loc = (loc_start p1, loc_end p3) in
        PLand(loc_info loc (pland p1 p3),p4)
      | _ -> PLand(p1,p2)

  let rec plor p1 p2 =
    match p2.lexpr_node with
      | PLor(p3,p4) ->
        let loc = (loc_start p1, loc_end p3) in
        PLor(loc_info loc (plor p1 p3),p4)
      | _ -> PLor(p1,p2)

  let clause_order start_end name1 name2 =
    raise
      (Not_well_formed
         (loc start_end,
          "wrong order of clause in contract: "
          ^ name1 ^ " after " ^ name2 ^ "."))

  let missing start_end token next_token =
    raise
      (Not_well_formed
         (loc start_end,
          Format.asprintf "expecting '%s' before %s" token next_token))

  type sense_of_relation = Unknown | Disequal | Less | Greater

  let check_empty (loc,msg) l =
    match l with
        [] -> ()
      | _ -> raise (Not_well_formed (loc,msg))

  let relation_sense rel sense =
    match rel, sense with
      | Eq, (Unknown|Greater|Less) -> sense, true
      | Neq, Unknown -> Disequal, false (* No chain of disequality for now*)
      | (Gt|Ge), (Unknown|Greater) -> Greater, true
      | (Lt|Le), (Unknown|Less) -> Less, true
      | _ -> sense, false

  let type_variables_stack = Stack.create ()

  let enter_type_variables_scope l =
    List.iter Logic_env.add_typename l;
    Stack.push l type_variables_stack

  let exit_type_variables_scope () =
    let l = Stack.pop type_variables_stack in
    List.iter Logic_env.remove_typename l

  let loc_decl start_end d = { decl_node = d; decl_loc = loc start_end }

  let loc_ext start_end d = { extended_node = d; extended_loc = loc start_end }

  let filter_from l = function
    | FromAny ->
      l, FromAny
    | From ds ->
      let f ds d = if List.exists (is_same_lexpr d) ds then ds else d :: ds in
      l, From(List.(rev (fold_left f [] ds)))

  let concat_froms cura newa =
    let compare_pair (curb,_) (newb,_) = is_same_lexpr curb newb in
    (* NB: the following has an horrible complexity, but the order of
       clauses in the input is preserved. *)
    let concat_one acc (newloc, newf)  =
      let (newloc, newf) as p = filter_from newloc newf in
      try
        let (curloc,curf) = List.find (compare_pair p) acc
        in
        match (curf, newf) with
          | _,FromAny ->
            (* the new fundeps does not give more information than the one
               which is already present. Just ignore it.
             *)
           acc
          | FromAny, _ ->
              (* the new fundeps is strictly more precise than the old one.
                 We replace the old dependency by the new one, but keep
                 the location at its old place in the list. This ensures
                 that we get the exact same clause if we try to
                 link the original contract with its pretty-printed version. *)
              Extlib.replace compare_pair p acc
          | From curl, From newl ->
            let incl l lin =
              List.(for_all (fun e -> exists (is_same_lexpr e) lin) l)
            in
            let drop d k =
              Kernel.warning ~current:false ~wkey:Kernel.wkey_multi_from
                "Drop '%a' \\from at %a for more precise one at %a"
                Logic_print.print_lexpr curloc
                Cil_datatype.Location.pretty d.lexpr_loc
                Cil_datatype.Location.pretty k.lexpr_loc
            in
            if incl curl newl then begin
              if not (incl newl curl) then drop newloc curloc;
              acc
            end
            else if incl newl curl then begin
              drop curloc newloc;
              Extlib.replace compare_pair p acc
            end
            else acc @ [p]
      with Not_found -> acc @ [p]
    in List.fold_left concat_one cura newa

  let concat_allocation fa1 fa2 =
    match fa1,fa2 with
      | FreeAllocAny,_ -> fa2
      | _,FreeAllocAny -> fa1
      | FreeAlloc(f1,a1),FreeAlloc(f2,a2) -> FreeAlloc(f2@f1,a2@a1)

  (* a1 represents the assigns _after_ the current clause a2. *)
  let concat_assigns start_pos a1 a2 =
    match a1,a2 with
        WritesAny,a -> Writes (concat_froms [] a)
      | Writes [], [] -> a1
      | Writes [], _  | Writes _, [] ->
        raise (
          Not_well_formed (loc start_pos,"Mixing \\nothing and a real location"))
      | Writes a1, a2 -> Writes (concat_froms (concat_froms [] a2) a1)

  let concat_loop_assigns_allocation start_pos annots bhvs2 a2 fa2=
    (* NB: this is supposed to merge assigns related to named behaviors, in
       case of annotation like
       for a,b: assigns x,y;
       for b,c: assigns z,t;
       DO NOT CALL this function for loop assigns not attached to specific
       behaviors.
     *)
    assert (bhvs2 <> []);
    if fa2 == FreeAllocAny && a2 == WritesAny
    then annots
    else
    let split l1 l2 =
      let treat_one (only1,both,only2) x =
        if List.mem x l1 then
          (List.filter (fun y -> x <> y) only1,x::both,only2)
        else (only1,both,x::only2)
      in List.fold_left treat_one (l1,[],[]) l2
    in
    let treat_one ca (bhvs2,acc) =
      match ca,a2,fa2 with
          (AAssigns(bhvs1,a1)),(Writes a2),_ ->
            let (only1,both,only2) = split bhvs1 bhvs2 in
            (match both with
              | [] -> bhvs2, ca::acc
              | _ ->
                let common_annot = AAssigns(both,concat_assigns start_pos a1 a2) in
                let annots =
                  match only1 with
                    | [] -> common_annot :: acc
                    | _ -> AAssigns(only1,a1) :: common_annot :: acc
                in only2,annots)
        | (AAllocation(bhvs1,fa1)),_,(FreeAlloc _) ->
           let (only1,both,only2) = split bhvs1 bhvs2 in
            (match both with
              | [] -> bhvs2, ca::acc
              | _ ->
                let common_annot =
                  AAllocation(both,concat_allocation fa1 fa2)
                in
                let annots =
                  match only1 with
                    | [] -> common_annot :: acc
                    | _ -> AAllocation(only1,fa1) :: common_annot :: acc
                in only2,annots)
         | _,_,_ -> bhvs2,ca::acc
    in
    let (bhvs2, annots) = List.fold_right treat_one annots (bhvs2,[]) in
    match bhvs2 with
      | [] -> annots (* Already considered all cases. *)
      | _ ->
	  let annots = if a2 <> WritesAny
	    then AAssigns (bhvs2,a2) :: annots
            else annots
	  in
	  if fa2 <> FreeAllocAny
	    then AAllocation (bhvs2,fa2) :: annots
            else annots

  let obsolete name ~source ~now =
    Kernel.warning ~source
      "parsing obsolete ACSL construct '%s'. '%s' should be used instead."
      name now

  let escape =
    let regex1 = Str.regexp "\\(\\(\\\\\\\\\\)*[^\\]\\)\\(['\"]\\)" in
    let regex2 = Str.regexp "\\(\\\\\\\\\\)*\\\\$" in
    fun str ->
      let str = Str.global_replace regex1 "\\1\\\\3" str in
      Str.global_replace regex2 "\\1\\\\" str

  let cv_const = Attr ("const", [])
  let cv_volatile = Attr ("volatile", [])
  let cv_ghost = Attr("ghost", [])

  let toplevel_pred tp_kind tp_statement = { tp_kind; tp_statement }

# 468 "src/kernel_internals/parsing/logic_parser.ml"

type ('s, 'r) _menhir_state = 
  | MenhirState0000 : ('s, _menhir_box_annot) _menhir_state
    (** State 0000.
        Stack shape : .
        Start symbol: annot. *)

  | MenhirState0002 : (('s, 'r) _menhir_cell1_VOLATILE, 'r) _menhir_state
    (** State 0002.
        Stack shape : VOLATILE.
        Start symbol: <undetermined>. *)

  | MenhirState0007 : (('s, 'r) _menhir_cell1_VALID_READ, 'r) _menhir_state
    (** State 0007.
        Stack shape : VALID_READ.
        Start symbol: <undetermined>. *)

  | MenhirState0008 : (('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_state
    (** State 0008.
        Stack shape : LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0102 : (('s, 'r) _menhir_cell1_label_name, 'r) _menhir_state
    (** State 0102.
        Stack shape : label_name.
        Start symbol: <undetermined>. *)

  | MenhirState0115 : ((('s, 'r) _menhir_cell1_VALID_READ, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0115.
        Stack shape : VALID_READ opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0116 : (('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_state
    (** State 0116.
        Stack shape : VALID_RANGE.
        Start symbol: <undetermined>. *)

  | MenhirState0118 : ((('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0118.
        Stack shape : VALID_RANGE opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0119 : (('s, 'r) _menhir_cell1_VALID_INDEX, 'r) _menhir_state
    (** State 0119.
        Stack shape : VALID_INDEX.
        Start symbol: <undetermined>. *)

  | MenhirState0121 : ((('s, 'r) _menhir_cell1_VALID_INDEX, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0121.
        Stack shape : VALID_INDEX opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0123 : (('s, 'r) _menhir_cell1_VALID_FUNCTION _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0123.
        Stack shape : VALID_FUNCTION LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0124 : (('s, 'r) _menhir_cell1_VALID, 'r) _menhir_state
    (** State 0124.
        Stack shape : VALID.
        Start symbol: <undetermined>. *)

  | MenhirState0126 : ((('s, 'r) _menhir_cell1_VALID, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0126.
        Stack shape : VALID opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0129 : (('s, 'r) _menhir_cell1_TYPEOF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0129.
        Stack shape : TYPEOF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0132 : (('s, 'r) _menhir_cell1_TILDE, 'r) _menhir_state
    (** State 0132.
        Stack shape : TILDE.
        Start symbol: <undetermined>. *)

  | MenhirState0139 : (('s, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 0139.
        Stack shape : STAR.
        Start symbol: <undetermined>. *)

  | MenhirState0142 : (('s, 'r) _menhir_cell1_SIZEOF _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0142.
        Stack shape : SIZEOF LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0154 : (('s, 'r) _menhir_cell1_UNION, 'r) _menhir_state
    (** State 0154.
        Stack shape : UNION.
        Start symbol: <undetermined>. *)

  | MenhirState0201 : (('s, 'r) _menhir_cell1_TYPENAME _menhir_cell0_LT, 'r) _menhir_state
    (** State 0201.
        Stack shape : TYPENAME LT.
        Start symbol: <undetermined>. *)

  | MenhirState0204 : (('s, 'r) _menhir_cell1_UNION, 'r) _menhir_state
    (** State 0204.
        Stack shape : UNION.
        Start symbol: <undetermined>. *)

  | MenhirState0206 : (('s, 'r) _menhir_cell1_STRUCT, 'r) _menhir_state
    (** State 0206.
        Stack shape : STRUCT.
        Start symbol: <undetermined>. *)

  | MenhirState0228 : (('s, 'r) _menhir_cell1_ENUM, 'r) _menhir_state
    (** State 0228.
        Stack shape : ENUM.
        Start symbol: <undetermined>. *)

  | MenhirState0234 : (('s, 'r) _menhir_cell1_type_spec_TYPENAME_, 'r) _menhir_state
    (** State 0234.
        Stack shape : type_spec(TYPENAME).
        Start symbol: <undetermined>. *)

  | MenhirState0236 : (('s, 'r) _menhir_cell1_LSQUARE, 'r) _menhir_state
    (** State 0236.
        Stack shape : LSQUARE.
        Start symbol: <undetermined>. *)

  | MenhirState0240 : ((('s, 'r) _menhir_cell1_LSQUARE, 'r) _menhir_cell1_array_size _menhir_cell0_RSQUARE, 'r) _menhir_state
    (** State 0240.
        Stack shape : LSQUARE array_size RSQUARE.
        Start symbol: <undetermined>. *)

  | MenhirState0242 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0242.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0244 : (('s, 'r) _menhir_cell1_stars, 'r) _menhir_state
    (** State 0244.
        Stack shape : stars.
        Start symbol: <undetermined>. *)

  | MenhirState0247 : ((('s, 'r) _menhir_cell1_stars, 'r) _menhir_cell1_abs_spec_bis, 'r) _menhir_state
    (** State 0247.
        Stack shape : stars abs_spec_bis.
        Start symbol: <undetermined>. *)

  | MenhirState0248 : ((('s, 'r) _menhir_cell1_abs_spec_bis, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0248.
        Stack shape : abs_spec_bis LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0259 : (('s, 'r) _menhir_cell1_UNION, 'r) _menhir_state
    (** State 0259.
        Stack shape : UNION.
        Start symbol: <undetermined>. *)

  | MenhirState0262 : (('s, 'r) _menhir_cell1_STRUCT, 'r) _menhir_state
    (** State 0262.
        Stack shape : STRUCT.
        Start symbol: <undetermined>. *)

  | MenhirState0284 : (('s, 'r) _menhir_cell1_ENUM, 'r) _menhir_state
    (** State 0284.
        Stack shape : ENUM.
        Start symbol: <undetermined>. *)

  | MenhirState0291 : (('s, 'r) _menhir_cell1_typename _menhir_cell0_LT, 'r) _menhir_state
    (** State 0291.
        Stack shape : typename LT.
        Start symbol: <undetermined>. *)

  | MenhirState0292 : (('s, 'r) _menhir_cell1_type_spec_typename_, 'r) _menhir_state
    (** State 0292.
        Stack shape : type_spec(typename).
        Start symbol: <undetermined>. *)

  | MenhirState0294 : (('s, 'r) _menhir_cell1_abs_spec_bis, 'r) _menhir_state
    (** State 0294.
        Stack shape : abs_spec_bis.
        Start symbol: <undetermined>. *)

  | MenhirState0301 : (('s, 'r) _menhir_cell1_logic_type_gen_typename_, 'r) _menhir_state
    (** State 0301.
        Stack shape : logic_type_gen(typename).
        Start symbol: <undetermined>. *)

  | MenhirState0308 : (('s, 'r) _menhir_cell1_abs_param_list, 'r) _menhir_state
    (** State 0308.
        Stack shape : abs_param_list.
        Start symbol: <undetermined>. *)

  | MenhirState0320 : (('s, 'r) _menhir_cell1_logic_type_gen_TYPENAME_, 'r) _menhir_state
    (** State 0320.
        Stack shape : logic_type_gen(TYPENAME).
        Start symbol: <undetermined>. *)

  | MenhirState0323 : (('s, 'r) _menhir_cell1_STRUCT, 'r) _menhir_state
    (** State 0323.
        Stack shape : STRUCT.
        Start symbol: <undetermined>. *)

  | MenhirState0330 : (('s, 'r) _menhir_cell1_SEPARATED _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0330.
        Stack shape : SEPARATED LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0337 : (('s, 'r) _menhir_cell1_PLUS, 'r) _menhir_state
    (** State 0337.
        Stack shape : PLUS.
        Start symbol: <undetermined>. *)

  | MenhirState0340 : (('s, 'r) _menhir_cell1_OLD _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0340.
        Stack shape : OLD LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0341 : (('s, 'r) _menhir_cell1_OFFSET, 'r) _menhir_state
    (** State 0341.
        Stack shape : OFFSET.
        Start symbol: <undetermined>. *)

  | MenhirState0343 : ((('s, 'r) _menhir_cell1_OFFSET, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0343.
        Stack shape : OFFSET opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0344 : (('s, 'r) _menhir_cell1_OBJECT_POINTER, 'r) _menhir_state
    (** State 0344.
        Stack shape : OBJECT_POINTER.
        Start symbol: <undetermined>. *)

  | MenhirState0346 : ((('s, 'r) _menhir_cell1_OBJECT_POINTER, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0346.
        Stack shape : OBJECT_POINTER opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0348 : (('s, 'r) _menhir_cell1_NOT, 'r) _menhir_state
    (** State 0348.
        Stack shape : NOT.
        Start symbol: <undetermined>. *)

  | MenhirState0349 : (('s, 'r) _menhir_cell1_NOT, 'r) _menhir_state
    (** State 0349.
        Stack shape : NOT.
        Start symbol: <undetermined>. *)

  | MenhirState0350 : (('s, 'r) _menhir_cell1_MINUS, 'r) _menhir_state
    (** State 0350.
        Stack shape : MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState0351 : (('s, 'r) _menhir_cell1_LSQUAREPIPE, 'r) _menhir_state
    (** State 0351.
        Stack shape : LSQUAREPIPE.
        Start symbol: <undetermined>. *)

  | MenhirState0354 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0354.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0359 : (('s, 'r) _menhir_cell1_LET, 'r) _menhir_state
    (** State 0359.
        Stack shape : LET.
        Start symbol: <undetermined>. *)

  | MenhirState0364 : ((('s, 'r) _menhir_cell1_LET, 'r) _menhir_cell1_bounded_var _menhir_cell0_EQUAL, 'r) _menhir_state
    (** State 0364.
        Stack shape : LET bounded_var EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0366 : (('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_state
    (** State 0366.
        Stack shape : LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0367 : (('s, 'r) _menhir_cell1_LSQUARE, 'r) _menhir_state
    (** State 0367.
        Stack shape : LSQUARE.
        Start symbol: <undetermined>. *)

  | MenhirState0368 : (('s, 'r) _menhir_cell1_LAMBDA, 'r) _menhir_state
    (** State 0368.
        Stack shape : LAMBDA.
        Start symbol: <undetermined>. *)

  | MenhirState0369 : (('s, 'r) _menhir_cell1_type_spec_typename_, 'r) _menhir_state
    (** State 0369.
        Stack shape : type_spec(typename).
        Start symbol: <undetermined>. *)

  | MenhirState0370 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0370.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0372 : (('s, 'r) _menhir_cell1_var_spec_bis, 'r) _menhir_state
    (** State 0372.
        Stack shape : var_spec_bis.
        Start symbol: <undetermined>. *)

  | MenhirState0375 : (('s, 'r) _menhir_cell1_var_spec_bis _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0375.
        Stack shape : var_spec_bis LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0380 : (('s, 'r) _menhir_cell1_stars, 'r) _menhir_state
    (** State 0380.
        Stack shape : stars.
        Start symbol: <undetermined>. *)

  | MenhirState0386 : (('s, 'r) _menhir_cell1_binders_reentrance, 'r) _menhir_state
    (** State 0386.
        Stack shape : binders_reentrance.
        Start symbol: <undetermined>. *)

  | MenhirState0390 : ((('s, 'r) _menhir_cell1_LAMBDA, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 0390.
        Stack shape : LAMBDA binders SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0394 : (('s, 'r) _menhir_cell1_INTER _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0394.
        Stack shape : INTER LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0395 : (('s, 'r) _menhir_cell1_INITIALIZED, 'r) _menhir_state
    (** State 0395.
        Stack shape : INITIALIZED.
        Start symbol: <undetermined>. *)

  | MenhirState0397 : ((('s, 'r) _menhir_cell1_INITIALIZED, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0397.
        Stack shape : INITIALIZED opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0403 : (('s, 'r) _menhir_cell1_FRESH, 'r) _menhir_state
    (** State 0403.
        Stack shape : FRESH.
        Start symbol: <undetermined>. *)

  | MenhirState0406 : ((('s, 'r) _menhir_cell1_FRESH, 'r) _menhir_cell1_opt_label_2 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0406.
        Stack shape : FRESH opt_label_2 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0408 : (('s, 'r) _menhir_cell1_FREEABLE, 'r) _menhir_state
    (** State 0408.
        Stack shape : FREEABLE.
        Start symbol: <undetermined>. *)

  | MenhirState0410 : ((('s, 'r) _menhir_cell1_FREEABLE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0410.
        Stack shape : FREEABLE opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0411 : (('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_state
    (** State 0411.
        Stack shape : FORALL.
        Start symbol: <undetermined>. *)

  | MenhirState0413 : ((('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 0413.
        Stack shape : FORALL binders SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0423 : (('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_state
    (** State 0423.
        Stack shape : EXISTS.
        Start symbol: <undetermined>. *)

  | MenhirState0425 : ((('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 0425.
        Stack shape : EXISTS binders SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0431 : (('s, 'r) _menhir_cell1_DANGLING, 'r) _menhir_state
    (** State 0431.
        Stack shape : DANGLING.
        Start symbol: <undetermined>. *)

  | MenhirState0433 : ((('s, 'r) _menhir_cell1_DANGLING, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0433.
        Stack shape : DANGLING opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0439 : (('s, 'r) _menhir_cell1_BSUNION _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0439.
        Stack shape : BSUNION LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0441 : (('s, 'r) _menhir_cell1_BSTYPE _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0441.
        Stack shape : BSTYPE LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0442 : ((('s, 'r) _menhir_cell1_BSTYPE _menhir_cell0_LPAR, 'r) _menhir_cell1_type_spec_typename_, 'r) _menhir_state
    (** State 0442.
        Stack shape : BSTYPE LPAR type_spec(typename).
        Start symbol: <undetermined>. *)

  | MenhirState0444 : (((('s, 'r) _menhir_cell1_BSTYPE _menhir_cell0_LPAR, 'r) _menhir_cell1_type_spec_typename_, 'r) _menhir_cell1_stars, 'r) _menhir_state
    (** State 0444.
        Stack shape : BSTYPE LPAR type_spec(typename) stars.
        Start symbol: <undetermined>. *)

  | MenhirState0447 : (('s, 'r) _menhir_cell1_BLOCK_LENGTH, 'r) _menhir_state
    (** State 0447.
        Stack shape : BLOCK_LENGTH.
        Start symbol: <undetermined>. *)

  | MenhirState0449 : ((('s, 'r) _menhir_cell1_BLOCK_LENGTH, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0449.
        Stack shape : BLOCK_LENGTH opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0451 : (('s, 'r) _menhir_cell1_BASE_ADDR, 'r) _menhir_state
    (** State 0451.
        Stack shape : BASE_ADDR.
        Start symbol: <undetermined>. *)

  | MenhirState0453 : ((('s, 'r) _menhir_cell1_BASE_ADDR, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0453.
        Stack shape : BASE_ADDR opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0458 : (('s, 'r) _menhir_cell1_AT _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0458.
        Stack shape : AT LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0462 : (('s, 'r) _menhir_cell1_AMP, 'r) _menhir_state
    (** State 0462.
        Stack shape : AMP.
        Start symbol: <undetermined>. *)

  | MenhirState0463 : (('s, 'r) _menhir_cell1_ALLOCATION, 'r) _menhir_state
    (** State 0463.
        Stack shape : ALLOCATION.
        Start symbol: <undetermined>. *)

  | MenhirState0465 : ((('s, 'r) _menhir_cell1_ALLOCATION, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0465.
        Stack shape : ALLOCATION opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0467 : (('s, 'r) _menhir_cell1_ALLOCABLE, 'r) _menhir_state
    (** State 0467.
        Stack shape : ALLOCABLE.
        Start symbol: <undetermined>. *)

  | MenhirState0469 : ((('s, 'r) _menhir_cell1_ALLOCABLE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0469.
        Stack shape : ALLOCABLE opt_label_1 LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0473 : (('s, 'r) _menhir_cell1_string _menhir_cell0_COLON, 'r) _menhir_state
    (** State 0473.
        Stack shape : string COLON.
        Start symbol: <undetermined>. *)

  | MenhirState0475 : (('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0475.
        Stack shape : lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0476 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_STARHAT, 'r) _menhir_state
    (** State 0476.
        Stack shape : lexpr_inner STARHAT.
        Start symbol: <undetermined>. *)

  | MenhirState0478 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_STARHAT, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0478.
        Stack shape : lexpr_inner STARHAT lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0479 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 0479.
        Stack shape : lexpr_inner STAR.
        Start symbol: <undetermined>. *)

  | MenhirState0480 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0480.
        Stack shape : lexpr_inner STAR lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0481 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_LSQUARE, 'r) _menhir_state
    (** State 0481.
        Stack shape : lexpr_inner LSQUARE.
        Start symbol: <undetermined>. *)

  | MenhirState0485 : (('s, 'r) _menhir_cell1_lexpr_option _menhir_cell0_DOTDOT, 'r) _menhir_state
    (** State 0485.
        Stack shape : lexpr_option DOTDOT.
        Start symbol: <undetermined>. *)

  | MenhirState0489 : ((('s, 'r) _menhir_cell1_lexpr_option _menhir_cell0_DOTDOT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0489.
        Stack shape : lexpr_option DOTDOT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0490 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_state
    (** State 0490.
        Stack shape : lexpr QUESTION.
        Start symbol: <undetermined>. *)

  | MenhirState0491 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0491.
        Stack shape : lexpr QUESTION lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0492 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_state
    (** State 0492.
        Stack shape : lexpr PIPE.
        Start symbol: <undetermined>. *)

  | MenhirState0493 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0493.
        Stack shape : lexpr PIPE lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0494 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_IN, 'r) _menhir_state
    (** State 0494.
        Stack shape : lexpr IN.
        Start symbol: <undetermined>. *)

  | MenhirState0498 : (('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0498.
        Stack shape : full_identifier LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0501 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0501.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0502 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_OR, 'r) _menhir_state
    (** State 0502.
        Stack shape : lexpr OR.
        Start symbol: <undetermined>. *)

  | MenhirState0503 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_OR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0503.
        Stack shape : lexpr OR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0504 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_HATHAT, 'r) _menhir_state
    (** State 0504.
        Stack shape : lexpr HATHAT.
        Start symbol: <undetermined>. *)

  | MenhirState0505 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_HATHAT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0505.
        Stack shape : lexpr HATHAT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0506 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_HAT, 'r) _menhir_state
    (** State 0506.
        Stack shape : lexpr HAT.
        Start symbol: <undetermined>. *)

  | MenhirState0507 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_HAT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0507.
        Stack shape : lexpr HAT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0508 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_AMP, 'r) _menhir_state
    (** State 0508.
        Stack shape : lexpr AMP.
        Start symbol: <undetermined>. *)

  | MenhirState0509 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_AMP, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0509.
        Stack shape : lexpr AMP lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0512 : (('s, 'r) _menhir_cell1_any_identifier _menhir_cell0_COLON, 'r) _menhir_state
    (** State 0512.
        Stack shape : any_identifier COLON.
        Start symbol: <undetermined>. *)

  | MenhirState0513 : ((('s, 'r) _menhir_cell1_any_identifier _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0513.
        Stack shape : any_identifier COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0514 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_IMPLIES, 'r) _menhir_state
    (** State 0514.
        Stack shape : lexpr IMPLIES.
        Start symbol: <undetermined>. *)

  | MenhirState0515 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_IMPLIES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0515.
        Stack shape : lexpr IMPLIES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0516 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_BIMPLIES, 'r) _menhir_state
    (** State 0516.
        Stack shape : lexpr BIMPLIES.
        Start symbol: <undetermined>. *)

  | MenhirState0517 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_BIMPLIES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0517.
        Stack shape : lexpr BIMPLIES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0518 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_BIFF, 'r) _menhir_state
    (** State 0518.
        Stack shape : lexpr BIFF.
        Start symbol: <undetermined>. *)

  | MenhirState0519 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_BIFF, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0519.
        Stack shape : lexpr BIFF lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0520 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_AND, 'r) _menhir_state
    (** State 0520.
        Stack shape : lexpr AND.
        Start symbol: <undetermined>. *)

  | MenhirState0521 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_AND, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0521.
        Stack shape : lexpr AND lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0522 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_IFF, 'r) _menhir_state
    (** State 0522.
        Stack shape : lexpr IFF.
        Start symbol: <undetermined>. *)

  | MenhirState0523 : (((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_IFF, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0523.
        Stack shape : lexpr IFF lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0524 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 0524.
        Stack shape : lexpr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0526 : (('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LBRACE, 'r) _menhir_state
    (** State 0526.
        Stack shape : full_identifier LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0529 : ((('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LBRACE, 'r) _menhir_cell1_ne_label_args _menhir_cell0_RBRACE _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0529.
        Stack shape : full_identifier LBRACE ne_label_args RBRACE LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0533 : (('s, 'r) _menhir_cell1_identifier_or_typename_full, 'r) _menhir_state
    (** State 0533.
        Stack shape : identifier_or_typename_full.
        Start symbol: <undetermined>. *)

  | MenhirState0535 : ((((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COLON2, 'r) _menhir_state
    (** State 0535.
        Stack shape : lexpr QUESTION lexpr COLON2.
        Start symbol: <undetermined>. *)

  | MenhirState0536 : (((((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_QUESTION, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COLON2, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0536.
        Stack shape : lexpr QUESTION lexpr COLON2 lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0537 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_LSQUARE, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0537.
        Stack shape : lexpr_inner LSQUARE lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0539 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_DOT, 'r) _menhir_state
    (** State 0539.
        Stack shape : lexpr_inner DOT.
        Start symbol: <undetermined>. *)

  | MenhirState0541 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_ARROW, 'r) _menhir_state
    (** State 0541.
        Stack shape : lexpr_inner ARROW.
        Start symbol: <undetermined>. *)

  | MenhirState0543 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_SLASH, 'r) _menhir_state
    (** State 0543.
        Stack shape : lexpr_inner SLASH.
        Start symbol: <undetermined>. *)

  | MenhirState0544 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_SLASH, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0544.
        Stack shape : lexpr_inner SLASH lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0545 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_PLUS, 'r) _menhir_state
    (** State 0545.
        Stack shape : lexpr_inner PLUS.
        Start symbol: <undetermined>. *)

  | MenhirState0546 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_PLUS, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0546.
        Stack shape : lexpr_inner PLUS lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0547 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_PERCENT, 'r) _menhir_state
    (** State 0547.
        Stack shape : lexpr_inner PERCENT.
        Start symbol: <undetermined>. *)

  | MenhirState0548 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_PERCENT, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0548.
        Stack shape : lexpr_inner PERCENT lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0549 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_MINUS, 'r) _menhir_state
    (** State 0549.
        Stack shape : lexpr_inner MINUS.
        Start symbol: <undetermined>. *)

  | MenhirState0550 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_MINUS, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0550.
        Stack shape : lexpr_inner MINUS lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0551 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_LTLT, 'r) _menhir_state
    (** State 0551.
        Stack shape : lexpr_inner LTLT.
        Start symbol: <undetermined>. *)

  | MenhirState0552 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_LTLT, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0552.
        Stack shape : lexpr_inner LTLT lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0553 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_GTGT, 'r) _menhir_state
    (** State 0553.
        Stack shape : lexpr_inner GTGT.
        Start symbol: <undetermined>. *)

  | MenhirState0554 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_GTGT, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0554.
        Stack shape : lexpr_inner GTGT lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0562 : ((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_relation, 'r) _menhir_state
    (** State 0562.
        Stack shape : lexpr_inner relation.
        Start symbol: <undetermined>. *)

  | MenhirState0563 : (((('s, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_cell1_relation, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0563.
        Stack shape : lexpr_inner relation lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0567 : ((('s, 'r) _menhir_cell1_string _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0567.
        Stack shape : string COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0568 : (((('s, 'r) _menhir_cell1_ALLOCABLE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0568.
        Stack shape : ALLOCABLE opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0570 : (((('s, 'r) _menhir_cell1_ALLOCATION, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0570.
        Stack shape : ALLOCATION opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0572 : ((('s, 'r) _menhir_cell1_AMP, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0572.
        Stack shape : AMP lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0573 : ((('s, 'r) _menhir_cell1_AT _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0573.
        Stack shape : AT LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0574 : (((('s, 'r) _menhir_cell1_AT _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 0574.
        Stack shape : AT LPAR lexpr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0577 : (((('s, 'r) _menhir_cell1_BASE_ADDR, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0577.
        Stack shape : BASE_ADDR opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0579 : (((('s, 'r) _menhir_cell1_BLOCK_LENGTH, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0579.
        Stack shape : BLOCK_LENGTH opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0584 : (((('s, 'r) _menhir_cell1_DANGLING, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0584.
        Stack shape : DANGLING opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0586 : (((('s, 'r) _menhir_cell1_EXISTS, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0586.
        Stack shape : EXISTS binders SEMICOLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0587 : (((('s, 'r) _menhir_cell1_FORALL, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0587.
        Stack shape : FORALL binders SEMICOLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0588 : (((('s, 'r) _menhir_cell1_FREEABLE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0588.
        Stack shape : FREEABLE opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0590 : (((('s, 'r) _menhir_cell1_FRESH, 'r) _menhir_cell1_opt_label_2 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0590.
        Stack shape : FRESH opt_label_2 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0591 : ((((('s, 'r) _menhir_cell1_FRESH, 'r) _menhir_cell1_opt_label_2 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 0591.
        Stack shape : FRESH opt_label_2 LPAR lexpr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0592 : (((((('s, 'r) _menhir_cell1_FRESH, 'r) _menhir_cell1_opt_label_2 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0592.
        Stack shape : FRESH opt_label_2 LPAR lexpr COMMA lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0594 : (((('s, 'r) _menhir_cell1_INITIALIZED, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0594.
        Stack shape : INITIALIZED opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0598 : (((('s, 'r) _menhir_cell1_LAMBDA, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0598.
        Stack shape : LAMBDA binders SEMICOLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0601 : ((('s, 'r) _menhir_cell1_LSQUARE, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0601.
        Stack shape : LSQUARE lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0603 : (('s, 'r) _menhir_cell1_DOT, 'r) _menhir_state
    (** State 0603.
        Stack shape : DOT.
        Start symbol: <undetermined>. *)

  | MenhirState0607 : ((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0607.
        Stack shape : LBRACE lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0608 : (((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_WITH, 'r) _menhir_state
    (** State 0608.
        Stack shape : LBRACE lexpr WITH.
        Start symbol: <undetermined>. *)

  | MenhirState0610 : (('s, 'r) _menhir_cell1_update_elt, 'r) _menhir_state
    (** State 0610.
        Stack shape : update_elt.
        Start symbol: <undetermined>. *)

  | MenhirState0612 : (('s, 'r) _menhir_cell1_path_elt, 'r) _menhir_state
    (** State 0612.
        Stack shape : path_elt.
        Start symbol: <undetermined>. *)

  | MenhirState0617 : (('s, 'r) _menhir_cell1_path _menhir_cell0_EQUAL, 'r) _menhir_state
    (** State 0617.
        Stack shape : path EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0618 : ((('s, 'r) _menhir_cell1_path _menhir_cell0_EQUAL, 'r) _menhir_cell1_LBRACE, 'r) _menhir_state
    (** State 0618.
        Stack shape : path EQUAL LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0619 : (((('s, 'r) _menhir_cell1_path _menhir_cell0_EQUAL, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_WITH, 'r) _menhir_state
    (** State 0619.
        Stack shape : path EQUAL LBRACE WITH.
        Start symbol: <undetermined>. *)

  | MenhirState0623 : (('s, 'r) _menhir_cell1_field_path_elt _menhir_cell0_EQUAL, 'r) _menhir_state
    (** State 0623.
        Stack shape : field_path_elt EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0624 : ((('s, 'r) _menhir_cell1_field_path_elt _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0624.
        Stack shape : field_path_elt EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0626 : (('s, 'r) _menhir_cell1_field_init_elt, 'r) _menhir_state
    (** State 0626.
        Stack shape : field_init_elt.
        Start symbol: <undetermined>. *)

  | MenhirState0631 : (('s, 'r) _menhir_cell1_array_path_elt _menhir_cell0_EQUAL, 'r) _menhir_state
    (** State 0631.
        Stack shape : array_path_elt EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0632 : ((('s, 'r) _menhir_cell1_array_path_elt _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0632.
        Stack shape : array_path_elt EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0634 : (('s, 'r) _menhir_cell1_array_init_elt, 'r) _menhir_state
    (** State 0634.
        Stack shape : array_init_elt.
        Start symbol: <undetermined>. *)

  | MenhirState0638 : ((('s, 'r) _menhir_cell1_path _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0638.
        Stack shape : path EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0641 : (((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_state
    (** State 0641.
        Stack shape : LBRACE lexpr PIPE.
        Start symbol: <undetermined>. *)

  | MenhirState0644 : ((((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_UNION, 'r) _menhir_state
    (** State 0644.
        Stack shape : LBRACE lexpr PIPE UNION.
        Start symbol: <undetermined>. *)

  | MenhirState0646 : ((((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_STRUCT, 'r) _menhir_state
    (** State 0646.
        Stack shape : LBRACE lexpr PIPE STRUCT.
        Start symbol: <undetermined>. *)

  | MenhirState0654 : ((((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_ENUM, 'r) _menhir_state
    (** State 0654.
        Stack shape : LBRACE lexpr PIPE ENUM.
        Start symbol: <undetermined>. *)

  | MenhirState0660 : ((((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 0660.
        Stack shape : LBRACE lexpr PIPE binders SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0661 : (((((('s, 'r) _menhir_cell1_LBRACE, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_binders _menhir_cell0_SEMICOLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0661.
        Stack shape : LBRACE lexpr PIPE binders SEMICOLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0664 : (((('s, 'r) _menhir_cell1_LET, 'r) _menhir_cell1_bounded_var _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0664.
        Stack shape : LET bounded_var EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0665 : ((((('s, 'r) _menhir_cell1_LET, 'r) _menhir_cell1_bounded_var _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 0665.
        Stack shape : LET bounded_var EQUAL lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0666 : (((((('s, 'r) _menhir_cell1_LET, 'r) _menhir_cell1_bounded_var _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0666.
        Stack shape : LET bounded_var EQUAL lexpr SEMICOLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0670 : (('s, 'r) _menhir_cell1_ENUM, 'r) _menhir_state
    (** State 0670.
        Stack shape : ENUM.
        Start symbol: <undetermined>. *)

  | MenhirState0677 : (('s, 'r) _menhir_cell1_type_spec_cv_TYPENAME_, 'r) _menhir_state
    (** State 0677.
        Stack shape : type_spec_cv(TYPENAME).
        Start symbol: <undetermined>. *)

  | MenhirState0678 : (('s, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 0678.
        Stack shape : STAR.
        Start symbol: <undetermined>. *)

  | MenhirState0682 : (('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0682.
        Stack shape : LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0684 : (('s, 'r) _menhir_cell1_stars_cv, 'r) _menhir_state
    (** State 0684.
        Stack shape : stars_cv.
        Start symbol: <undetermined>. *)

  | MenhirState0685 : ((('s, 'r) _menhir_cell1_stars_cv, 'r) _menhir_cell1_STAR, 'r) _menhir_state
    (** State 0685.
        Stack shape : stars_cv STAR.
        Start symbol: <undetermined>. *)

  | MenhirState0688 : ((('s, 'r) _menhir_cell1_stars_cv, 'r) _menhir_cell1_abs_spec_bis_cv, 'r) _menhir_state
    (** State 0688.
        Stack shape : stars_cv abs_spec_bis_cv.
        Start symbol: <undetermined>. *)

  | MenhirState0689 : ((('s, 'r) _menhir_cell1_abs_spec_bis_cv, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0689.
        Stack shape : abs_spec_bis_cv LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0695 : (('s, 'r) _menhir_cell1_abs_spec_bis_cv, 'r) _menhir_state
    (** State 0695.
        Stack shape : abs_spec_bis_cv.
        Start symbol: <undetermined>. *)

  | MenhirState0699 : (('s, 'r) _menhir_cell1_type_spec_TYPENAME_, 'r) _menhir_state
    (** State 0699.
        Stack shape : type_spec(TYPENAME).
        Start symbol: <undetermined>. *)

  | MenhirState0701 : (('s, 'r) _menhir_cell1_cv, 'r) _menhir_state
    (** State 0701.
        Stack shape : cv.
        Start symbol: <undetermined>. *)

  | MenhirState0705 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0705.
        Stack shape : LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0707 : (('s, 'r) _menhir_cell1_cv, 'r) _menhir_state
    (** State 0707.
        Stack shape : cv.
        Start symbol: <undetermined>. *)

  | MenhirState0710 : ((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_cast_logic_type _menhir_cell0_RPAR, 'r) _menhir_state
    (** State 0710.
        Stack shape : LPAR cast_logic_type RPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0711 : (((('s, 'r) _menhir_cell1_LPAR, 'r) _menhir_cell1_cast_logic_type _menhir_cell0_RPAR, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0711.
        Stack shape : LPAR cast_logic_type RPAR lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0714 : ((('s, 'r) _menhir_cell1_MINUS, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0714.
        Stack shape : MINUS lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0715 : ((('s, 'r) _menhir_cell1_NOT, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0715.
        Stack shape : NOT lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0717 : (((('s, 'r) _menhir_cell1_OBJECT_POINTER, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0717.
        Stack shape : OBJECT_POINTER opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0719 : (((('s, 'r) _menhir_cell1_OFFSET, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0719.
        Stack shape : OFFSET opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0721 : ((('s, 'r) _menhir_cell1_OLD _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0721.
        Stack shape : OLD LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0723 : ((('s, 'r) _menhir_cell1_PLUS, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0723.
        Stack shape : PLUS lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0726 : ((('s, 'r) _menhir_cell1_SIZEOF _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0726.
        Stack shape : SIZEOF LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0730 : ((('s, 'r) _menhir_cell1_STAR, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0730.
        Stack shape : STAR lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0731 : ((('s, 'r) _menhir_cell1_TILDE, 'r) _menhir_cell1_lexpr_inner, 'r) _menhir_state
    (** State 0731.
        Stack shape : TILDE lexpr_inner.
        Start symbol: <undetermined>. *)

  | MenhirState0732 : ((('s, 'r) _menhir_cell1_TYPEOF _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0732.
        Stack shape : TYPEOF LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0734 : (((('s, 'r) _menhir_cell1_VALID, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0734.
        Stack shape : VALID opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0736 : ((('s, 'r) _menhir_cell1_VALID_FUNCTION _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0736.
        Stack shape : VALID_FUNCTION LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0738 : (((('s, 'r) _menhir_cell1_VALID_INDEX, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0738.
        Stack shape : VALID_INDEX opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0739 : ((((('s, 'r) _menhir_cell1_VALID_INDEX, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 0739.
        Stack shape : VALID_INDEX opt_label_1 LPAR lexpr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0740 : (((((('s, 'r) _menhir_cell1_VALID_INDEX, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0740.
        Stack shape : VALID_INDEX opt_label_1 LPAR lexpr COMMA lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0742 : (((('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0742.
        Stack shape : VALID_RANGE opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0743 : ((((('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 0743.
        Stack shape : VALID_RANGE opt_label_1 LPAR lexpr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0744 : (((((('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0744.
        Stack shape : VALID_RANGE opt_label_1 LPAR lexpr COMMA lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0745 : ((((((('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_state
    (** State 0745.
        Stack shape : VALID_RANGE opt_label_1 LPAR lexpr COMMA lexpr COMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0746 : (((((((('s, 'r) _menhir_cell1_VALID_RANGE, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_COMMA, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0746.
        Stack shape : VALID_RANGE opt_label_1 LPAR lexpr COMMA lexpr COMMA lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0748 : (((('s, 'r) _menhir_cell1_VALID_READ, 'r) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0748.
        Stack shape : VALID_READ opt_label_1 LPAR lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0750 : ((('s, 'r) _menhir_cell1_VOLATILE, 'r) _menhir_cell1_ne_zones, 'r) _menhir_state
    (** State 0750.
        Stack shape : VOLATILE ne_zones.
        Start symbol: <undetermined>. *)

  | MenhirState0751 : (('s, 'r) _menhir_cell1_WRITES, 'r) _menhir_state
    (** State 0751.
        Stack shape : WRITES.
        Start symbol: <undetermined>. *)

  | MenhirState0752 : ((('s, 'r) _menhir_cell1_WRITES, 'r) _menhir_cell1_any_identifier, 'r) _menhir_state
    (** State 0752.
        Stack shape : WRITES any_identifier.
        Start symbol: <undetermined>. *)

  | MenhirState0753 : (('s, 'r) _menhir_cell1_READS, 'r) _menhir_state
    (** State 0753.
        Stack shape : READS.
        Start symbol: <undetermined>. *)

  | MenhirState0754 : ((('s, 'r) _menhir_cell1_READS, 'r) _menhir_cell1_any_identifier, 'r) _menhir_state
    (** State 0754.
        Stack shape : READS any_identifier.
        Start symbol: <undetermined>. *)

  | MenhirState0760 : (('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_state
    (** State 0760.
        Stack shape : TYPE.
        Start symbol: <undetermined>. *)

  | MenhirState0761 : ((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_state
    (** State 0761.
        Stack shape : TYPE INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState0763 : (((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_cell1_any_identifier _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0763.
        Stack shape : TYPE INVARIANT any_identifier LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0774 : (('s, 'r) _menhir_cell1_UNION, 'r) _menhir_state
    (** State 0774.
        Stack shape : UNION.
        Start symbol: <undetermined>. *)

  | MenhirState0776 : (('s, 'r) _menhir_cell1_STRUCT, 'r) _menhir_state
    (** State 0776.
        Stack shape : STRUCT.
        Start symbol: <undetermined>. *)

  | MenhirState0798 : (('s, 'r) _menhir_cell1_ENUM, 'r) _menhir_state
    (** State 0798.
        Stack shape : ENUM.
        Start symbol: <undetermined>. *)

  | MenhirState0804 : (('s, 'r) _menhir_cell1_type_spec_identifier_or_typename_, 'r) _menhir_state
    (** State 0804.
        Stack shape : type_spec(identifier_or_typename).
        Start symbol: <undetermined>. *)

  | MenhirState0808 : ((((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_cell1_any_identifier _menhir_cell0_LPAR, 'r) _menhir_cell1_parameter _menhir_cell0_RPAR _menhir_cell0_EQUAL, 'r) _menhir_state
    (** State 0808.
        Stack shape : TYPE INVARIANT any_identifier LPAR parameter RPAR EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0809 : (((((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_cell1_any_identifier _menhir_cell0_LPAR, 'r) _menhir_cell1_parameter _menhir_cell0_RPAR _menhir_cell0_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0809.
        Stack shape : TYPE INVARIANT any_identifier LPAR parameter RPAR EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0812 : (('s, 'r) _menhir_cell1_identifier_or_typename _menhir_cell0_LT, 'r) _menhir_state
    (** State 0812.
        Stack shape : identifier_or_typename LT.
        Start symbol: <undetermined>. *)

  | MenhirState0813 : (('s, 'r) _menhir_cell1_type_spec_identifier_or_typename_, 'r) _menhir_state
    (** State 0813.
        Stack shape : type_spec(identifier_or_typename).
        Start symbol: <undetermined>. *)

  | MenhirState0819 : (('s, 'r) _menhir_cell1_logic_type_gen_identifier_or_typename_, 'r) _menhir_state
    (** State 0819.
        Stack shape : logic_type_gen(identifier_or_typename).
        Start symbol: <undetermined>. *)

  | MenhirState0822 : ((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, 'r) _menhir_state
    (** State 0822.
        Stack shape : TYPE poly_id_type_add_typename EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0823 : (((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, 'r) _menhir_cell1_PIPE, 'r) _menhir_state
    (** State 0823.
        Stack shape : TYPE poly_id_type_add_typename EQUAL PIPE.
        Start symbol: <undetermined>. *)

  | MenhirState0825 : (('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LPAR, 'r) _menhir_state
    (** State 0825.
        Stack shape : full_identifier LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0829 : (('s, 'r) _menhir_cell1_logic_type, 'r) _menhir_state
    (** State 0829.
        Stack shape : logic_type.
        Start symbol: <undetermined>. *)

  | MenhirState0831 : ((((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_datacons, 'r) _menhir_state
    (** State 0831.
        Stack shape : TYPE poly_id_type_add_typename EQUAL PIPE datacons.
        Start symbol: <undetermined>. *)

  | MenhirState0832 : ((('s, 'r) _menhir_cell1_datacons, 'r) _menhir_cell1_PIPE, 'r) _menhir_state
    (** State 0832.
        Stack shape : datacons PIPE.
        Start symbol: <undetermined>. *)

  | MenhirState0833 : (((('s, 'r) _menhir_cell1_datacons, 'r) _menhir_cell1_PIPE, 'r) _menhir_cell1_datacons, 'r) _menhir_state
    (** State 0833.
        Stack shape : datacons PIPE datacons.
        Start symbol: <undetermined>. *)

  | MenhirState0840 : (((('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, 'r) _menhir_cell1_datacons, 'r) _menhir_state
    (** State 0840.
        Stack shape : TYPE poly_id_type_add_typename EQUAL datacons.
        Start symbol: <undetermined>. *)

  | MenhirState0845 : (('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LT, 'r) _menhir_state
    (** State 0845.
        Stack shape : full_identifier LT.
        Start symbol: <undetermined>. *)

  | MenhirState0849 : (('s, 'r) _menhir_cell1_full_identifier, 'r) _menhir_state
    (** State 0849.
        Stack shape : full_identifier.
        Start symbol: <undetermined>. *)

  | MenhirState0852 : (('s, 'r) _menhir_cell1_SLICE _menhir_cell0_PRAGMA, 'r) _menhir_state
    (** State 0852.
        Stack shape : SLICE PRAGMA.
        Start symbol: <undetermined>. *)

  | MenhirState0853 : ((('s, 'r) _menhir_cell1_SLICE _menhir_cell0_PRAGMA, 'r) _menhir_cell1_any_identifier, 'r) _menhir_state
    (** State 0853.
        Stack shape : SLICE PRAGMA any_identifier.
        Start symbol: <undetermined>. *)

  | MenhirState0855 : (((('s, 'r) _menhir_cell1_SLICE _menhir_cell0_PRAGMA, 'r) _menhir_cell1_any_identifier, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0855.
        Stack shape : SLICE PRAGMA any_identifier lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0857 : (('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_state
    (** State 0857.
        Stack shape : PREDICATE.
        Start symbol: <undetermined>. *)

  | MenhirState0859 : ((('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_cell1_poly_id, 'r) _menhir_state
    (** State 0859.
        Stack shape : PREDICATE poly_id.
        Start symbol: <undetermined>. *)

  | MenhirState0860 : ((('s, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_LPAR, 'r) _menhir_state
    (** State 0860.
        Stack shape : poly_id LPAR.
        Start symbol: <undetermined>. *)

  | MenhirState0862 : (('s, 'r) _menhir_cell1_parameter, 'r) _menhir_state
    (** State 0862.
        Stack shape : parameter.
        Start symbol: <undetermined>. *)

  | MenhirState0867 : (((('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_state
    (** State 0867.
        Stack shape : PREDICATE poly_id opt_parameters.
        Start symbol: <undetermined>. *)

  | MenhirState0869 : ((((('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_cell1_EQUAL, 'r) _menhir_state
    (** State 0869.
        Stack shape : PREDICATE poly_id opt_parameters EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0870 : (((((('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_cell1_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0870.
        Stack shape : PREDICATE poly_id opt_parameters EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0873 : (('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LBRACE, 'r) _menhir_state
    (** State 0873.
        Stack shape : full_identifier LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0876 : ((('s, 'r) _menhir_cell1_full_identifier _menhir_cell0_LBRACE, 'r) _menhir_cell1_ne_label_list _menhir_cell0_RBRACE _menhir_cell0_LT, 'r) _menhir_state
    (** State 0876.
        Stack shape : full_identifier LBRACE ne_label_list RBRACE LT.
        Start symbol: <undetermined>. *)

  | MenhirState0879 : (('s, 'r) _menhir_cell1_MODEL, 'r) _menhir_state
    (** State 0879.
        Stack shape : MODEL.
        Start symbol: <undetermined>. *)

  | MenhirState0881 : ((('s, 'r) _menhir_cell1_MODEL, 'r) _menhir_cell1_type_spec_typename_ _menhir_cell0_LBRACE, 'r) _menhir_state
    (** State 0881.
        Stack shape : MODEL type_spec(typename) LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0887 : (('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_state
    (** State 0887.
        Stack shape : LOOP.
        Start symbol: <undetermined>. *)

  | MenhirState0888 : ((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_VARIANT, 'r) _menhir_state
    (** State 0888.
        Stack shape : LOOP VARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState0891 : (('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0891.
        Stack shape : lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0892 : ((('s, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_FOR, 'r) _menhir_state
    (** State 0892.
        Stack shape : lexpr FOR.
        Start symbol: <undetermined>. *)

  | MenhirState0894 : ((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_PRAGMA, 'r) _menhir_state
    (** State 0894.
        Stack shape : LOOP PRAGMA.
        Start symbol: <undetermined>. *)

  | MenhirState0895 : (((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_PRAGMA, 'r) _menhir_cell1_any_identifier, 'r) _menhir_state
    (** State 0895.
        Stack shape : LOOP PRAGMA any_identifier.
        Start symbol: <undetermined>. *)

  | MenhirState0898 : ((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_state
    (** State 0898.
        Stack shape : LOOP INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState0899 : (((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0899.
        Stack shape : LOOP INVARIANT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0901 : (('s, 'r) _menhir_cell1_FREES, 'r) _menhir_state
    (** State 0901.
        Stack shape : FREES.
        Start symbol: <undetermined>. *)

  | MenhirState0905 : ((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_EXT_CODE_ANNOT, 'r) _menhir_state
    (** State 0905.
        Stack shape : LOOP EXT_CODE_ANNOT.
        Start symbol: <undetermined>. *)

  | MenhirState0909 : ((('s, 'r) _menhir_cell1_LOOP, 'r) _menhir_cell1_ASSIGNS, 'r) _menhir_state
    (** State 0909.
        Stack shape : LOOP ASSIGNS.
        Start symbol: <undetermined>. *)

  | MenhirState0912 : ((('s, 'r) _menhir_cell1_ASSIGNS, 'r) _menhir_cell1_ne_zones, 'r) _menhir_state
    (** State 0912.
        Stack shape : ASSIGNS ne_zones.
        Start symbol: <undetermined>. *)

  | MenhirState0916 : (('s, 'r) _menhir_cell1_ALLOCATES, 'r) _menhir_state
    (** State 0916.
        Stack shape : ALLOCATES.
        Start symbol: <undetermined>. *)

  | MenhirState0920 : (('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_state
    (** State 0920.
        Stack shape : LOGIC.
        Start symbol: <undetermined>. *)

  | MenhirState0922 : ((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_state
    (** State 0922.
        Stack shape : LOGIC logic_rt_type.
        Start symbol: <undetermined>. *)

  | MenhirState0923 : (((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_cell1_poly_id, 'r) _menhir_state
    (** State 0923.
        Stack shape : LOGIC logic_rt_type poly_id.
        Start symbol: <undetermined>. *)

  | MenhirState0924 : ((((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_state
    (** State 0924.
        Stack shape : LOGIC logic_rt_type poly_id opt_parameters.
        Start symbol: <undetermined>. *)

  | MenhirState0926 : (((((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_cell1_EQUAL, 'r) _menhir_state
    (** State 0926.
        Stack shape : LOGIC logic_rt_type poly_id opt_parameters EQUAL.
        Start symbol: <undetermined>. *)

  | MenhirState0927 : ((((((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_cell1_EQUAL, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0927.
        Stack shape : LOGIC logic_rt_type poly_id opt_parameters EQUAL lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0929 : (('s, 'r) _menhir_cell1_LEMMA, 'r) _menhir_state
    (** State 0929.
        Stack shape : LEMMA.
        Start symbol: <undetermined>. *)

  | MenhirState0931 : ((('s, 'r) _menhir_cell1_LEMMA, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_state
    (** State 0931.
        Stack shape : LEMMA poly_id COLON.
        Start symbol: <undetermined>. *)

  | MenhirState0932 : (((('s, 'r) _menhir_cell1_LEMMA, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0932.
        Stack shape : LEMMA poly_id COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0934 : (('s, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_state
    (** State 0934.
        Stack shape : INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState0935 : ((('s, 'r) _menhir_cell1_INVARIANT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0935.
        Stack shape : INVARIANT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0937 : (('s, 'r) _menhir_cell1_INDUCTIVE, 'r) _menhir_state
    (** State 0937.
        Stack shape : INDUCTIVE.
        Start symbol: <undetermined>. *)

  | MenhirState0938 : ((('s, 'r) _menhir_cell1_INDUCTIVE, 'r) _menhir_cell1_poly_id, 'r) _menhir_state
    (** State 0938.
        Stack shape : INDUCTIVE poly_id.
        Start symbol: <undetermined>. *)

  | MenhirState0941 : (((('s, 'r) _menhir_cell1_INDUCTIVE, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_parameters _menhir_cell0_midrule___anonymous_0_ _menhir_cell0_LBRACE, 'r) _menhir_state
    (** State 0941.
        Stack shape : INDUCTIVE poly_id parameters midrule(__anonymous_0) LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState0942 : (('s, 'r) _menhir_cell1_CASE, 'r) _menhir_state
    (** State 0942.
        Stack shape : CASE.
        Start symbol: <undetermined>. *)

  | MenhirState0944 : ((('s, 'r) _menhir_cell1_CASE, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_state
    (** State 0944.
        Stack shape : CASE poly_id COLON.
        Start symbol: <undetermined>. *)

  | MenhirState0945 : (((('s, 'r) _menhir_cell1_CASE, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0945.
        Stack shape : CASE poly_id COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0946 : ((((('s, 'r) _menhir_cell1_CASE, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 0946.
        Stack shape : CASE poly_id COLON lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0951 : (('s, 'r) _menhir_cell1_IMPACT _menhir_cell0_PRAGMA, 'r) _menhir_state
    (** State 0951.
        Stack shape : IMPACT PRAGMA.
        Start symbol: <undetermined>. *)

  | MenhirState0952 : ((('s, 'r) _menhir_cell1_IMPACT _menhir_cell0_PRAGMA, 'r) _menhir_cell1_any_identifier, 'r) _menhir_state
    (** State 0952.
        Stack shape : IMPACT PRAGMA any_identifier.
        Start symbol: <undetermined>. *)

  | MenhirState0954 : (((('s, 'r) _menhir_cell1_IMPACT _menhir_cell0_PRAGMA, 'r) _menhir_cell1_any_identifier, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0954.
        Stack shape : IMPACT PRAGMA any_identifier lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0957 : (('s, 'r) _menhir_cell1_GLOBAL _menhir_cell0_INVARIANT, 'r) _menhir_state
    (** State 0957.
        Stack shape : GLOBAL INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState0959 : ((('s, 'r) _menhir_cell1_GLOBAL _menhir_cell0_INVARIANT, 'r) _menhir_cell1_any_identifier _menhir_cell0_COLON, 'r) _menhir_state
    (** State 0959.
        Stack shape : GLOBAL INVARIANT any_identifier COLON.
        Start symbol: <undetermined>. *)

  | MenhirState0960 : (((('s, 'r) _menhir_cell1_GLOBAL _menhir_cell0_INVARIANT, 'r) _menhir_cell1_any_identifier _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0960.
        Stack shape : GLOBAL INVARIANT any_identifier COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0962 : (('s, 'r) _menhir_cell1_FOR, 'r) _menhir_state
    (** State 0962.
        Stack shape : FOR.
        Start symbol: <undetermined>. *)

  | MenhirState0964 : ((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_ne_behavior_name_list _menhir_cell0_COLON, 'r) _menhir_state
    (** State 0964.
        Stack shape : FOR ne_behavior_name_list COLON.
        Start symbol: <undetermined>. *)

  | MenhirState0965 : (('s, 'r) _menhir_cell1_REQUIRES, 'r) _menhir_state
    (** State 0965.
        Stack shape : REQUIRES.
        Start symbol: <undetermined>. *)

  | MenhirState0966 : ((('s, 'r) _menhir_cell1_REQUIRES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0966.
        Stack shape : REQUIRES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0967 : (((('s, 'r) _menhir_cell1_REQUIRES, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 0967.
        Stack shape : REQUIRES lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0968 : (('s, 'r) _menhir_cell1_CHECK_REQUIRES, 'r) _menhir_state
    (** State 0968.
        Stack shape : CHECK_REQUIRES.
        Start symbol: <undetermined>. *)

  | MenhirState0969 : ((('s, 'r) _menhir_cell1_CHECK_REQUIRES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0969.
        Stack shape : CHECK_REQUIRES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0970 : (((('s, 'r) _menhir_cell1_CHECK_REQUIRES, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 0970.
        Stack shape : CHECK_REQUIRES lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState0971 : (('s, 'r) _menhir_cell1_ADMIT_REQUIRES, 'r) _menhir_state
    (** State 0971.
        Stack shape : ADMIT_REQUIRES.
        Start symbol: <undetermined>. *)

  | MenhirState0972 : ((('s, 'r) _menhir_cell1_ADMIT_REQUIRES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 0972.
        Stack shape : ADMIT_REQUIRES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState0973 : (((('s, 'r) _menhir_cell1_ADMIT_REQUIRES, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 0973.
        Stack shape : ADMIT_REQUIRES lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1001 : (('s, 'r) _menhir_cell1_FOR, 'r) _menhir_state
    (** State 1001.
        Stack shape : FOR.
        Start symbol: <undetermined>. *)

  | MenhirState1003 : ((('s, 'r) _menhir_cell1_FOR, 'r) _menhir_cell1_ne_behavior_name_list _menhir_cell0_COLON, 'r) _menhir_state
    (** State 1003.
        Stack shape : FOR ne_behavior_name_list COLON.
        Start symbol: <undetermined>. *)

  | MenhirState1005 : (('s, 'r) _menhir_cell1_CHECK_LOOP _menhir_cell0_INVARIANT, 'r) _menhir_state
    (** State 1005.
        Stack shape : CHECK_LOOP INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState1006 : ((('s, 'r) _menhir_cell1_CHECK_LOOP _menhir_cell0_INVARIANT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1006.
        Stack shape : CHECK_LOOP INVARIANT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1009 : (('s, 'r) _menhir_cell1_ADMIT_LOOP _menhir_cell0_INVARIANT, 'r) _menhir_state
    (** State 1009.
        Stack shape : ADMIT_LOOP INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState1010 : ((('s, 'r) _menhir_cell1_ADMIT_LOOP _menhir_cell0_INVARIANT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1010.
        Stack shape : ADMIT_LOOP INVARIANT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1012 : (('s, 'r) _menhir_cell1_loop_variant, 'r) _menhir_state
    (** State 1012.
        Stack shape : loop_variant.
        Start symbol: <undetermined>. *)

  | MenhirState1013 : (('s, 'r) _menhir_cell1_loop_pragma, 'r) _menhir_state
    (** State 1013.
        Stack shape : loop_pragma.
        Start symbol: <undetermined>. *)

  | MenhirState1014 : (('s, 'r) _menhir_cell1_loop_invariant, 'r) _menhir_state
    (** State 1014.
        Stack shape : loop_invariant.
        Start symbol: <undetermined>. *)

  | MenhirState1015 : (('s, 'r) _menhir_cell1_loop_grammar_extension, 'r) _menhir_state
    (** State 1015.
        Stack shape : loop_grammar_extension.
        Start symbol: <undetermined>. *)

  | MenhirState1016 : (('s, 'r) _menhir_cell1_loop_effects, 'r) _menhir_state
    (** State 1016.
        Stack shape : loop_effects.
        Start symbol: <undetermined>. *)

  | MenhirState1019 : (('s, 'r) _menhir_cell1_loop_allocation, 'r) _menhir_state
    (** State 1019.
        Stack shape : loop_allocation.
        Start symbol: <undetermined>. *)

  | MenhirState1027 : (('s, 'r) _menhir_cell1_behavior_name, 'r) _menhir_state
    (** State 1027.
        Stack shape : behavior_name.
        Start symbol: <undetermined>. *)

  | MenhirState1030 : (('s, 'r) _menhir_cell1_EXT_CODE_ANNOT, 'r) _menhir_state
    (** State 1030.
        Stack shape : EXT_CODE_ANNOT.
        Start symbol: <undetermined>. *)

  | MenhirState1033 : (('s, 'r) _menhir_cell1_CHECK_INVARIANT, 'r) _menhir_state
    (** State 1033.
        Stack shape : CHECK_INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState1034 : ((('s, 'r) _menhir_cell1_CHECK_INVARIANT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1034.
        Stack shape : CHECK_INVARIANT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1036 : (('s, 'r) _menhir_cell1_CHECK, 'r) _menhir_state
    (** State 1036.
        Stack shape : CHECK.
        Start symbol: <undetermined>. *)

  | MenhirState1037 : ((('s, 'r) _menhir_cell1_CHECK, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1037.
        Stack shape : CHECK lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1039 : (('s, 'r) _menhir_cell1_ASSERT, 'r) _menhir_state
    (** State 1039.
        Stack shape : ASSERT.
        Start symbol: <undetermined>. *)

  | MenhirState1040 : ((('s, 'r) _menhir_cell1_ASSERT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1040.
        Stack shape : ASSERT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1042 : (('s, 'r) _menhir_cell1_ADMIT_INVARIANT, 'r) _menhir_state
    (** State 1042.
        Stack shape : ADMIT_INVARIANT.
        Start symbol: <undetermined>. *)

  | MenhirState1043 : ((('s, 'r) _menhir_cell1_ADMIT_INVARIANT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1043.
        Stack shape : ADMIT_INVARIANT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1045 : (('s, 'r) _menhir_cell1_ADMIT, 'r) _menhir_state
    (** State 1045.
        Stack shape : ADMIT.
        Start symbol: <undetermined>. *)

  | MenhirState1046 : ((('s, 'r) _menhir_cell1_ADMIT, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1046.
        Stack shape : ADMIT lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1049 : (('s, 'r) _menhir_cell1_requires _menhir_cell0_TERMINATES, 'r) _menhir_state
    (** State 1049.
        Stack shape : requires TERMINATES.
        Start symbol: <undetermined>. *)

  | MenhirState1050 : ((('s, 'r) _menhir_cell1_requires _menhir_cell0_TERMINATES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1050.
        Stack shape : requires TERMINATES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1054 : (('s, 'r) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_DECREASES, 'r) _menhir_state
    (** State 1054.
        Stack shape : requires terminates DECREASES.
        Start symbol: <undetermined>. *)

  | MenhirState1055 : ((('s, 'r) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_DECREASES, 'r) _menhir_cell1_variant, 'r) _menhir_state
    (** State 1055.
        Stack shape : requires terminates DECREASES variant.
        Start symbol: <undetermined>. *)

  | MenhirState1061 : (('s, 'r) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, 'r) _menhir_state
    (** State 1061.
        Stack shape : requires terminates decreases.
        Start symbol: <undetermined>. *)

  | MenhirState1062 : (('s, 'r) _menhir_cell1_EXT_CONTRACT, 'r) _menhir_state
    (** State 1062.
        Stack shape : EXT_CONTRACT.
        Start symbol: <undetermined>. *)

  | MenhirState1064 : ((('s, 'r) _menhir_cell1_EXT_CONTRACT, 'r) _menhir_cell1_ne_grammar_extension, 'r) _menhir_state
    (** State 1064.
        Stack shape : EXT_CONTRACT ne_grammar_extension.
        Start symbol: <undetermined>. *)

  | MenhirState1067 : ((('s, 'r) _menhir_cell1_EXT_CONTRACT, 'r) _menhir_cell1_extension_content _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 1067.
        Stack shape : EXT_CONTRACT extension_content SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1068 : (('s, 'r) _menhir_cell1_ASSIGNS, 'r) _menhir_state
    (** State 1068.
        Stack shape : ASSIGNS.
        Start symbol: <undetermined>. *)

  | MenhirState1069 : ((('s, 'r) _menhir_cell1_ASSIGNS, 'r) _menhir_cell1_assigns, 'r) _menhir_state
    (** State 1069.
        Stack shape : ASSIGNS assigns.
        Start symbol: <undetermined>. *)

  | MenhirState1070 : (((('s, 'r) _menhir_cell1_ASSIGNS, 'r) _menhir_cell1_assigns, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 1070.
        Stack shape : ASSIGNS assigns SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1072 : (('s, 'r) _menhir_cell1_post_cond_kind, 'r) _menhir_state
    (** State 1072.
        Stack shape : post_cond_kind.
        Start symbol: <undetermined>. *)

  | MenhirState1073 : ((('s, 'r) _menhir_cell1_post_cond_kind, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1073.
        Stack shape : post_cond_kind lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1074 : (((('s, 'r) _menhir_cell1_post_cond_kind, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 1074.
        Stack shape : post_cond_kind lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1078 : (('s, 'r) _menhir_cell1_allocation, 'r) _menhir_state
    (** State 1078.
        Stack shape : allocation.
        Start symbol: <undetermined>. *)

  | MenhirState1079 : ((('s, 'r) _menhir_cell1_allocation, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 1079.
        Stack shape : allocation SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1085 : ((('s, 'r) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, 'r) _menhir_cell1_simple_clauses, 'r) _menhir_state
    (** State 1085.
        Stack shape : requires terminates decreases simple_clauses.
        Start symbol: <undetermined>. *)

  | MenhirState1086 : (('s, 'r) _menhir_cell1_BEHAVIOR, 'r) _menhir_state
    (** State 1086.
        Stack shape : BEHAVIOR.
        Start symbol: <undetermined>. *)

  | MenhirState1088 : ((('s, 'r) _menhir_cell1_BEHAVIOR, 'r) _menhir_cell1_behavior_name _menhir_cell0_COLON, 'r) _menhir_state
    (** State 1088.
        Stack shape : BEHAVIOR behavior_name COLON.
        Start symbol: <undetermined>. *)

  | MenhirState1089 : (('s, 'r) _menhir_cell1_ASSUMES, 'r) _menhir_state
    (** State 1089.
        Stack shape : ASSUMES.
        Start symbol: <undetermined>. *)

  | MenhirState1090 : ((('s, 'r) _menhir_cell1_ASSUMES, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1090.
        Stack shape : ASSUMES lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1091 : (((('s, 'r) _menhir_cell1_ASSUMES, 'r) _menhir_cell1_lexpr, 'r) _menhir_cell1_SEMICOLON, 'r) _menhir_state
    (** State 1091.
        Stack shape : ASSUMES lexpr SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1094 : (((('s, 'r) _menhir_cell1_BEHAVIOR, 'r) _menhir_cell1_behavior_name _menhir_cell0_COLON, 'r) _menhir_cell1_behavior_body, 'r) _menhir_state
    (** State 1094.
        Stack shape : BEHAVIOR behavior_name COLON behavior_body.
        Start symbol: <undetermined>. *)

  | MenhirState1097 : (((('s, 'r) _menhir_cell1_BEHAVIOR, 'r) _menhir_cell1_behavior_name _menhir_cell0_COLON, 'r) _menhir_cell1_assumes, 'r) _menhir_state
    (** State 1097.
        Stack shape : BEHAVIOR behavior_name COLON assumes.
        Start symbol: <undetermined>. *)

  | MenhirState1098 : ((((('s, 'r) _menhir_cell1_BEHAVIOR, 'r) _menhir_cell1_behavior_name _menhir_cell0_COLON, 'r) _menhir_cell1_assumes, 'r) _menhir_cell1_requires, 'r) _menhir_state
    (** State 1098.
        Stack shape : BEHAVIOR behavior_name COLON assumes requires.
        Start symbol: <undetermined>. *)

  | MenhirState1108 : (((('s, 'r) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, 'r) _menhir_cell1_simple_clauses, 'r) _menhir_cell1_behaviors, 'r) _menhir_state
    (** State 1108.
        Stack shape : requires terminates decreases simple_clauses behaviors.
        Start symbol: <undetermined>. *)

  | MenhirState1110 : (('s, 'r) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS, 'r) _menhir_state
    (** State 1110.
        Stack shape : DISJOINT BEHAVIORS.
        Start symbol: <undetermined>. *)

  | MenhirState1111 : ((('s, 'r) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS, 'r) _menhir_cell1_ne_behavior_name_list, 'r) _menhir_state
    (** State 1111.
        Stack shape : DISJOINT BEHAVIORS ne_behavior_name_list.
        Start symbol: <undetermined>. *)

  | MenhirState1114 : ((('s, 'r) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS, 'r) _menhir_cell1_behavior_name_list _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 1114.
        Stack shape : DISJOINT BEHAVIORS behavior_name_list SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1116 : (('s, 'r) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS, 'r) _menhir_state
    (** State 1116.
        Stack shape : COMPLETE BEHAVIORS.
        Start symbol: <undetermined>. *)

  | MenhirState1117 : ((('s, 'r) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS, 'r) _menhir_cell1_ne_behavior_name_list, 'r) _menhir_state
    (** State 1117.
        Stack shape : COMPLETE BEHAVIORS ne_behavior_name_list.
        Start symbol: <undetermined>. *)

  | MenhirState1120 : ((('s, 'r) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS, 'r) _menhir_cell1_behavior_name_list _menhir_cell0_SEMICOLON, 'r) _menhir_state
    (** State 1120.
        Stack shape : COMPLETE BEHAVIORS behavior_name_list SEMICOLON.
        Start symbol: <undetermined>. *)

  | MenhirState1124 : ((((('s, 'r) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, 'r) _menhir_cell1_simple_clauses, 'r) _menhir_cell1_behaviors, 'r) _menhir_cell1_ne_complete_or_disjoint, 'r) _menhir_state
    (** State 1124.
        Stack shape : requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint.
        Start symbol: <undetermined>. *)

  | MenhirState1143 : (('s, 'r) _menhir_cell1_EXT_GLOBAL_BLOCK, 'r) _menhir_state
    (** State 1143.
        Stack shape : EXT_GLOBAL_BLOCK.
        Start symbol: <undetermined>. *)

  | MenhirState1145 : ((('s, 'r) _menhir_cell1_EXT_GLOBAL_BLOCK, 'r) _menhir_cell1_any_identifier _menhir_cell0_LBRACE, 'r) _menhir_state
    (** State 1145.
        Stack shape : EXT_GLOBAL_BLOCK any_identifier LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState1146 : (('s, 'r) _menhir_cell1_EXT_GLOBAL, 'r) _menhir_state
    (** State 1146.
        Stack shape : EXT_GLOBAL.
        Start symbol: <undetermined>. *)

  | MenhirState1151 : (('s, 'r) _menhir_cell1_ext_decl_loc, 'r) _menhir_state
    (** State 1151.
        Stack shape : ext_decl_loc.
        Start symbol: <undetermined>. *)

  | MenhirState1154 : (('s, 'r) _menhir_cell1_CHECK_LEMMA, 'r) _menhir_state
    (** State 1154.
        Stack shape : CHECK_LEMMA.
        Start symbol: <undetermined>. *)

  | MenhirState1156 : ((('s, 'r) _menhir_cell1_CHECK_LEMMA, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_state
    (** State 1156.
        Stack shape : CHECK_LEMMA poly_id COLON.
        Start symbol: <undetermined>. *)

  | MenhirState1157 : (((('s, 'r) _menhir_cell1_CHECK_LEMMA, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1157.
        Stack shape : CHECK_LEMMA poly_id COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1160 : (('s, 'r) _menhir_cell1_AXIOMATIC, 'r) _menhir_state
    (** State 1160.
        Stack shape : AXIOMATIC.
        Start symbol: <undetermined>. *)

  | MenhirState1162 : ((('s, 'r) _menhir_cell1_AXIOMATIC, 'r) _menhir_cell1_any_identifier _menhir_cell0_LBRACE, 'r) _menhir_state
    (** State 1162.
        Stack shape : AXIOMATIC any_identifier LBRACE.
        Start symbol: <undetermined>. *)

  | MenhirState1163 : (('s, 'r) _menhir_cell1_TYPE, 'r) _menhir_state
    (** State 1163.
        Stack shape : TYPE.
        Start symbol: <undetermined>. *)

  | MenhirState1166 : (('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_state
    (** State 1166.
        Stack shape : PREDICATE.
        Start symbol: <undetermined>. *)

  | MenhirState1167 : ((('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_cell1_poly_id, 'r) _menhir_state
    (** State 1167.
        Stack shape : PREDICATE poly_id.
        Start symbol: <undetermined>. *)

  | MenhirState1168 : (((('s, 'r) _menhir_cell1_PREDICATE, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_state
    (** State 1168.
        Stack shape : PREDICATE poly_id opt_parameters.
        Start symbol: <undetermined>. *)

  | MenhirState1169 : (((('s, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_cell1_READS, 'r) _menhir_state
    (** State 1169.
        Stack shape : poly_id opt_parameters READS.
        Start symbol: <undetermined>. *)

  | MenhirState1173 : (('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_state
    (** State 1173.
        Stack shape : LOGIC.
        Start symbol: <undetermined>. *)

  | MenhirState1174 : ((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_state
    (** State 1174.
        Stack shape : LOGIC logic_rt_type.
        Start symbol: <undetermined>. *)

  | MenhirState1175 : (((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_cell1_poly_id, 'r) _menhir_state
    (** State 1175.
        Stack shape : LOGIC logic_rt_type poly_id.
        Start symbol: <undetermined>. *)

  | MenhirState1176 : ((((('s, 'r) _menhir_cell1_LOGIC, 'r) _menhir_cell1_logic_rt_type, 'r) _menhir_cell1_poly_id, 'r) _menhir_cell1_opt_parameters, 'r) _menhir_state
    (** State 1176.
        Stack shape : LOGIC logic_rt_type poly_id opt_parameters.
        Start symbol: <undetermined>. *)

  | MenhirState1179 : (('s, 'r) _menhir_cell1_AXIOM, 'r) _menhir_state
    (** State 1179.
        Stack shape : AXIOM.
        Start symbol: <undetermined>. *)

  | MenhirState1181 : ((('s, 'r) _menhir_cell1_AXIOM, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_state
    (** State 1181.
        Stack shape : AXIOM poly_id COLON.
        Start symbol: <undetermined>. *)

  | MenhirState1182 : (((('s, 'r) _menhir_cell1_AXIOM, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1182.
        Stack shape : AXIOM poly_id COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1184 : (('s, 'r) _menhir_cell1_ADMIT_LEMMA, 'r) _menhir_state
    (** State 1184.
        Stack shape : ADMIT_LEMMA.
        Start symbol: <undetermined>. *)

  | MenhirState1186 : ((('s, 'r) _menhir_cell1_ADMIT_LEMMA, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_state
    (** State 1186.
        Stack shape : ADMIT_LEMMA poly_id COLON.
        Start symbol: <undetermined>. *)

  | MenhirState1187 : (((('s, 'r) _menhir_cell1_ADMIT_LEMMA, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1187.
        Stack shape : ADMIT_LEMMA poly_id COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1192 : (('s, 'r) _menhir_cell1_logic_decl_loc, 'r) _menhir_state
    (** State 1192.
        Stack shape : logic_decl_loc.
        Start symbol: <undetermined>. *)

  | MenhirState1195 : (('s, 'r) _menhir_cell1_AXIOM, 'r) _menhir_state
    (** State 1195.
        Stack shape : AXIOM.
        Start symbol: <undetermined>. *)

  | MenhirState1197 : ((('s, 'r) _menhir_cell1_AXIOM, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_state
    (** State 1197.
        Stack shape : AXIOM poly_id COLON.
        Start symbol: <undetermined>. *)

  | MenhirState1198 : (((('s, 'r) _menhir_cell1_AXIOM, 'r) _menhir_cell1_poly_id _menhir_cell0_COLON, 'r) _menhir_cell1_lexpr, 'r) _menhir_state
    (** State 1198.
        Stack shape : AXIOM poly_id COLON lexpr.
        Start symbol: <undetermined>. *)

  | MenhirState1220 : (('s, _menhir_box_annot) _menhir_cell1_is_acsl_spec, _menhir_box_annot) _menhir_state
    (** State 1220.
        Stack shape : is_acsl_spec.
        Start symbol: annot. *)

  | MenhirState1314 : (('s, _menhir_box_annot) _menhir_cell1_wildcard, _menhir_box_annot) _menhir_state
    (** State 1314.
        Stack shape : wildcard.
        Start symbol: annot. *)

  | MenhirState1326 : (('s, _menhir_box_annot) _menhir_cell1_decl, _menhir_box_annot) _menhir_state
    (** State 1326.
        Stack shape : decl.
        Start symbol: annot. *)

  | MenhirState1332 : ('s, _menhir_box_ext_spec) _menhir_state
    (** State 1332.
        Stack shape : .
        Start symbol: ext_spec. *)

  | MenhirState1333 : (('s, _menhir_box_ext_spec) _menhir_cell1_INCLUDE, _menhir_box_ext_spec) _menhir_state
    (** State 1333.
        Stack shape : INCLUDE.
        Start symbol: ext_spec. *)

  | MenhirState1337 : (('s, _menhir_box_ext_spec) _menhir_cell1_GLOBAL _menhir_cell0_EXT_LET, _menhir_box_ext_spec) _menhir_state
    (** State 1337.
        Stack shape : GLOBAL EXT_LET.
        Start symbol: ext_spec. *)

  | MenhirState1339 : ((('s, _menhir_box_ext_spec) _menhir_cell1_GLOBAL _menhir_cell0_EXT_LET, _menhir_box_ext_spec) _menhir_cell1_any_identifier _menhir_cell0_EQUAL, _menhir_box_ext_spec) _menhir_state
    (** State 1339.
        Stack shape : GLOBAL EXT_LET any_identifier EQUAL.
        Start symbol: ext_spec. *)

  | MenhirState1340 : (((('s, _menhir_box_ext_spec) _menhir_cell1_GLOBAL _menhir_cell0_EXT_LET, _menhir_box_ext_spec) _menhir_cell1_any_identifier _menhir_cell0_EQUAL, _menhir_box_ext_spec) _menhir_cell1_lexpr, _menhir_box_ext_spec) _menhir_state
    (** State 1340.
        Stack shape : GLOBAL EXT_LET any_identifier EQUAL lexpr.
        Start symbol: ext_spec. *)

  | MenhirState1342 : (('s, _menhir_box_ext_spec) _menhir_cell1_EXT_LET, _menhir_box_ext_spec) _menhir_state
    (** State 1342.
        Stack shape : EXT_LET.
        Start symbol: ext_spec. *)

  | MenhirState1344 : ((('s, _menhir_box_ext_spec) _menhir_cell1_EXT_LET, _menhir_box_ext_spec) _menhir_cell1_any_identifier _menhir_cell0_EQUAL, _menhir_box_ext_spec) _menhir_state
    (** State 1344.
        Stack shape : EXT_LET any_identifier EQUAL.
        Start symbol: ext_spec. *)

  | MenhirState1345 : (((('s, _menhir_box_ext_spec) _menhir_cell1_EXT_LET, _menhir_box_ext_spec) _menhir_cell1_any_identifier _menhir_cell0_EQUAL, _menhir_box_ext_spec) _menhir_cell1_lexpr, _menhir_box_ext_spec) _menhir_state
    (** State 1345.
        Stack shape : EXT_LET any_identifier EQUAL lexpr.
        Start symbol: ext_spec. *)

  | MenhirState1348 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_state
    (** State 1348.
        Stack shape : ext_global_clauses_opt.
        Start symbol: ext_spec. *)

  | MenhirState1349 : (('s, _menhir_box_ext_spec) _menhir_cell1_FUNCTION, _menhir_box_ext_spec) _menhir_state
    (** State 1349.
        Stack shape : FUNCTION.
        Start symbol: ext_spec. *)

  | MenhirState1353 : (('s, _menhir_box_ext_spec) _menhir_cell1_EXT_AT, _menhir_box_ext_spec) _menhir_state
    (** State 1353.
        Stack shape : EXT_AT.
        Start symbol: ext_spec. *)

  | MenhirState1357 : (('s, _menhir_box_ext_spec) _menhir_cell1_stmt_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1357.
        Stack shape : stmt_markup.
        Start symbol: ext_spec. *)

  | MenhirState1360 : (('s, _menhir_box_ext_spec) _menhir_cell1_CONTRACT, _menhir_box_ext_spec) _menhir_state
    (** State 1360.
        Stack shape : CONTRACT.
        Start symbol: ext_spec. *)

  | MenhirState1364 : ((('s, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_cell1_ext_module_specs_opt, _menhir_box_ext_spec) _menhir_state
    (** State 1364.
        Stack shape : ext_global_clauses_opt ext_module_specs_opt.
        Start symbol: ext_spec. *)

  | MenhirState1365 : (('s, _menhir_box_ext_spec) _menhir_cell1_MODULE, _menhir_box_ext_spec) _menhir_state
    (** State 1365.
        Stack shape : MODULE.
        Start symbol: ext_spec. *)

  | MenhirState1368 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_module_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1368.
        Stack shape : ext_module_markup.
        Start symbol: ext_spec. *)

  | MenhirState1369 : ((('s, _menhir_box_ext_spec) _menhir_cell1_ext_module_markup, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_state
    (** State 1369.
        Stack shape : ext_module_markup ext_global_clauses_opt.
        Start symbol: ext_spec. *)

  | MenhirState1371 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_module_spec, _menhir_box_ext_spec) _menhir_state
    (** State 1371.
        Stack shape : ext_module_spec.
        Start symbol: ext_spec. *)

  | MenhirState1373 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_function_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1373.
        Stack shape : ext_function_markup.
        Start symbol: ext_spec. *)

  | MenhirState1377 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_function_spec, _menhir_box_ext_spec) _menhir_state
    (** State 1377.
        Stack shape : ext_function_spec.
        Start symbol: ext_spec. *)

  | MenhirState1380 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_contract_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1380.
        Stack shape : ext_contract_markup.
        Start symbol: ext_spec. *)

  | MenhirState1382 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1382.
        Stack shape : ext_at_stmt_markup.
        Start symbol: ext_spec. *)

  | MenhirState1384 : ((('s, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup, _menhir_box_ext_spec) _menhir_cell1_ext_contract_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1384.
        Stack shape : ext_at_stmt_markup ext_contract_markup.
        Start symbol: ext_spec. *)

  | MenhirState1389 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_global_clause, _menhir_box_ext_spec) _menhir_state
    (** State 1389.
        Stack shape : ext_global_clause.
        Start symbol: ext_spec. *)

  | MenhirState1394 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_global_spec, _menhir_box_ext_spec) _menhir_state
    (** State 1394.
        Stack shape : ext_global_spec.
        Start symbol: ext_spec. *)

  | MenhirState1397 : ((('s, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_cell1_ext_fun_specs, _menhir_box_ext_spec) _menhir_state
    (** State 1397.
        Stack shape : ext_global_clauses_opt ext_fun_specs.
        Start symbol: ext_spec. *)

  | MenhirState1399 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_fun_spec, _menhir_box_ext_spec) _menhir_state
    (** State 1399.
        Stack shape : ext_fun_spec.
        Start symbol: ext_spec. *)

  | MenhirState1401 : (('s, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup, _menhir_box_ext_spec) _menhir_state
    (** State 1401.
        Stack shape : ext_at_stmt_markup.
        Start symbol: ext_spec. *)

  | MenhirState1402 : ('s, _menhir_box_lexpr_eof) _menhir_state
    (** State 1402.
        Stack shape : .
        Start symbol: lexpr_eof. *)

  | MenhirState1404 : (('s, _menhir_box_lexpr_eof) _menhir_cell1_lexpr, _menhir_box_lexpr_eof) _menhir_state
    (** State 1404.
        Stack shape : lexpr.
        Start symbol: lexpr_eof. *)

  | MenhirState1406 : ('s, _menhir_box_spec) _menhir_state
    (** State 1406.
        Stack shape : .
        Start symbol: spec. *)


and ('s, 'r) _menhir_cell1_abs_param_list = 
  | MenhirCell1_abs_param_list of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type list) * Lexing.position

and ('s, 'r) _menhir_cell1_abs_spec_bis = 
  | MenhirCell1_abs_spec_bis of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type -> Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_abs_spec_bis_cv = 
  | MenhirCell1_abs_spec_bis_cv of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type -> Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_allocation = 
  | MenhirCell1_allocation of 's * ('s, 'r) _menhir_state * (Logic_ptree.allocation) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_any_identifier = 
  | MenhirCell1_any_identifier of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_array_init_elt = 
  | MenhirCell1_array_init_elt of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr * Logic_ptree.lexpr)

and ('s, 'r) _menhir_cell1_array_path_elt = 
  | MenhirCell1_array_path_elt of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr)

and ('s, 'r) _menhir_cell1_array_size = 
  | MenhirCell1_array_size of 's * ('s, 'r) _menhir_state * (Logic_ptree.array_size)

and ('s, 'r) _menhir_cell1_assigns = 
  | MenhirCell1_assigns of 's * ('s, 'r) _menhir_state * ((Logic_ptree.lexpr * Logic_ptree.deps) list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_assumes = 
  | MenhirCell1_assumes of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr list)

and ('s, 'r) _menhir_cell1_behavior_body = 
  | MenhirCell1_behavior_body of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr list * Logic_ptree.toplevel_predicate list *
  (Logic_ptree.allocation * Logic_ptree.assigns *
   (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
   Logic_ptree.extension list))

and ('s, 'r) _menhir_cell1_behavior_name = 
  | MenhirCell1_behavior_name of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_behavior_name_list = 
  | MenhirCell1_behavior_name_list of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_behaviors = 
  | MenhirCell1_behaviors of 's * ('s, 'r) _menhir_state * (Logic_ptree.behavior list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_binders = 
  | MenhirCell1_binders of 's * ('s, 'r) _menhir_state * (Logic_ptree.quantifiers)

and ('s, 'r) _menhir_cell1_binders_reentrance = 
  | MenhirCell1_binders_reentrance of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type * Logic_ptree.quantifiers)

and ('s, 'r) _menhir_cell1_bounded_var = 
  | MenhirCell1_bounded_var of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_cast_logic_type = 
  | MenhirCell1_cast_logic_type of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_cv = 
  | MenhirCell1_cv of 's * ('s, 'r) _menhir_state * (Cil_types.attribute)

and ('s, 'r) _menhir_cell1_datacons = 
  | MenhirCell1_datacons of 's * ('s, 'r) _menhir_state * (string * Logic_ptree.logic_type list)

and ('s, 'r) _menhir_cell1_decl = 
  | MenhirCell1_decl of 's * ('s, 'r) _menhir_state * (Logic_ptree.decl_node) * Lexing.position * Lexing.position

and 's _menhir_cell0_decreases = 
  | MenhirCell0_decreases of 's * (Logic_ptree.variant option) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ext_at_stmt_markup = 
  | MenhirCell1_ext_at_stmt_markup of 's * ('s, 'r) _menhir_state * (string list) * Lexing.position

and ('s, 'r) _menhir_cell1_ext_contract_markup = 
  | MenhirCell1_ext_contract_markup of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_ext_decl_loc = 
  | MenhirCell1_ext_decl_loc of 's * ('s, 'r) _menhir_state * (Logic_ptree.extended_decl)

and ('s, 'r) _menhir_cell1_ext_fun_spec = 
  | MenhirCell1_ext_fun_spec of 's * ('s, 'r) _menhir_state * (Logic_ptree.ext_function)

and ('s, 'r) _menhir_cell1_ext_fun_specs = 
  | MenhirCell1_ext_fun_specs of 's * ('s, 'r) _menhir_state * (Logic_ptree.ext_function list)

and ('s, 'r) _menhir_cell1_ext_function_markup = 
  | MenhirCell1_ext_function_markup of 's * ('s, 'r) _menhir_state * (string * Logic_ptree.location)

and ('s, 'r) _menhir_cell1_ext_function_spec = 
  | MenhirCell1_ext_function_spec of 's * ('s, 'r) _menhir_state * (Logic_ptree.ext_function)

and ('s, 'r) _menhir_cell1_ext_global_clause = 
  | MenhirCell1_ext_global_clause of 's * ('s, 'r) _menhir_state * (Logic_ptree.ext_decl)

and ('s, 'r) _menhir_cell1_ext_global_clauses_opt = 
  | MenhirCell1_ext_global_clauses_opt of 's * ('s, 'r) _menhir_state * (Logic_ptree.ext_decl list)

and ('s, 'r) _menhir_cell1_ext_global_spec = 
  | MenhirCell1_ext_global_spec of 's * ('s, 'r) _menhir_state * (Logic_ptree.ext_module)

and ('s, 'r) _menhir_cell1_ext_module_markup = 
  | MenhirCell1_ext_module_markup of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_ext_module_spec = 
  | MenhirCell1_ext_module_spec of 's * ('s, 'r) _menhir_state * ((string * Logic_ptree.location) option * Logic_ptree.ext_function list)

and ('s, 'r) _menhir_cell1_ext_module_specs_opt = 
  | MenhirCell1_ext_module_specs_opt of 's * ('s, 'r) _menhir_state * (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list)

and ('s, 'r) _menhir_cell1_extension_content = 
  | MenhirCell1_extension_content of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr list)

and ('s, 'r) _menhir_cell1_field_init_elt = 
  | MenhirCell1_field_init_elt of 's * ('s, 'r) _menhir_state * (string * Logic_ptree.lexpr)

and ('s, 'r) _menhir_cell1_field_path_elt = 
  | MenhirCell1_field_path_elt of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_full_identifier = 
  | MenhirCell1_full_identifier of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_identifier_or_typename = 
  | MenhirCell1_identifier_or_typename of 's * ('s, 'r) _menhir_state * (string) * Lexing.position

and ('s, 'r) _menhir_cell1_identifier_or_typename_full = 
  | MenhirCell1_identifier_or_typename_full of 's * ('s, 'r) _menhir_state * (string) * Lexing.position

and ('s, 'r) _menhir_cell1_is_acsl_spec = 
  | MenhirCell1_is_acsl_spec of 's * ('s, 'r) _menhir_state * (string) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_label_name = 
  | MenhirCell1_label_name of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_lexpr = 
  | MenhirCell1_lexpr of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_lexpr_inner = 
  | MenhirCell1_lexpr_inner of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_lexpr_option = 
  | MenhirCell1_lexpr_option of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr option) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_logic_decl_loc = 
  | MenhirCell1_logic_decl_loc of 's * ('s, 'r) _menhir_state * (Logic_ptree.decl)

and ('s, 'r) _menhir_cell1_logic_rt_type = 
  | MenhirCell1_logic_rt_type of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_logic_type = 
  | MenhirCell1_logic_type of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type) * Lexing.position

and ('s, 'r) _menhir_cell1_logic_type_gen_TYPENAME_ = 
  | MenhirCell1_logic_type_gen_TYPENAME_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_logic_type_gen_identifier_or_typename_ = 
  | MenhirCell1_logic_type_gen_identifier_or_typename_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_logic_type_gen_typename_ = 
  | MenhirCell1_logic_type_gen_typename_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type) * Lexing.position

and ('s, 'r) _menhir_cell1_loop_allocation = 
  | MenhirCell1_loop_allocation of 's * ('s, 'r) _menhir_state * (Logic_ptree.allocation) * Lexing.position

and ('s, 'r) _menhir_cell1_loop_effects = 
  | MenhirCell1_loop_effects of 's * ('s, 'r) _menhir_state * ((Logic_ptree.lexpr * Logic_ptree.deps) list) * Lexing.position

and ('s, 'r) _menhir_cell1_loop_grammar_extension = 
  | MenhirCell1_loop_grammar_extension of 's * ('s, 'r) _menhir_state * (Logic_ptree.extension) * Lexing.position

and ('s, 'r) _menhir_cell1_loop_invariant = 
  | MenhirCell1_loop_invariant of 's * ('s, 'r) _menhir_state * (Logic_ptree.toplevel_predicate) * Lexing.position

and ('s, 'r) _menhir_cell1_loop_pragma = 
  | MenhirCell1_loop_pragma of 's * ('s, 'r) _menhir_state * (Logic_ptree.loop_pragma) * Lexing.position

and ('s, 'r) _menhir_cell1_loop_variant = 
  | MenhirCell1_loop_variant of 's * ('s, 'r) _menhir_state * (Logic_ptree.location * Logic_ptree.variant) * Lexing.position

and 's _menhir_cell0_midrule___anonymous_0_ = 
  | MenhirCell0_midrule___anonymous_0_ of 's * (unit)

and ('s, 'r) _menhir_cell1_ne_behavior_name_list = 
  | MenhirCell1_ne_behavior_name_list of 's * ('s, 'r) _menhir_state * (string list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ne_complete_or_disjoint = 
  | MenhirCell1_ne_complete_or_disjoint of 's * ('s, 'r) _menhir_state * (string list list * string list list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ne_grammar_extension = 
  | MenhirCell1_ne_grammar_extension of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr list)

and ('s, 'r) _menhir_cell1_ne_label_args = 
  | MenhirCell1_ne_label_args of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_ne_label_list = 
  | MenhirCell1_ne_label_list of 's * ('s, 'r) _menhir_state * (string list)

and ('s, 'r) _menhir_cell1_ne_zones = 
  | MenhirCell1_ne_zones of 's * ('s, 'r) _menhir_state * (Logic_ptree.lexpr list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_opt_label_1 = 
  | MenhirCell1_opt_label_1 of 's * ('s, 'r) _menhir_state * (string option)

and ('s, 'r) _menhir_cell1_opt_label_2 = 
  | MenhirCell1_opt_label_2 of 's * ('s, 'r) _menhir_state * ((string * string) option)

and ('s, 'r) _menhir_cell1_opt_parameters = 
  | MenhirCell1_opt_parameters of 's * ('s, 'r) _menhir_state * ((Logic_ptree.logic_type * string) list)

and ('s, 'r) _menhir_cell1_parameter = 
  | MenhirCell1_parameter of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type * string)

and ('s, 'r) _menhir_cell1_parameters = 
  | MenhirCell1_parameters of 's * ('s, 'r) _menhir_state * ((Logic_ptree.logic_type * string) list)

and ('s, 'r) _menhir_cell1_path = 
  | MenhirCell1_path of 's * ('s, 'r) _menhir_state * (Logic_ptree.path_elt list)

and ('s, 'r) _menhir_cell1_path_elt = 
  | MenhirCell1_path_elt of 's * ('s, 'r) _menhir_state * (Logic_ptree.path_elt)

and ('s, 'r) _menhir_cell1_poly_id = 
  | MenhirCell1_poly_id of 's * ('s, 'r) _menhir_state * (string * string list * string list)

and ('s, 'r) _menhir_cell1_poly_id_type_add_typename = 
  | MenhirCell1_poly_id_type_add_typename of 's * ('s, 'r) _menhir_state * (string * string list)

and ('s, 'r) _menhir_cell1_post_cond_kind = 
  | MenhirCell1_post_cond_kind of 's * ('s, 'r) _menhir_state * (Cil_types.predicate_kind * Cil_types.termination_kind) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_pragma_or_code_annotation = 
  | MenhirCell1_pragma_or_code_annotation of 's * ('s, 'r) _menhir_state * (Logic_ptree.code_annot) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_relation = 
  | MenhirCell1_relation of 's * ('s, 'r) _menhir_state * (Logic_ptree.relation) * Lexing.position

and ('s, 'r) _menhir_cell1_requires = 
  | MenhirCell1_requires of 's * ('s, 'r) _menhir_state * (Logic_ptree.toplevel_predicate list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_simple_clauses = 
  | MenhirCell1_simple_clauses of 's * ('s, 'r) _menhir_state * (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_stars = 
  | MenhirCell1_stars of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type -> Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_stars_cv = 
  | MenhirCell1_stars_cv of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type -> Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_stmt_markup = 
  | MenhirCell1_stmt_markup of 's * ('s, 'r) _menhir_state * (string)

and ('s, 'r) _menhir_cell1_string = 
  | MenhirCell1_string of 's * ('s, 'r) _menhir_state * (bool * string) * Lexing.position * Lexing.position

and 's _menhir_cell0_terminates = 
  | MenhirCell0_terminates of 's * (Logic_ptree.lexpr option) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_type_spec_TYPENAME_ = 
  | MenhirCell1_type_spec_TYPENAME_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_type_spec_identifier_or_typename_ = 
  | MenhirCell1_type_spec_identifier_or_typename_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_type_spec_typename_ = 
  | MenhirCell1_type_spec_typename_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type) * Lexing.position

and ('s, 'r) _menhir_cell1_type_spec_cv_TYPENAME_ = 
  | MenhirCell1_type_spec_cv_TYPENAME_ of 's * ('s, 'r) _menhir_state * (Logic_ptree.logic_type)

and ('s, 'r) _menhir_cell1_typename = 
  | MenhirCell1_typename of 's * ('s, 'r) _menhir_state * (string) * Lexing.position

and ('s, 'r) _menhir_cell1_update_elt = 
  | MenhirCell1_update_elt of 's * ('s, 'r) _menhir_state * (Logic_ptree.path_elt list * Logic_ptree.update_term)

and ('s, 'r) _menhir_cell1_var_spec_bis = 
  | MenhirCell1_var_spec_bis of 's * ('s, 'r) _menhir_state * ((Logic_ptree.logic_type -> Logic_ptree.logic_type) *
  (Logic_ptree.logic_type -> Logic_ptree.logic_type) * string)

and ('s, 'r) _menhir_cell1_variant = 
  | MenhirCell1_variant of 's * ('s, 'r) _menhir_state * (Logic_ptree.variant) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_wildcard = 
  | MenhirCell1_wildcard of 's * ('s, 'r) _menhir_state * (unit)

and ('s, 'r) _menhir_cell1_ADMIT = 
  | MenhirCell1_ADMIT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ADMIT_INVARIANT = 
  | MenhirCell1_ADMIT_INVARIANT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ADMIT_LEMMA = 
  | MenhirCell1_ADMIT_LEMMA of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ADMIT_LOOP = 
  | MenhirCell1_ADMIT_LOOP of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ADMIT_REQUIRES = 
  | MenhirCell1_ADMIT_REQUIRES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ALLOCABLE = 
  | MenhirCell1_ALLOCABLE of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_ALLOCATES = 
  | MenhirCell1_ALLOCATES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ALLOCATION = 
  | MenhirCell1_ALLOCATION of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_AMP = 
  | MenhirCell1_AMP of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_AND = 
  | MenhirCell1_AND of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ARROW = 
  | MenhirCell1_ARROW of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_ASSERT = 
  | MenhirCell1_ASSERT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ASSIGNS = 
  | MenhirCell1_ASSIGNS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_ASSUMES = 
  | MenhirCell1_ASSUMES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_AT = 
  | MenhirCell1_AT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_AXIOM = 
  | MenhirCell1_AXIOM of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_AXIOMATIC = 
  | MenhirCell1_AXIOMATIC of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BASE_ADDR = 
  | MenhirCell1_BASE_ADDR of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BEHAVIOR = 
  | MenhirCell1_BEHAVIOR of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_BEHAVIORS = 
  | MenhirCell0_BEHAVIORS of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_BIFF = 
  | MenhirCell1_BIFF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BIMPLIES = 
  | MenhirCell1_BIMPLIES of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_BLOCK_LENGTH = 
  | MenhirCell1_BLOCK_LENGTH of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BSTYPE = 
  | MenhirCell1_BSTYPE of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_BSUNION = 
  | MenhirCell1_BSUNION of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_CASE = 
  | MenhirCell1_CASE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_CHECK = 
  | MenhirCell1_CHECK of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_CHECK_INVARIANT = 
  | MenhirCell1_CHECK_INVARIANT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_CHECK_LEMMA = 
  | MenhirCell1_CHECK_LEMMA of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_CHECK_LOOP = 
  | MenhirCell1_CHECK_LOOP of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_CHECK_REQUIRES = 
  | MenhirCell1_CHECK_REQUIRES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_COLON = 
  | MenhirCell0_COLON of 's * Lexing.position

and ('s, 'r) _menhir_cell1_COLON2 = 
  | MenhirCell1_COLON2 of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COMMA = 
  | MenhirCell1_COMMA of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_COMPLETE = 
  | MenhirCell1_COMPLETE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_CONTRACT = 
  | MenhirCell1_CONTRACT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_DANGLING = 
  | MenhirCell1_DANGLING of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_DECREASES = 
  | MenhirCell0_DECREASES of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_DISJOINT = 
  | MenhirCell1_DISJOINT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_DOT = 
  | MenhirCell1_DOT of 's * ('s, 'r) _menhir_state

and 's _menhir_cell0_DOTDOT = 
  | MenhirCell0_DOTDOT of 's * Lexing.position

and ('s, 'r) _menhir_cell1_ENUM = 
  | MenhirCell1_ENUM of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EQUAL = 
  | MenhirCell1_EQUAL of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_EQUAL = 
  | MenhirCell0_EQUAL of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EXISTS = 
  | MenhirCell1_EXISTS of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_EXT_AT = 
  | MenhirCell1_EXT_AT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EXT_CODE_ANNOT = 
  | MenhirCell1_EXT_CODE_ANNOT of 's * ('s, 'r) _menhir_state * (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 3075 "src/kernel_internals/parsing/logic_parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EXT_CONTRACT = 
  | MenhirCell1_EXT_CONTRACT of 's * ('s, 'r) _menhir_state * (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 3082 "src/kernel_internals/parsing/logic_parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EXT_GLOBAL = 
  | MenhirCell1_EXT_GLOBAL of 's * ('s, 'r) _menhir_state * (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 3089 "src/kernel_internals/parsing/logic_parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EXT_GLOBAL_BLOCK = 
  | MenhirCell1_EXT_GLOBAL_BLOCK of 's * ('s, 'r) _menhir_state * (
# 278 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 3096 "src/kernel_internals/parsing/logic_parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_EXT_LET = 
  | MenhirCell1_EXT_LET of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_EXT_LET = 
  | MenhirCell0_EXT_LET of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_FOR = 
  | MenhirCell1_FOR of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_FORALL = 
  | MenhirCell1_FORALL of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_FREEABLE = 
  | MenhirCell1_FREEABLE of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_FREES = 
  | MenhirCell1_FREES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_FRESH = 
  | MenhirCell1_FRESH of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_FUNCTION = 
  | MenhirCell1_FUNCTION of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_GLOBAL = 
  | MenhirCell1_GLOBAL of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_GTGT = 
  | MenhirCell1_GTGT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_HAT = 
  | MenhirCell1_HAT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_HATHAT = 
  | MenhirCell1_HATHAT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IFF = 
  | MenhirCell1_IFF of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IMPACT = 
  | MenhirCell1_IMPACT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_IMPLIES = 
  | MenhirCell1_IMPLIES of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_IN = 
  | MenhirCell1_IN of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_INCLUDE = 
  | MenhirCell1_INCLUDE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_INDUCTIVE = 
  | MenhirCell1_INDUCTIVE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_INITIALIZED = 
  | MenhirCell1_INITIALIZED of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_INTER = 
  | MenhirCell1_INTER of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_INVARIANT = 
  | MenhirCell1_INVARIANT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_INVARIANT = 
  | MenhirCell0_INVARIANT of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LAMBDA = 
  | MenhirCell1_LAMBDA of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LBRACE = 
  | MenhirCell1_LBRACE of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LBRACE = 
  | MenhirCell0_LBRACE of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LEMMA = 
  | MenhirCell1_LEMMA of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LET = 
  | MenhirCell1_LET of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_LOGIC = 
  | MenhirCell1_LOGIC of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LONG = 
  | MenhirCell1_LONG of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LOOP = 
  | MenhirCell1_LOOP of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_LPAR = 
  | MenhirCell1_LPAR of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LPAR = 
  | MenhirCell0_LPAR of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LSQUARE = 
  | MenhirCell1_LSQUARE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_LSQUAREPIPE = 
  | MenhirCell1_LSQUAREPIPE of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_LT = 
  | MenhirCell0_LT of 's * Lexing.position

and ('s, 'r) _menhir_cell1_LTLT = 
  | MenhirCell1_LTLT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_MINUS = 
  | MenhirCell1_MINUS of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_MODEL = 
  | MenhirCell1_MODEL of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_MODULE = 
  | MenhirCell1_MODULE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_NOT = 
  | MenhirCell1_NOT of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_OBJECT_POINTER = 
  | MenhirCell1_OBJECT_POINTER of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_OFFSET = 
  | MenhirCell1_OFFSET of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_OLD = 
  | MenhirCell1_OLD of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_OR = 
  | MenhirCell1_OR of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_PERCENT = 
  | MenhirCell1_PERCENT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_PIPE = 
  | MenhirCell1_PIPE of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_PLUS = 
  | MenhirCell1_PLUS of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_PRAGMA = 
  | MenhirCell1_PRAGMA of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_PRAGMA = 
  | MenhirCell0_PRAGMA of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_PREDICATE = 
  | MenhirCell1_PREDICATE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_QUESTION = 
  | MenhirCell1_QUESTION of 's * ('s, 'r) _menhir_state

and 's _menhir_cell0_RBRACE = 
  | MenhirCell0_RBRACE of 's * Lexing.position

and ('s, 'r) _menhir_cell1_READS = 
  | MenhirCell1_READS of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_REQUIRES = 
  | MenhirCell1_REQUIRES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_RPAR = 
  | MenhirCell0_RPAR of 's * Lexing.position

and 's _menhir_cell0_RSQUARE = 
  | MenhirCell0_RSQUARE of 's * Lexing.position

and ('s, 'r) _menhir_cell1_SEMICOLON = 
  | MenhirCell1_SEMICOLON of 's * ('s, 'r) _menhir_state * Lexing.position

and 's _menhir_cell0_SEMICOLON = 
  | MenhirCell0_SEMICOLON of 's * Lexing.position

and ('s, 'r) _menhir_cell1_SEPARATED = 
  | MenhirCell1_SEPARATED of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_SHORT = 
  | MenhirCell1_SHORT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_SIGNED = 
  | MenhirCell1_SIGNED of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_SIZEOF = 
  | MenhirCell1_SIZEOF of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_SLASH = 
  | MenhirCell1_SLASH of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_SLICE = 
  | MenhirCell1_SLICE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_STAR = 
  | MenhirCell1_STAR of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_STARHAT = 
  | MenhirCell1_STARHAT of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_STRUCT = 
  | MenhirCell1_STRUCT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and 's _menhir_cell0_TERMINATES = 
  | MenhirCell0_TERMINATES of 's * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TILDE = 
  | MenhirCell1_TILDE of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_TYPE = 
  | MenhirCell1_TYPE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TYPENAME = 
  | MenhirCell1_TYPENAME of 's * ('s, 'r) _menhir_state * (
# 257 "src/kernel_internals/parsing/logic_parser.mly"
       (string)
# 3313 "src/kernel_internals/parsing/logic_parser.ml"
) * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_TYPEOF = 
  | MenhirCell1_TYPEOF of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_UNION = 
  | MenhirCell1_UNION of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_UNSIGNED = 
  | MenhirCell1_UNSIGNED of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VALID = 
  | MenhirCell1_VALID of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_VALID_FUNCTION = 
  | MenhirCell1_VALID_FUNCTION of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_VALID_INDEX = 
  | MenhirCell1_VALID_INDEX of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_VALID_RANGE = 
  | MenhirCell1_VALID_RANGE of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_VALID_READ = 
  | MenhirCell1_VALID_READ of 's * ('s, 'r) _menhir_state * Lexing.position

and ('s, 'r) _menhir_cell1_VARIANT = 
  | MenhirCell1_VARIANT of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_VOLATILE = 
  | MenhirCell1_VOLATILE of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and ('s, 'r) _menhir_cell1_WITH = 
  | MenhirCell1_WITH of 's * ('s, 'r) _menhir_state

and ('s, 'r) _menhir_cell1_WRITES = 
  | MenhirCell1_WRITES of 's * ('s, 'r) _menhir_state * Lexing.position * Lexing.position

and _menhir_box_spec = 
  | MenhirBox_spec of (Logic_ptree.spec) [@@unboxed]

and _menhir_box_lexpr_eof = 
  | MenhirBox_lexpr_eof of (Logic_ptree.lexpr) [@@unboxed]

and _menhir_box_ext_spec = 
  | MenhirBox_ext_spec of (Logic_ptree.ext_spec) [@@unboxed]

and _menhir_box_annot = 
  | MenhirBox_annot of (Logic_ptree.annot) [@@unboxed]

let _menhir_action_004 =
  fun _1 ->
    (* abs_param -> logic_type *)
    (
# 712 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 3370 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_005 =
  fun _1 ->
    (* abs_param_list -> abs_param *)
    (
# 704 "src/kernel_internals/parsing/logic_parser.mly"
            ( [ _1 ] )
# 3379 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_006 =
  fun _1 _3 ->
    (* abs_param_list -> abs_param_list COMMA abs_param *)
    (
# 705 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( _1 @ [ _3 ] )
# 3388 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_007 =
  fun () ->
    (* abs_param_type_list -> *)
    (
# 695 "src/kernel_internals/parsing/logic_parser.mly"
                 ( [ ] )
# 3397 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_008 =
  fun _1 ->
    (* abs_param_type_list -> abs_param_list *)
    (
# 696 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 3406 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_009 =
  fun _startpos__1_ ->
    (* abs_param_type_list -> abs_param_list COMMA DOTDOTDOT *)
    let _symbolstartpos = _startpos__1_ in
    (
# 697 "src/kernel_internals/parsing/logic_parser.mly"
                                 (
  let source = pos _symbolstartpos in
  Kernel.not_yet_implemented ~source "variadic C function types"
  )
# 3419 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_010 =
  fun _1 ->
    (* abs_spec -> tabs *)
    (
# 772 "src/kernel_internals/parsing/logic_parser.mly"
                          ( _1 )
# 3428 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_011 =
  fun _1 ->
    (* abs_spec -> stars *)
    (
# 773 "src/kernel_internals/parsing/logic_parser.mly"
                          ( _1 )
# 3437 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_012 =
  fun _1 _2 ->
    (* abs_spec -> stars tabs *)
    (
# 774 "src/kernel_internals/parsing/logic_parser.mly"
                          ( fun t -> _2 (_1 t) )
# 3446 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_013 =
  fun _1 _2 ->
    (* abs_spec -> stars abs_spec_bis *)
    (
# 775 "src/kernel_internals/parsing/logic_parser.mly"
                          ( fun t -> _2 (_1 t) )
# 3455 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_014 =
  fun _1 _2 _3 ->
    (* abs_spec -> stars abs_spec_bis tabs *)
    (
# 776 "src/kernel_internals/parsing/logic_parser.mly"
                          ( fun t -> _2 (_3 (_1 t)) )
# 3464 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_015 =
  fun _1 _2 ->
    (* abs_spec -> abs_spec_bis tabs *)
    (
# 777 "src/kernel_internals/parsing/logic_parser.mly"
                          ( fun t -> _1 (_2 t) )
# 3473 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_016 =
  fun _1 ->
    (* abs_spec -> abs_spec_bis *)
    (
# 778 "src/kernel_internals/parsing/logic_parser.mly"
                          ( _1 )
# 3482 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_017 =
  fun _2 ->
    (* abs_spec_bis -> LPAR abs_spec RPAR *)
    (
# 792 "src/kernel_internals/parsing/logic_parser.mly"
                     ( _2 )
# 3491 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_018 =
  fun _1 _3 ->
    (* abs_spec_bis -> abs_spec_bis LPAR abs_param_type_list RPAR *)
    (
# 793 "src/kernel_internals/parsing/logic_parser.mly"
                                             ( fun t -> _1 (LTarrow(_3,t)) )
# 3500 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_019 =
  fun _2 ->
    (* abs_spec_bis_cv -> LPAR abs_spec_cv RPAR *)
    (
# 797 "src/kernel_internals/parsing/logic_parser.mly"
                        ( _2 )
# 3509 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_020 =
  fun _1 _3 ->
    (* abs_spec_bis_cv -> abs_spec_bis_cv LPAR abs_param_type_list RPAR *)
    (
# 798 "src/kernel_internals/parsing/logic_parser.mly"
                                                ( fun t -> _1 (LTarrow(_3,t)) )
# 3518 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_021 =
  fun _1 ->
    (* abs_spec_cv -> tabs *)
    (
# 782 "src/kernel_internals/parsing/logic_parser.mly"
                               ( _1 )
# 3527 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_022 =
  fun _1 ->
    (* abs_spec_cv -> stars_cv *)
    (
# 783 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( _1 )
# 3536 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_023 =
  fun _1 _2 ->
    (* abs_spec_cv -> stars_cv tabs *)
    (
# 784 "src/kernel_internals/parsing/logic_parser.mly"
                                               ( fun t -> _2 (_1 t) )
# 3545 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_024 =
  fun _1 _2 ->
    (* abs_spec_cv -> stars_cv abs_spec_bis_cv *)
    (
# 785 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( fun t -> _2 (_1 t) )
# 3554 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_025 =
  fun _1 _2 _3 ->
    (* abs_spec_cv -> stars_cv abs_spec_bis_cv tabs *)
    (
# 786 "src/kernel_internals/parsing/logic_parser.mly"
                                               ( fun t -> _2 (_3 (_1 t)) )
# 3563 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_026 =
  fun _1 _2 ->
    (* abs_spec_cv -> abs_spec_bis_cv tabs *)
    (
# 787 "src/kernel_internals/parsing/logic_parser.mly"
                                               ( fun t -> _1 (_2 t) )
# 3572 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_027 =
  fun _1 ->
    (* abs_spec_cv -> abs_spec_bis_cv *)
    (
# 788 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( _1 )
# 3581 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_028 =
  fun () ->
    (* abs_spec_cv_option -> *)
    (
# 767 "src/kernel_internals/parsing/logic_parser.mly"
                ( fun t -> t )
# 3590 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_029 =
  fun _1 ->
    (* abs_spec_cv_option -> abs_spec_cv *)
    (
# 768 "src/kernel_internals/parsing/logic_parser.mly"
              ( _1 )
# 3599 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_030 =
  fun () ->
    (* abs_spec_option -> *)
    (
# 762 "src/kernel_internals/parsing/logic_parser.mly"
              ( fun t -> t )
# 3608 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_031 =
  fun _1 ->
    (* abs_spec_option -> abs_spec *)
    (
# 763 "src/kernel_internals/parsing/logic_parser.mly"
              ( _1 )
# 3617 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_032 =
  fun () ->
    (* acsl_c_keyword -> CASE *)
    (
# 1910 "src/kernel_internals/parsing/logic_parser.mly"
           ( "case" )
# 3626 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_033 =
  fun () ->
    (* acsl_c_keyword -> FOR *)
    (
# 1911 "src/kernel_internals/parsing/logic_parser.mly"
           ( "for" )
# 3635 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_034 =
  fun () ->
    (* acsl_c_keyword -> VOLATILE *)
    (
# 1912 "src/kernel_internals/parsing/logic_parser.mly"
           ( "volatile" )
# 3644 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_035 =
  fun _2 ->
    (* allocation -> ALLOCATES zones *)
    (
# 1188 "src/kernel_internals/parsing/logic_parser.mly"
                  ( FreeAlloc([],_2) )
# 3653 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation))

let _menhir_action_036 =
  fun _2 ->
    (* allocation -> FREES zones *)
    (
# 1189 "src/kernel_internals/parsing/logic_parser.mly"
              ( FreeAlloc(_2,[]) )
# 3662 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation))

let _menhir_action_037 =
  fun _1 ->
    (* annot -> annotation EOF *)
    (
# 1301 "src/kernel_internals/parsing/logic_parser.mly"
                  ( _1 )
# 3671 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_038 =
  fun () ->
    (* annot -> is_acsl_spec any EOF *)
    (
# 1302 "src/kernel_internals/parsing/logic_parser.mly"
                       ( Aspec )
# 3680 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_039 =
  fun _1 ->
    (* annot -> decl_list EOF *)
    (
# 1303 "src/kernel_internals/parsing/logic_parser.mly"
                  ( Adecl (_1) )
# 3689 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_040 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* annotation -> loop_annotations *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1308 "src/kernel_internals/parsing/logic_parser.mly"
      ( let (b,v,p) = _1 in
        (* TODO: do better, do not lose the structure ! *)
        let l = b@v@p in
        Aloop_annot (loc _sloc, l) )
# 3704 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_041 =
  fun _2 _4 ->
    (* annotation -> FOR ne_behavior_name_list COLON contract_or_code_annotation *)
    (
# 1313 "src/kernel_internals/parsing/logic_parser.mly"
      ( _4 _2 )
# 3713 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_042 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* annotation -> pragma_or_code_annotation *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1314 "src/kernel_internals/parsing/logic_parser.mly"
                            ( Acode_annot (loc _sloc,_1) )
# 3725 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_043 =
  fun _endpos__2_ _startpos__1_ ->
    (* annotation -> pragma_or_code_annotation beg_pragma_or_code_annotation *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1316 "src/kernel_internals/parsing/logic_parser.mly"
      ( raise
          (Not_well_formed (loc _sloc,
                            "Only one code annotation is allowed per comment"))
      )
# 3740 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_044 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* annotation -> identifier *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1320 "src/kernel_internals/parsing/logic_parser.mly"
             ( Aattribute_annot (loc _sloc, _1) )
# 3752 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_045 =
  fun _endpos__1_ _startpos__1_ ->
    (* annotation -> BSGHOST *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1321 "src/kernel_internals/parsing/logic_parser.mly"
          ( Aattribute_annot(loc _sloc,"\\ghost") )
# 3764 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_046 =
  fun () ->
    (* any -> wildcard *)
    (
# 2108 "src/kernel_internals/parsing/logic_parser.mly"
           ( () )
# 3773 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_047 =
  fun () ->
    (* any -> wildcard any *)
    (
# 2109 "src/kernel_internals/parsing/logic_parser.mly"
               ( () )
# 3782 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_048 =
  fun _1 ->
    (* any_identifier -> identifier *)
    (
# 1848 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 3791 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_049 =
  fun _1 ->
    (* any_identifier -> is_acsl_typename *)
    (
# 1849 "src/kernel_internals/parsing/logic_parser.mly"
                   ( _1 )
# 3800 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_050 =
  fun _1 ->
    (* any_identifier -> TYPENAME *)
    (
# 1850 "src/kernel_internals/parsing/logic_parser.mly"
           ( _1 )
# 3809 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_051 =
  fun _1 ->
    (* any_identifier -> keyword *)
    (
# 1851 "src/kernel_internals/parsing/logic_parser.mly"
          ( _1 )
# 3818 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_052 =
  fun _1 ->
    (* array_init -> array_init_elt *)
    (
# 611 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( [_1] )
# 3827 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.lexpr * Logic_ptree.lexpr) list))

let _menhir_action_053 =
  fun _1 _3 ->
    (* array_init -> array_init_elt COMMA array_init *)
    (
# 612 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( _1::_3 )
# 3836 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.lexpr * Logic_ptree.lexpr) list))

let _menhir_action_054 =
  fun _1 _3 ->
    (* array_init_elt -> array_path_elt EQUAL lexpr *)
    (
# 607 "src/kernel_internals/parsing/logic_parser.mly"
                             ( (_1, _3) )
# 3845 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr * Logic_ptree.lexpr))

let _menhir_action_055 =
  fun _2 ->
    (* array_path_elt -> LSQUARE lexpr RSQUARE *)
    (
# 602 "src/kernel_internals/parsing/logic_parser.mly"
                             ( _2 )
# 3854 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_056 =
  fun _2 ->
    (* array_path_elt -> LSQUARE range RSQUARE *)
    (
# 603 "src/kernel_internals/parsing/logic_parser.mly"
                             ( _2 )
# 3863 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_057 =
  fun _1 ->
    (* array_size -> INT_CONSTANT *)
    (
# 675 "src/kernel_internals/parsing/logic_parser.mly"
               ( ASinteger _1 )
# 3872 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.array_size))

let _menhir_action_058 =
  fun _1 ->
    (* array_size -> full_identifier *)
    (
# 676 "src/kernel_internals/parsing/logic_parser.mly"
                  ( ASidentifier _1 )
# 3881 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.array_size))

let _menhir_action_059 =
  fun () ->
    (* array_size -> *)
    (
# 677 "src/kernel_internals/parsing/logic_parser.mly"
              ( ASnone )
# 3890 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.array_size))

let _menhir_action_060 =
  fun _1 ->
    (* assigns -> zones *)
    (
# 1285 "src/kernel_internals/parsing/logic_parser.mly"
        ( List.map (fun x -> (x,FromAny)) _1 )
# 3899 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.lexpr * Logic_ptree.deps) list))

let _menhir_action_061 =
  fun _1 _3 ->
    (* assigns -> ne_zones FROM zones *)
    (
# 1286 "src/kernel_internals/parsing/logic_parser.mly"
                      (List.map (fun x -> (x, From _3)) _1)
# 3908 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.lexpr * Logic_ptree.deps) list))

let _menhir_action_062 =
  fun () ->
    (* assumes -> *)
    (
# 1259 "src/kernel_internals/parsing/logic_parser.mly"
                ( [] )
# 3917 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_063 =
  fun _2 _4 ->
    (* assumes -> ASSUMES lexpr SEMICOLON assumes *)
    (
# 1260 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( _2::_4 )
# 3926 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_064 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* assumes -> ASSUMES lexpr clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1261 "src/kernel_internals/parsing/logic_parser.mly"
                          ( missing _loc__2_ ";" _3 )
# 3936 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_065 =
  fun () ->
    (* beg_pragma_or_code_annotation -> IMPACT *)
    (
# 1464 "src/kernel_internals/parsing/logic_parser.mly"
         ()
# 3945 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_066 =
  fun () ->
    (* beg_pragma_or_code_annotation -> SLICE *)
    (
# 1465 "src/kernel_internals/parsing/logic_parser.mly"
        ()
# 3954 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_067 =
  fun () ->
    (* beg_pragma_or_code_annotation -> FOR *)
    (
# 1466 "src/kernel_internals/parsing/logic_parser.mly"
      ()
# 3963 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_068 =
  fun () ->
    (* beg_pragma_or_code_annotation -> ASSERT *)
    (
# 1467 "src/kernel_internals/parsing/logic_parser.mly"
         ()
# 3972 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_069 =
  fun () ->
    (* beg_pragma_or_code_annotation -> CHECK *)
    (
# 1468 "src/kernel_internals/parsing/logic_parser.mly"
        ()
# 3981 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_070 =
  fun () ->
    (* beg_pragma_or_code_annotation -> ADMIT *)
    (
# 1469 "src/kernel_internals/parsing/logic_parser.mly"
        ()
# 3990 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_071 =
  fun () ->
    (* beg_pragma_or_code_annotation -> INVARIANT *)
    (
# 1470 "src/kernel_internals/parsing/logic_parser.mly"
            ()
# 3999 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_072 =
  fun () ->
    (* beg_pragma_or_code_annotation -> CHECK_INVARIANT *)
    (
# 1471 "src/kernel_internals/parsing/logic_parser.mly"
                  ()
# 4008 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_073 =
  fun () ->
    (* beg_pragma_or_code_annotation -> ADMIT_INVARIANT *)
    (
# 1472 "src/kernel_internals/parsing/logic_parser.mly"
                  ()
# 4017 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_074 =
  fun () ->
    (* beg_pragma_or_code_annotation -> CHECK_LOOP *)
    (
# 1473 "src/kernel_internals/parsing/logic_parser.mly"
             ()
# 4026 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_075 =
  fun () ->
    (* beg_pragma_or_code_annotation -> ADMIT_LOOP *)
    (
# 1474 "src/kernel_internals/parsing/logic_parser.mly"
             ()
# 4035 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_076 =
  fun () ->
    (* beg_pragma_or_code_annotation -> EXT_CODE_ANNOT *)
    (
# 1475 "src/kernel_internals/parsing/logic_parser.mly"
                 ()
# 4044 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_077 =
  fun _1 _2 _3 ->
    (* behavior_body -> assumes requires simple_clauses *)
    (
# 1249 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( _1,_2,_3 )
# 4053 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list * Logic_ptree.toplevel_predicate list *
  (Logic_ptree.allocation * Logic_ptree.assigns *
   (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
   Logic_ptree.extension list)))

let _menhir_action_078 =
  fun _endpos__3_ _startpos__3_ ->
    (* behavior_body -> assumes ne_requires ASSUMES *)
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 1251 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__3_ "assumes" "requires" )
# 4066 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list * Logic_ptree.toplevel_predicate list *
  (Logic_ptree.allocation * Logic_ptree.assigns *
   (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
   Logic_ptree.extension list)))

let _menhir_action_079 =
  fun _endpos__4_ _startpos__4_ ->
    (* behavior_body -> assumes requires ne_simple_clauses ASSUMES *)
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    (
# 1253 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__4_ "assumes" "assigns or post-condition" )
# 4079 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list * Logic_ptree.toplevel_predicate list *
  (Logic_ptree.allocation * Logic_ptree.assigns *
   (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
   Logic_ptree.extension list)))

let _menhir_action_080 =
  fun _endpos__4_ _startpos__4_ ->
    (* behavior_body -> assumes requires ne_simple_clauses REQUIRES *)
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    (
# 1255 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__4_ "requires" "assigns or post-condition" )
# 4092 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list * Logic_ptree.toplevel_predicate list *
  (Logic_ptree.allocation * Logic_ptree.assigns *
   (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
   Logic_ptree.extension list)))

let _menhir_action_081 =
  fun _1 ->
    (* behavior_name -> any_identifier *)
    (
# 1844 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 4104 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_082 =
  fun () ->
    (* behavior_name_list -> *)
    (
# 1834 "src/kernel_internals/parsing/logic_parser.mly"
                        ( [] )
# 4113 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_083 =
  fun _1 ->
    (* behavior_name_list -> ne_behavior_name_list *)
    (
# 1835 "src/kernel_internals/parsing/logic_parser.mly"
                        ( _1 )
# 4122 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_084 =
  fun () ->
    (* behaviors -> *)
    (
# 1233 "src/kernel_internals/parsing/logic_parser.mly"
                ( [] )
# 4131 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.behavior list))

let _menhir_action_085 =
  fun _1 ->
    (* behaviors -> ne_behaviors *)
    (
# 1234 "src/kernel_internals/parsing/logic_parser.mly"
               ( _1 )
# 4140 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.behavior list))

let _menhir_action_086 =
  fun _1 ->
    (* binders -> binders_reentrance *)
    (
# 639 "src/kernel_internals/parsing/logic_parser.mly"
                     ( let (_lt, vars) = _1 in vars )
# 4149 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.quantifiers))

let _menhir_action_087 =
  fun _1 ->
    (* binders_reentrance -> decl_spec *)
    (
# 643 "src/kernel_internals/parsing/logic_parser.mly"
            ( let (lt, var) = _1 in (lt, [var]) )
# 4158 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type * Logic_ptree.quantifiers))

let _menhir_action_088 =
  fun _1 _3 ->
    (* binders_reentrance -> binders_reentrance COMMA decl_spec *)
    (
# 645 "src/kernel_internals/parsing/logic_parser.mly"
    ( let _, vars = _1 in
      let (lt, var) = _3 in
        (lt, vars @ [ var ])
    )
# 4170 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type * Logic_ptree.quantifiers))

let _menhir_action_089 =
  fun _1 _3 ->
    (* binders_reentrance -> binders_reentrance COMMA var_spec *)
    (
# 650 "src/kernel_internals/parsing/logic_parser.mly"
    ( let last_type_spec, vars = _1 in
        (last_type_spec, vars @ [ let (modif, name) = _3 in (modif last_type_spec, name)])
    )
# 4181 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type * Logic_ptree.quantifiers))

let _menhir_action_090 =
  fun _1 ->
    (* bounded_var -> full_identifier *)
    (
# 1874 "src/kernel_internals/parsing/logic_parser.mly"
                  ( _1 )
# 4190 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_091 =
  fun _endpos__1_ _startpos__1_ ->
    (* bounded_var -> is_acsl_typename *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1876 "src/kernel_internals/parsing/logic_parser.mly"
    ( raise
	(Not_well_formed(loc _sloc,
			 "Type names are not allowed as binding variable"))
    )
# 4205 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_092 =
  fun _endpos__1_ _startpos__1_ ->
    (* bounded_var -> TYPENAME *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1881 "src/kernel_internals/parsing/logic_parser.mly"
    ( raise
	(Not_well_formed(loc _sloc,
			 "Type names are not allowed as binding variable"))
    )
# 4220 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_093 =
  fun () ->
    (* bs_keyword -> ALLOCABLE *)
    (
# 2007 "src/kernel_internals/parsing/logic_parser.mly"
            ( () )
# 4229 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_094 =
  fun () ->
    (* bs_keyword -> ALLOCATION *)
    (
# 2008 "src/kernel_internals/parsing/logic_parser.mly"
             ( () )
# 4238 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_095 =
  fun () ->
    (* bs_keyword -> AUTOMATIC *)
    (
# 2009 "src/kernel_internals/parsing/logic_parser.mly"
            ( () )
# 4247 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_096 =
  fun () ->
    (* bs_keyword -> AT *)
    (
# 2010 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 4256 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_097 =
  fun () ->
    (* bs_keyword -> BASE_ADDR *)
    (
# 2011 "src/kernel_internals/parsing/logic_parser.mly"
            ( () )
# 4265 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_098 =
  fun () ->
    (* bs_keyword -> BLOCK_LENGTH *)
    (
# 2012 "src/kernel_internals/parsing/logic_parser.mly"
               ( () )
# 4274 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_099 =
  fun () ->
    (* bs_keyword -> BSGHOST *)
    (
# 2013 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 4283 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_100 =
  fun () ->
    (* bs_keyword -> DYNAMIC *)
    (
# 2014 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 4292 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_101 =
  fun () ->
    (* bs_keyword -> EMPTY *)
    (
# 2015 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 4301 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_102 =
  fun () ->
    (* bs_keyword -> FALSE *)
    (
# 2016 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 4310 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_103 =
  fun () ->
    (* bs_keyword -> FORALL *)
    (
# 2017 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 4319 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_104 =
  fun () ->
    (* bs_keyword -> FREEABLE *)
    (
# 2018 "src/kernel_internals/parsing/logic_parser.mly"
           ( () )
# 4328 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_105 =
  fun () ->
    (* bs_keyword -> FRESH *)
    (
# 2019 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 4337 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_106 =
  fun () ->
    (* bs_keyword -> FROM *)
    (
# 2020 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 4346 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_107 =
  fun () ->
    (* bs_keyword -> INTER *)
    (
# 2021 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 4355 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_108 =
  fun () ->
    (* bs_keyword -> LAMBDA *)
    (
# 2022 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 4364 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_109 =
  fun () ->
    (* bs_keyword -> LET *)
    (
# 2023 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 4373 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_110 =
  fun () ->
    (* bs_keyword -> NOTHING *)
    (
# 2024 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 4382 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_111 =
  fun () ->
    (* bs_keyword -> NULL *)
    (
# 2025 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 4391 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_112 =
  fun () ->
    (* bs_keyword -> OLD *)
    (
# 2026 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 4400 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_113 =
  fun () ->
    (* bs_keyword -> OFFSET *)
    (
# 2027 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 4409 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_114 =
  fun () ->
    (* bs_keyword -> REGISTER *)
    (
# 2028 "src/kernel_internals/parsing/logic_parser.mly"
           ( () )
# 4418 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_115 =
  fun () ->
    (* bs_keyword -> RESULT *)
    (
# 2029 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 4427 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_116 =
  fun () ->
    (* bs_keyword -> SEPARATED *)
    (
# 2030 "src/kernel_internals/parsing/logic_parser.mly"
            ( () )
# 4436 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_117 =
  fun () ->
    (* bs_keyword -> TRUE *)
    (
# 2031 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 4445 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_118 =
  fun () ->
    (* bs_keyword -> BSTYPE *)
    (
# 2032 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 4454 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_119 =
  fun () ->
    (* bs_keyword -> TYPEOF *)
    (
# 2033 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 4463 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_120 =
  fun () ->
    (* bs_keyword -> BSUNION *)
    (
# 2034 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 4472 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_121 =
  fun () ->
    (* bs_keyword -> UNALLOCATED *)
    (
# 2035 "src/kernel_internals/parsing/logic_parser.mly"
              ( () )
# 4481 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_122 =
  fun () ->
    (* bs_keyword -> OBJECT_POINTER *)
    (
# 2036 "src/kernel_internals/parsing/logic_parser.mly"
                 ( () )
# 4490 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_123 =
  fun () ->
    (* bs_keyword -> VALID *)
    (
# 2037 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 4499 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_124 =
  fun () ->
    (* bs_keyword -> VALID_INDEX *)
    (
# 2038 "src/kernel_internals/parsing/logic_parser.mly"
              ( () )
# 4508 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_125 =
  fun () ->
    (* bs_keyword -> VALID_RANGE *)
    (
# 2039 "src/kernel_internals/parsing/logic_parser.mly"
              ( () )
# 4517 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_126 =
  fun () ->
    (* bs_keyword -> VALID_READ *)
    (
# 2040 "src/kernel_internals/parsing/logic_parser.mly"
             ( () )
# 4526 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_127 =
  fun () ->
    (* bs_keyword -> VALID_FUNCTION *)
    (
# 2041 "src/kernel_internals/parsing/logic_parser.mly"
                 ( () )
# 4535 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_128 =
  fun () ->
    (* bs_keyword -> INITIALIZED *)
    (
# 2042 "src/kernel_internals/parsing/logic_parser.mly"
              ( () )
# 4544 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_129 =
  fun () ->
    (* bs_keyword -> DANGLING *)
    (
# 2043 "src/kernel_internals/parsing/logic_parser.mly"
           ( () )
# 4553 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_130 =
  fun () ->
    (* bs_keyword -> WITH *)
    (
# 2044 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 4562 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_131 =
  fun () ->
    (* c_keyword -> CHAR *)
    (
# 1888 "src/kernel_internals/parsing/logic_parser.mly"
           ( "char" )
# 4571 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_132 =
  fun () ->
    (* c_keyword -> BOOLEAN *)
    (
# 1889 "src/kernel_internals/parsing/logic_parser.mly"
           ( "boolean" )
# 4580 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_133 =
  fun () ->
    (* c_keyword -> BOOL *)
    (
# 1890 "src/kernel_internals/parsing/logic_parser.mly"
           ( "_Bool" )
# 4589 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_134 =
  fun () ->
    (* c_keyword -> CONST *)
    (
# 1891 "src/kernel_internals/parsing/logic_parser.mly"
           ( "const" )
# 4598 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_135 =
  fun () ->
    (* c_keyword -> DOUBLE *)
    (
# 1892 "src/kernel_internals/parsing/logic_parser.mly"
           ( "double" )
# 4607 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_136 =
  fun () ->
    (* c_keyword -> ENUM *)
    (
# 1893 "src/kernel_internals/parsing/logic_parser.mly"
           ( "enum" )
# 4616 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_137 =
  fun () ->
    (* c_keyword -> ELSE *)
    (
# 1894 "src/kernel_internals/parsing/logic_parser.mly"
           ( "else" )
# 4625 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_138 =
  fun () ->
    (* c_keyword -> FLOAT *)
    (
# 1895 "src/kernel_internals/parsing/logic_parser.mly"
           ( "float" )
# 4634 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_139 =
  fun () ->
    (* c_keyword -> IF *)
    (
# 1896 "src/kernel_internals/parsing/logic_parser.mly"
           ( "if" )
# 4643 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_140 =
  fun () ->
    (* c_keyword -> INT *)
    (
# 1897 "src/kernel_internals/parsing/logic_parser.mly"
           ( "int" )
# 4652 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_141 =
  fun () ->
    (* c_keyword -> LONG *)
    (
# 1898 "src/kernel_internals/parsing/logic_parser.mly"
           ( "long" )
# 4661 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_142 =
  fun () ->
    (* c_keyword -> SHORT *)
    (
# 1899 "src/kernel_internals/parsing/logic_parser.mly"
           ( "short" )
# 4670 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_143 =
  fun () ->
    (* c_keyword -> SIGNED *)
    (
# 1900 "src/kernel_internals/parsing/logic_parser.mly"
           ( "signed" )
# 4679 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_144 =
  fun () ->
    (* c_keyword -> SIZEOF *)
    (
# 1901 "src/kernel_internals/parsing/logic_parser.mly"
           ( "sizeof" )
# 4688 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_145 =
  fun () ->
    (* c_keyword -> STATIC *)
    (
# 1902 "src/kernel_internals/parsing/logic_parser.mly"
           ( "static" )
# 4697 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_146 =
  fun () ->
    (* c_keyword -> STRUCT *)
    (
# 1903 "src/kernel_internals/parsing/logic_parser.mly"
           ( "struct" )
# 4706 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_147 =
  fun () ->
    (* c_keyword -> UNION *)
    (
# 1904 "src/kernel_internals/parsing/logic_parser.mly"
           ( "union" )
# 4715 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_148 =
  fun () ->
    (* c_keyword -> UNSIGNED *)
    (
# 1905 "src/kernel_internals/parsing/logic_parser.mly"
           ( "unsigned" )
# 4724 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_149 =
  fun () ->
    (* c_keyword -> VOID *)
    (
# 1906 "src/kernel_internals/parsing/logic_parser.mly"
           ( "void" )
# 4733 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_150 =
  fun _1 _2 ->
    (* cast_logic_type -> type_spec_cv(TYPENAME) abs_spec_cv_option *)
    (
# 754 "src/kernel_internals/parsing/logic_parser.mly"
                                             ( _2 _1 )
# 4742 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_151 =
  fun () ->
    (* clause_kw -> ADMIT_REQUIRES *)
    (
# 1121 "src/kernel_internals/parsing/logic_parser.mly"
                 ( "admit requires" )
# 4751 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_152 =
  fun () ->
    (* clause_kw -> ADMIT_INVARIANT *)
    (
# 1122 "src/kernel_internals/parsing/logic_parser.mly"
                  ( "admit invariant" )
# 4760 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_153 =
  fun () ->
    (* clause_kw -> ADMIT_LEMMA *)
    (
# 1123 "src/kernel_internals/parsing/logic_parser.mly"
              ( "admit lemma" )
# 4769 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_154 =
  fun () ->
    (* clause_kw -> ADMIT_LOOP *)
    (
# 1124 "src/kernel_internals/parsing/logic_parser.mly"
             ( "admit loop" )
# 4778 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_155 =
  fun () ->
    (* clause_kw -> CHECK_REQUIRES *)
    (
# 1125 "src/kernel_internals/parsing/logic_parser.mly"
                 ( "check requires" )
# 4787 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_156 =
  fun () ->
    (* clause_kw -> CHECK_INVARIANT *)
    (
# 1126 "src/kernel_internals/parsing/logic_parser.mly"
                  ( "check invariant" )
# 4796 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_157 =
  fun () ->
    (* clause_kw -> CHECK_LEMMA *)
    (
# 1127 "src/kernel_internals/parsing/logic_parser.mly"
              ( "check lemma" )
# 4805 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_158 =
  fun () ->
    (* clause_kw -> CHECK_LOOP *)
    (
# 1128 "src/kernel_internals/parsing/logic_parser.mly"
             ( "check loop" )
# 4814 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_159 =
  fun () ->
    (* clause_kw -> REQUIRES *)
    (
# 1129 "src/kernel_internals/parsing/logic_parser.mly"
           ( "requires" )
# 4823 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_160 =
  fun () ->
    (* clause_kw -> ASSUMES *)
    (
# 1130 "src/kernel_internals/parsing/logic_parser.mly"
          ("assumes")
# 4832 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_161 =
  fun () ->
    (* clause_kw -> ASSIGNS *)
    (
# 1131 "src/kernel_internals/parsing/logic_parser.mly"
          ( "assigns" )
# 4841 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_162 =
  fun _1 ->
    (* clause_kw -> post_cond *)
    (
# 1132 "src/kernel_internals/parsing/logic_parser.mly"
            ( snd _1 )
# 4850 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_163 =
  fun () ->
    (* clause_kw -> DECREASES *)
    (
# 1133 "src/kernel_internals/parsing/logic_parser.mly"
            ( "decreases")
# 4859 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_164 =
  fun () ->
    (* clause_kw -> BEHAVIOR *)
    (
# 1134 "src/kernel_internals/parsing/logic_parser.mly"
           ( "behavior")
# 4868 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_165 =
  fun () ->
    (* clause_kw -> ALLOCATES *)
    (
# 1135 "src/kernel_internals/parsing/logic_parser.mly"
            ("allocates")
# 4877 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_166 =
  fun () ->
    (* clause_kw -> FREES *)
    (
# 1136 "src/kernel_internals/parsing/logic_parser.mly"
        ("frees")
# 4886 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_167 =
  fun () ->
    (* clause_kw -> COMPLETE *)
    (
# 1137 "src/kernel_internals/parsing/logic_parser.mly"
           ("complete")
# 4895 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_168 =
  fun () ->
    (* clause_kw -> DISJOINT *)
    (
# 1138 "src/kernel_internals/parsing/logic_parser.mly"
           ("disjoint")
# 4904 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_169 =
  fun _1 ->
    (* clause_kw -> EXT_CONTRACT *)
    (
# 1139 "src/kernel_internals/parsing/logic_parser.mly"
               ( _1 )
# 4913 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_170 =
  fun () ->
    (* clause_kw -> EOF *)
    (
# 1140 "src/kernel_internals/parsing/logic_parser.mly"
      ( "end of annotation" )
# 4922 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_171 =
  fun _2 ->
    (* code_annotation -> ASSERT lexpr SEMICOLON *)
    (
# 1486 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs -> AAssert (bhvs,toplevel_pred Assert _2) )
# 4931 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_172 =
  fun _2 ->
    (* code_annotation -> CHECK lexpr SEMICOLON *)
    (
# 1488 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs -> AAssert (bhvs,toplevel_pred Check _2) )
# 4940 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_173 =
  fun _2 ->
    (* code_annotation -> ADMIT lexpr SEMICOLON *)
    (
# 1490 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs -> AAssert (bhvs,toplevel_pred Admit _2) )
# 4949 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_174 =
  fun _2 ->
    (* code_annotation -> INVARIANT lexpr SEMICOLON *)
    (
# 1492 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs -> AInvariant (bhvs,false,toplevel_pred Assert _2) )
# 4958 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_175 =
  fun _2 ->
    (* code_annotation -> CHECK_INVARIANT lexpr SEMICOLON *)
    (
# 1494 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs -> AInvariant (bhvs,false,toplevel_pred Check _2) )
# 4967 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_176 =
  fun _2 ->
    (* code_annotation -> ADMIT_INVARIANT lexpr SEMICOLON *)
    (
# 1496 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs -> AInvariant (bhvs,false,toplevel_pred Admit _2) )
# 4976 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_177 =
  fun _1 _2 _endpos__1_ _startpos__1_ ->
    (* code_annotation -> EXT_CODE_ANNOT extension_content SEMICOLON *)
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 1498 "src/kernel_internals/parsing/logic_parser.mly"
  ( fun bhvs ->
    let open Cil_types in
    let ext = _1 in
    try
      begin match Logic_env.extension_category ext with
        | Ext_code_annot (Ext_here | Ext_next_stmt | Ext_next_both) ->
          let processed = Logic_env.preprocess_extension ext _2 in
          Logic_ptree.AExtended(bhvs,false,(ext,processed))
        | Ext_code_annot Ext_next_loop ->
          raise
            (Not_well_formed
               (loc _loc__1_,
                Printf.sprintf
                  "%s is a loop annotation extension. It can't be used as a \
                   plain code annotation extension. Did you mean 'loop %s'?"
                  ext ext))
        | _ -> raise Not_found
      end
    with Not_found ->
      Kernel.fatal ~source:(pos _startpos__1_)
        "%s is not a code annotation extension. Parser got wrong lexeme" ext
  )
# 5007 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.code_annot))

let _menhir_action_178 =
  fun () ->
    (* complete_or_disjoint -> *)
    (
# 1265 "src/kernel_internals/parsing/logic_parser.mly"
                ( [],[] )
# 5016 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list list * string list list))

let _menhir_action_179 =
  fun _1 ->
    (* complete_or_disjoint -> ne_complete_or_disjoint *)
    (
# 1266 "src/kernel_internals/parsing/logic_parser.mly"
                          ( _1 )
# 5025 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list list * string list list))

let _menhir_action_180 =
  fun _1 ->
    (* constant -> INT_CONSTANT *)
    (
# 668 "src/kernel_internals/parsing/logic_parser.mly"
                 ( IntConstant _1 )
# 5034 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.constant))

let _menhir_action_181 =
  fun _1 ->
    (* constant -> FLOAT_CONSTANT *)
    (
# 669 "src/kernel_internals/parsing/logic_parser.mly"
                 ( FloatConstant _1 )
# 5043 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.constant))

let _menhir_action_182 =
  fun _1 ->
    (* constant -> STRING_CONSTANT *)
    (
# 670 "src/kernel_internals/parsing/logic_parser.mly"
                  ( StringConstant _1 )
# 5052 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.constant))

let _menhir_action_183 =
  fun _1 ->
    (* constant -> WSTRING_CONSTANT *)
    (
# 671 "src/kernel_internals/parsing/logic_parser.mly"
                   ( WStringConstant _1 )
# 5061 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.constant))

let _menhir_action_184 =
  fun _1 _2 _3 _4 _5 _6 _endpos__1_ _endpos__2_ _endpos__3_ _endpos__4_ _endpos__5_ _endpos__6_ _startpos__1_ _startpos__2_ _startpos__3_ _startpos__4_ _startpos__5_ _startpos__6_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors complete_or_disjoint *)
    let _endpos = _endpos__6_ in
    let _symbolstartpos = if _startpos__1_ != _endpos__1_ then
      _startpos__1_
    else
      if _startpos__2_ != _endpos__2_ then
        _startpos__2_
      else
        if _startpos__3_ != _endpos__3_ then
          _startpos__3_
        else
          if _startpos__4_ != _endpos__4_ then
            _startpos__4_
          else
            if _startpos__5_ != _endpos__5_ then
              _startpos__5_
            else
              if _startpos__6_ != _endpos__6_ then
                _startpos__6_
              else
                _endpos in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1054 "src/kernel_internals/parsing/logic_parser.mly"
    ( let requires=_1 in
      let (allocation,assigns,post_cond,extended) = _4 in
      let behaviors = _5 in
      let (completes,disjoints) = _6 in
      let behaviors =
        if requires <> [] || post_cond <> [] ||
	   allocation <> FreeAllocAny ||
           assigns <> WritesAny || extended <> []
        then
          (Cabshelper.mk_behavior
             ~requires ~post_cond ~assigns ~allocation ~extended ())
          :: behaviors
        else if _2<>None || _3<>None ||
                behaviors<>[] || completes<>[] ||disjoints<>[]
        then behaviors
        else raise (Not_well_formed (loc _sloc,"Empty annotation is not allowed"))
      in
        { spec_terminates = _2;
          spec_variant = _3;
          spec_behavior = behaviors;
          spec_complete_behaviors = completes;
          spec_disjoint_behaviors = disjoints;
        }, loc _sloc
    )
# 5114 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_185 =
  fun _endpos__3_ _startpos__3_ ->
    (* contract -> requires ne_terminates REQUIRES *)
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 1078 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( clause_order _loc__3_ "requires" "terminates" )
# 5124 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_186 =
  fun _endpos__4_ _startpos__4_ ->
    (* contract -> requires terminates ne_decreases REQUIRES *)
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    (
# 1080 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__4_ "requires" "decreases" )
# 5134 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_187 =
  fun _endpos__4_ _startpos__4_ ->
    (* contract -> requires terminates ne_decreases TERMINATES *)
    let _loc__4_ = (_startpos__4_, _endpos__4_) in
    (
# 1082 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__4_ "terminates" "decreases" )
# 5144 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_188 =
  fun _endpos__5_ _startpos__5_ ->
    (* contract -> requires terminates decreases ne_simple_clauses REQUIRES *)
    let _loc__5_ = (_startpos__5_, _endpos__5_) in
    (
# 1084 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__5_ "requires" "post-condition, assigns or allocates" )
# 5154 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_189 =
  fun _endpos__5_ _startpos__5_ ->
    (* contract -> requires terminates decreases ne_simple_clauses TERMINATES *)
    let _loc__5_ = (_startpos__5_, _endpos__5_) in
    (
# 1086 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__5_ "terminates" "post-condition, assigns or allocates" )
# 5164 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_190 =
  fun _endpos__5_ _startpos__5_ ->
    (* contract -> requires terminates decreases ne_simple_clauses DECREASES *)
    let _loc__5_ = (_startpos__5_, _endpos__5_) in
    (
# 1088 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__5_ "decreases" "post-condition, assigns or allocates" )
# 5174 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_191 =
  fun _endpos__6_ _startpos__6_ ->
    (* contract -> requires terminates decreases simple_clauses ne_behaviors TERMINATES *)
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    (
# 1090 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__6_ "terminates" "behavior" )
# 5184 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_192 =
  fun _endpos__6_ _startpos__6_ ->
    (* contract -> requires terminates decreases simple_clauses ne_behaviors DECREASES *)
    let _loc__6_ = (_startpos__6_, _endpos__6_) in
    (
# 1092 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__6_ "decreases" "behavior" )
# 5194 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_193 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint REQUIRES *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1095 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "requires" "complete or disjoint" )
# 5204 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_194 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint TERMINATES *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1098 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "terminates" "complete or disjoint" )
# 5214 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_195 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint DECREASES *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1101 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "decreases" "complete or disjoint" )
# 5224 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_196 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint BEHAVIOR *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1104 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "behavior" "complete or disjoint" )
# 5234 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_197 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint ASSIGNS *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1107 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "assigns" "complete or disjoint" )
# 5244 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_198 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint ALLOCATES *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1110 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "allocates" "complete or disjoint" )
# 5254 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_199 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint FREES *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1113 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "frees" "complete or disjoint" )
# 5264 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_200 =
  fun _endpos__7_ _startpos__7_ ->
    (* contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint post_cond_kind *)
    let _loc__7_ = (_startpos__7_, _endpos__7_) in
    (
# 1116 "src/kernel_internals/parsing/logic_parser.mly"
      ( clause_order _loc__7_ "post-condition" "complete or disjoint" )
# 5274 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec * Logic_ptree.location))

let _menhir_action_201 =
  fun _1 ->
    (* contract_or_code_annotation -> contract *)
    (
# 1326 "src/kernel_internals/parsing/logic_parser.mly"
      ( fun bhvs -> let s, pos = _1 in Acode_annot (pos, AStmtSpec (bhvs,s)) )
# 5283 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.annot))

let _menhir_action_202 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* contract_or_code_annotation -> code_annotation *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1327 "src/kernel_internals/parsing/logic_parser.mly"
                  ( fun bhvs -> Acode_annot (loc _sloc, (_1 bhvs)) )
# 5295 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list -> Logic_ptree.annot))

let _menhir_action_203 =
  fun () ->
    (* cv -> CONST *)
    (
# 740 "src/kernel_internals/parsing/logic_parser.mly"
        ( cv_const )
# 5304 "src/kernel_internals/parsing/logic_parser.ml"
     : (Cil_types.attribute))

let _menhir_action_204 =
  fun () ->
    (* cv -> VOLATILE *)
    (
# 741 "src/kernel_internals/parsing/logic_parser.mly"
           ( cv_volatile )
# 5313 "src/kernel_internals/parsing/logic_parser.ml"
     : (Cil_types.attribute))

let _menhir_action_205 =
  fun () ->
    (* cv -> BSGHOST *)
    (
# 742 "src/kernel_internals/parsing/logic_parser.mly"
          ( cv_ghost )
# 5322 "src/kernel_internals/parsing/logic_parser.ml"
     : (Cil_types.attribute))

let _menhir_action_206 =
  fun () ->
    (* cv_after -> *)
    (
# 750 "src/kernel_internals/parsing/logic_parser.mly"
              ( fun t -> t )
# 5331 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_207 =
  fun _1 _2 ->
    (* cv_after -> cv cv_after *)
    (
# 751 "src/kernel_internals/parsing/logic_parser.mly"
              ( fun t -> _2 (LTattribute (t,_1)) )
# 5340 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_208 =
  fun _1 ->
    (* datacons -> full_identifier *)
    (
# 1780 "src/kernel_internals/parsing/logic_parser.mly"
                  ( (_1,[]) )
# 5349 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * Logic_ptree.logic_type list))

let _menhir_action_209 =
  fun _1 _3 ->
    (* datacons -> full_identifier LPAR ne_type_list RPAR *)
    (
# 1781 "src/kernel_internals/parsing/logic_parser.mly"
                                         ( (_1,_3) )
# 5358 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * Logic_ptree.logic_type list))

let _menhir_action_210 =
  fun () ->
    (* datacons_list -> *)
    (
# 1770 "src/kernel_internals/parsing/logic_parser.mly"
                ( [] )
# 5367 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.logic_type list) list))

let _menhir_action_211 =
  fun _2 _3 ->
    (* datacons_list -> PIPE datacons datacons_list *)
    (
# 1771 "src/kernel_internals/parsing/logic_parser.mly"
                              ( _2 :: _3 )
# 5376 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.logic_type list) list))

let _menhir_action_212 =
  fun _3 _5 ->
    (* decl -> GLOBAL INVARIANT any_identifier COLON lexpr SEMICOLON *)
    (
# 1550 "src/kernel_internals/parsing/logic_parser.mly"
    ( LDinvariant (_3, _5) )
# 5385 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_213 =
  fun _2 _3 ->
    (* decl -> VOLATILE ne_zones volatile_opt SEMICOLON *)
    (
# 1551 "src/kernel_internals/parsing/logic_parser.mly"
                                           ( LDvolatile (_2, _3) )
# 5394 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_214 =
  fun _1 ->
    (* decl -> type_annot *)
    (
# 1552 "src/kernel_internals/parsing/logic_parser.mly"
             (LDtype_annot _1)
# 5403 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_215 =
  fun _1 ->
    (* decl -> model_annot *)
    (
# 1553 "src/kernel_internals/parsing/logic_parser.mly"
              (LDmodel_annot _1)
# 5412 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_216 =
  fun _1 ->
    (* decl -> logic_def *)
    (
# 1554 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 5421 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_217 =
  fun _1 ->
    (* decl -> ext_decl *)
    (
# 1555 "src/kernel_internals/parsing/logic_parser.mly"
           ( LDextended _1 )
# 5430 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_218 =
  fun _1 ->
    (* decl -> deprecated_logic_decl *)
    (
# 1556 "src/kernel_internals/parsing/logic_parser.mly"
                        ( _1 )
# 5439 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_219 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* decl_list -> decl *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1544 "src/kernel_internals/parsing/logic_parser.mly"
                  ( [loc_decl _sloc _1] )
# 5451 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl list))

let _menhir_action_220 =
  fun _1 _2 _endpos__1_ _startpos__1_ ->
    (* decl_list -> decl decl_list *)
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 1545 "src/kernel_internals/parsing/logic_parser.mly"
                  ( (loc_decl _loc__1_ _1) :: _2 )
# 5461 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl list))

let _menhir_action_221 =
  fun _1 _2 ->
    (* decl_spec -> type_spec(typename) var_spec *)
    (
# 656 "src/kernel_internals/parsing/logic_parser.mly"
                               ( (_1, let (modif, name) = _2 in (modif _1, name))  )
# 5470 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type * (Logic_ptree.logic_type * string)))

let _menhir_action_222 =
  fun () ->
    (* decreases -> *)
    (
# 1168 "src/kernel_internals/parsing/logic_parser.mly"
                  ( None )
# 5479 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.variant option))

let _menhir_action_223 =
  fun _1 ->
    (* decreases -> ne_decreases *)
    (
# 1169 "src/kernel_internals/parsing/logic_parser.mly"
               ( Some _1 )
# 5488 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.variant option))

let _menhir_action_224 =
  fun _2 _3 _4 _startpos__1_ ->
    (* deprecated_logic_decl -> LOGIC logic_rt_type poly_id opt_parameters SEMICOLON *)
    let _symbolstartpos = _startpos__1_ in
    (
# 1691 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id, labels, tvars) = _3 in
      let source = pos _symbolstartpos in
      exit_type_variables_scope ();
      obsolete  "logic declaration" ~source ~now:"an axiomatic block";
      LDlogic_reads (id, labels, tvars, _2, _4, None) )
# 5502 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_225 =
  fun _2 _3 _startpos__1_ ->
    (* deprecated_logic_decl -> PREDICATE poly_id opt_parameters SEMICOLON *)
    let _symbolstartpos = _startpos__1_ in
    (
# 1698 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      let source = pos _symbolstartpos in
      obsolete "logic declaration" ~source ~now:"an axiomatic block";
      LDpredicate_reads (id, labels, tvars, _3, None) )
# 5516 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_226 =
  fun _2 _startpos__1_ ->
    (* deprecated_logic_decl -> TYPE poly_id_type SEMICOLON *)
    let _symbolstartpos = _startpos__1_ in
    (
# 1705 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,tvars) = _2 in
      Logic_env.add_typename id;
      exit_type_variables_scope ();
      let source = pos _symbolstartpos in
      obsolete "logic type declaration" ~source ~now:"an axiomatic block";
      LDtype(id,tvars,None)
    )
# 5532 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_227 =
  fun _2 _endpos__5_ _startpos__1_ ->
    (* deprecated_logic_decl -> AXIOM poly_id COLON lexpr SEMICOLON *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1714 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,_,_) = _2 in
      raise
	(Not_well_formed
	   (loc _sloc,"Axiom " ^ id ^ " is declared outside of an axiomatic."))
    )
# 5548 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_228 =
  fun _2 ->
    (* ext_at_stmt_markup -> EXT_AT stmt_markup_attr COLON *)
    (
# 1043 "src/kernel_internals/parsing/logic_parser.mly"
                                ( _2 )
# 5557 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_229 =
  fun _2 ->
    (* ext_contract_markup -> CONTRACT ext_identifier_opt COLON *)
    (
# 1029 "src/kernel_internals/parsing/logic_parser.mly"
                                    ( _2 )
# 5566 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_230 =
  fun _1 _2 ->
    (* ext_decl -> EXT_GLOBAL extension_content SEMICOLON *)
    (
# 1560 "src/kernel_internals/parsing/logic_parser.mly"
                                         (
     let processed = Logic_env.preprocess_extension _1 _2 in
     Ext_lexpr(_1, processed)
   )
# 5578 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.global_extension))

let _menhir_action_231 =
  fun _1 _2 _4 ->
    (* ext_decl -> EXT_GLOBAL_BLOCK any_identifier LBRACE ext_decls RBRACE *)
    (
# 1564 "src/kernel_internals/parsing/logic_parser.mly"
                                                          (
    let processed_id,processed_block =
       Logic_env.preprocess_extension_block _1 (_2,_4)
    in
    Ext_extension(_1,processed_id,processed_block)
   )
# 5592 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.global_extension))

let _menhir_action_232 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* ext_decl_loc -> ext_decl *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1580 "src/kernel_internals/parsing/logic_parser.mly"
           ( loc_ext _sloc _1 )
# 5604 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.extended_decl))

let _menhir_action_233 =
  fun () ->
    (* ext_decls -> *)
    (
# 1574 "src/kernel_internals/parsing/logic_parser.mly"
    ( [] )
# 5613 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.extended_decl list))

let _menhir_action_234 =
  fun _1 _2 ->
    (* ext_decls -> ext_decl_loc ext_decls *)
    (
# 1576 "src/kernel_internals/parsing/logic_parser.mly"
    ( _1::_2 )
# 5622 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.extended_decl list))

let _menhir_action_235 =
  fun _1 _2 _endpos__2_ _startpos__1_ ->
    (* ext_fun_spec -> ext_at_stmt_markup ext_stmt_loop_spec *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1001 "src/kernel_internals/parsing/logic_parser.mly"
    ( Ext_stmt(_1,_2,loc _sloc) )
# 5634 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function))

let _menhir_action_236 =
  fun _2 ->
    (* ext_fun_spec -> ext_contract_markup contract *)
    (
# 1003 "src/kernel_internals/parsing/logic_parser.mly"
    ( let s,pos = _2 in Ext_spec (s,pos) )
# 5643 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function))

let _menhir_action_237 =
  fun _1 ->
    (* ext_fun_specs -> ext_fun_spec *)
    (
# 995 "src/kernel_internals/parsing/logic_parser.mly"
                             ( [_1] )
# 5652 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_238 =
  fun _1 _2 ->
    (* ext_fun_specs -> ext_fun_spec ext_fun_specs *)
    (
# 996 "src/kernel_internals/parsing/logic_parser.mly"
                             ( _1::_2 )
# 5661 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_239 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* ext_function_markup -> FUNCTION ext_identifier COLON *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1025 "src/kernel_internals/parsing/logic_parser.mly"
                                ( _2, loc _sloc )
# 5673 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * Logic_ptree.location))

let _menhir_action_240 =
  fun _1 ->
    (* ext_function_spec -> ext_global_clause *)
    (
# 990 "src/kernel_internals/parsing/logic_parser.mly"
                    ( Ext_glob _1 )
# 5682 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function))

let _menhir_action_241 =
  fun _1 ->
    (* ext_function_spec -> ext_fun_spec *)
    (
# 991 "src/kernel_internals/parsing/logic_parser.mly"
                    ( _1 )
# 5691 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function))

let _menhir_action_242 =
  fun () ->
    (* ext_function_specs -> ext_at_stmt_markup *)
    (
# 984 "src/kernel_internals/parsing/logic_parser.mly"
                      ( [])
# 5700 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_243 =
  fun _1 ->
    (* ext_function_specs -> ext_function_spec *)
    (
# 985 "src/kernel_internals/parsing/logic_parser.mly"
                      ( [_1] )
# 5709 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_244 =
  fun _1 _2 ->
    (* ext_function_specs -> ext_function_spec ext_function_specs *)
    (
# 986 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( _1::_2 )
# 5718 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_245 =
  fun () ->
    (* ext_function_specs_opt -> *)
    (
# 979 "src/kernel_internals/parsing/logic_parser.mly"
                      ( [] )
# 5727 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_246 =
  fun _1 ->
    (* ext_function_specs_opt -> ext_function_specs *)
    (
# 980 "src/kernel_internals/parsing/logic_parser.mly"
                      ( _1 )
# 5736 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_function list))

let _menhir_action_247 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* ext_global_clause -> decl *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 939 "src/kernel_internals/parsing/logic_parser.mly"
        ( Ext_decl (loc_decl _sloc _1) )
# 5748 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl))

let _menhir_action_248 =
  fun _2 _4 ->
    (* ext_global_clause -> EXT_LET any_identifier EQUAL lexpr SEMICOLON *)
    (
# 940 "src/kernel_internals/parsing/logic_parser.mly"
                                               ( Ext_macro (false, _2, _4) )
# 5757 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl))

let _menhir_action_249 =
  fun _3 _5 ->
    (* ext_global_clause -> GLOBAL EXT_LET any_identifier EQUAL lexpr SEMICOLON *)
    (
# 941 "src/kernel_internals/parsing/logic_parser.mly"
                                                      ( Ext_macro (true, _3, _5) )
# 5766 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl))

let _menhir_action_250 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* ext_global_clause -> INCLUDE string SEMICOLON *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 942 "src/kernel_internals/parsing/logic_parser.mly"
                           ( let b,s = _2 in Ext_include(b,s, loc _sloc) )
# 5778 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl))

let _menhir_action_251 =
  fun _1 ->
    (* ext_global_clauses -> ext_global_clause *)
    (
# 934 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( [_1] )
# 5787 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl list))

let _menhir_action_252 =
  fun _1 _2 ->
    (* ext_global_clauses -> ext_global_clause ext_global_clauses *)
    (
# 935 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( _1::_2 )
# 5796 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl list))

let _menhir_action_253 =
  fun () ->
    (* ext_global_clauses_opt -> *)
    (
# 929 "src/kernel_internals/parsing/logic_parser.mly"
                       ( [] )
# 5805 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl list))

let _menhir_action_254 =
  fun _1 ->
    (* ext_global_clauses_opt -> ext_global_clauses *)
    (
# 930 "src/kernel_internals/parsing/logic_parser.mly"
                       ( _1 )
# 5814 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_decl list))

let _menhir_action_255 =
  fun _1 _2 _3 ->
    (* ext_global_spec -> ext_module_markup ext_global_clauses_opt ext_module_specs *)
    (
# 957 "src/kernel_internals/parsing/logic_parser.mly"
    ( (Some _1),_2,_3 )
# 5823 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_module))

let _menhir_action_256 =
  fun _1 _2 ->
    (* ext_global_spec -> ext_module_markup ext_global_clauses_opt *)
    (
# 959 "src/kernel_internals/parsing/logic_parser.mly"
    ( (Some _1),_2,[] )
# 5832 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_module))

let _menhir_action_257 =
  fun _1 ->
    (* ext_global_specs -> ext_global_spec *)
    (
# 951 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( [_1] )
# 5841 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_module list))

let _menhir_action_258 =
  fun _1 _2 ->
    (* ext_global_specs -> ext_global_spec ext_global_specs *)
    (
# 952 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( _1::_2 )
# 5850 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_module list))

let _menhir_action_259 =
  fun () ->
    (* ext_global_specs_opt -> *)
    (
# 946 "src/kernel_internals/parsing/logic_parser.mly"
                     ( [] )
# 5859 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_module list))

let _menhir_action_260 =
  fun _1 ->
    (* ext_global_specs_opt -> ext_global_specs *)
    (
# 947 "src/kernel_internals/parsing/logic_parser.mly"
                     ( _1 )
# 5868 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_module list))

let _menhir_action_261 =
  fun _1 ->
    (* ext_identifier -> any_identifier *)
    (
# 1017 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 5877 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_262 =
  fun () ->
    (* ext_identifier_opt -> *)
    (
# 1012 "src/kernel_internals/parsing/logic_parser.mly"
                 ( "" )
# 5886 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_263 =
  fun _1 ->
    (* ext_identifier_opt -> ext_identifier *)
    (
# 1013 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 5895 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_264 =
  fun _2 ->
    (* ext_module_markup -> MODULE ext_identifier COLON *)
    (
# 1021 "src/kernel_internals/parsing/logic_parser.mly"
                              ( _2 )
# 5904 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_265 =
  fun _1 _2 ->
    (* ext_module_spec -> ext_function_markup ext_function_specs_opt *)
    (
# 975 "src/kernel_internals/parsing/logic_parser.mly"
                                             ( (Some _1),_2 )
# 5913 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.location) option * Logic_ptree.ext_function list))

let _menhir_action_266 =
  fun _1 ->
    (* ext_module_specs -> ext_module_spec *)
    (
# 970 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( [_1] )
# 5922 "src/kernel_internals/parsing/logic_parser.ml"
     : (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list))

let _menhir_action_267 =
  fun _1 _2 ->
    (* ext_module_specs -> ext_module_spec ext_module_specs *)
    (
# 971 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( _1::_2 )
# 5932 "src/kernel_internals/parsing/logic_parser.ml"
     : (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list))

let _menhir_action_268 =
  fun () ->
    (* ext_module_specs_opt -> *)
    (
# 963 "src/kernel_internals/parsing/logic_parser.mly"
                    ( [] )
# 5942 "src/kernel_internals/parsing/logic_parser.ml"
     : (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list))

let _menhir_action_269 =
  fun _1 ->
    (* ext_module_specs_opt -> ext_module_specs *)
    (
# 964 "src/kernel_internals/parsing/logic_parser.mly"
                    ( _1 )
# 5952 "src/kernel_internals/parsing/logic_parser.ml"
     : (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list))

let _menhir_action_270 =
  fun _1 ->
    (* ext_module_specs_opt -> ext_fun_specs *)
    (
# 965 "src/kernel_internals/parsing/logic_parser.mly"
                 ( [None, _1] )
# 5962 "src/kernel_internals/parsing/logic_parser.ml"
     : (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list))

let _menhir_action_271 =
  fun _1 _2 ->
    (* ext_module_specs_opt -> ext_fun_specs ext_module_specs *)
    (
# 966 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( (None, _1)::_2 )
# 5972 "src/kernel_internals/parsing/logic_parser.ml"
     : (((string * Logic_ptree.location) option * Logic_ptree.ext_function list)
  list))

let _menhir_action_272 =
  fun _1 _2 _3 ->
    (* ext_spec -> ext_global_clauses_opt ext_module_specs_opt ext_global_specs_opt EOF *)
    (
# 925 "src/kernel_internals/parsing/logic_parser.mly"
                                                                        ( (None,_1,_2)::_3 )
# 5982 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.ext_spec))

let _menhir_action_273 =
  fun _1 ->
    (* ext_stmt_loop_spec -> annotation *)
    (
# 1007 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 5991 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_274 =
  fun _2 ->
    (* ext_stmt_loop_spec -> ext_contract_markup contract *)
    (
# 1008 "src/kernel_internals/parsing/logic_parser.mly"
                               ( let s, pos = _2 in Acode_annot (pos, AStmtSpec ([],s)) )
# 6000 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.annot))

let _menhir_action_275 =
  fun () ->
    (* extension_content -> *)
    (
# 1224 "src/kernel_internals/parsing/logic_parser.mly"
                ( [] )
# 6009 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_276 =
  fun _1 ->
    (* extension_content -> zones *)
    (
# 1225 "src/kernel_internals/parsing/logic_parser.mly"
        ( _1 )
# 6018 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_277 =
  fun _1 ->
    (* field_init -> field_init_elt *)
    (
# 597 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( [_1] )
# 6027 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.lexpr) list))

let _menhir_action_278 =
  fun _1 _3 ->
    (* field_init -> field_init_elt COMMA field_init *)
    (
# 598 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( _1::_3 )
# 6036 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.lexpr) list))

let _menhir_action_279 =
  fun _1 _3 ->
    (* field_init_elt -> field_path_elt EQUAL lexpr *)
    (
# 593 "src/kernel_internals/parsing/logic_parser.mly"
                             ( (_1, _3) )
# 6045 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * Logic_ptree.lexpr))

let _menhir_action_280 =
  fun _2 ->
    (* field_path_elt -> DOT identifier_or_typename_full *)
    (
# 590 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( _2 )
# 6054 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_281 =
  fun id ->
    (* full_identifier -> identifier *)
    (
# 876 "src/kernel_internals/parsing/logic_parser.mly"
                  ( id )
# 6063 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_282 =
  fun () ->
    (* full_identifier -> ADMIT *)
    (
# 877 "src/kernel_internals/parsing/logic_parser.mly"
        ( "admit" )
# 6072 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_283 =
  fun () ->
    (* full_identifier -> ALLOCATES *)
    (
# 878 "src/kernel_internals/parsing/logic_parser.mly"
            ( "allocates" )
# 6081 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_284 =
  fun () ->
    (* full_identifier -> ASSERT *)
    (
# 879 "src/kernel_internals/parsing/logic_parser.mly"
         ( "assert" )
# 6090 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_285 =
  fun () ->
    (* full_identifier -> ASSIGNS *)
    (
# 880 "src/kernel_internals/parsing/logic_parser.mly"
          ( "assigns" )
# 6099 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_286 =
  fun () ->
    (* full_identifier -> ASSUMES *)
    (
# 881 "src/kernel_internals/parsing/logic_parser.mly"
          ( "assumes" )
# 6108 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_287 =
  fun () ->
    (* full_identifier -> EXT_AT *)
    (
# 882 "src/kernel_internals/parsing/logic_parser.mly"
         ( "at" )
# 6117 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_288 =
  fun () ->
    (* full_identifier -> AXIOM *)
    (
# 883 "src/kernel_internals/parsing/logic_parser.mly"
        ( "axiom" )
# 6126 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_289 =
  fun () ->
    (* full_identifier -> AXIOMATIC *)
    (
# 884 "src/kernel_internals/parsing/logic_parser.mly"
            ( "axiomatic" )
# 6135 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_290 =
  fun () ->
    (* full_identifier -> BEHAVIOR *)
    (
# 885 "src/kernel_internals/parsing/logic_parser.mly"
           ( "behavior" )
# 6144 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_291 =
  fun () ->
    (* full_identifier -> BREAKS *)
    (
# 886 "src/kernel_internals/parsing/logic_parser.mly"
         ( "breaks" )
# 6153 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_292 =
  fun () ->
    (* full_identifier -> CHECK *)
    (
# 887 "src/kernel_internals/parsing/logic_parser.mly"
        ( "check" )
# 6162 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_293 =
  fun () ->
    (* full_identifier -> COMPLETE *)
    (
# 888 "src/kernel_internals/parsing/logic_parser.mly"
           ( "complete" )
# 6171 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_294 =
  fun () ->
    (* full_identifier -> CONTINUES *)
    (
# 889 "src/kernel_internals/parsing/logic_parser.mly"
            ( "continues" )
# 6180 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_295 =
  fun () ->
    (* full_identifier -> CONTRACT *)
    (
# 890 "src/kernel_internals/parsing/logic_parser.mly"
           ( "contract" )
# 6189 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_296 =
  fun () ->
    (* full_identifier -> DECREASES *)
    (
# 891 "src/kernel_internals/parsing/logic_parser.mly"
            ( "decreases" )
# 6198 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_297 =
  fun () ->
    (* full_identifier -> DISJOINT *)
    (
# 892 "src/kernel_internals/parsing/logic_parser.mly"
           ( "disjoint" )
# 6207 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_298 =
  fun () ->
    (* full_identifier -> ENSURES *)
    (
# 893 "src/kernel_internals/parsing/logic_parser.mly"
          ( "ensures" )
# 6216 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_299 =
  fun () ->
    (* full_identifier -> EXITS *)
    (
# 894 "src/kernel_internals/parsing/logic_parser.mly"
        ( "exits" )
# 6225 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_300 =
  fun () ->
    (* full_identifier -> FREES *)
    (
# 895 "src/kernel_internals/parsing/logic_parser.mly"
        ( "frees" )
# 6234 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_301 =
  fun () ->
    (* full_identifier -> FUNCTION *)
    (
# 896 "src/kernel_internals/parsing/logic_parser.mly"
           ( "function" )
# 6243 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_302 =
  fun () ->
    (* full_identifier -> GLOBAL *)
    (
# 897 "src/kernel_internals/parsing/logic_parser.mly"
         ( "global" )
# 6252 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_303 =
  fun () ->
    (* full_identifier -> IMPACT *)
    (
# 898 "src/kernel_internals/parsing/logic_parser.mly"
         ( "impact" )
# 6261 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_304 =
  fun () ->
    (* full_identifier -> INDUCTIVE *)
    (
# 899 "src/kernel_internals/parsing/logic_parser.mly"
            ( "inductive" )
# 6270 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_305 =
  fun () ->
    (* full_identifier -> INCLUDE *)
    (
# 900 "src/kernel_internals/parsing/logic_parser.mly"
          ( "include" )
# 6279 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_306 =
  fun () ->
    (* full_identifier -> INVARIANT *)
    (
# 901 "src/kernel_internals/parsing/logic_parser.mly"
            ( "invariant" )
# 6288 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_307 =
  fun () ->
    (* full_identifier -> LEMMA *)
    (
# 902 "src/kernel_internals/parsing/logic_parser.mly"
        ( "lemma" )
# 6297 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_308 =
  fun () ->
    (* full_identifier -> EXT_LET *)
    (
# 903 "src/kernel_internals/parsing/logic_parser.mly"
          ( "let" )
# 6306 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_309 =
  fun () ->
    (* full_identifier -> LOGIC *)
    (
# 904 "src/kernel_internals/parsing/logic_parser.mly"
        ( "logic" )
# 6315 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_310 =
  fun () ->
    (* full_identifier -> LOOP *)
    (
# 905 "src/kernel_internals/parsing/logic_parser.mly"
       ( "loop" )
# 6324 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_311 =
  fun () ->
    (* full_identifier -> MODEL *)
    (
# 906 "src/kernel_internals/parsing/logic_parser.mly"
        ( "model" )
# 6333 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_312 =
  fun () ->
    (* full_identifier -> MODULE *)
    (
# 907 "src/kernel_internals/parsing/logic_parser.mly"
         ( "module" )
# 6342 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_313 =
  fun () ->
    (* full_identifier -> PRAGMA *)
    (
# 908 "src/kernel_internals/parsing/logic_parser.mly"
         ( "pragma" )
# 6351 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_314 =
  fun () ->
    (* full_identifier -> PREDICATE *)
    (
# 909 "src/kernel_internals/parsing/logic_parser.mly"
            ( "predicate" )
# 6360 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_315 =
  fun () ->
    (* full_identifier -> REQUIRES *)
    (
# 910 "src/kernel_internals/parsing/logic_parser.mly"
           ( "requires" )
# 6369 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_316 =
  fun () ->
    (* full_identifier -> RETURNS *)
    (
# 911 "src/kernel_internals/parsing/logic_parser.mly"
          ( "returns" )
# 6378 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_317 =
  fun () ->
    (* full_identifier -> SLICE *)
    (
# 912 "src/kernel_internals/parsing/logic_parser.mly"
        ( "slice" )
# 6387 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_318 =
  fun () ->
    (* full_identifier -> TERMINATES *)
    (
# 913 "src/kernel_internals/parsing/logic_parser.mly"
             ( "terminates" )
# 6396 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_319 =
  fun () ->
    (* full_identifier -> TYPE *)
    (
# 914 "src/kernel_internals/parsing/logic_parser.mly"
       ( "type" )
# 6405 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_320 =
  fun () ->
    (* full_identifier -> VARIANT *)
    (
# 915 "src/kernel_internals/parsing/logic_parser.mly"
          ( "variant" )
# 6414 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_321 =
  fun id ->
    (* full_identifier -> EXT_CODE_ANNOT *)
    (
# 916 "src/kernel_internals/parsing/logic_parser.mly"
                      ( id )
# 6423 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_322 =
  fun id ->
    (* full_identifier -> EXT_CONTRACT *)
    (
# 917 "src/kernel_internals/parsing/logic_parser.mly"
                    ( id )
# 6432 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_323 =
  fun id ->
    (* full_identifier -> EXT_GLOBAL *)
    (
# 918 "src/kernel_internals/parsing/logic_parser.mly"
                  ( id )
# 6441 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_324 =
  fun id ->
    (* full_identifier -> EXT_GLOBAL_BLOCK *)
    (
# 919 "src/kernel_internals/parsing/logic_parser.mly"
                        ( id )
# 6450 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_325 =
  fun _1 ->
    (* identifier -> IDENTIFIER *)
    (
# 1865 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 6459 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_326 =
  fun () ->
    (* identifier -> BEHAVIORS *)
    (
# 1867 "src/kernel_internals/parsing/logic_parser.mly"
             ( "behaviors" )
# 6468 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_327 =
  fun () ->
    (* identifier -> LABEL *)
    (
# 1868 "src/kernel_internals/parsing/logic_parser.mly"
             ( "label" )
# 6477 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_328 =
  fun () ->
    (* identifier -> READS *)
    (
# 1869 "src/kernel_internals/parsing/logic_parser.mly"
             ( "reads" )
# 6486 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_329 =
  fun () ->
    (* identifier -> WRITES *)
    (
# 1870 "src/kernel_internals/parsing/logic_parser.mly"
             ( "writes" )
# 6495 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_330 =
  fun _1 ->
    (* identifier_or_typename -> TYPENAME *)
    (
# 1855 "src/kernel_internals/parsing/logic_parser.mly"
           ( _1 )
# 6504 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_331 =
  fun _1 ->
    (* identifier_or_typename -> full_identifier *)
    (
# 1856 "src/kernel_internals/parsing/logic_parser.mly"
                  ( _1 )
# 6513 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_332 =
  fun _1 ->
    (* identifier_or_typename_full -> is_acsl_typename *)
    (
# 1860 "src/kernel_internals/parsing/logic_parser.mly"
                    ( _1 )
# 6522 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_333 =
  fun _1 ->
    (* identifier_or_typename_full -> identifier_or_typename *)
    (
# 1861 "src/kernel_internals/parsing/logic_parser.mly"
                         ( _1 )
# 6531 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_334 =
  fun _3 _4 _endpos__5_ _startpos__1_ ->
    (* impact_pragma -> IMPACT PRAGMA any_identifier lexpr SEMICOLON *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1534 "src/kernel_internals/parsing/logic_parser.mly"
    ( if _3 = "expr" then IPexpr _4
      else raise (Not_well_formed (loc _sloc, "Unknown impact pragma")) )
# 6544 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.impact_pragma))

let _menhir_action_335 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* impact_pragma -> IMPACT PRAGMA any_identifier SEMICOLON *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1537 "src/kernel_internals/parsing/logic_parser.mly"
    ( if _3 = "stmt" then IPstmt
      else raise (Not_well_formed (loc _sloc, "Unknown impact pragma")) )
# 6557 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.impact_pragma))

let _menhir_action_336 =
  fun () ->
    (* indcases -> *)
    (
# 1790 "src/kernel_internals/parsing/logic_parser.mly"
    ( [] )
# 6566 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * string list * string list * Logic_ptree.lexpr) list))

let _menhir_action_337 =
  fun _2 _4 _6 ->
    (* indcases -> CASE poly_id COLON lexpr SEMICOLON indcases *)
    (
# 1792 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      (id,labels,tvars,_4)::_6 )
# 6577 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * string list * string list * Logic_ptree.lexpr) list))

let _menhir_action_338 =
  fun _1 ->
    (* is_acsl_decl_or_code_annot -> EXT_CODE_ANNOT *)
    (
# 1950 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 6586 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_339 =
  fun _1 ->
    (* is_acsl_decl_or_code_annot -> EXT_GLOBAL *)
    (
# 1951 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 6595 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_340 =
  fun _1 ->
    (* is_acsl_decl_or_code_annot -> EXT_GLOBAL_BLOCK *)
    (
# 1952 "src/kernel_internals/parsing/logic_parser.mly"
                       ( _1 )
# 6604 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_341 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> ASSUMES *)
    (
# 1953 "src/kernel_internals/parsing/logic_parser.mly"
            ( "assumes" )
# 6613 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_342 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> ASSERT *)
    (
# 1954 "src/kernel_internals/parsing/logic_parser.mly"
            ( "assert" )
# 6622 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_343 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> CHECK *)
    (
# 1955 "src/kernel_internals/parsing/logic_parser.mly"
            ( "check" )
# 6631 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_344 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> ADMIT *)
    (
# 1956 "src/kernel_internals/parsing/logic_parser.mly"
            ( "admit" )
# 6640 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_345 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> GLOBAL *)
    (
# 1957 "src/kernel_internals/parsing/logic_parser.mly"
            ( "global" )
# 6649 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_346 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> IMPACT *)
    (
# 1958 "src/kernel_internals/parsing/logic_parser.mly"
            ( "impact" )
# 6658 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_347 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> INDUCTIVE *)
    (
# 1959 "src/kernel_internals/parsing/logic_parser.mly"
            ( "inductive" )
# 6667 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_348 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> INVARIANT *)
    (
# 1960 "src/kernel_internals/parsing/logic_parser.mly"
            ( "invariant" )
# 6676 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_349 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> ADMIT_INVARIANT *)
    (
# 1961 "src/kernel_internals/parsing/logic_parser.mly"
                  ( "admit invariant" )
# 6685 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_350 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> CHECK_INVARIANT *)
    (
# 1962 "src/kernel_internals/parsing/logic_parser.mly"
                  ( "check invariant" )
# 6694 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_351 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> LEMMA *)
    (
# 1963 "src/kernel_internals/parsing/logic_parser.mly"
            ( "lemma" )
# 6703 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_352 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> ADMIT_LEMMA *)
    (
# 1964 "src/kernel_internals/parsing/logic_parser.mly"
              ( "admit lemma" )
# 6712 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_353 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> CHECK_LEMMA *)
    (
# 1965 "src/kernel_internals/parsing/logic_parser.mly"
              ( "check lemma" )
# 6721 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_354 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> LOOP *)
    (
# 1966 "src/kernel_internals/parsing/logic_parser.mly"
            ( "loop" )
# 6730 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_355 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> ADMIT_LOOP *)
    (
# 1967 "src/kernel_internals/parsing/logic_parser.mly"
             ( "admit loop" )
# 6739 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_356 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> CHECK_LOOP *)
    (
# 1968 "src/kernel_internals/parsing/logic_parser.mly"
             ( "check loop" )
# 6748 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_357 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> PRAGMA *)
    (
# 1969 "src/kernel_internals/parsing/logic_parser.mly"
            ( "pragma" )
# 6757 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_358 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> PREDICATE *)
    (
# 1970 "src/kernel_internals/parsing/logic_parser.mly"
            ( "predicate" )
# 6766 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_359 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> SLICE *)
    (
# 1971 "src/kernel_internals/parsing/logic_parser.mly"
            ( "slice" )
# 6775 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_360 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> TYPE *)
    (
# 1972 "src/kernel_internals/parsing/logic_parser.mly"
            ( "type" )
# 6784 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_361 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> MODEL *)
    (
# 1973 "src/kernel_internals/parsing/logic_parser.mly"
            ( "model" )
# 6793 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_362 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> AXIOM *)
    (
# 1974 "src/kernel_internals/parsing/logic_parser.mly"
            ( "axiom" )
# 6802 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_363 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> VARIANT *)
    (
# 1975 "src/kernel_internals/parsing/logic_parser.mly"
            ( "variant" )
# 6811 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_364 =
  fun () ->
    (* is_acsl_decl_or_code_annot -> AXIOMATIC *)
    (
# 1976 "src/kernel_internals/parsing/logic_parser.mly"
            ( "axiomatic" )
# 6820 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_365 =
  fun _1 ->
    (* is_acsl_spec -> post_cond *)
    (
# 1934 "src/kernel_internals/parsing/logic_parser.mly"
             ( snd _1 )
# 6829 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_366 =
  fun _1 ->
    (* is_acsl_spec -> EXT_CONTRACT *)
    (
# 1935 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 6838 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_367 =
  fun () ->
    (* is_acsl_spec -> ASSIGNS *)
    (
# 1936 "src/kernel_internals/parsing/logic_parser.mly"
             ( "assigns" )
# 6847 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_368 =
  fun () ->
    (* is_acsl_spec -> ALLOCATES *)
    (
# 1937 "src/kernel_internals/parsing/logic_parser.mly"
             ( "allocates" )
# 6856 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_369 =
  fun () ->
    (* is_acsl_spec -> FREES *)
    (
# 1938 "src/kernel_internals/parsing/logic_parser.mly"
             ( "frees" )
# 6865 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_370 =
  fun () ->
    (* is_acsl_spec -> BEHAVIOR *)
    (
# 1939 "src/kernel_internals/parsing/logic_parser.mly"
             ( "behavior" )
# 6874 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_371 =
  fun () ->
    (* is_acsl_spec -> REQUIRES *)
    (
# 1940 "src/kernel_internals/parsing/logic_parser.mly"
             ( "requires" )
# 6883 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_372 =
  fun () ->
    (* is_acsl_spec -> CHECK_REQUIRES *)
    (
# 1941 "src/kernel_internals/parsing/logic_parser.mly"
                 ( "check requires" )
# 6892 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_373 =
  fun () ->
    (* is_acsl_spec -> ADMIT_REQUIRES *)
    (
# 1942 "src/kernel_internals/parsing/logic_parser.mly"
                 ( "admit requires" )
# 6901 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_374 =
  fun () ->
    (* is_acsl_spec -> TERMINATES *)
    (
# 1943 "src/kernel_internals/parsing/logic_parser.mly"
             ( "terminates" )
# 6910 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_375 =
  fun () ->
    (* is_acsl_spec -> COMPLETE *)
    (
# 1944 "src/kernel_internals/parsing/logic_parser.mly"
             ( "complete" )
# 6919 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_376 =
  fun () ->
    (* is_acsl_spec -> DECREASES *)
    (
# 1945 "src/kernel_internals/parsing/logic_parser.mly"
             ( "decreases" )
# 6928 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_377 =
  fun () ->
    (* is_acsl_spec -> DISJOINT *)
    (
# 1946 "src/kernel_internals/parsing/logic_parser.mly"
             ( "disjoint" )
# 6937 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_378 =
  fun () ->
    (* is_acsl_typename -> INTEGER *)
    (
# 1980 "src/kernel_internals/parsing/logic_parser.mly"
           ( "integer" (* token that can be used in C fields *) )
# 6946 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_379 =
  fun () ->
    (* is_acsl_typename -> REAL *)
    (
# 1981 "src/kernel_internals/parsing/logic_parser.mly"
           ( "real" (* token that can be used in C fields *) )
# 6955 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_380 =
  fun () ->
    (* is_ext_spec -> CONTRACT *)
    (
# 1985 "src/kernel_internals/parsing/logic_parser.mly"
           ( "contract" )
# 6964 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_381 =
  fun () ->
    (* is_ext_spec -> FUNCTION *)
    (
# 1986 "src/kernel_internals/parsing/logic_parser.mly"
           ( "function" )
# 6973 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_382 =
  fun () ->
    (* is_ext_spec -> MODULE *)
    (
# 1987 "src/kernel_internals/parsing/logic_parser.mly"
           ( "module" )
# 6982 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_383 =
  fun () ->
    (* is_ext_spec -> INCLUDE *)
    (
# 1988 "src/kernel_internals/parsing/logic_parser.mly"
           ( "include" )
# 6991 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_384 =
  fun () ->
    (* is_ext_spec -> EXT_AT *)
    (
# 1989 "src/kernel_internals/parsing/logic_parser.mly"
           ( "at" )
# 7000 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_385 =
  fun () ->
    (* is_ext_spec -> EXT_LET *)
    (
# 1990 "src/kernel_internals/parsing/logic_parser.mly"
           ( "let" )
# 7009 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_386 =
  fun () ->
    (* keyword -> LOGIC *)
    (
# 1994 "src/kernel_internals/parsing/logic_parser.mly"
          ( "logic" )
# 7018 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_387 =
  fun _1 ->
    (* keyword -> non_logic_keyword *)
    (
# 1995 "src/kernel_internals/parsing/logic_parser.mly"
                    ( _1 )
# 7027 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_388 =
  fun _1 ->
    (* label_name -> any_identifier *)
    (
# 1830 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 7036 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_389 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr IMPLIES lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 354 "src/kernel_internals/parsing/logic_parser.mly"
                      ( info _sloc (PLimplies (_1, _3)) )
# 7048 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_390 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr IFF lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 355 "src/kernel_internals/parsing/logic_parser.mly"
                  ( info _sloc (PLiff (_1, _3)) )
# 7060 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_391 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr OR lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 356 "src/kernel_internals/parsing/logic_parser.mly"
                     ( info _sloc (plor _1 _3) )
# 7072 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_392 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr AND lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 357 "src/kernel_internals/parsing/logic_parser.mly"
                     ( info _sloc (pland _1 _3) )
# 7084 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_393 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr HATHAT lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 358 "src/kernel_internals/parsing/logic_parser.mly"
                        ( info _sloc (PLxor (_1, _3)) )
# 7096 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_394 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr AMP lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 360 "src/kernel_internals/parsing/logic_parser.mly"
                  ( info _sloc (PLbinop (_1, Bbw_and, _3)) )
# 7108 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_395 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr PIPE lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 361 "src/kernel_internals/parsing/logic_parser.mly"
                   ( info _sloc (PLbinop (_1, Bbw_or, _3)) )
# 7120 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_396 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr HAT lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 362 "src/kernel_internals/parsing/logic_parser.mly"
                  ( info _sloc (PLbinop (_1, Bbw_xor, _3)) )
# 7132 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_397 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr BIMPLIES lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 363 "src/kernel_internals/parsing/logic_parser.mly"
                       ( info _sloc (PLbinop (info _sloc (PLunop (Ubw_not, _1)), Bbw_or, _3)) )
# 7144 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_398 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr BIFF lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 364 "src/kernel_internals/parsing/logic_parser.mly"
                   ( info _sloc (PLbinop (info _sloc (PLunop (Ubw_not, _1)), Bbw_xor, _3)) )
# 7156 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_399 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> lexpr IN lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 365 "src/kernel_internals/parsing/logic_parser.mly"
                 ( info _sloc (PLapp ("\\subset", [], [info _sloc (PLset [_1]);_3])) )
# 7168 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_400 =
  fun _1 _3 _5 _endpos__5_ _startpos__1_ ->
    (* lexpr -> lexpr QUESTION lexpr COLON2 lexpr *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 367 "src/kernel_internals/parsing/logic_parser.mly"
    ( info _sloc (PLif (_1, _3, _5)) )
# 7180 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_401 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> any_identifier COLON lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 369 "src/kernel_internals/parsing/logic_parser.mly"
                                              ( info _sloc (PLnamed (_1, _3)) )
# 7192 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_402 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr -> string COLON lexpr *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 371 "src/kernel_internals/parsing/logic_parser.mly"
      ( let (iswide,str) = _1 in
        if iswide then begin
           let l = loc _sloc in
           raise (Not_well_formed(l, "Wide strings are not allowed as labels."))
         end;
        let str = escape str in
         info _sloc (PLnamed (str, _3))
       )
# 7211 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_403 =
  fun _1 ->
    (* lexpr -> lexpr_rel *)
    (
# 379 "src/kernel_internals/parsing/logic_parser.mly"
            ( _1 )
# 7220 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_404 =
  fun _2 _4 _6 _endpos__6_ _startpos__1_ ->
    (* lexpr_binder -> LET bounded_var EQUAL lexpr SEMICOLON lexpr *)
    let _endpos = _endpos__6_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 396 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLlet(_2,_4,_6)))
# 7232 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_405 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    (* lexpr_binder -> FORALL binders SEMICOLON lexpr *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 398 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLforall (_2, _4)) )
# 7244 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_406 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    (* lexpr_binder -> EXISTS binders SEMICOLON lexpr *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 400 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLexists (_2, _4)) )
# 7256 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_407 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    (* lexpr_binder -> LAMBDA binders SEMICOLON lexpr *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 402 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLlambda (_2,_4)) )
# 7268 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_408 =
  fun _1 ->
    (* lexpr_end_rel -> lexpr_inner *)
    (
# 406 "src/kernel_internals/parsing/logic_parser.mly"
               ( _1 )
# 7277 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_409 =
  fun _1 ->
    (* lexpr_end_rel -> lexpr_binder *)
    (
# 407 "src/kernel_internals/parsing/logic_parser.mly"
               ( _1 )
# 7286 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_410 =
  fun _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_end_rel -> NOT lexpr_binder *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 408 "src/kernel_internals/parsing/logic_parser.mly"
                   ( info _sloc (PLnot _2) )
# 7298 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_411 =
  fun _1 ->
    (* lexpr_eof -> lexpr EOF *)
    (
# 344 "src/kernel_internals/parsing/logic_parser.mly"
            ( _1 )
# 7307 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_412 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> string *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 453 "src/kernel_internals/parsing/logic_parser.mly"
         (
      let (is_wide,content) = _1 in
      let cst = if is_wide then
        WStringConstant content
      else
        StringConstant content
      in
      info _sloc (PLconstant cst)
    )
# 7327 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_413 =
  fun _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_inner -> NOT lexpr_inner *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 462 "src/kernel_internals/parsing/logic_parser.mly"
                  ( info _sloc (PLnot _2) )
# 7339 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_414 =
  fun _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> TRUE *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 463 "src/kernel_internals/parsing/logic_parser.mly"
       ( info _sloc PLtrue )
# 7351 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_415 =
  fun _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> FALSE *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 464 "src/kernel_internals/parsing/logic_parser.mly"
        ( info _sloc PLfalse )
# 7363 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_416 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> OBJECT_POINTER opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 465 "src/kernel_internals/parsing/logic_parser.mly"
                                             ( info _sloc (PLobject_pointer (_2,_4)) )
# 7375 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_417 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> VALID opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 466 "src/kernel_internals/parsing/logic_parser.mly"
                                    ( info _sloc (PLvalid (_2,_4)) )
# 7387 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_418 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> VALID_READ opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 467 "src/kernel_internals/parsing/logic_parser.mly"
                                         ( info _sloc (PLvalid_read (_2,_4)) )
# 7399 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_419 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> VALID_FUNCTION LPAR lexpr RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 468 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( info _sloc (PLvalid_function _3) )
# 7411 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_420 =
  fun _2 _4 _6 _endpos__7_ _startpos__1_ ->
    (* lexpr_inner -> VALID_INDEX opt_label_1 LPAR lexpr COMMA lexpr RPAR *)
    let _endpos = _endpos__7_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 469 "src/kernel_internals/parsing/logic_parser.mly"
                                                      (
  let source = pos _symbolstartpos in
  obsolete ~source "\\valid_index(addr,idx)" ~now:"\\valid(addr+idx)";
  info _sloc (PLvalid (_2,info _sloc (PLbinop (_4, Badd, _6)))) )
# 7426 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_421 =
  fun _2 _4 _6 _8 _endpos__9_ _startpos__1_ ->
    (* lexpr_inner -> VALID_RANGE opt_label_1 LPAR lexpr COMMA lexpr COMMA lexpr RPAR *)
    let _endpos = _endpos__9_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 473 "src/kernel_internals/parsing/logic_parser.mly"
                                                                  (
  let source = pos _symbolstartpos in
  obsolete "\\valid_range(addr,min,max)"
    ~source ~now:"\\valid(addr+(min..max))";
  info _sloc (PLvalid
          (_2,info _sloc (PLbinop (_4, Badd, (info _sloc (PLrange((Some _6),Some _8)))))))
)
# 7444 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_422 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> INITIALIZED opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 480 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( info _sloc (PLinitialized (_2,_4)) )
# 7456 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_423 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> DANGLING opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 481 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( info _sloc (PLdangling (_2,_4)) )
# 7468 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_424 =
  fun _2 _4 _6 _endpos__7_ _startpos__1_ ->
    (* lexpr_inner -> FRESH opt_label_2 LPAR lexpr COMMA lexpr RPAR *)
    let _endpos = _endpos__7_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 482 "src/kernel_internals/parsing/logic_parser.mly"
                                                ( info _sloc (PLfresh (_2,_4, _6)) )
# 7480 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_425 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> BASE_ADDR opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 483 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( info _sloc (PLbase_addr (_2,_4)) )
# 7492 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_426 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> BLOCK_LENGTH opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 484 "src/kernel_internals/parsing/logic_parser.mly"
                                           ( info _sloc (PLblock_length (_2,_4)) )
# 7504 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_427 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> OFFSET opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 485 "src/kernel_internals/parsing/logic_parser.mly"
                                     ( info _sloc (PLoffset (_2,_4)) )
# 7516 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_428 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> ALLOCABLE opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 486 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( info _sloc (PLallocable (_2,_4)) )
# 7528 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_429 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> FREEABLE opt_label_1 LPAR lexpr RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 487 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( info _sloc (PLfreeable (_2,_4)) )
# 7540 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_430 =
  fun _startpos__1_ ->
    (* lexpr_inner -> ALLOCATION opt_label_1 LPAR lexpr RPAR *)
    let _symbolstartpos = _startpos__1_ in
    (
# 489 "src/kernel_internals/parsing/logic_parser.mly"
  ( let source = pos _symbolstartpos in
    Kernel.not_yet_implemented ~source "\\allocation" )
# 7551 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_431 =
  fun _startpos__1_ ->
    (* lexpr_inner -> AUTOMATIC *)
    let _symbolstartpos = _startpos__1_ in
    (
# 491 "src/kernel_internals/parsing/logic_parser.mly"
            (
  let source = pos _symbolstartpos in
  Kernel.not_yet_implemented ~source "\\automatic" )
# 7563 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_432 =
  fun _startpos__1_ ->
    (* lexpr_inner -> DYNAMIC *)
    let _symbolstartpos = _startpos__1_ in
    (
# 494 "src/kernel_internals/parsing/logic_parser.mly"
          (
  let source = pos _symbolstartpos in
  Kernel.not_yet_implemented ~source "\\dynamic" )
# 7575 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_433 =
  fun _startpos__1_ ->
    (* lexpr_inner -> REGISTER *)
    let _symbolstartpos = _startpos__1_ in
    (
# 497 "src/kernel_internals/parsing/logic_parser.mly"
           (
  let source = pos _symbolstartpos in
  Kernel.not_yet_implemented ~source "\\register" )
# 7587 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_434 =
  fun _startpos__1_ ->
    (* lexpr_inner -> STATIC *)
    let _symbolstartpos = _startpos__1_ in
    (
# 500 "src/kernel_internals/parsing/logic_parser.mly"
         (
  let source = pos _symbolstartpos in
  Kernel.not_yet_implemented ~source "\\static" )
# 7599 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_435 =
  fun _startpos__1_ ->
    (* lexpr_inner -> UNALLOCATED *)
    let _symbolstartpos = _startpos__1_ in
    (
# 503 "src/kernel_internals/parsing/logic_parser.mly"
              (
  let source = pos _symbolstartpos in
  Kernel.not_yet_implemented ~source "\\unallocated" )
# 7611 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_436 =
  fun _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> NULL *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 506 "src/kernel_internals/parsing/logic_parser.mly"
       ( info _sloc PLnull )
# 7623 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_437 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> constant *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 507 "src/kernel_internals/parsing/logic_parser.mly"
           ( info _sloc (PLconstant _1) )
# 7635 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_438 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner PLUS lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 508 "src/kernel_internals/parsing/logic_parser.mly"
                               ( info _sloc (PLbinop (_1, Badd, _3)) )
# 7647 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_439 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner MINUS lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 509 "src/kernel_internals/parsing/logic_parser.mly"
                                ( info _sloc (PLbinop (_1, Bsub, _3)) )
# 7659 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_440 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner STAR lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 510 "src/kernel_internals/parsing/logic_parser.mly"
                               ( info _sloc (PLbinop (_1, Bmul, _3)) )
# 7671 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_441 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner SLASH lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 511 "src/kernel_internals/parsing/logic_parser.mly"
                                ( info _sloc (PLbinop (_1, Bdiv, _3)) )
# 7683 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_442 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner PERCENT lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 512 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( info _sloc (PLbinop (_1, Bmod, _3)) )
# 7695 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_443 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner STARHAT lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 513 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( info _sloc (PLrepeat (_1, _3)) )
# 7707 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_444 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner ARROW identifier_or_typename_full *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 514 "src/kernel_internals/parsing/logic_parser.mly"
                                                ( info _sloc (PLarrow (_1, _3)) )
# 7719 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_445 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner DOT identifier_or_typename_full *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 515 "src/kernel_internals/parsing/logic_parser.mly"
                                              ( info _sloc (PLdot (_1, _3)) )
# 7731 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_446 =
  fun _1 _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner LSQUARE range RSQUARE *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 516 "src/kernel_internals/parsing/logic_parser.mly"
                                    ( info _sloc (PLarrget (_1, _3)) )
# 7743 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_447 =
  fun _1 _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner LSQUARE lexpr RSQUARE *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 517 "src/kernel_internals/parsing/logic_parser.mly"
                                    ( info _sloc (PLarrget (_1, _3)) )
# 7755 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_448 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> LSQUAREPIPE lexpr_list RSQUAREPIPE *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 518 "src/kernel_internals/parsing/logic_parser.mly"
                                     ( info _sloc (PLlist _2) )
# 7767 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_449 =
  fun _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_inner -> MINUS lexpr_inner *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 519 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( info _sloc (PLunop (Uminus, _2)) )
# 7779 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_450 =
  fun _2 ->
    (* lexpr_inner -> PLUS lexpr_inner *)
    (
# 520 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( _2 )
# 7788 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_451 =
  fun _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_inner -> TILDE lexpr_inner *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 521 "src/kernel_internals/parsing/logic_parser.mly"
                    ( info _sloc (PLunop (Ubw_not, _2)) )
# 7800 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_452 =
  fun _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_inner -> STAR lexpr_inner *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 522 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( info _sloc (PLunop (Ustar, _2)) )
# 7812 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_453 =
  fun _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_inner -> AMP lexpr_inner *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 523 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( info _sloc (PLunop (Uamp, _2)) )
# 7824 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_454 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> SIZEOF LPAR lexpr RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 524 "src/kernel_internals/parsing/logic_parser.mly"
                         ( info _sloc (PLsizeofE _3) )
# 7836 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_455 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> SIZEOF LPAR cast_logic_type RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 525 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( info _sloc (PLsizeof _3) )
# 7848 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_456 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> OLD LPAR lexpr RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 526 "src/kernel_internals/parsing/logic_parser.mly"
                      ( info _sloc (PLold _3) )
# 7860 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_457 =
  fun _3 _5 _endpos__6_ _startpos__1_ ->
    (* lexpr_inner -> AT LPAR lexpr COMMA label_name RPAR *)
    let _endpos = _endpos__6_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 527 "src/kernel_internals/parsing/logic_parser.mly"
                                      ( info _sloc (PLat (_3, _5)) )
# 7872 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_458 =
  fun _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> RESULT *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 528 "src/kernel_internals/parsing/logic_parser.mly"
         ( info _sloc PLresult )
# 7884 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_459 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> SEPARATED LPAR ne_lexpr_list RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 530 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLseparated _3) )
# 7896 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_460 =
  fun _1 _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> full_identifier LPAR ne_lexpr_list RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 532 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLapp (_1, [], _3)) )
# 7908 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_461 =
  fun _1 _3 _6 _endpos__7_ _startpos__1_ ->
    (* lexpr_inner -> full_identifier LBRACE ne_label_args RBRACE LPAR ne_lexpr_list RPAR *)
    let _endpos = _endpos__7_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 534 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLapp (_1, _3, _6)) )
# 7920 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_462 =
  fun _1 _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> full_identifier LBRACE ne_label_args RBRACE *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 536 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLapp (_1, _3, [])) )
# 7932 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_463 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> full_identifier *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 537 "src/kernel_internals/parsing/logic_parser.mly"
                   ( info _sloc (PLvar _1) )
# 7944 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_464 =
  fun _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> PI *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 538 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLvar "\\pi") )
# 7956 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_465 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner GTGT lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 539 "src/kernel_internals/parsing/logic_parser.mly"
                               ( info _sloc (PLbinop (_1, Brshift, _3)))
# 7968 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_466 =
  fun _1 _3 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> lexpr_inner LTLT lexpr_inner *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 540 "src/kernel_internals/parsing/logic_parser.mly"
                               ( info _sloc (PLbinop (_1, Blshift, _3)))
# 7980 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_467 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> LPAR lexpr RPAR *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 541 "src/kernel_internals/parsing/logic_parser.mly"
                  ( info _sloc _2.lexpr_node )
# 7992 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_468 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> LPAR range RPAR *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 542 "src/kernel_internals/parsing/logic_parser.mly"
                  ( info _sloc _2.lexpr_node )
# 8004 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_469 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> LPAR cast_logic_type RPAR lexpr_inner *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 544 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLcast (_2, _4)) )
# 8016 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_470 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> TYPEOF LPAR lexpr RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 545 "src/kernel_internals/parsing/logic_parser.mly"
                         ( info _sloc (PLtypeof _3) )
# 8028 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_471 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> BSTYPE LPAR type_spec(typename) RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 546 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( info _sloc (PLtype _3) )
# 8040 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_472 =
  fun _3 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> BSTYPE LPAR type_spec(typename) stars RPAR *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 547 "src/kernel_internals/parsing/logic_parser.mly"
                                             ( info _sloc (PLtype (_4 _3)) )
# 8052 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_473 =
  fun _endpos__1_ _startpos__1_ ->
    (* lexpr_inner -> EMPTY *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 549 "src/kernel_internals/parsing/logic_parser.mly"
        ( info _sloc PLempty )
# 8064 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_474 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> BSUNION LPAR lexpr_list RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 550 "src/kernel_internals/parsing/logic_parser.mly"
                               ( info _sloc (PLunion _3) )
# 8076 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_475 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* lexpr_inner -> INTER LPAR lexpr_list RPAR *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 551 "src/kernel_internals/parsing/logic_parser.mly"
                             ( info _sloc (PLinter _3) )
# 8088 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_476 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> LBRACE lexpr_list RBRACE *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 553 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLset (_2)) )
# 8100 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_477 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> LBRACE lexpr PIPE binders RBRACE *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 555 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLcomprehension (_2,_4,None)) )
# 8112 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_478 =
  fun _2 _4 _6 _endpos__7_ _startpos__1_ ->
    (* lexpr_inner -> LBRACE lexpr PIPE binders SEMICOLON lexpr RBRACE *)
    let _endpos = _endpos__7_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 557 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLcomprehension (_2,_4,Some _6)) )
# 8124 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_479 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> LBRACE field_init RBRACE *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 560 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLinitField(_2)) )
# 8136 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_480 =
  fun _2 _endpos__3_ _startpos__1_ ->
    (* lexpr_inner -> LBRACE array_init RBRACE *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 562 "src/kernel_internals/parsing/logic_parser.mly"
      ( info _sloc (PLinitIndex(_2)) )
# 8148 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_481 =
  fun _2 _4 _endpos__5_ _startpos__1_ ->
    (* lexpr_inner -> LBRACE lexpr WITH update RBRACE *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 564 "src/kernel_internals/parsing/logic_parser.mly"
      ( List.fold_left
	  (fun a (path,upd_val) -> info _sloc (PLupdate(a,path,upd_val))) _2 _4 )
# 8161 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_482 =
  fun () ->
    (* lexpr_list -> *)
    (
# 334 "src/kernel_internals/parsing/logic_parser.mly"
                ( [] )
# 8170 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_483 =
  fun _1 ->
    (* lexpr_list -> ne_lexpr_list *)
    (
# 335 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 8179 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_484 =
  fun () ->
    (* lexpr_option -> *)
    (
# 348 "src/kernel_internals/parsing/logic_parser.mly"
                ( None )
# 8188 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr option))

let _menhir_action_485 =
  fun _1 ->
    (* lexpr_option -> lexpr *)
    (
# 349 "src/kernel_internals/parsing/logic_parser.mly"
                ( Some _1 )
# 8197 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr option))

let _menhir_action_486 =
  fun _1 ->
    (* lexpr_rel -> lexpr_end_rel *)
    (
# 383 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 8206 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_487 =
  fun _1 _2 _endpos__2_ _startpos__1_ ->
    (* lexpr_rel -> lexpr_inner rel_list *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 385 "src/kernel_internals/parsing/logic_parser.mly"
      ( let rel, rhs, _, oth_rel = _2 in
        let loc = loc_start _1, loc_end rhs in
        let relation = loc_info loc (PLrel(_1,rel,rhs)) in
        match oth_rel with
            None -> relation
          | Some oth_relation -> info _sloc (pland relation oth_relation)
      )
# 8224 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_488 =
  fun _1 ->
    (* logic_decl -> logic_def *)
    (
# 1730 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 8233 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_489 =
  fun _2 _3 _4 _5 ->
    (* logic_decl -> LOGIC logic_rt_type poly_id opt_parameters reads_clause SEMICOLON *)
    (
# 1733 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id, labels, tvars) = _3 in
      exit_type_variables_scope ();
      LDlogic_reads (id, labels, tvars, _2, _4, _5) )
# 8244 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_490 =
  fun _2 _3 _4 ->
    (* logic_decl -> PREDICATE poly_id opt_parameters reads_clause SEMICOLON *)
    (
# 1738 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      LDpredicate_reads (id, labels, tvars, _3, _4) )
# 8255 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_491 =
  fun _2 ->
    (* logic_decl -> TYPE poly_id_type SEMICOLON *)
    (
# 1743 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,tvars) = _2 in
      Logic_env.add_typename id;
      exit_type_variables_scope ();
      LDtype(id,tvars,None) )
# 8267 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_492 =
  fun _2 _4 ->
    (* logic_decl -> AXIOM poly_id COLON lexpr SEMICOLON *)
    (
# 1749 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      LDlemma (id, labels, tvars, toplevel_pred Admit _4) )
# 8278 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_493 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* logic_decl_loc -> logic_decl *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1755 "src/kernel_internals/parsing/logic_parser.mly"
             ( loc_decl _sloc _1 )
# 8290 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl))

let _menhir_action_494 =
  fun () ->
    (* logic_decls -> *)
    (
# 1724 "src/kernel_internals/parsing/logic_parser.mly"
    ( [] )
# 8299 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl list))

let _menhir_action_495 =
  fun _1 _2 ->
    (* logic_decls -> logic_decl_loc logic_decls *)
    (
# 1726 "src/kernel_internals/parsing/logic_parser.mly"
    ( _1::_2 )
# 8308 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl list))

let _menhir_action_496 =
  fun _2 _3 _4 _6 ->
    (* logic_def -> LOGIC logic_rt_type poly_id opt_parameters EQUAL lexpr SEMICOLON *)
    (
# 1653 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id, labels, tvars) = _3 in
      exit_type_variables_scope ();
      LDlogic_def (id, labels, tvars, _2, _4, _6) )
# 8319 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_497 =
  fun _2 _3 _5 ->
    (* logic_def -> PREDICATE poly_id opt_parameters EQUAL lexpr SEMICOLON *)
    (
# 1658 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      LDpredicate_def (id, labels, tvars, _3, _5) )
# 8330 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_498 =
  fun cases params pred ->
    (* logic_def -> INDUCTIVE poly_id parameters midrule(__anonymous_0) LBRACE indcases RBRACE *)
    (
# 1665 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = pred in
      LDinductive_def(id, labels, tvars, params, cases) )
# 8340 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_499 =
  fun _2 _4 ->
    (* logic_def -> LEMMA poly_id COLON lexpr SEMICOLON *)
    (
# 1668 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      LDlemma (id, labels, tvars, toplevel_pred Assert _4) )
# 8351 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_500 =
  fun _2 _4 ->
    (* logic_def -> CHECK_LEMMA poly_id COLON lexpr SEMICOLON *)
    (
# 1672 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      LDlemma (id, labels, tvars, toplevel_pred Check _4) )
# 8362 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_501 =
  fun _2 _4 ->
    (* logic_def -> ADMIT_LEMMA poly_id COLON lexpr SEMICOLON *)
    (
# 1676 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (id,labels,tvars) = _2 in
      exit_type_variables_scope ();
      LDlemma (id, labels, tvars, toplevel_pred Admit _4) )
# 8373 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_502 =
  fun _2 _4 ->
    (* logic_def -> AXIOMATIC any_identifier LBRACE logic_decls RBRACE *)
    (
# 1680 "src/kernel_internals/parsing/logic_parser.mly"
    ( LDaxiomatic(_2,_4) )
# 8382 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_503 =
  fun _2 _4 ->
    (* logic_def -> TYPE poly_id_type_add_typename EQUAL typedef SEMICOLON *)
    (
# 1682 "src/kernel_internals/parsing/logic_parser.mly"
        ( let (id,tvars) = _2 in
          exit_type_variables_scope ();
          LDtype(id,tvars,Some _4)
        )
# 8394 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.decl_node))

let _menhir_action_504 =
  fun _1 ->
    (* logic_rt_type -> logic_type_gen(identifier_or_typename) *)
    (
# 758 "src/kernel_internals/parsing/logic_parser.mly"
                                         ( _1 )
# 8403 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_505 =
  fun _1 ->
    (* logic_type -> logic_type_gen(typename) *)
    (
# 737 "src/kernel_internals/parsing/logic_parser.mly"
                                     ( _1 )
# 8412 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_506 =
  fun _1 _2 ->
    (* logic_type_gen(TYPENAME) -> type_spec(TYPENAME) abs_spec_option *)
    (
# 729 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( _2 _1 )
# 8421 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_507 =
  fun _1 _2 ->
    (* logic_type_gen(identifier_or_typename) -> type_spec(identifier_or_typename) abs_spec_option *)
    (
# 729 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( _2 _1 )
# 8430 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_508 =
  fun _1 _2 ->
    (* logic_type_gen(typename) -> type_spec(typename) abs_spec_option *)
    (
# 729 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( _2 _1 )
# 8439 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_509 =
  fun _2 ->
    (* loop_allocation -> LOOP allocation SEMICOLON *)
    (
# 1413 "src/kernel_internals/parsing/logic_parser.mly"
                            ( _2 )
# 8448 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation))

let _menhir_action_510 =
  fun () ->
    (* loop_annot_opt -> *)
    (
# 1403 "src/kernel_internals/parsing/logic_parser.mly"
    ( ([], FreeAllocAny, WritesAny, [], [], [], []) )
# 8457 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_511 =
  fun _1 ->
    (* loop_annot_opt -> loop_annot_stack *)
    (
# 1405 "src/kernel_internals/parsing/logic_parser.mly"
    ( _1 )
# 8469 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_512 =
  fun _1 _2 ->
    (* loop_annot_stack -> loop_invariant loop_annot_opt *)
    (
# 1355 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (i,fa,a,b,v,p,e) = _2 in (_1::i,fa,a,b,v,p,e) )
# 8481 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_513 =
  fun _1 _2 _endpos__2_ _startpos__1_ ->
    (* loop_annot_stack -> loop_effects loop_annot_opt *)
    let _endpos = _endpos__2_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1357 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (i,fa,a,b,v,p,e) = _2 in (i,fa,concat_assigns _sloc a _1,b,v,p,e) )
# 8496 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_514 =
  fun _1 _2 ->
    (* loop_annot_stack -> loop_allocation loop_annot_opt *)
    (
# 1359 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (i,fa,a,b,v,p,e) = _2 in (i,concat_allocation fa _1,a,b,v,p,e) )
# 8508 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_515 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    (* loop_annot_stack -> FOR ne_behavior_name_list COLON loop_annot_stack *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1361 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (i,fa,a,b,v,p,e) = _4 in
      let behav = _2 in
      let invs = List.map (fun i -> AInvariant(behav,true,i)) i in
      let ext = List.map (fun x -> AExtended(behav,true,x)) e in
      let oth = concat_loop_assigns_allocation _sloc b behav a fa in
      ([],FreeAllocAny,WritesAny,invs@ext@oth,v,p,[])
    )
# 8529 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_516 =
  fun _1 _2 ->
    (* loop_annot_stack -> loop_variant loop_annot_opt *)
    (
# 1369 "src/kernel_internals/parsing/logic_parser.mly"
    ( let pos,loop_variant = _1 in
      let (i,fa,a,b,v,p,e) = _2 in
      check_empty
        (pos,"loop invariant is not allowed after loop variant.") i ;
      check_empty
        (pos, "loop extension is not allowed after loop variant.") e;
      (match fa with
        | FreeAlloc(f,a) ->
	    check_empty
              (pos,"loop frees is not allowed after loop variant.") f ;
	    check_empty
              (pos,"loop allocates is not allowed after loop variant.") a
        | FreeAllocAny -> ());
      (match a with
          WritesAny -> ()
        | Writes _ ->
          raise
            (Not_well_formed
               (pos,"loop assigns is not allowed after loop variant.")));
      check_empty
        (pos,"loop behavior is not allowed after loop variant.") b ;
      check_empty
        (pos,"loop annotations can have at most one variant.") v ;
      (i,fa,a,b,AVariant loop_variant::v,p,e) )
# 8564 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_517 =
  fun _1 _2 ->
    (* loop_annot_stack -> loop_pragma loop_annot_opt *)
    (
# 1394 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (i,fa,a,b,v,p,e) = _2 in (i,fa,a,b,v,APragma (Loop_pragma _1)::p,e) )
# 8576 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_518 =
  fun _1 _2 ->
    (* loop_annot_stack -> loop_grammar_extension loop_annot_opt *)
    (
# 1395 "src/kernel_internals/parsing/logic_parser.mly"
                                        (
    let (i,fa,a,b,v,p,e) = _2 in
    (i,fa,a,b,v,p, _1::e)
  )
# 8591 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list * Logic_ptree.allocation *
  Logic_ptree.assigns * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.extension list))

let _menhir_action_519 =
  fun _1 ->
    (* loop_annotations -> loop_annot_stack *)
    (
# 1334 "src/kernel_internals/parsing/logic_parser.mly"
    ( let (i,fa,a,b,v,p, e) = _1 in
      let invs = List.map (fun i -> AInvariant([],true,i)) i in
      let ext = List.map (fun x -> AExtended([],true, x)) e in
      let oth = match a with
        | WritesAny -> b
        | Writes _ ->
            (* by definition all existing AAssigns are tied to at least
               one behavior. No need to merge against them. *)
            AAssigns ([],a)::b
      in
      let oth = match fa with
        | FreeAllocAny -> oth
        | _ -> AAllocation ([],fa)::oth
      in
	(invs@oth@ext,v,p)
    )
# 8618 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.code_annot list * Logic_ptree.code_annot list *
  Logic_ptree.code_annot list))

let _menhir_action_520 =
  fun _3 ->
    (* loop_effects -> LOOP ASSIGNS assigns SEMICOLON *)
    (
# 1409 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( _3 )
# 8628 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.lexpr * Logic_ptree.deps) list))

let _menhir_action_521 =
  fun _2 _3 _endpos__2_ _startpos__2_ ->
    (* loop_grammar_extension -> LOOP EXT_CODE_ANNOT extension_content SEMICOLON *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1428 "src/kernel_internals/parsing/logic_parser.mly"
                                                  (
  let open Cil_types in
  let ext = _2 in
  try
    begin match Logic_env.extension_category ext with
      | Ext_code_annot (Ext_next_loop | Ext_next_both) ->
        let processed = Logic_env.preprocess_extension ext _3 in
        (ext, processed)
      | Ext_code_annot (Ext_here | Ext_next_stmt) ->
        raise
          (Not_well_formed
            (loc _loc__2_, ext ^ " is not a loop annotation extension"))
      | _ -> raise Not_found
    end
  with Not_found ->
    Kernel.fatal ~source:(pos _startpos__2_)
      "%s is not a code annotation extension. Parser got wrong lexeme." ext
)
# 8655 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.extension))

let _menhir_action_522 =
  fun _3 ->
    (* loop_invariant -> LOOP INVARIANT lexpr SEMICOLON *)
    (
# 1417 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( toplevel_pred Assert _3 )
# 8664 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate))

let _menhir_action_523 =
  fun _3 ->
    (* loop_invariant -> CHECK_LOOP INVARIANT lexpr SEMICOLON *)
    (
# 1418 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( toplevel_pred Check _3 )
# 8673 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate))

let _menhir_action_524 =
  fun _3 ->
    (* loop_invariant -> ADMIT_LOOP INVARIANT lexpr SEMICOLON *)
    (
# 1419 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( toplevel_pred Admit _3 )
# 8682 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate))

let _menhir_action_525 =
  fun _3 _4 _endpos__5_ _startpos__1_ ->
    (* loop_pragma -> LOOP PRAGMA any_identifier ne_lexpr_list SEMICOLON *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1450 "src/kernel_internals/parsing/logic_parser.mly"
  ( if _3 = "UNROLL_LOOP" || _3 = "UNROLL" then
      (if _3 <> "UNROLL" then
	 Format.eprintf "Warning: use of deprecated keyword '%s'.\nShould use 'UNROLL' instead.@." _3;
       Unroll_specs _4)
    else if _3 = "WIDEN_VARIABLES" then
      Widen_variables _4
    else if _3 = "WIDEN_HINTS" then
      Widen_hints _4
    else raise (Not_well_formed (loc _sloc,"Unknown loop pragma")) )
# 8702 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.loop_pragma))

let _menhir_action_526 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* loop_variant -> LOOP VARIANT variant SEMICOLON *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1423 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( loc _sloc,_3 )
# 8714 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.location * Logic_ptree.variant))

let _menhir_action_527 =
  fun () ->
    (* midrule(__anonymous_0) -> *)
    let x = 
# 1663 "src/kernel_internals/parsing/logic_parser.mly"
            (exit_type_variables_scope())
# 8723 "src/kernel_internals/parsing/logic_parser.ml"
     in
    (
# 94 "<standard.mly>"
    ( x )
# 8728 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_528 =
  fun _2 _4 ->
    (* model_annot -> MODEL type_spec(typename) LBRACE parameter opt_semicolon RBRACE SEMICOLON *)
    (
# 1614 "src/kernel_internals/parsing/logic_parser.mly"
  ( let typ,name = _4 in
    { model_for_type = _2; model_name = name; model_type = typ; }
  )
# 8739 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.model_annot))

let _menhir_action_529 =
  fun _1 ->
    (* ne_behavior_name_list -> behavior_name *)
    (
# 1839 "src/kernel_internals/parsing/logic_parser.mly"
                                            ( [_1] )
# 8748 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_530 =
  fun _1 _3 ->
    (* ne_behavior_name_list -> behavior_name COMMA ne_behavior_name_list *)
    (
# 1840 "src/kernel_internals/parsing/logic_parser.mly"
                                            (_1 :: _3)
# 8757 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_531 =
  fun _2 _4 _5 ->
    (* ne_behaviors -> BEHAVIOR behavior_name COLON behavior_body behaviors *)
    (
# 1238 "src/kernel_internals/parsing/logic_parser.mly"
      ( let (assumes,requires,(allocation,assigns,post_cond,extended)) = _4 in
        let behaviors = _5 in
        let b =
          Cabshelper.mk_behavior
            ~name:_2
            ~assumes ~requires ~post_cond ~assigns ~allocation ~extended ()
        in b::behaviors
      )
# 8773 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.behavior list))

let _menhir_action_532 =
  fun _3 _5 ->
    (* ne_complete_or_disjoint -> COMPLETE BEHAVIORS behavior_name_list SEMICOLON complete_or_disjoint *)
    (
# 1271 "src/kernel_internals/parsing/logic_parser.mly"
      ( let complete,disjoint = _5 in _3::complete, disjoint )
# 8782 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list list * string list list))

let _menhir_action_533 =
  fun _3 _5 ->
    (* ne_complete_or_disjoint -> DISJOINT BEHAVIORS behavior_name_list SEMICOLON complete_or_disjoint *)
    (
# 1274 "src/kernel_internals/parsing/logic_parser.mly"
      ( let complete,disjoint = _5 in complete,_3::disjoint )
# 8791 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list list * string list list))

let _menhir_action_534 =
  fun _4 _endpos__3_ _startpos__3_ ->
    (* ne_complete_or_disjoint -> COMPLETE BEHAVIORS ne_behavior_name_list clause_kw *)
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 1278 "src/kernel_internals/parsing/logic_parser.mly"
                                                     ( missing _loc__3_ ";" _4 )
# 8801 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list list * string list list))

let _menhir_action_535 =
  fun _4 _endpos__3_ _startpos__3_ ->
    (* ne_complete_or_disjoint -> DISJOINT BEHAVIORS ne_behavior_name_list clause_kw *)
    let _loc__3_ = (_startpos__3_, _endpos__3_) in
    (
# 1279 "src/kernel_internals/parsing/logic_parser.mly"
                                                     ( missing _loc__3_ ";" _4 )
# 8811 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list list * string list list))

let _menhir_action_536 =
  fun _1 _2 ->
    (* ne_datacons_list -> datacons datacons_list *)
    (
# 1775 "src/kernel_internals/parsing/logic_parser.mly"
                         ( _1 :: _2 )
# 8820 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.logic_type list) list))

let _menhir_action_537 =
  fun _2 _3 ->
    (* ne_datacons_list -> PIPE datacons datacons_list *)
    (
# 1776 "src/kernel_internals/parsing/logic_parser.mly"
                              ( _2 :: _3 )
# 8829 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * Logic_ptree.logic_type list) list))

let _menhir_action_538 =
  fun _2 ->
    (* ne_decreases -> DECREASES variant SEMICOLON *)
    (
# 1173 "src/kernel_internals/parsing/logic_parser.mly"
                              ( _2 )
# 8838 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.variant))

let _menhir_action_539 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_decreases -> DECREASES variant clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1174 "src/kernel_internals/parsing/logic_parser.mly"
                              ( missing _loc__2_ ";" _3 )
# 8848 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.variant))

let _menhir_action_540 =
  fun _1 ->
    (* ne_grammar_extension -> zones *)
    (
# 1219 "src/kernel_internals/parsing/logic_parser.mly"
        ( _1 )
# 8857 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_541 =
  fun _1 ->
    (* ne_label_args -> identifier_or_typename_full *)
    (
# 571 "src/kernel_internals/parsing/logic_parser.mly"
                              ( [ _1 ] )
# 8866 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_542 =
  fun _1 _3 ->
    (* ne_label_args -> identifier_or_typename_full COMMA ne_label_args *)
    (
# 572 "src/kernel_internals/parsing/logic_parser.mly"
                                                  ( _1 :: _3 )
# 8875 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_543 =
  fun _1 ->
    (* ne_label_list -> label_name *)
    (
# 1804 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( [_1] )
# 8884 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_544 =
  fun _1 _3 ->
    (* ne_label_list -> label_name COMMA ne_label_list *)
    (
# 1805 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( _1 :: _3 )
# 8893 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_545 =
  fun _1 ->
    (* ne_lexpr_list -> lexpr *)
    (
# 339 "src/kernel_internals/parsing/logic_parser.mly"
                           ( [_1] )
# 8902 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_546 =
  fun _1 _3 ->
    (* ne_lexpr_list -> lexpr COMMA ne_lexpr_list *)
    (
# 340 "src/kernel_internals/parsing/logic_parser.mly"
                            ( _1 :: _3 )
# 8911 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_547 =
  fun l ->
    (* ne_logic_type_list(TYPENAME) -> separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) *)
    (
# 872 "src/kernel_internals/parsing/logic_parser.mly"
                                                           ( l )
# 8920 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_548 =
  fun l ->
    (* ne_logic_type_list(identifier_or_typename) -> separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) *)
    (
# 872 "src/kernel_internals/parsing/logic_parser.mly"
                                                           ( l )
# 8929 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_549 =
  fun l ->
    (* ne_logic_type_list(typename) -> separated_nonempty_list(COMMA,logic_type_gen(typename)) *)
    (
# 872 "src/kernel_internals/parsing/logic_parser.mly"
                                                           ( l )
# 8938 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_550 =
  fun _1 ->
    (* ne_parameters -> parameter *)
    (
# 716 "src/kernel_internals/parsing/logic_parser.mly"
            ( [_1] )
# 8947 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type * string) list))

let _menhir_action_551 =
  fun _1 _3 ->
    (* ne_parameters -> parameter COMMA ne_parameters *)
    (
# 717 "src/kernel_internals/parsing/logic_parser.mly"
                                ( _1 :: _3 )
# 8956 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type * string) list))

let _menhir_action_552 =
  fun _2 _4 ->
    (* ne_requires -> REQUIRES lexpr SEMICOLON requires *)
    (
# 1149 "src/kernel_internals/parsing/logic_parser.mly"
                                    ( toplevel_pred Assert _2::_4 )
# 8965 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_553 =
  fun _2 _4 ->
    (* ne_requires -> CHECK_REQUIRES lexpr SEMICOLON requires *)
    (
# 1150 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( toplevel_pred Check _2 :: _4 )
# 8974 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_554 =
  fun _2 _4 ->
    (* ne_requires -> ADMIT_REQUIRES lexpr SEMICOLON requires *)
    (
# 1151 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( toplevel_pred Admit _2 :: _4 )
# 8983 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_555 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_requires -> REQUIRES lexpr clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1152 "src/kernel_internals/parsing/logic_parser.mly"
                           ( missing _loc__2_ ";" _3 )
# 8993 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_556 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_requires -> CHECK_REQUIRES lexpr clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1153 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( missing _loc__2_ ";" _3 )
# 9003 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_557 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_requires -> ADMIT_REQUIRES lexpr clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1154 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( missing _loc__2_ ";" _3 )
# 9013 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_558 =
  fun _1 _2 _4 ->
    (* ne_simple_clauses -> post_cond_kind lexpr SEMICOLON simple_clauses *)
    (
# 1193 "src/kernel_internals/parsing/logic_parser.mly"
    ( let tp_kind, kind = _1 in
      let allocation,assigns,post_cond,extended = _4 in
      allocation,assigns,
      ((kind,toplevel_pred tp_kind _2)::post_cond),extended )
# 9025 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_559 =
  fun _1 _3 ->
    (* ne_simple_clauses -> allocation SEMICOLON simple_clauses *)
    (
# 1198 "src/kernel_internals/parsing/logic_parser.mly"
    ( let allocation,assigns,post_cond,extended = _3 in
      let a = concat_allocation allocation _1 in
      a,assigns,post_cond,extended
    )
# 9039 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_560 =
  fun _2 _4 _endpos__4_ _startpos__1_ ->
    (* ne_simple_clauses -> ASSIGNS assigns SEMICOLON simple_clauses *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1203 "src/kernel_internals/parsing/logic_parser.mly"
    ( let allocation,assigns,post_cond,extended = _4 in
      let a = concat_assigns _sloc assigns _2
      in allocation,a,post_cond,extended
    )
# 9056 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_561 =
  fun _1 _2 _4 ->
    (* ne_simple_clauses -> EXT_CONTRACT extension_content SEMICOLON simple_clauses *)
    (
# 1208 "src/kernel_internals/parsing/logic_parser.mly"
    ( let allocation,assigns,post_cond,extended = _4 in
      let processed = Logic_env.preprocess_extension _1 _2 in
      allocation,assigns,post_cond,(_1,processed)::extended
    )
# 9070 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_562 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_simple_clauses -> post_cond_kind lexpr clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1212 "src/kernel_internals/parsing/logic_parser.mly"
                                 ( missing _loc__2_ ";" _3 )
# 9082 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_563 =
  fun _2 _endpos__1_ _startpos__1_ ->
    (* ne_simple_clauses -> allocation clause_kw *)
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 1213 "src/kernel_internals/parsing/logic_parser.mly"
                       ( missing _loc__1_ ";" _2 )
# 9094 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_564 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_simple_clauses -> ASSIGNS assigns clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1214 "src/kernel_internals/parsing/logic_parser.mly"
                            ( missing _loc__2_ ";" _3 )
# 9106 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_565 =
  fun _3 _endpos__1_ _startpos__1_ ->
    (* ne_simple_clauses -> EXT_CONTRACT ne_grammar_extension clause_kw *)
    let _loc__1_ = (_startpos__1_, _endpos__1_) in
    (
# 1215 "src/kernel_internals/parsing/logic_parser.mly"
                                              ( missing _loc__1_ ";" _3 )
# 9118 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_566 =
  fun _2 ->
    (* ne_terminates -> TERMINATES lexpr SEMICOLON *)
    (
# 1163 "src/kernel_internals/parsing/logic_parser.mly"
                             ( _2 )
# 9129 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_567 =
  fun _3 _endpos__2_ _startpos__2_ ->
    (* ne_terminates -> TERMINATES lexpr clause_kw *)
    let _loc__2_ = (_startpos__2_, _endpos__2_) in
    (
# 1164 "src/kernel_internals/parsing/logic_parser.mly"
                             ( missing _loc__2_ ";" _3 )
# 9139 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_568 =
  fun _1 ->
    (* ne_tvar_list -> full_identifier *)
    (
# 1799 "src/kernel_internals/parsing/logic_parser.mly"
                                     ( [_1] )
# 9148 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_569 =
  fun _1 _3 ->
    (* ne_tvar_list -> full_identifier COMMA ne_tvar_list *)
    (
# 1800 "src/kernel_internals/parsing/logic_parser.mly"
                                     ( _1 :: _3 )
# 9157 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_570 =
  fun _1 ->
    (* ne_type_list -> logic_type *)
    (
# 1785 "src/kernel_internals/parsing/logic_parser.mly"
             ( [_1] )
# 9166 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_571 =
  fun _1 _3 ->
    (* ne_type_list -> logic_type COMMA ne_type_list *)
    (
# 1786 "src/kernel_internals/parsing/logic_parser.mly"
                                ( _1::_3 )
# 9175 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_572 =
  fun _1 ->
    (* ne_zones -> ne_lexpr_list *)
    (
# 1295 "src/kernel_internals/parsing/logic_parser.mly"
                ( _1 )
# 9184 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_573 =
  fun _1 ->
    (* non_logic_keyword -> c_keyword *)
    (
# 1999 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 9193 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_574 =
  fun _1 ->
    (* non_logic_keyword -> acsl_c_keyword *)
    (
# 2000 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 9202 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_575 =
  fun _1 ->
    (* non_logic_keyword -> is_ext_spec *)
    (
# 2001 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 9211 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_576 =
  fun _1 ->
    (* non_logic_keyword -> is_acsl_spec *)
    (
# 2002 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 9220 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_577 =
  fun _1 ->
    (* non_logic_keyword -> is_acsl_decl_or_code_annot *)
    (
# 2003 "src/kernel_internals/parsing/logic_parser.mly"
                             ( _1 )
# 9229 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_578 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* opt_label_1 -> opt_label_list *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = if _startpos__1_ != _endpos__1_ then
      _startpos__1_
    else
      _endpos in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1809 "src/kernel_internals/parsing/logic_parser.mly"
                 ( match _1 with
		     | [] -> None
		     | l::[] -> Some l
		     | _ -> raise (Not_well_formed (loc _sloc,"Only one label is allowed")) )
# 9247 "src/kernel_internals/parsing/logic_parser.ml"
     : (string option))

let _menhir_action_579 =
  fun _1 _endpos__1_ _startpos__1_ ->
    (* opt_label_2 -> opt_label_list *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = if _startpos__1_ != _endpos__1_ then
      _startpos__1_
    else
      _endpos in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1816 "src/kernel_internals/parsing/logic_parser.mly"
                 ( match _1 with
		     | [] -> None
		     | l1::l2::[] -> Some (l1,l2)
		     | _::[] -> raise (Not_well_formed (loc _sloc,"One label is missing"))
		     | _ -> raise (Not_well_formed (loc _sloc,"Only two labels are allowed")) )
# 9266 "src/kernel_internals/parsing/logic_parser.ml"
     : ((string * string) option))

let _menhir_action_580 =
  fun () ->
    (* opt_label_list -> *)
    (
# 1824 "src/kernel_internals/parsing/logic_parser.mly"
                              ( [] )
# 9275 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_581 =
  fun _2 ->
    (* opt_label_list -> LBRACE ne_label_list RBRACE *)
    (
# 1825 "src/kernel_internals/parsing/logic_parser.mly"
                              ( _2 )
# 9284 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_582 =
  fun () ->
    (* opt_parameters -> *)
    (
# 1642 "src/kernel_internals/parsing/logic_parser.mly"
              ( [] )
# 9293 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type * string) list))

let _menhir_action_583 =
  fun _1 ->
    (* opt_parameters -> parameters *)
    (
# 1643 "src/kernel_internals/parsing/logic_parser.mly"
             ( _1 )
# 9302 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type * string) list))

let _menhir_action_584 =
  fun () ->
    (* opt_semicolon -> *)
    (
# 1608 "src/kernel_internals/parsing/logic_parser.mly"
                ( )
# 9311 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_585 =
  fun () ->
    (* opt_semicolon -> SEMICOLON *)
    (
# 1609 "src/kernel_internals/parsing/logic_parser.mly"
            ( )
# 9320 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_586 =
  fun _1 _2 ->
    (* parameter -> type_spec(identifier_or_typename) var_spec *)
    (
# 722 "src/kernel_internals/parsing/logic_parser.mly"
  ( let (modif, name) = _2 in (modif _1, name))
# 9329 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type * string))

let _menhir_action_587 =
  fun _2 ->
    (* parameters -> LPAR ne_parameters RPAR *)
    (
# 1647 "src/kernel_internals/parsing/logic_parser.mly"
                          ( _2 )
# 9338 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type * string) list))

let _menhir_action_588 =
  fun _1 ->
    (* path -> path_elt *)
    (
# 627 "src/kernel_internals/parsing/logic_parser.mly"
                ( [_1] )
# 9347 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.path_elt list))

let _menhir_action_589 =
  fun _1 _2 ->
    (* path -> path_elt path *)
    (
# 628 "src/kernel_internals/parsing/logic_parser.mly"
                ( _1::_2 )
# 9356 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.path_elt list))

let _menhir_action_590 =
  fun _1 ->
    (* path_elt -> field_path_elt *)
    (
# 632 "src/kernel_internals/parsing/logic_parser.mly"
                 ( PLpathField _1 )
# 9365 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.path_elt))

let _menhir_action_591 =
  fun _1 ->
    (* path_elt -> array_path_elt *)
    (
# 633 "src/kernel_internals/parsing/logic_parser.mly"
                 ( PLpathIndex _1 )
# 9374 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.path_elt))

let _menhir_action_592 =
  fun _1 ->
    (* poly_id -> poly_id_type *)
    (
# 1634 "src/kernel_internals/parsing/logic_parser.mly"
               ( let (id,tvar) = _1 in (id,[],tvar) )
# 9383 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * string list * string list))

let _menhir_action_593 =
  fun _1 _3 ->
    (* poly_id -> full_identifier LBRACE ne_label_list RBRACE *)
    (
# 1636 "src/kernel_internals/parsing/logic_parser.mly"
      ( enter_type_variables_scope []; (_1,_3,[]) )
# 9392 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * string list * string list))

let _menhir_action_594 =
  fun _1 _3 _6 ->
    (* poly_id -> full_identifier LBRACE ne_label_list RBRACE LT ne_tvar_list GT *)
    (
# 1638 "src/kernel_internals/parsing/logic_parser.mly"
      ( enter_type_variables_scope _6; _1,_3,_6 )
# 9401 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * string list * string list))

let _menhir_action_595 =
  fun _1 ->
    (* poly_id_type -> full_identifier *)
    (
# 1621 "src/kernel_internals/parsing/logic_parser.mly"
    ( enter_type_variables_scope []; (_1,[]) )
# 9410 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * string list))

let _menhir_action_596 =
  fun _1 _3 ->
    (* poly_id_type -> full_identifier LT ne_tvar_list GT *)
    (
# 1623 "src/kernel_internals/parsing/logic_parser.mly"
        ( enter_type_variables_scope _3; (_1,_3) )
# 9419 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * string list))

let _menhir_action_597 =
  fun _1 ->
    (* poly_id_type_add_typename -> poly_id_type *)
    (
# 1630 "src/kernel_internals/parsing/logic_parser.mly"
               ( let (id,_) = _1 in Logic_env.add_typename id; _1 )
# 9428 "src/kernel_internals/parsing/logic_parser.ml"
     : (string * string list))

let _menhir_action_598 =
  fun () ->
    (* post_cond -> ENSURES *)
    (
# 1916 "src/kernel_internals/parsing/logic_parser.mly"
          ( (Assert,Normal), "ensures" )
# 9437 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_599 =
  fun () ->
    (* post_cond -> EXITS *)
    (
# 1917 "src/kernel_internals/parsing/logic_parser.mly"
          ( (Assert,Exits), "exits" )
# 9446 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_600 =
  fun () ->
    (* post_cond -> BREAKS *)
    (
# 1918 "src/kernel_internals/parsing/logic_parser.mly"
          ( (Assert,Breaks), "breaks" )
# 9455 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_601 =
  fun () ->
    (* post_cond -> CONTINUES *)
    (
# 1919 "src/kernel_internals/parsing/logic_parser.mly"
            ( (Assert,Continues), "continues" )
# 9464 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_602 =
  fun () ->
    (* post_cond -> RETURNS *)
    (
# 1920 "src/kernel_internals/parsing/logic_parser.mly"
          ( (Assert,Returns), "returns" )
# 9473 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_603 =
  fun () ->
    (* post_cond -> CHECK_ENSURES *)
    (
# 1921 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Check,Normal), "check ensures" )
# 9482 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_604 =
  fun () ->
    (* post_cond -> CHECK_EXITS *)
    (
# 1922 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Check,Exits), "check exits" )
# 9491 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_605 =
  fun () ->
    (* post_cond -> CHECK_BREAKS *)
    (
# 1923 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Check,Breaks), "check breaks" )
# 9500 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_606 =
  fun () ->
    (* post_cond -> CHECK_CONTINUES *)
    (
# 1924 "src/kernel_internals/parsing/logic_parser.mly"
                  ( (Check,Continues), "check continues" )
# 9509 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_607 =
  fun () ->
    (* post_cond -> CHECK_RETURNS *)
    (
# 1925 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Check,Returns), "check returns" )
# 9518 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_608 =
  fun () ->
    (* post_cond -> ADMIT_ENSURES *)
    (
# 1926 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Admit,Normal), "admit ensures" )
# 9527 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_609 =
  fun () ->
    (* post_cond -> ADMIT_EXITS *)
    (
# 1927 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Admit,Exits), "admit exits" )
# 9536 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_610 =
  fun () ->
    (* post_cond -> ADMIT_BREAKS *)
    (
# 1928 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Admit,Breaks), "admit breaks" )
# 9545 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_611 =
  fun () ->
    (* post_cond -> ADMIT_CONTINUES *)
    (
# 1929 "src/kernel_internals/parsing/logic_parser.mly"
                  ( (Admit,Continues), "admit continues" )
# 9554 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_612 =
  fun () ->
    (* post_cond -> ADMIT_RETURNS *)
    (
# 1930 "src/kernel_internals/parsing/logic_parser.mly"
                ( (Admit,Returns), "admit returns" )
# 9563 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Cil_types.predicate_kind * Cil_types.termination_kind) * string))

let _menhir_action_613 =
  fun _1 ->
    (* post_cond_kind -> post_cond *)
    (
# 1229 "src/kernel_internals/parsing/logic_parser.mly"
            ( fst _1 )
# 9572 "src/kernel_internals/parsing/logic_parser.ml"
     : (Cil_types.predicate_kind * Cil_types.termination_kind))

let _menhir_action_614 =
  fun _1 ->
    (* pragma_or_code_annotation -> slice_pragma *)
    (
# 1479 "src/kernel_internals/parsing/logic_parser.mly"
                   ( APragma (Slice_pragma _1) )
# 9581 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.code_annot))

let _menhir_action_615 =
  fun _1 ->
    (* pragma_or_code_annotation -> impact_pragma *)
    (
# 1480 "src/kernel_internals/parsing/logic_parser.mly"
                   ( APragma (Impact_pragma _1) )
# 9590 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.code_annot))

let _menhir_action_616 =
  fun _1 ->
    (* pragma_or_code_annotation -> code_annotation *)
    (
# 1481 "src/kernel_internals/parsing/logic_parser.mly"
                   ( _1 []  )
# 9599 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.code_annot))

let _menhir_action_617 =
  fun _1 _3 _endpos__1_ _endpos__3_ _startpos__1_ _startpos__2_ ->
    (* range -> lexpr_option DOTDOT lexpr_option *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = if _startpos__1_ != _endpos__1_ then
      _startpos__1_
    else
      _startpos__2_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 584 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( info _sloc (PLrange(_1,_3)) )
# 9614 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr))

let _menhir_action_618 =
  fun () ->
    (* reads_clause -> *)
    (
# 1760 "src/kernel_internals/parsing/logic_parser.mly"
                ( None )
# 9623 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list option))

let _menhir_action_619 =
  fun _2 ->
    (* reads_clause -> READS zones *)
    (
# 1761 "src/kernel_internals/parsing/logic_parser.mly"
              ( Some _2 )
# 9632 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list option))

let _menhir_action_620 =
  fun _1 _2 ->
    (* rel_list -> relation lexpr_end_rel *)
    (
# 413 "src/kernel_internals/parsing/logic_parser.mly"
  ( _1, _2, fst(relation_sense _1 Unknown), None )
# 9641 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation * Logic_ptree.lexpr * sense_of_relation *
  Logic_ptree.lexpr option))

let _menhir_action_621 =
  fun _1 _2 _3 _endpos__3_ _startpos__1_ ->
    (* rel_list -> relation lexpr_inner rel_list *)
    let _endpos = _endpos__3_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 415 "src/kernel_internals/parsing/logic_parser.mly"
  (
    let next_rel, rhs, sense, oth_rel = _3 in
    let (sense, correct) = relation_sense _1 sense
    in
    if correct then
      let loc = loc_start _2, loc_end rhs in
      let my_rel = loc_info loc (PLrel(_2,next_rel,rhs)) in
      let oth_rel = match oth_rel with
          None -> my_rel
        | Some rel ->
	    let loc = loc_start _2, loc_end rel in
	    loc_info loc (pland my_rel rel)
      in
      _1,_2,sense,Some oth_rel
    else begin
      let loc = loc _sloc in
      raise (Not_well_formed(loc,"Inconsistent relation chain."));
    end
  )
# 9672 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation * Logic_ptree.lexpr * sense_of_relation *
  Logic_ptree.lexpr option))

let _menhir_action_622 =
  fun () ->
    (* relation -> LT *)
    (
# 437 "src/kernel_internals/parsing/logic_parser.mly"
        ( Lt )
# 9682 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_623 =
  fun () ->
    (* relation -> GT *)
    (
# 438 "src/kernel_internals/parsing/logic_parser.mly"
        ( Gt )
# 9691 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_624 =
  fun () ->
    (* relation -> LE *)
    (
# 439 "src/kernel_internals/parsing/logic_parser.mly"
        ( Le )
# 9700 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_625 =
  fun () ->
    (* relation -> GE *)
    (
# 440 "src/kernel_internals/parsing/logic_parser.mly"
        ( Ge )
# 9709 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_626 =
  fun () ->
    (* relation -> EQ *)
    (
# 441 "src/kernel_internals/parsing/logic_parser.mly"
        ( Eq )
# 9718 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_627 =
  fun () ->
    (* relation -> NE *)
    (
# 442 "src/kernel_internals/parsing/logic_parser.mly"
        ( Neq )
# 9727 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_628 =
  fun _endpos__1_ _startpos__1_ ->
    (* relation -> EQUAL *)
    let _endpos = _endpos__1_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 444 "src/kernel_internals/parsing/logic_parser.mly"
        (
      let l = loc _sloc in
      raise
        (Not_well_formed(l,
                         "Assignment operators not allowed in annotations."))
    )
# 9744 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.relation))

let _menhir_action_629 =
  fun () ->
    (* requires -> *)
    (
# 1144 "src/kernel_internals/parsing/logic_parser.mly"
                ( [] )
# 9753 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_630 =
  fun _1 ->
    (* requires -> ne_requires *)
    (
# 1145 "src/kernel_internals/parsing/logic_parser.mly"
              ( _1 )
# 9762 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.toplevel_predicate list))

let _menhir_action_631 =
  fun x ->
    (* separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) -> logic_type_gen(TYPENAME) *)
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 9771 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_632 =
  fun x xs ->
    (* separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) -> logic_type_gen(TYPENAME) COMMA separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) *)
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 9780 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_633 =
  fun x ->
    (* separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) -> logic_type_gen(identifier_or_typename) *)
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 9789 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_634 =
  fun x xs ->
    (* separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) -> logic_type_gen(identifier_or_typename) COMMA separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) *)
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 9798 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_635 =
  fun x ->
    (* separated_nonempty_list(COMMA,logic_type_gen(typename)) -> logic_type_gen(typename) *)
    (
# 250 "<standard.mly>"
    ( [ x ] )
# 9807 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_636 =
  fun x xs ->
    (* separated_nonempty_list(COMMA,logic_type_gen(typename)) -> logic_type_gen(typename) COMMA separated_nonempty_list(COMMA,logic_type_gen(typename)) *)
    (
# 253 "<standard.mly>"
    ( x :: xs )
# 9816 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type list))

let _menhir_action_637 =
  fun () ->
    (* simple_clauses -> *)
    (
# 1183 "src/kernel_internals/parsing/logic_parser.mly"
                ( FreeAllocAny,WritesAny,[],[] )
# 9825 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_638 =
  fun _1 ->
    (* simple_clauses -> ne_simple_clauses *)
    (
# 1184 "src/kernel_internals/parsing/logic_parser.mly"
                    ( _1 )
# 9836 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.allocation * Logic_ptree.assigns *
  (Cil_types.termination_kind * Logic_ptree.toplevel_predicate) list *
  Logic_ptree.extension list))

let _menhir_action_639 =
  fun _3 _4 _endpos__5_ _startpos__1_ ->
    (* slice_pragma -> SLICE PRAGMA any_identifier lexpr SEMICOLON *)
    let _endpos = _endpos__5_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1524 "src/kernel_internals/parsing/logic_parser.mly"
    ( if _3 = "expr" then SPexpr _4
      else raise (Not_well_formed (loc _sloc, "Unknown slice pragma")) )
# 9851 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.slice_pragma))

let _menhir_action_640 =
  fun _3 _endpos__4_ _startpos__1_ ->
    (* slice_pragma -> SLICE PRAGMA any_identifier SEMICOLON *)
    let _endpos = _endpos__4_ in
    let _symbolstartpos = _startpos__1_ in
    let _sloc = (_symbolstartpos, _endpos) in
    (
# 1527 "src/kernel_internals/parsing/logic_parser.mly"
    ( if _3 = "ctrl" then SPctrl
      else if _3 = "stmt" then SPstmt
      else raise (Not_well_formed (loc _sloc, "Unknown slice pragma")) )
# 9865 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.slice_pragma))

let _menhir_action_641 =
  fun _1 ->
    (* spec -> contract EOF *)
    (
# 1049 "src/kernel_internals/parsing/logic_parser.mly"
               ( fst _1 )
# 9874 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.spec))

let _menhir_action_642 =
  fun () ->
    (* stars -> STAR *)
    (
# 802 "src/kernel_internals/parsing/logic_parser.mly"
                ( fun t -> LTpointer t )
# 9883 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_643 =
  fun _1 ->
    (* stars -> stars STAR *)
    (
# 803 "src/kernel_internals/parsing/logic_parser.mly"
                ( fun t -> (LTpointer (_1 t)) )
# 9892 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_644 =
  fun () ->
    (* stars_cv -> STAR *)
    (
# 807 "src/kernel_internals/parsing/logic_parser.mly"
                ( fun t -> LTpointer t )
# 9901 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_645 =
  fun _2 ->
    (* stars_cv -> STAR cv *)
    (
# 808 "src/kernel_internals/parsing/logic_parser.mly"
                ( fun t -> LTattribute ((LTpointer t), _2) )
# 9910 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_646 =
  fun _1 ->
    (* stars_cv -> stars_cv STAR *)
    (
# 809 "src/kernel_internals/parsing/logic_parser.mly"
                   ( fun t -> (LTpointer (_1 t)) )
# 9919 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_647 =
  fun _1 _3 ->
    (* stars_cv -> stars_cv STAR cv *)
    (
# 810 "src/kernel_internals/parsing/logic_parser.mly"
                   ( fun t -> (LTattribute ((LTpointer (_1 t)), _3)) )
# 9928 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_648 =
  fun _1 ->
    (* stmt_markup -> any_identifier *)
    (
# 1033 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 9937 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_649 =
  fun _1 ->
    (* stmt_markup -> INT_CONSTANT *)
    (
# 1034 "src/kernel_internals/parsing/logic_parser.mly"
               ( _1 )
# 9946 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_650 =
  fun _1 ->
    (* stmt_markup_attr -> stmt_markup *)
    (
# 1038 "src/kernel_internals/parsing/logic_parser.mly"
                                   ( [_1] )
# 9955 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_651 =
  fun _1 _2 ->
    (* stmt_markup_attr -> stmt_markup stmt_markup_attr *)
    (
# 1039 "src/kernel_internals/parsing/logic_parser.mly"
                               ( _1 :: _2 )
# 9964 "src/kernel_internals/parsing/logic_parser.ml"
     : (string list))

let _menhir_action_652 =
  fun _1 ->
    (* string -> STRING_LITERAL *)
    (
# 575 "src/kernel_internals/parsing/logic_parser.mly"
                 ( _1 )
# 9973 "src/kernel_internals/parsing/logic_parser.ml"
     : (bool * string))

let _menhir_action_653 =
  fun _1 _2 ->
    (* string -> string STRING_LITERAL *)
    (
# 576 "src/kernel_internals/parsing/logic_parser.mly"
                        (
      let (is_wide,prefix) = _1 in
      let (is_wide2,suffix) = _2 in
      (is_wide || is_wide2, prefix ^ suffix)
    )
# 9986 "src/kernel_internals/parsing/logic_parser.ml"
     : (bool * string))

let _menhir_action_654 =
  fun _2 ->
    (* tabs -> LSQUARE array_size RSQUARE *)
    (
# 815 "src/kernel_internals/parsing/logic_parser.mly"
    (
      fun t -> LTarray (t,_2)
    )
# 9997 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_655 =
  fun _2 _4 ->
    (* tabs -> LSQUARE array_size RSQUARE tabs *)
    (
# 819 "src/kernel_internals/parsing/logic_parser.mly"
    (
      fun t -> (LTarray (_4 t,_2))
    )
# 10008 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type -> Logic_ptree.logic_type))

let _menhir_action_656 =
  fun () ->
    (* terminates -> *)
    (
# 1158 "src/kernel_internals/parsing/logic_parser.mly"
                ( None )
# 10017 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr option))

let _menhir_action_657 =
  fun _1 ->
    (* terminates -> ne_terminates *)
    (
# 1159 "src/kernel_internals/parsing/logic_parser.mly"
                ( Some _1 )
# 10026 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr option))

let _menhir_action_658 =
  fun _3 _5 _8 ->
    (* type_annot -> TYPE INVARIANT any_identifier LPAR parameter RPAR EQUAL lexpr SEMICOLON *)
    (
# 1604 "src/kernel_internals/parsing/logic_parser.mly"
  ( let typ,name = _5 in{ inv_name = _3; this_name = name; this_type = typ; inv = _8; } )
# 10035 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.type_annot))

let _menhir_action_659 =
  fun () ->
    (* type_spec(TYPENAME) -> INTEGER *)
    (
# 825 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTinteger )
# 10044 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_660 =
  fun () ->
    (* type_spec(TYPENAME) -> REAL *)
    (
# 826 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTreal )
# 10053 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_661 =
  fun () ->
    (* type_spec(TYPENAME) -> BOOLEAN *)
    (
# 827 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTnamed (Utf8_logic.boolean,[]) )
# 10062 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_662 =
  fun () ->
    (* type_spec(TYPENAME) -> VOID *)
    (
# 828 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTvoid )
# 10071 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_663 =
  fun () ->
    (* type_spec(TYPENAME) -> BOOL *)
    (
# 829 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IBool )
# 10080 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_664 =
  fun () ->
    (* type_spec(TYPENAME) -> CHAR *)
    (
# 830 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IChar )
# 10089 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_665 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED CHAR *)
    (
# 831 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ISChar )
# 10098 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_666 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED CHAR *)
    (
# 832 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUChar )
# 10107 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_667 =
  fun () ->
    (* type_spec(TYPENAME) -> INT *)
    (
# 833 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IInt )
# 10116 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_668 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED INT *)
    (
# 834 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IInt )
# 10125 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_669 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED INT *)
    (
# 835 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUInt )
# 10134 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_670 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED *)
    (
# 836 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUInt )
# 10143 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_671 =
  fun () ->
    (* type_spec(TYPENAME) -> SHORT *)
    (
# 837 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IShort )
# 10152 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_672 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED SHORT *)
    (
# 838 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IShort )
# 10161 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_673 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED SHORT *)
    (
# 839 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUShort )
# 10170 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_674 =
  fun () ->
    (* type_spec(TYPENAME) -> SHORT INT *)
    (
# 840 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IShort )
# 10179 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_675 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED SHORT INT *)
    (
# 841 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IShort )
# 10188 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_676 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED SHORT INT *)
    (
# 842 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IUShort )
# 10197 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_677 =
  fun () ->
    (* type_spec(TYPENAME) -> LONG *)
    (
# 843 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10206 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_678 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED LONG *)
    (
# 844 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10215 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_679 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED LONG *)
    (
# 845 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IULong )
# 10224 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_680 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED LONG INT *)
    (
# 846 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10233 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_681 =
  fun () ->
    (* type_spec(TYPENAME) -> LONG INT *)
    (
# 847 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10242 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_682 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED LONG INT *)
    (
# 848 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTint IULong )
# 10251 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_683 =
  fun () ->
    (* type_spec(TYPENAME) -> LONG LONG *)
    (
# 849 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILongLong )
# 10260 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_684 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED LONG LONG *)
    (
# 851 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint ILongLong )
# 10269 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_685 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED LONG LONG *)
    (
# 853 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IULongLong )
# 10278 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_686 =
  fun () ->
    (* type_spec(TYPENAME) -> LONG LONG INT *)
    (
# 855 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTint ILongLong )
# 10287 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_687 =
  fun () ->
    (* type_spec(TYPENAME) -> SIGNED LONG LONG INT *)
    (
# 857 "src/kernel_internals/parsing/logic_parser.mly"
                        ( LTint ILongLong )
# 10296 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_688 =
  fun () ->
    (* type_spec(TYPENAME) -> UNSIGNED LONG LONG INT *)
    (
# 859 "src/kernel_internals/parsing/logic_parser.mly"
                         ( LTint IULongLong )
# 10305 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_689 =
  fun () ->
    (* type_spec(TYPENAME) -> FLOAT *)
    (
# 861 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FFloat )
# 10314 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_690 =
  fun () ->
    (* type_spec(TYPENAME) -> DOUBLE *)
    (
# 862 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FDouble )
# 10323 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_691 =
  fun () ->
    (* type_spec(TYPENAME) -> LONG DOUBLE *)
    (
# 863 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FLongDouble )
# 10332 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_692 =
  fun id ->
    (* type_spec(TYPENAME) -> STRUCT identifier_or_typename_full *)
    (
# 864 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( LTstruct id )
# 10341 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_693 =
  fun id ->
    (* type_spec(TYPENAME) -> ENUM identifier_or_typename_full *)
    (
# 865 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( LTenum id )
# 10350 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_694 =
  fun id ->
    (* type_spec(TYPENAME) -> UNION identifier_or_typename_full *)
    (
# 866 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( LTunion id )
# 10359 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_695 =
  fun name ->
    (* type_spec(TYPENAME) -> TYPENAME *)
    (
# 867 "src/kernel_internals/parsing/logic_parser.mly"
                        ( LTnamed (name,[]) )
# 10368 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_696 =
  fun name prms ->
    (* type_spec(TYPENAME) -> TYPENAME LT ne_logic_type_list(TYPENAME) GT *)
    (
# 868 "src/kernel_internals/parsing/logic_parser.mly"
                                                      ( LTnamed(name,prms) )
# 10377 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_697 =
  fun () ->
    (* type_spec(identifier_or_typename) -> INTEGER *)
    (
# 825 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTinteger )
# 10386 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_698 =
  fun () ->
    (* type_spec(identifier_or_typename) -> REAL *)
    (
# 826 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTreal )
# 10395 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_699 =
  fun () ->
    (* type_spec(identifier_or_typename) -> BOOLEAN *)
    (
# 827 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTnamed (Utf8_logic.boolean,[]) )
# 10404 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_700 =
  fun () ->
    (* type_spec(identifier_or_typename) -> VOID *)
    (
# 828 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTvoid )
# 10413 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_701 =
  fun () ->
    (* type_spec(identifier_or_typename) -> BOOL *)
    (
# 829 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IBool )
# 10422 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_702 =
  fun () ->
    (* type_spec(identifier_or_typename) -> CHAR *)
    (
# 830 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IChar )
# 10431 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_703 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED CHAR *)
    (
# 831 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ISChar )
# 10440 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_704 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED CHAR *)
    (
# 832 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUChar )
# 10449 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_705 =
  fun () ->
    (* type_spec(identifier_or_typename) -> INT *)
    (
# 833 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IInt )
# 10458 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_706 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED INT *)
    (
# 834 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IInt )
# 10467 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_707 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED INT *)
    (
# 835 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUInt )
# 10476 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_708 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED *)
    (
# 836 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUInt )
# 10485 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_709 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SHORT *)
    (
# 837 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IShort )
# 10494 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_710 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED SHORT *)
    (
# 838 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IShort )
# 10503 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_711 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED SHORT *)
    (
# 839 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUShort )
# 10512 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_712 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SHORT INT *)
    (
# 840 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IShort )
# 10521 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_713 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED SHORT INT *)
    (
# 841 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IShort )
# 10530 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_714 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED SHORT INT *)
    (
# 842 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IUShort )
# 10539 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_715 =
  fun () ->
    (* type_spec(identifier_or_typename) -> LONG *)
    (
# 843 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10548 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_716 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED LONG *)
    (
# 844 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10557 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_717 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED LONG *)
    (
# 845 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IULong )
# 10566 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_718 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED LONG INT *)
    (
# 846 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10575 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_719 =
  fun () ->
    (* type_spec(identifier_or_typename) -> LONG INT *)
    (
# 847 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10584 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_720 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED LONG INT *)
    (
# 848 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTint IULong )
# 10593 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_721 =
  fun () ->
    (* type_spec(identifier_or_typename) -> LONG LONG *)
    (
# 849 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILongLong )
# 10602 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_722 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED LONG LONG *)
    (
# 851 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint ILongLong )
# 10611 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_723 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED LONG LONG *)
    (
# 853 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IULongLong )
# 10620 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_724 =
  fun () ->
    (* type_spec(identifier_or_typename) -> LONG LONG INT *)
    (
# 855 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTint ILongLong )
# 10629 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_725 =
  fun () ->
    (* type_spec(identifier_or_typename) -> SIGNED LONG LONG INT *)
    (
# 857 "src/kernel_internals/parsing/logic_parser.mly"
                        ( LTint ILongLong )
# 10638 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_726 =
  fun () ->
    (* type_spec(identifier_or_typename) -> UNSIGNED LONG LONG INT *)
    (
# 859 "src/kernel_internals/parsing/logic_parser.mly"
                         ( LTint IULongLong )
# 10647 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_727 =
  fun () ->
    (* type_spec(identifier_or_typename) -> FLOAT *)
    (
# 861 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FFloat )
# 10656 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_728 =
  fun () ->
    (* type_spec(identifier_or_typename) -> DOUBLE *)
    (
# 862 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FDouble )
# 10665 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_729 =
  fun () ->
    (* type_spec(identifier_or_typename) -> LONG DOUBLE *)
    (
# 863 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FLongDouble )
# 10674 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_730 =
  fun id ->
    (* type_spec(identifier_or_typename) -> STRUCT identifier_or_typename_full *)
    (
# 864 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( LTstruct id )
# 10683 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_731 =
  fun id ->
    (* type_spec(identifier_or_typename) -> ENUM identifier_or_typename_full *)
    (
# 865 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( LTenum id )
# 10692 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_732 =
  fun id ->
    (* type_spec(identifier_or_typename) -> UNION identifier_or_typename_full *)
    (
# 866 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( LTunion id )
# 10701 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_733 =
  fun name ->
    (* type_spec(identifier_or_typename) -> identifier_or_typename *)
    (
# 867 "src/kernel_internals/parsing/logic_parser.mly"
                        ( LTnamed (name,[]) )
# 10710 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_734 =
  fun name prms ->
    (* type_spec(identifier_or_typename) -> identifier_or_typename LT ne_logic_type_list(identifier_or_typename) GT *)
    (
# 868 "src/kernel_internals/parsing/logic_parser.mly"
                                                      ( LTnamed(name,prms) )
# 10719 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_735 =
  fun () ->
    (* type_spec(typename) -> INTEGER *)
    (
# 825 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTinteger )
# 10728 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_736 =
  fun () ->
    (* type_spec(typename) -> REAL *)
    (
# 826 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTreal )
# 10737 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_737 =
  fun () ->
    (* type_spec(typename) -> BOOLEAN *)
    (
# 827 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTnamed (Utf8_logic.boolean,[]) )
# 10746 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_738 =
  fun () ->
    (* type_spec(typename) -> VOID *)
    (
# 828 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTvoid )
# 10755 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_739 =
  fun () ->
    (* type_spec(typename) -> BOOL *)
    (
# 829 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IBool )
# 10764 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_740 =
  fun () ->
    (* type_spec(typename) -> CHAR *)
    (
# 830 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IChar )
# 10773 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_741 =
  fun () ->
    (* type_spec(typename) -> SIGNED CHAR *)
    (
# 831 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ISChar )
# 10782 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_742 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED CHAR *)
    (
# 832 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUChar )
# 10791 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_743 =
  fun () ->
    (* type_spec(typename) -> INT *)
    (
# 833 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IInt )
# 10800 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_744 =
  fun () ->
    (* type_spec(typename) -> SIGNED INT *)
    (
# 834 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IInt )
# 10809 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_745 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED INT *)
    (
# 835 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUInt )
# 10818 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_746 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED *)
    (
# 836 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUInt )
# 10827 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_747 =
  fun () ->
    (* type_spec(typename) -> SHORT *)
    (
# 837 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IShort )
# 10836 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_748 =
  fun () ->
    (* type_spec(typename) -> SIGNED SHORT *)
    (
# 838 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IShort )
# 10845 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_749 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED SHORT *)
    (
# 839 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IUShort )
# 10854 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_750 =
  fun () ->
    (* type_spec(typename) -> SHORT INT *)
    (
# 840 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IShort )
# 10863 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_751 =
  fun () ->
    (* type_spec(typename) -> SIGNED SHORT INT *)
    (
# 841 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IShort )
# 10872 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_752 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED SHORT INT *)
    (
# 842 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IUShort )
# 10881 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_753 =
  fun () ->
    (* type_spec(typename) -> LONG *)
    (
# 843 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10890 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_754 =
  fun () ->
    (* type_spec(typename) -> SIGNED LONG *)
    (
# 844 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10899 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_755 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED LONG *)
    (
# 845 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint IULong )
# 10908 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_756 =
  fun () ->
    (* type_spec(typename) -> SIGNED LONG INT *)
    (
# 846 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10917 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_757 =
  fun () ->
    (* type_spec(typename) -> LONG INT *)
    (
# 847 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILong )
# 10926 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_758 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED LONG INT *)
    (
# 848 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTint IULong )
# 10935 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_759 =
  fun () ->
    (* type_spec(typename) -> LONG LONG *)
    (
# 849 "src/kernel_internals/parsing/logic_parser.mly"
                 ( LTint ILongLong )
# 10944 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_760 =
  fun () ->
    (* type_spec(typename) -> SIGNED LONG LONG *)
    (
# 851 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint ILongLong )
# 10953 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_761 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED LONG LONG *)
    (
# 853 "src/kernel_internals/parsing/logic_parser.mly"
                     ( LTint IULongLong )
# 10962 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_762 =
  fun () ->
    (* type_spec(typename) -> LONG LONG INT *)
    (
# 855 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTint ILongLong )
# 10971 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_763 =
  fun () ->
    (* type_spec(typename) -> SIGNED LONG LONG INT *)
    (
# 857 "src/kernel_internals/parsing/logic_parser.mly"
                        ( LTint ILongLong )
# 10980 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_764 =
  fun () ->
    (* type_spec(typename) -> UNSIGNED LONG LONG INT *)
    (
# 859 "src/kernel_internals/parsing/logic_parser.mly"
                         ( LTint IULongLong )
# 10989 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_765 =
  fun () ->
    (* type_spec(typename) -> FLOAT *)
    (
# 861 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FFloat )
# 10998 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_766 =
  fun () ->
    (* type_spec(typename) -> DOUBLE *)
    (
# 862 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FDouble )
# 11007 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_767 =
  fun () ->
    (* type_spec(typename) -> LONG DOUBLE *)
    (
# 863 "src/kernel_internals/parsing/logic_parser.mly"
                    ( LTfloat FLongDouble )
# 11016 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_768 =
  fun id ->
    (* type_spec(typename) -> STRUCT identifier_or_typename_full *)
    (
# 864 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( LTstruct id )
# 11025 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_769 =
  fun id ->
    (* type_spec(typename) -> ENUM identifier_or_typename_full *)
    (
# 865 "src/kernel_internals/parsing/logic_parser.mly"
                                        ( LTenum id )
# 11034 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_770 =
  fun id ->
    (* type_spec(typename) -> UNION identifier_or_typename_full *)
    (
# 866 "src/kernel_internals/parsing/logic_parser.mly"
                                          ( LTunion id )
# 11043 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_771 =
  fun name ->
    (* type_spec(typename) -> typename *)
    (
# 867 "src/kernel_internals/parsing/logic_parser.mly"
                        ( LTnamed (name,[]) )
# 11052 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_772 =
  fun name prms ->
    (* type_spec(typename) -> typename LT ne_logic_type_list(typename) GT *)
    (
# 868 "src/kernel_internals/parsing/logic_parser.mly"
                                                      ( LTnamed(name,prms) )
# 11061 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_773 =
  fun _1 _2 ->
    (* type_spec_cv(TYPENAME) -> type_spec(TYPENAME) cv_after *)
    (
# 746 "src/kernel_internals/parsing/logic_parser.mly"
                               ( _2 _1 )
# 11070 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_774 =
  fun _1 _2 ->
    (* type_spec_cv(TYPENAME) -> cv type_spec_cv(TYPENAME) *)
    (
# 747 "src/kernel_internals/parsing/logic_parser.mly"
                            ( LTattribute (_2, _1) )
# 11079 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.logic_type))

let _menhir_action_775 =
  fun _1 ->
    (* typedef -> ne_datacons_list *)
    (
# 1765 "src/kernel_internals/parsing/logic_parser.mly"
                   ( TDsum _1 )
# 11088 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.typedef))

let _menhir_action_776 =
  fun _1 ->
    (* typedef -> logic_type *)
    (
# 1766 "src/kernel_internals/parsing/logic_parser.mly"
             ( TDsyn _1 )
# 11097 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.typedef))

let _menhir_action_777 =
  fun name ->
    (* typename -> TYPENAME *)
    (
# 733 "src/kernel_internals/parsing/logic_parser.mly"
                  ( name )
# 11106 "src/kernel_internals/parsing/logic_parser.ml"
     : (string))

let _menhir_action_778 =
  fun _1 ->
    (* update -> update_elt *)
    (
# 617 "src/kernel_internals/parsing/logic_parser.mly"
                              ( [_1] )
# 11115 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.path_elt list * Logic_ptree.update_term) list))

let _menhir_action_779 =
  fun _1 _3 ->
    (* update -> update_elt COMMA update *)
    (
# 618 "src/kernel_internals/parsing/logic_parser.mly"
                          ( _1::_3 )
# 11124 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.path_elt list * Logic_ptree.update_term) list))

let _menhir_action_780 =
  fun _1 _3 ->
    (* update_elt -> path EQUAL lexpr *)
    (
# 622 "src/kernel_internals/parsing/logic_parser.mly"
                                  ( _1, PLupdateTerm _3 )
# 11133 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.path_elt list * Logic_ptree.update_term))

let _menhir_action_781 =
  fun _1 _5 ->
    (* update_elt -> path EQUAL LBRACE WITH update RBRACE *)
    (
# 623 "src/kernel_internals/parsing/logic_parser.mly"
                                       ( _1, PLupdateCont _5 )
# 11142 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.path_elt list * Logic_ptree.update_term))

let _menhir_action_782 =
  fun _1 ->
    (* var_spec -> var_spec_bis *)
    (
# 660 "src/kernel_internals/parsing/logic_parser.mly"
                     ( let (outer, inner,name) = _1 in
                       ((fun x -> outer (inner x)), name))
# 11152 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type -> Logic_ptree.logic_type) * string))

let _menhir_action_783 =
  fun _1 _2 ->
    (* var_spec -> stars var_spec_bis *)
    (
# 663 "src/kernel_internals/parsing/logic_parser.mly"
  ( let (outer, inner, name) = _2 in
      ((fun x -> outer (inner (_1 x))), name) )
# 11162 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type -> Logic_ptree.logic_type) * string))

let _menhir_action_784 =
  fun _1 ->
    (* var_spec_bis -> full_identifier *)
    (
# 681 "src/kernel_internals/parsing/logic_parser.mly"
                      ( ((fun x -> x),(fun x -> x), _1) )
# 11171 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type -> Logic_ptree.logic_type) *
  (Logic_ptree.logic_type -> Logic_ptree.logic_type) * string))

let _menhir_action_785 =
  fun _1 _3 ->
    (* var_spec_bis -> var_spec_bis LSQUARE array_size RSQUARE *)
    (
# 683 "src/kernel_internals/parsing/logic_parser.mly"
      ( let (outer, inner, name) = _1 in
          (outer, (fun x -> inner (LTarray (x,_3))), name)
      )
# 11183 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type -> Logic_ptree.logic_type) *
  (Logic_ptree.logic_type -> Logic_ptree.logic_type) * string))

let _menhir_action_786 =
  fun _2 ->
    (* var_spec_bis -> LPAR var_spec RPAR *)
    (
# 686 "src/kernel_internals/parsing/logic_parser.mly"
                     ( let (modif, name) = _2 in (modif, (fun x -> x), name) )
# 11193 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type -> Logic_ptree.logic_type) *
  (Logic_ptree.logic_type -> Logic_ptree.logic_type) * string))

let _menhir_action_787 =
  fun _1 _3 ->
    (* var_spec_bis -> var_spec_bis LPAR abs_param_type_list RPAR *)
    (
# 688 "src/kernel_internals/parsing/logic_parser.mly"
      ( let (outer, inner,name) = _1 in
        let params = _3 in
        (outer, (fun x -> inner (LTarrow (params,x))), name)
      )
# 11206 "src/kernel_internals/parsing/logic_parser.ml"
     : ((Logic_ptree.logic_type -> Logic_ptree.logic_type) *
  (Logic_ptree.logic_type -> Logic_ptree.logic_type) * string))

let _menhir_action_788 =
  fun _1 _3 ->
    (* variant -> lexpr FOR any_identifier *)
    (
# 1178 "src/kernel_internals/parsing/logic_parser.mly"
                           ( (_1, Some _3) )
# 11216 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.variant))

let _menhir_action_789 =
  fun _1 ->
    (* variant -> lexpr *)
    (
# 1179 "src/kernel_internals/parsing/logic_parser.mly"
                           ( (_1, None) )
# 11225 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.variant))

let _menhir_action_790 =
  fun () ->
    (* volatile_opt -> *)
    (
# 1584 "src/kernel_internals/parsing/logic_parser.mly"
              ( None, None )
# 11234 "src/kernel_internals/parsing/logic_parser.ml"
     : (string option * string option))

let _menhir_action_791 =
  fun _2 _3 ->
    (* volatile_opt -> READS any_identifier volatile_opt *)
    (
# 1586 "src/kernel_internals/parsing/logic_parser.mly"
              ( let read,write=_3 in
                  if read = None then
		    (Some _2),write
		  else
                    (Format.eprintf "Warning: read %s ignored@." _2; _3)
	      )
# 11248 "src/kernel_internals/parsing/logic_parser.ml"
     : (string option * string option))

let _menhir_action_792 =
  fun _2 _3 ->
    (* volatile_opt -> WRITES any_identifier volatile_opt *)
    (
# 1593 "src/kernel_internals/parsing/logic_parser.mly"
              ( let read,write=_3 in
                  if write = None then
		    read,(Some _2)
		  else
                    (Format.eprintf "Warning: write %s ignored@." _2; _3)
	      )
# 11262 "src/kernel_internals/parsing/logic_parser.ml"
     : (string option * string option))

let _menhir_action_793 =
  fun () ->
    (* wildcard -> any_identifier *)
    (
# 2048 "src/kernel_internals/parsing/logic_parser.mly"
                 ( () )
# 11271 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_794 =
  fun () ->
    (* wildcard -> bs_keyword *)
    (
# 2049 "src/kernel_internals/parsing/logic_parser.mly"
             ( () )
# 11280 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_795 =
  fun () ->
    (* wildcard -> AMP *)
    (
# 2050 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 11289 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_796 =
  fun () ->
    (* wildcard -> AND *)
    (
# 2051 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 11298 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_797 =
  fun () ->
    (* wildcard -> ARROW *)
    (
# 2052 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11307 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_798 =
  fun () ->
    (* wildcard -> BIFF *)
    (
# 2053 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11316 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_799 =
  fun () ->
    (* wildcard -> BIMPLIES *)
    (
# 2054 "src/kernel_internals/parsing/logic_parser.mly"
           ( () )
# 11325 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_800 =
  fun () ->
    (* wildcard -> COLON *)
    (
# 2055 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11334 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_801 =
  fun () ->
    (* wildcard -> COLON2 *)
    (
# 2056 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11343 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_802 =
  fun () ->
    (* wildcard -> COLONCOLON *)
    (
# 2057 "src/kernel_internals/parsing/logic_parser.mly"
             ( () )
# 11352 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_803 =
  fun () ->
    (* wildcard -> COMMA *)
    (
# 2058 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11361 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_804 =
  fun () ->
    (* wildcard -> INT_CONSTANT *)
    (
# 2059 "src/kernel_internals/parsing/logic_parser.mly"
               ( () )
# 11370 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_805 =
  fun () ->
    (* wildcard -> FLOAT_CONSTANT *)
    (
# 2060 "src/kernel_internals/parsing/logic_parser.mly"
                 ( () )
# 11379 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_806 =
  fun () ->
    (* wildcard -> STRING_CONSTANT *)
    (
# 2061 "src/kernel_internals/parsing/logic_parser.mly"
                  ( () )
# 11388 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_807 =
  fun () ->
    (* wildcard -> WSTRING_CONSTANT *)
    (
# 2062 "src/kernel_internals/parsing/logic_parser.mly"
                   ( () )
# 11397 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_808 =
  fun () ->
    (* wildcard -> DOLLAR *)
    (
# 2063 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11406 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_809 =
  fun () ->
    (* wildcard -> DOT *)
    (
# 2064 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 11415 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_810 =
  fun () ->
    (* wildcard -> DOTDOT *)
    (
# 2065 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11424 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_811 =
  fun () ->
    (* wildcard -> DOTDOTDOT *)
    (
# 2066 "src/kernel_internals/parsing/logic_parser.mly"
            ( () )
# 11433 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_812 =
  fun () ->
    (* wildcard -> EQ *)
    (
# 2067 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11442 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_813 =
  fun () ->
    (* wildcard -> EQUAL *)
    (
# 2068 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11451 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_814 =
  fun () ->
    (* wildcard -> EXISTS *)
    (
# 2069 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11460 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_815 =
  fun () ->
    (* wildcard -> GE *)
    (
# 2070 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11469 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_816 =
  fun () ->
    (* wildcard -> GHOST *)
    (
# 2071 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11478 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_817 =
  fun () ->
    (* wildcard -> GT *)
    (
# 2072 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11487 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_818 =
  fun () ->
    (* wildcard -> GTGT *)
    (
# 2073 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11496 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_819 =
  fun () ->
    (* wildcard -> HAT *)
    (
# 2074 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 11505 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_820 =
  fun () ->
    (* wildcard -> HATHAT *)
    (
# 2075 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11514 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_821 =
  fun () ->
    (* wildcard -> IFF *)
    (
# 2076 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 11523 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_822 =
  fun () ->
    (* wildcard -> IMPLIES *)
    (
# 2077 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 11532 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_823 =
  fun () ->
    (* wildcard -> LBRACE *)
    (
# 2078 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11541 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_824 =
  fun () ->
    (* wildcard -> LE *)
    (
# 2079 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11550 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_825 =
  fun () ->
    (* wildcard -> LPAR *)
    (
# 2080 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11559 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_826 =
  fun () ->
    (* wildcard -> LSQUARE *)
    (
# 2081 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 11568 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_827 =
  fun () ->
    (* wildcard -> LSQUAREPIPE *)
    (
# 2082 "src/kernel_internals/parsing/logic_parser.mly"
              ( () )
# 11577 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_828 =
  fun () ->
    (* wildcard -> LT *)
    (
# 2083 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11586 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_829 =
  fun () ->
    (* wildcard -> LTLT *)
    (
# 2084 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11595 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_830 =
  fun () ->
    (* wildcard -> MINUS *)
    (
# 2085 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11604 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_831 =
  fun () ->
    (* wildcard -> NE *)
    (
# 2086 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11613 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_832 =
  fun () ->
    (* wildcard -> NOT *)
    (
# 2087 "src/kernel_internals/parsing/logic_parser.mly"
      ( () )
# 11622 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_833 =
  fun () ->
    (* wildcard -> OR *)
    (
# 2088 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11631 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_834 =
  fun () ->
    (* wildcard -> PERCENT *)
    (
# 2089 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 11640 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_835 =
  fun () ->
    (* wildcard -> PI *)
    (
# 2090 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11649 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_836 =
  fun () ->
    (* wildcard -> PIPE *)
    (
# 2091 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11658 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_837 =
  fun () ->
    (* wildcard -> PLUS *)
    (
# 2092 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11667 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_838 =
  fun () ->
    (* wildcard -> QUESTION *)
    (
# 2093 "src/kernel_internals/parsing/logic_parser.mly"
           ( () )
# 11676 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_839 =
  fun () ->
    (* wildcard -> RBRACE *)
    (
# 2094 "src/kernel_internals/parsing/logic_parser.mly"
         ( () )
# 11685 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_840 =
  fun () ->
    (* wildcard -> RPAR *)
    (
# 2095 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11694 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_841 =
  fun () ->
    (* wildcard -> RSQUARE *)
    (
# 2096 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 11703 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_842 =
  fun () ->
    (* wildcard -> RSQUAREPIPE *)
    (
# 2097 "src/kernel_internals/parsing/logic_parser.mly"
              ( () )
# 11712 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_843 =
  fun () ->
    (* wildcard -> SEMICOLON *)
    (
# 2098 "src/kernel_internals/parsing/logic_parser.mly"
            ( () )
# 11721 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_844 =
  fun () ->
    (* wildcard -> SLASH *)
    (
# 2099 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11730 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_845 =
  fun () ->
    (* wildcard -> STAR *)
    (
# 2100 "src/kernel_internals/parsing/logic_parser.mly"
       ( () )
# 11739 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_846 =
  fun () ->
    (* wildcard -> STARHAT *)
    (
# 2101 "src/kernel_internals/parsing/logic_parser.mly"
          ( () )
# 11748 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_847 =
  fun () ->
    (* wildcard -> STRING_LITERAL *)
    (
# 2102 "src/kernel_internals/parsing/logic_parser.mly"
                 ( () )
# 11757 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_848 =
  fun () ->
    (* wildcard -> TILDE *)
    (
# 2103 "src/kernel_internals/parsing/logic_parser.mly"
        ( () )
# 11766 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_849 =
  fun () ->
    (* wildcard -> IN *)
    (
# 2104 "src/kernel_internals/parsing/logic_parser.mly"
     ( () )
# 11775 "src/kernel_internals/parsing/logic_parser.ml"
     : (unit))

let _menhir_action_850 =
  fun _1 ->
    (* zones -> ne_zones *)
    (
# 1290 "src/kernel_internals/parsing/logic_parser.mly"
           ( _1 )
# 11784 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_action_851 =
  fun () ->
    (* zones -> NOTHING *)
    (
# 1291 "src/kernel_internals/parsing/logic_parser.mly"
           ( [] )
# 11793 "src/kernel_internals/parsing/logic_parser.ml"
     : (Logic_ptree.lexpr list))

let _menhir_print_token : token -> string =
  fun _tok ->
    match _tok with
    | ADMIT ->
        "ADMIT"
    | ADMIT_BREAKS ->
        "ADMIT_BREAKS"
    | ADMIT_CONTINUES ->
        "ADMIT_CONTINUES"
    | ADMIT_ENSURES ->
        "ADMIT_ENSURES"
    | ADMIT_EXITS ->
        "ADMIT_EXITS"
    | ADMIT_INVARIANT ->
        "ADMIT_INVARIANT"
    | ADMIT_LEMMA ->
        "ADMIT_LEMMA"
    | ADMIT_LOOP ->
        "ADMIT_LOOP"
    | ADMIT_REQUIRES ->
        "ADMIT_REQUIRES"
    | ADMIT_RETURNS ->
        "ADMIT_RETURNS"
    | ALLOCABLE ->
        "ALLOCABLE"
    | ALLOCATES ->
        "ALLOCATES"
    | ALLOCATION ->
        "ALLOCATION"
    | AMP ->
        "AMP"
    | AND ->
        "AND"
    | ARROW ->
        "ARROW"
    | ASSERT ->
        "ASSERT"
    | ASSIGNS ->
        "ASSIGNS"
    | ASSUMES ->
        "ASSUMES"
    | AT ->
        "AT"
    | AUTOMATIC ->
        "AUTOMATIC"
    | AXIOM ->
        "AXIOM"
    | AXIOMATIC ->
        "AXIOMATIC"
    | BASE_ADDR ->
        "BASE_ADDR"
    | BEHAVIOR ->
        "BEHAVIOR"
    | BEHAVIORS ->
        "BEHAVIORS"
    | BIFF ->
        "BIFF"
    | BIMPLIES ->
        "BIMPLIES"
    | BLOCK_LENGTH ->
        "BLOCK_LENGTH"
    | BOOL ->
        "BOOL"
    | BOOLEAN ->
        "BOOLEAN"
    | BREAKS ->
        "BREAKS"
    | BSGHOST ->
        "BSGHOST"
    | BSTYPE ->
        "BSTYPE"
    | BSUNION ->
        "BSUNION"
    | CASE ->
        "CASE"
    | CHAR ->
        "CHAR"
    | CHECK ->
        "CHECK"
    | CHECK_BREAKS ->
        "CHECK_BREAKS"
    | CHECK_CONTINUES ->
        "CHECK_CONTINUES"
    | CHECK_ENSURES ->
        "CHECK_ENSURES"
    | CHECK_EXITS ->
        "CHECK_EXITS"
    | CHECK_INVARIANT ->
        "CHECK_INVARIANT"
    | CHECK_LEMMA ->
        "CHECK_LEMMA"
    | CHECK_LOOP ->
        "CHECK_LOOP"
    | CHECK_REQUIRES ->
        "CHECK_REQUIRES"
    | CHECK_RETURNS ->
        "CHECK_RETURNS"
    | COLON ->
        "COLON"
    | COLON2 ->
        "COLON2"
    | COLONCOLON ->
        "COLONCOLON"
    | COMMA ->
        "COMMA"
    | COMPLETE ->
        "COMPLETE"
    | CONST ->
        "CONST"
    | CONTINUES ->
        "CONTINUES"
    | CONTRACT ->
        "CONTRACT"
    | DANGLING ->
        "DANGLING"
    | DECREASES ->
        "DECREASES"
    | DISJOINT ->
        "DISJOINT"
    | DOLLAR ->
        "DOLLAR"
    | DOT ->
        "DOT"
    | DOTDOT ->
        "DOTDOT"
    | DOTDOTDOT ->
        "DOTDOTDOT"
    | DOUBLE ->
        "DOUBLE"
    | DYNAMIC ->
        "DYNAMIC"
    | ELSE ->
        "ELSE"
    | EMPTY ->
        "EMPTY"
    | ENSURES ->
        "ENSURES"
    | ENUM ->
        "ENUM"
    | EOF ->
        "EOF"
    | EQ ->
        "EQ"
    | EQUAL ->
        "EQUAL"
    | EXISTS ->
        "EXISTS"
    | EXITS ->
        "EXITS"
    | EXT_AT ->
        "EXT_AT"
    | EXT_CODE_ANNOT _ ->
        "EXT_CODE_ANNOT"
    | EXT_CONTRACT _ ->
        "EXT_CONTRACT"
    | EXT_GLOBAL _ ->
        "EXT_GLOBAL"
    | EXT_GLOBAL_BLOCK _ ->
        "EXT_GLOBAL_BLOCK"
    | EXT_LET ->
        "EXT_LET"
    | FALSE ->
        "FALSE"
    | FLOAT ->
        "FLOAT"
    | FLOAT_CONSTANT _ ->
        "FLOAT_CONSTANT"
    | FOR ->
        "FOR"
    | FORALL ->
        "FORALL"
    | FREEABLE ->
        "FREEABLE"
    | FREES ->
        "FREES"
    | FRESH ->
        "FRESH"
    | FROM ->
        "FROM"
    | FUNCTION ->
        "FUNCTION"
    | GE ->
        "GE"
    | GHOST ->
        "GHOST"
    | GLOBAL ->
        "GLOBAL"
    | GT ->
        "GT"
    | GTGT ->
        "GTGT"
    | HAT ->
        "HAT"
    | HATHAT ->
        "HATHAT"
    | IDENTIFIER _ ->
        "IDENTIFIER"
    | IF ->
        "IF"
    | IFF ->
        "IFF"
    | IMPACT ->
        "IMPACT"
    | IMPLIES ->
        "IMPLIES"
    | IN ->
        "IN"
    | INCLUDE ->
        "INCLUDE"
    | INDUCTIVE ->
        "INDUCTIVE"
    | INITIALIZED ->
        "INITIALIZED"
    | INT ->
        "INT"
    | INTEGER ->
        "INTEGER"
    | INTER ->
        "INTER"
    | INT_CONSTANT _ ->
        "INT_CONSTANT"
    | INVARIANT ->
        "INVARIANT"
    | LABEL ->
        "LABEL"
    | LAMBDA ->
        "LAMBDA"
    | LBRACE ->
        "LBRACE"
    | LE ->
        "LE"
    | LEMMA ->
        "LEMMA"
    | LET ->
        "LET"
    | LOGIC ->
        "LOGIC"
    | LONG ->
        "LONG"
    | LOOP ->
        "LOOP"
    | LPAR ->
        "LPAR"
    | LSQUARE ->
        "LSQUARE"
    | LSQUAREPIPE ->
        "LSQUAREPIPE"
    | LT ->
        "LT"
    | LTLT ->
        "LTLT"
    | MINUS ->
        "MINUS"
    | MODEL ->
        "MODEL"
    | MODULE ->
        "MODULE"
    | NE ->
        "NE"
    | NOT ->
        "NOT"
    | NOTHING ->
        "NOTHING"
    | NULL ->
        "NULL"
    | OBJECT_POINTER ->
        "OBJECT_POINTER"
    | OFFSET ->
        "OFFSET"
    | OLD ->
        "OLD"
    | OR ->
        "OR"
    | PERCENT ->
        "PERCENT"
    | PI ->
        "PI"
    | PIPE ->
        "PIPE"
    | PLUS ->
        "PLUS"
    | PRAGMA ->
        "PRAGMA"
    | PREDICATE ->
        "PREDICATE"
    | QUESTION ->
        "QUESTION"
    | RBRACE ->
        "RBRACE"
    | READS ->
        "READS"
    | REAL ->
        "REAL"
    | REGISTER ->
        "REGISTER"
    | REQUIRES ->
        "REQUIRES"
    | RESULT ->
        "RESULT"
    | RETURNS ->
        "RETURNS"
    | RPAR ->
        "RPAR"
    | RSQUARE ->
        "RSQUARE"
    | RSQUAREPIPE ->
        "RSQUAREPIPE"
    | SEMICOLON ->
        "SEMICOLON"
    | SEPARATED ->
        "SEPARATED"
    | SHORT ->
        "SHORT"
    | SIGNED ->
        "SIGNED"
    | SIZEOF ->
        "SIZEOF"
    | SLASH ->
        "SLASH"
    | SLICE ->
        "SLICE"
    | STAR ->
        "STAR"
    | STARHAT ->
        "STARHAT"
    | STATIC ->
        "STATIC"
    | STRING_CONSTANT _ ->
        "STRING_CONSTANT"
    | STRING_LITERAL _ ->
        "STRING_LITERAL"
    | STRUCT ->
        "STRUCT"
    | TERMINATES ->
        "TERMINATES"
    | TILDE ->
        "TILDE"
    | TRUE ->
        "TRUE"
    | TYPE ->
        "TYPE"
    | TYPENAME _ ->
        "TYPENAME"
    | TYPEOF ->
        "TYPEOF"
    | UNALLOCATED ->
        "UNALLOCATED"
    | UNION ->
        "UNION"
    | UNSIGNED ->
        "UNSIGNED"
    | VALID ->
        "VALID"
    | VALID_FUNCTION ->
        "VALID_FUNCTION"
    | VALID_INDEX ->
        "VALID_INDEX"
    | VALID_RANGE ->
        "VALID_RANGE"
    | VALID_READ ->
        "VALID_READ"
    | VARIANT ->
        "VARIANT"
    | VOID ->
        "VOID"
    | VOLATILE ->
        "VOLATILE"
    | WITH ->
        "WITH"
    | WRITES ->
        "WRITES"
    | WSTRING_CONSTANT _ ->
        "WSTRING_CONSTANT"

let _menhir_fail : unit -> 'a =
  fun () ->
    Printf.eprintf "Internal failure -- please contact the parser generator's developers.\n%!";
    assert false

include struct
  
  [@@@ocaml.warning "-4-37"]
  
  let _menhir_run_1408 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _v _tok ->
      (* State 1408: *)
      match (_tok : MenhirBasics.token) with
      | EOF ->
          (* Shifting (EOF) to state 1409 *)
          (* State 1409: *)
          (* Reducing production spec -> contract EOF *)
          let _1 = _v in
          let _v = _menhir_action_641 _1 in
          (* State 1407: *)
          (* Accepting *)
          MenhirBox_spec _v
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  let _menhir_goto_annot : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annot =
    fun _menhir_stack _v ->
      (* State 1331: *)
      (* Accepting *)
      MenhirBox_annot _v
  
  let _menhir_run_1324 : type  ttv_stack. ttv_stack -> _ -> _menhir_box_annot =
    fun _menhir_stack _v ->
      (* State 1324: *)
      (* The current token is EOF. *)
      (* Shifting (EOF) to state 1325 *)
      (* State 1325: *)
      (* Reducing production annot -> decl_list EOF *)
      let _1 = _v in
      let _v = _menhir_action_039 _1 in
      _menhir_goto_annot _menhir_stack _v
  
  let rec _menhir_goto_decl_list : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState1326 ->
          _menhir_run_1327 _menhir_stack _v
      | MenhirState0000 ->
          _menhir_run_1324 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1327 : type  ttv_stack. (ttv_stack, _menhir_box_annot) _menhir_cell1_decl -> _ -> _menhir_box_annot =
    fun _menhir_stack _v ->
      (* State 1327: *)
      let MenhirCell1_decl (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      (* Reducing production decl_list -> decl decl_list *)
      let _2 = _v in
      let _v = _menhir_action_220 _1 _2 _endpos__1_ _startpos__1_ in
      _menhir_goto_decl_list _menhir_stack _v _menhir_s
  
  let _menhir_goto_ext_global_specs_opt : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_cell1_ext_module_specs_opt -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _v ->
      (* State 1391: *)
      (* The current token is EOF. *)
      (* Shifting (EOF) to state 1392 *)
      (* State 1392: *)
      let MenhirCell1_ext_module_specs_opt (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ext_global_clauses_opt (_menhir_stack, _, _1) = _menhir_stack in
      (* Reducing production ext_spec -> ext_global_clauses_opt ext_module_specs_opt ext_global_specs_opt EOF *)
      let _3 = _v in
      let _v = _menhir_action_272 _1 _2 _3 in
      (* State 1347: *)
      (* Accepting *)
      MenhirBox_ext_spec _v
  
  let _menhir_run_1393 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_cell1_ext_module_specs_opt -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _v ->
      (* State 1393: *)
      (* Reducing production ext_global_specs_opt -> ext_global_specs *)
      let _1 = _v in
      let _v = _menhir_action_260 _1 in
      _menhir_goto_ext_global_specs_opt _menhir_stack _v
  
  let rec _menhir_goto_ext_global_specs : type  ttv_stack. ttv_stack -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _v _menhir_s ->
      match _menhir_s with
      | MenhirState1394 ->
          _menhir_run_1395 _menhir_stack _v
      | MenhirState1364 ->
          _menhir_run_1393 _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1395 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_spec -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _v ->
      (* State 1395: *)
      let MenhirCell1_ext_global_spec (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_global_specs -> ext_global_spec ext_global_specs *)
      let _2 = _v in
      let _v = _menhir_action_258 _1 _2 in
      _menhir_goto_ext_global_specs _menhir_stack _v _menhir_s
  
  let _menhir_run_1318 : type  ttv_stack. (ttv_stack, _menhir_box_annot) _menhir_cell1_is_acsl_spec -> _menhir_box_annot =
    fun _menhir_stack ->
      (* State 1318: *)
      (* The current token is EOF. *)
      (* Shifting (EOF) to state 1319 *)
      (* State 1319: *)
      let MenhirCell1_is_acsl_spec (_menhir_stack, _, _, _, _) = _menhir_stack in
      (* Reducing production annot -> is_acsl_spec any EOF *)
      let _v = _menhir_action_038 () in
      _menhir_goto_annot _menhir_stack _v
  
  let rec _menhir_goto_any : type  ttv_stack. ttv_stack -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_s ->
      match _menhir_s with
      | MenhirState1220 ->
          _menhir_run_1318 _menhir_stack
      | MenhirState1314 ->
          _menhir_run_1317 _menhir_stack
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1317 : type  ttv_stack. (ttv_stack, _menhir_box_annot) _menhir_cell1_wildcard -> _menhir_box_annot =
    fun _menhir_stack ->
      (* State 1317: *)
      let MenhirCell1_wildcard (_menhir_stack, _menhir_s, _) = _menhir_stack in
      (* Reducing production any -> wildcard any *)
      let _ = _menhir_action_047 () in
      _menhir_goto_any _menhir_stack _menhir_s
  
  let _menhir_run_1329 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annot =
    fun _menhir_stack _v _tok ->
      (* State 1329: *)
      match (_tok : MenhirBasics.token) with
      | EOF ->
          (* Shifting (EOF) to state 1330 *)
          (* State 1330: *)
          (* Reducing production annot -> annotation EOF *)
          let _1 = _v in
          let _v = _menhir_action_037 _1 in
          _menhir_goto_annot _menhir_stack _v
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  let rec _menhir_run_0001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production identifier -> WRITES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_329 () in
      _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_identifier : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1401 ->
          _menhir_run_1321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1382 ->
          _menhir_run_1321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_1321 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0496 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1195 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1184 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1179 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1173 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1174 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1166 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1163 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1154 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0937 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0942 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0929 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0920 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0922 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0881 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0876 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0857 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0860 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0862 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0849 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0845 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0760 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0822 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0832 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0823 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0763 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0812 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0819 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0804 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0798 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0776 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0774 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0132 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0139 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0337 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0348 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0349 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0350 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0710 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0670 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0654 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0646 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0644 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0603 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0462 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0562 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0476 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0553 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0551 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0549 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0545 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0547 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0543 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0479 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0541 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0539 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0526 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0533 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0386 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0369 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0370 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0380 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0372 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0359 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0323 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0284 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0262 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0259 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0236 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0228 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0206 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0204 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0154 ->
          _menhir_run_0198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1365 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1360 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1353 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1357 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1349 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1342 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1337 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1220 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1314 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1160 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1143 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1116 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1086 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1001 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0957 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0951 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0894 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0892 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0873 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0852 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0761 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0753 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0751 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0574 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0008 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0102 ->
          _menhir_run_0109 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1321 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1321: *)
      (* Reducing production annotation -> identifier *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_044 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_annotation : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1401 ->
          _menhir_run_1386 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1382 ->
          _menhir_run_1386 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0000 ->
          _menhir_run_1329 _menhir_stack _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1386 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup -> _ -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1386: *)
      (* Reducing production ext_stmt_loop_spec -> annotation *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_273 _1 in
      _menhir_goto_ext_stmt_loop_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _tok
  
  and _menhir_goto_ext_stmt_loop_spec : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup -> _ -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1383: *)
      let MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production ext_fun_spec -> ext_at_stmt_markup ext_stmt_loop_spec *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_235 _1 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_ext_fun_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ext_fun_spec : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1399 ->
          _menhir_run_1399 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1348 ->
          _menhir_run_1399 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1379 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1379 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1399 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1399: *)
      match (_tok : MenhirBasics.token) with
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_ext_fun_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_AT) to state 1353 *)
          _menhir_run_1353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1399
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_ext_fun_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONTRACT) to state 1360 *)
          _menhir_run_1360 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1399
      | EOF | FUNCTION | MODULE ->
          (* Reducing production ext_fun_specs -> ext_fun_spec *)
          let _1 = _v in
          let _v = _menhir_action_237 _1 in
          _menhir_goto_ext_fun_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1353 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1353: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EXT_AT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1353 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 1354 *)
          _menhir_run_1354 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0004 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 4: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production acsl_c_keyword -> VOLATILE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_034 () in
      _menhir_goto_acsl_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_acsl_c_keyword : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 112: *)
      (* Reducing production non_logic_keyword -> acsl_c_keyword *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_574 _1 in
      _menhir_goto_non_logic_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_non_logic_keyword : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 98: *)
      (* Reducing production keyword -> non_logic_keyword *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_387 _1 in
      _menhir_goto_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_keyword : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 104: *)
      (* Reducing production any_identifier -> keyword *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_051 _1 in
      _menhir_goto_any_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_any_identifier : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1353 ->
          _menhir_run_1359 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1357 ->
          _menhir_run_1359 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1365 ->
          _menhir_run_1352 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1360 ->
          _menhir_run_1352 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1349 ->
          _menhir_run_1352 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1342 ->
          _menhir_run_1343 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1337 ->
          _menhir_run_1338 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1220 ->
          _menhir_run_1316 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | MenhirState1314 ->
          _menhir_run_1316 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
      | MenhirState1160 ->
          _menhir_run_1161 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1143 ->
          _menhir_run_1144 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_1029 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_1029 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1116 ->
          _menhir_run_1029 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1086 ->
          _menhir_run_1029 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1001 ->
          _menhir_run_1029 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_1029 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0957 ->
          _menhir_run_0958 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0951 ->
          _menhir_run_0952 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0894 ->
          _menhir_run_0895 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0892 ->
          _menhir_run_0893 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0852 ->
          _menhir_run_0853 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0761 ->
          _menhir_run_0762 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0753 ->
          _menhir_run_0754 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0751 ->
          _menhir_run_0752 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0873 ->
          _menhir_run_0111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0574 ->
          _menhir_run_0111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0008 ->
          _menhir_run_0111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0102 ->
          _menhir_run_0111 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1359 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1359: *)
      (* Reducing production stmt_markup -> any_identifier *)
      let _1 = _v in
      let _v = _menhir_action_648 _1 in
      _menhir_goto_stmt_markup _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_stmt_markup : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1357: *)
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | VOID ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | VARIANT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | UNSIGNED ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | UNION ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | TYPENAME _v_0 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1357
      | TYPE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | STRUCT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | STATIC ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | SLICE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | SIZEOF ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | SIGNED ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | SHORT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | RETURNS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | REAL ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | READS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | MODULE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | MODEL ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | LOOP ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | LONG ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | LOGIC ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | LEMMA ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | LABEL ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | INT_CONSTANT _v_1 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INT_CONSTANT) to state 1354 *)
          _menhir_run_1354 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1357
      | INTEGER ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | INT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | IMPACT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | IF ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | IDENTIFIER _v_2 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1357
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | FREES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | FOR ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | FLOAT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | EXT_GLOBAL_BLOCK _v_3 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1357
      | EXT_GLOBAL _v_4 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState1357
      | EXT_CONTRACT _v_5 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1357
      | EXT_CODE_ANNOT _v_6 ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState1357
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | EXITS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ENUM ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ENSURES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ELSE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | DECREASES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CONST ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHECK ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CHAR ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | CASE ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | BREAKS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | BOOLEAN ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | BOOL ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | AXIOM ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ASSERT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | ADMIT ->
          let _menhir_stack = MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1357
      | COLON ->
          (* Reducing production stmt_markup_attr -> stmt_markup *)
          let _1 = _v in
          let _v = _menhir_action_650 _1 in
          _menhir_goto_stmt_markup_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0005 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 5: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> VOID *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_149 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_c_keyword : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 110: *)
      (* Reducing production non_logic_keyword -> c_keyword *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_573 _1 in
      _menhir_goto_non_logic_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0009 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 9: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> VARIANT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_363 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_is_acsl_decl_or_code_annot : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 108: *)
      (* Reducing production non_logic_keyword -> is_acsl_decl_or_code_annot *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_577 _1 in
      _menhir_goto_non_logic_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0010 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 10: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> UNSIGNED *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_148 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0011 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 11: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> UNION *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_147 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0012 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 12: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production any_identifier -> TYPENAME *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_050 _1 in
      _menhir_goto_any_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0013 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 13: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> TYPE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_360 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0014 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 14: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> TERMINATES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_374 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_is_acsl_spec : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0000 ->
          _menhir_run_1220 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1365 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1360 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1353 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1357 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1349 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1342 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1337 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1220 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1314 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1160 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1143 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1116 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1086 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1001 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0957 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0951 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0894 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0892 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0873 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0852 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0761 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0753 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0751 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0574 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0008 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0102 ->
          _menhir_run_0107 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1220 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _ -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1220: *)
      let _menhir_stack = MenhirCell1_is_acsl_spec (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _ ->
          (* Shifting (WSTRING_CONSTANT) to state 1221 *)
          _menhir_run_1221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | WITH ->
          (* Shifting (WITH) to state 1222 *)
          _menhir_run_1222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 1223 *)
          _menhir_run_1223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 1224 *)
          _menhir_run_1224 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 1225 *)
          _menhir_run_1225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 1226 *)
          _menhir_run_1226 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | VALID ->
          (* Shifting (VALID) to state 1227 *)
          _menhir_run_1227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 1228 *)
          _menhir_run_1228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 1229 *)
          _menhir_run_1229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1220
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | TRUE ->
          (* Shifting (TRUE) to state 1230 *)
          _menhir_run_1230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | TILDE ->
          (* Shifting (TILDE) to state 1231 *)
          _menhir_run_1231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | STRING_LITERAL _ ->
          (* Shifting (STRING_LITERAL) to state 1232 *)
          _menhir_run_1232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | STRING_CONSTANT _ ->
          (* Shifting (STRING_CONSTANT) to state 1233 *)
          _menhir_run_1233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | STARHAT ->
          (* Shifting (STARHAT) to state 1234 *)
          _menhir_run_1234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | STAR ->
          (* Shifting (STAR) to state 1235 *)
          _menhir_run_1235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SLASH ->
          (* Shifting (SLASH) to state 1236 *)
          _menhir_run_1236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 1237 *)
          _menhir_run_1237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1238 *)
          _menhir_run_1238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | RSQUAREPIPE ->
          (* Shifting (RSQUAREPIPE) to state 1239 *)
          _menhir_run_1239 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 1240 *)
          _menhir_run_1240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | RPAR ->
          (* Shifting (RPAR) to state 1241 *)
          _menhir_run_1241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | RESULT ->
          (* Shifting (RESULT) to state 1242 *)
          _menhir_run_1242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | REGISTER ->
          (* Shifting (REGISTER) to state 1243 *)
          _menhir_run_1243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | RBRACE ->
          (* Shifting (RBRACE) to state 1244 *)
          _menhir_run_1244 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | QUESTION ->
          (* Shifting (QUESTION) to state 1245 *)
          _menhir_run_1245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | PLUS ->
          (* Shifting (PLUS) to state 1246 *)
          _menhir_run_1246 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | PIPE ->
          (* Shifting (PIPE) to state 1247 *)
          _menhir_run_1247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | PI ->
          (* Shifting (PI) to state 1248 *)
          _menhir_run_1248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | PERCENT ->
          (* Shifting (PERCENT) to state 1249 *)
          _menhir_run_1249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | OR ->
          (* Shifting (OR) to state 1250 *)
          _menhir_run_1250 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | OLD ->
          (* Shifting (OLD) to state 1251 *)
          _menhir_run_1251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | OFFSET ->
          (* Shifting (OFFSET) to state 1252 *)
          _menhir_run_1252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 1253 *)
          _menhir_run_1253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | NULL ->
          (* Shifting (NULL) to state 1254 *)
          _menhir_run_1254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | NOTHING ->
          (* Shifting (NOTHING) to state 1255 *)
          _menhir_run_1255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | NOT ->
          (* Shifting (NOT) to state 1256 *)
          _menhir_run_1256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | NE ->
          (* Shifting (NE) to state 1257 *)
          _menhir_run_1257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | MINUS ->
          (* Shifting (MINUS) to state 1258 *)
          _menhir_run_1258 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LTLT ->
          (* Shifting (LTLT) to state 1259 *)
          _menhir_run_1259 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LT ->
          (* Shifting (LT) to state 1260 *)
          _menhir_run_1260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 1261 *)
          _menhir_run_1261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 1262 *)
          _menhir_run_1262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LPAR ->
          (* Shifting (LPAR) to state 1263 *)
          _menhir_run_1263 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LET ->
          (* Shifting (LET) to state 1264 *)
          _menhir_run_1264 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LE ->
          (* Shifting (LE) to state 1265 *)
          _menhir_run_1265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LBRACE ->
          (* Shifting (LBRACE) to state 1266 *)
          _menhir_run_1266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 1267 *)
          _menhir_run_1267 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INT_CONSTANT _ ->
          (* Shifting (INT_CONSTANT) to state 1268 *)
          _menhir_run_1268 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INTER ->
          (* Shifting (INTER) to state 1269 *)
          _menhir_run_1269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 1270 *)
          _menhir_run_1270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | IN ->
          (* Shifting (IN) to state 1271 *)
          _menhir_run_1271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 1272 *)
          _menhir_run_1272 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | IFF ->
          (* Shifting (IFF) to state 1273 *)
          _menhir_run_1273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | IDENTIFIER _v_5 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1220
      | HATHAT ->
          (* Shifting (HATHAT) to state 1274 *)
          _menhir_run_1274 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | HAT ->
          (* Shifting (HAT) to state 1275 *)
          _menhir_run_1275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | GTGT ->
          (* Shifting (GTGT) to state 1276 *)
          _menhir_run_1276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | GT ->
          (* Shifting (GT) to state 1277 *)
          _menhir_run_1277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | GHOST ->
          (* Shifting (GHOST) to state 1278 *)
          _menhir_run_1278 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | GE ->
          (* Shifting (GE) to state 1279 *)
          _menhir_run_1279 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FROM ->
          (* Shifting (FROM) to state 1280 *)
          _menhir_run_1280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FRESH ->
          (* Shifting (FRESH) to state 1281 *)
          _menhir_run_1281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 1282 *)
          _menhir_run_1282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FORALL ->
          (* Shifting (FORALL) to state 1283 *)
          _menhir_run_1283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FLOAT_CONSTANT _ ->
          (* Shifting (FLOAT_CONSTANT) to state 1284 *)
          _menhir_run_1284 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | FALSE ->
          (* Shifting (FALSE) to state 1285 *)
          _menhir_run_1285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EXT_GLOBAL_BLOCK _v_7 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState1220
      | EXT_GLOBAL _v_8 ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState1220
      | EXT_CONTRACT _v_9 ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState1220
      | EXT_CODE_ANNOT _v_10 ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState1220
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EXISTS ->
          (* Shifting (EXISTS) to state 1286 *)
          _menhir_run_1286 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EQUAL ->
          (* Shifting (EQUAL) to state 1287 *)
          _menhir_run_1287 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EQ ->
          (* Shifting (EQ) to state 1288 *)
          _menhir_run_1288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | EMPTY ->
          (* Shifting (EMPTY) to state 1289 *)
          _menhir_run_1289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 1290 *)
          _menhir_run_1290 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DOTDOTDOT ->
          (* Shifting (DOTDOTDOT) to state 1291 *)
          _menhir_run_1291 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DOTDOT ->
          (* Shifting (DOTDOT) to state 1292 *)
          _menhir_run_1292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DOT ->
          (* Shifting (DOT) to state 1293 *)
          _menhir_run_1293 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DOLLAR ->
          (* Shifting (DOLLAR) to state 1294 *)
          _menhir_run_1294 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | DANGLING ->
          (* Shifting (DANGLING) to state 1295 *)
          _menhir_run_1295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | COMMA ->
          (* Shifting (COMMA) to state 1296 *)
          _menhir_run_1296 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | COLONCOLON ->
          (* Shifting (COLONCOLON) to state 1297 *)
          _menhir_run_1297 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | COLON2 ->
          (* Shifting (COLON2) to state 1298 *)
          _menhir_run_1298 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | COLON ->
          (* Shifting (COLON) to state 1299 *)
          _menhir_run_1299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BSUNION ->
          (* Shifting (BSUNION) to state 1300 *)
          _menhir_run_1300 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 1301 *)
          _menhir_run_1301 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 1302 *)
          _menhir_run_1302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 1303 *)
          _menhir_run_1303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 1304 *)
          _menhir_run_1304 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BIFF ->
          (* Shifting (BIFF) to state 1305 *)
          _menhir_run_1305 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 1306 *)
          _menhir_run_1306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 1307 *)
          _menhir_run_1307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | AT ->
          (* Shifting (AT) to state 1308 *)
          _menhir_run_1308 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ARROW ->
          (* Shifting (ARROW) to state 1309 *)
          _menhir_run_1309 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | AND ->
          (* Shifting (AND) to state 1310 *)
          _menhir_run_1310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | AMP ->
          (* Shifting (AMP) to state 1311 *)
          _menhir_run_1311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 1312 *)
          _menhir_run_1312 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 1313 *)
          _menhir_run_1313 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1220
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1221 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1221: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> WSTRING_CONSTANT *)
      let _v = _menhir_action_807 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_wildcard : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _ -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1314: *)
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (WSTRING_CONSTANT) to state 1221 *)
          _menhir_run_1221 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | WRITES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | WITH ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (WITH) to state 1222 *)
          _menhir_run_1222 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VOID ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VARIANT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VALID_READ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VALID_READ) to state 1223 *)
          _menhir_run_1223 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VALID_RANGE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VALID_RANGE) to state 1224 *)
          _menhir_run_1224 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VALID_INDEX ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VALID_INDEX) to state 1225 *)
          _menhir_run_1225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VALID_FUNCTION ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VALID_FUNCTION) to state 1226 *)
          _menhir_run_1226 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | VALID ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VALID) to state 1227 *)
          _menhir_run_1227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | UNSIGNED ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | UNION ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | UNALLOCATED ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (UNALLOCATED) to state 1228 *)
          _menhir_run_1228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | TYPEOF ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPEOF) to state 1229 *)
          _menhir_run_1229 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | TYPENAME _v_1 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1314
      | TYPE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | TRUE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TRUE) to state 1230 *)
          _menhir_run_1230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | TILDE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TILDE) to state 1231 *)
          _menhir_run_1231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | STRUCT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | STRING_LITERAL _ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STRING_LITERAL) to state 1232 *)
          _menhir_run_1232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | STRING_CONSTANT _ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STRING_CONSTANT) to state 1233 *)
          _menhir_run_1233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | STATIC ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | STARHAT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STARHAT) to state 1234 *)
          _menhir_run_1234 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | STAR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STAR) to state 1235 *)
          _menhir_run_1235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SLICE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SLASH ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SLASH) to state 1236 *)
          _menhir_run_1236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SIZEOF ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SIGNED ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SHORT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SEPARATED ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SEPARATED) to state 1237 *)
          _menhir_run_1237 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | SEMICOLON ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SEMICOLON) to state 1238 *)
          _menhir_run_1238 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | RSQUAREPIPE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RSQUAREPIPE) to state 1239 *)
          _menhir_run_1239 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | RSQUARE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RSQUARE) to state 1240 *)
          _menhir_run_1240 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | RPAR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RPAR) to state 1241 *)
          _menhir_run_1241 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | RETURNS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | RESULT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RESULT) to state 1242 *)
          _menhir_run_1242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | REGISTER ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (REGISTER) to state 1243 *)
          _menhir_run_1243 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | REAL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | READS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | RBRACE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (RBRACE) to state 1244 *)
          _menhir_run_1244 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | QUESTION ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (QUESTION) to state 1245 *)
          _menhir_run_1245 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | PLUS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PLUS) to state 1246 *)
          _menhir_run_1246 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | PIPE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PIPE) to state 1247 *)
          _menhir_run_1247 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | PI ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PI) to state 1248 *)
          _menhir_run_1248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | PERCENT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PERCENT) to state 1249 *)
          _menhir_run_1249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | OR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (OR) to state 1250 *)
          _menhir_run_1250 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | OLD ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (OLD) to state 1251 *)
          _menhir_run_1251 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | OFFSET ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (OFFSET) to state 1252 *)
          _menhir_run_1252 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | OBJECT_POINTER ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (OBJECT_POINTER) to state 1253 *)
          _menhir_run_1253 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | NULL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (NULL) to state 1254 *)
          _menhir_run_1254 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | NOTHING ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (NOTHING) to state 1255 *)
          _menhir_run_1255 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | NOT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (NOT) to state 1256 *)
          _menhir_run_1256 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | NE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (NE) to state 1257 *)
          _menhir_run_1257 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | MODULE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | MODEL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | MINUS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MINUS) to state 1258 *)
          _menhir_run_1258 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LTLT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LTLT) to state 1259 *)
          _menhir_run_1259 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LT) to state 1260 *)
          _menhir_run_1260 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LSQUAREPIPE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUAREPIPE) to state 1261 *)
          _menhir_run_1261 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 1262 *)
          _menhir_run_1262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LPAR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 1263 *)
          _menhir_run_1263 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LOOP ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LONG ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LOGIC ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LET ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LET) to state 1264 *)
          _menhir_run_1264 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LEMMA ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LE) to state 1265 *)
          _menhir_run_1265 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LBRACE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LBRACE) to state 1266 *)
          _menhir_run_1266 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LAMBDA ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LAMBDA) to state 1267 *)
          _menhir_run_1267 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | LABEL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INT_CONSTANT _ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INT_CONSTANT) to state 1268 *)
          _menhir_run_1268 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INTER ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INTER) to state 1269 *)
          _menhir_run_1269 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INTEGER ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INITIALIZED ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INITIALIZED) to state 1270 *)
          _menhir_run_1270 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | IN ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IN) to state 1271 *)
          _menhir_run_1271 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IMPLIES) to state 1272 *)
          _menhir_run_1272 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | IMPACT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | IFF ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IFF) to state 1273 *)
          _menhir_run_1273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | IF ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | IDENTIFIER _v_5 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1314
      | HATHAT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (HATHAT) to state 1274 *)
          _menhir_run_1274 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | HAT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (HAT) to state 1275 *)
          _menhir_run_1275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | GTGT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GTGT) to state 1276 *)
          _menhir_run_1276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | GT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GT) to state 1277 *)
          _menhir_run_1277 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | GHOST ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GHOST) to state 1278 *)
          _menhir_run_1278 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | GE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GE) to state 1279 *)
          _menhir_run_1279 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FROM ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FROM) to state 1280 *)
          _menhir_run_1280 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FRESH ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FRESH) to state 1281 *)
          _menhir_run_1281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FREES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FREEABLE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FREEABLE) to state 1282 *)
          _menhir_run_1282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FORALL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FORALL) to state 1283 *)
          _menhir_run_1283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FOR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FLOAT_CONSTANT _ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FLOAT_CONSTANT) to state 1284 *)
          _menhir_run_1284 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FLOAT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | FALSE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FALSE) to state 1285 *)
          _menhir_run_1285 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EXT_GLOBAL_BLOCK _v_7 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState1314
      | EXT_GLOBAL _v_8 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState1314
      | EXT_CONTRACT _v_9 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState1314
      | EXT_CODE_ANNOT _v_10 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState1314
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EXITS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EXISTS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXISTS) to state 1286 *)
          _menhir_run_1286 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EQUAL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EQUAL) to state 1287 *)
          _menhir_run_1287 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EQ ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EQ) to state 1288 *)
          _menhir_run_1288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ENUM ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ENSURES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EMPTY ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EMPTY) to state 1289 *)
          _menhir_run_1289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ELSE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DYNAMIC ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DYNAMIC) to state 1290 *)
          _menhir_run_1290 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DOTDOTDOT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOTDOTDOT) to state 1291 *)
          _menhir_run_1291 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DOTDOT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOTDOT) to state 1292 *)
          _menhir_run_1292 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DOT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOT) to state 1293 *)
          _menhir_run_1293 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DOLLAR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOLLAR) to state 1294 *)
          _menhir_run_1294 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DECREASES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | DANGLING ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DANGLING) to state 1295 *)
          _menhir_run_1295 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CONST ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | COMMA ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 1296 *)
          _menhir_run_1296 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | COLONCOLON ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COLONCOLON) to state 1297 *)
          _menhir_run_1297 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | COLON2 ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COLON2) to state 1298 *)
          _menhir_run_1298 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | COLON ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COLON) to state 1299 *)
          _menhir_run_1299 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHECK ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CHAR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | CASE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BSUNION ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BSUNION) to state 1300 *)
          _menhir_run_1300 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BSTYPE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BSTYPE) to state 1301 *)
          _menhir_run_1301 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BSGHOST ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BSGHOST) to state 1302 *)
          _menhir_run_1302 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BREAKS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BOOLEAN ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BOOL ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BLOCK_LENGTH ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BLOCK_LENGTH) to state 1303 *)
          _menhir_run_1303 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BIMPLIES) to state 1304 *)
          _menhir_run_1304 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BIFF ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BIFF) to state 1305 *)
          _menhir_run_1305 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | BASE_ADDR ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (BASE_ADDR) to state 1306 *)
          _menhir_run_1306 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | AXIOM ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | AUTOMATIC ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AUTOMATIC) to state 1307 *)
          _menhir_run_1307 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | AT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AT) to state 1308 *)
          _menhir_run_1308 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ASSERT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ARROW ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ARROW) to state 1309 *)
          _menhir_run_1309 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | AND ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AND) to state 1310 *)
          _menhir_run_1310 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | AMP ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AMP) to state 1311 *)
          _menhir_run_1311 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ALLOCATION ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ALLOCATION) to state 1312 *)
          _menhir_run_1312 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ALLOCABLE ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ALLOCABLE) to state 1313 *)
          _menhir_run_1313 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | ADMIT ->
          let _menhir_stack = MenhirCell1_wildcard (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1314
      | EOF ->
          (* Reducing production any -> wildcard *)
          let _ = _menhir_action_046 () in
          _menhir_goto_any _menhir_stack _menhir_s
  
  and _menhir_run_1222 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1222: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> WITH *)
      let _ = _menhir_action_130 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_goto_bs_keyword : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _ -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok ->
      (* State 1315: *)
      (* Reducing production wildcard -> bs_keyword *)
      let _v = _menhir_action_794 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1223 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1223: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> VALID_READ *)
      let _ = _menhir_action_126 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1224 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1224: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> VALID_RANGE *)
      let _ = _menhir_action_125 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1225 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1225: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> VALID_INDEX *)
      let _ = _menhir_action_124 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1226 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1226: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> VALID_FUNCTION *)
      let _ = _menhir_action_127 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1227 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1227: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> VALID *)
      let _ = _menhir_action_123 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1228 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1228: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> UNALLOCATED *)
      let _ = _menhir_action_121 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1229 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1229: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> TYPEOF *)
      let _ = _menhir_action_119 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1230 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1230: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> TRUE *)
      let _ = _menhir_action_117 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1231 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1231: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> TILDE *)
      let _v = _menhir_action_848 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0015 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 15: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> STRUCT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_146 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1232 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1232: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> STRING_LITERAL *)
      let _v = _menhir_action_847 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1233 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1233: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> STRING_CONSTANT *)
      let _v = _menhir_action_806 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0016 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 16: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> STATIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_145 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1234 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1234: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> STARHAT *)
      let _v = _menhir_action_846 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1235 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1235: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> STAR *)
      let _v = _menhir_action_845 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0017 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 17: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> SLICE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_359 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1236 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1236: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> SLASH *)
      let _v = _menhir_action_844 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0018 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 18: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> SIZEOF *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_144 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0019 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 19: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> SIGNED *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_143 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0020 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 20: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> SHORT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_142 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1237 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1237: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> SEPARATED *)
      let _ = _menhir_action_116 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1238 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1238: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> SEMICOLON *)
      let _v = _menhir_action_843 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1239 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1239: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> RSQUAREPIPE *)
      let _v = _menhir_action_842 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1240 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1240: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> RSQUARE *)
      let _v = _menhir_action_841 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1241 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1241: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> RPAR *)
      let _v = _menhir_action_840 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0021 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 21: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> RETURNS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_602 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_post_cond : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1061 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1124 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1098 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1067 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1070 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1079 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1074 ->
          _menhir_run_1076 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1117 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1111 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1090 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1069 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1073 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1078 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1064 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1055 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1050 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0966 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0969 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0972 ->
          _menhir_run_0995 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1365 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1360 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1353 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1357 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1349 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1342 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1337 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1220 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1314 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1160 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1143 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1116 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1086 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1001 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0957 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0951 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0894 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0892 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0873 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0852 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0761 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0753 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0751 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0574 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0102 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0008 ->
          _menhir_run_0097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1076 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1076: *)
      (* Reducing production post_cond_kind -> post_cond *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_613 _1 in
      _menhir_goto_post_cond_kind _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_post_cond_kind : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1124 ->
          _menhir_run_1132 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _tok
      | MenhirState1061 ->
          _menhir_run_1072 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1098 ->
          _menhir_run_1072 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1067 ->
          _menhir_run_1072 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1079 ->
          _menhir_run_1072 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1074 ->
          _menhir_run_1072 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1070 ->
          _menhir_run_1072 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1132 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, ttv_result) _menhir_cell1_simple_clauses, ttv_result) _menhir_cell1_behaviors, ttv_result) _menhir_cell1_ne_complete_or_disjoint -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _tok ->
      (* State 1132: *)
      let MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _, _, _, _) = _menhir_stack in
      let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
      let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
      let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
      (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint post_cond_kind *)
      let (_endpos__7_, _startpos__7_) = (_endpos, _startpos) in
      let _v = _menhir_action_200 _endpos__7_ _startpos__7_ in
      _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
  
  and _menhir_goto_contract : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1406 ->
          _menhir_run_1408 _menhir_stack _v _tok
      | MenhirState1384 ->
          _menhir_run_1385 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1380 ->
          _menhir_run_1381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0964 ->
          _menhir_run_1141 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1385 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup, _menhir_box_ext_spec) _menhir_cell1_ext_contract_markup -> _ -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1385: *)
      let MenhirCell1_ext_contract_markup (_menhir_stack, _, _) = _menhir_stack in
      (* Reducing production ext_stmt_loop_spec -> ext_contract_markup contract *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_274 _2 in
      _menhir_goto_ext_stmt_loop_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _tok
  
  and _menhir_run_1381 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_contract_markup -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1381: *)
      let MenhirCell1_ext_contract_markup (_menhir_stack, _menhir_s, _) = _menhir_stack in
      (* Reducing production ext_fun_spec -> ext_contract_markup contract *)
      let _2 = _v in
      let _v = _menhir_action_236 _2 in
      _menhir_goto_ext_fun_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1141 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_ne_behavior_name_list _menhir_cell0_COLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1141: *)
      (* Reducing production contract_or_code_annotation -> contract *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_201 _1 in
      _menhir_goto_contract_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _tok
  
  and _menhir_goto_contract_or_code_annotation : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_ne_behavior_name_list _menhir_cell0_COLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1140: *)
      let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ne_behavior_name_list (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_FOR (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production annotation -> FOR ne_behavior_name_list COLON contract_or_code_annotation *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_041 _2 _4 in
      _menhir_goto_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _v _menhir_s _tok
  
  and _menhir_run_1072 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1072: *)
      let _menhir_stack = MenhirCell1_post_cond_kind (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1072
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1072
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | STRING_LITERAL _v_2 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1072
      | STRING_CONSTANT _v_3 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1072
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INT_CONSTANT _v_4 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState1072
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | IDENTIFIER _v_5 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1072
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FLOAT_CONSTANT _v_6 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState1072
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | EXT_GLOBAL_BLOCK _v_7 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState1072
      | EXT_GLOBAL _v_8 ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState1072
      | EXT_CONTRACT _v_9 ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState1072
      | EXT_CODE_ANNOT _v_10 ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState1072
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1072
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0003 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 3: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production constant -> WSTRING_CONSTANT *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_183 _1 in
      _menhir_goto_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_constant : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 510: *)
      (* Reducing production lexpr_inner -> constant *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_437 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_lexpr_inner : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0132 ->
          _menhir_run_0731 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0139 ->
          _menhir_run_0730 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0337 ->
          _menhir_run_0723 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0348 ->
          _menhir_run_0715 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0349 ->
          _menhir_run_0715 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0350 ->
          _menhir_run_0714 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0710 ->
          _menhir_run_0711 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0462 ->
          _menhir_run_0572 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0562 ->
          _menhir_run_0563 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0553 ->
          _menhir_run_0554 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0551 ->
          _menhir_run_0552 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0549 ->
          _menhir_run_0550 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0547 ->
          _menhir_run_0548 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0545 ->
          _menhir_run_0546 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0543 ->
          _menhir_run_0544 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0479 ->
          _menhir_run_0480 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0476 ->
          _menhir_run_0478 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0475 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0731 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TILDE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 731: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0731
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0731
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0731
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_TILDE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> TILDE lexpr_inner *)
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_451 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0481 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 481: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0481
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0481
      | DOTDOT ->
          (* Reducing production lexpr_option -> *)
          let _v = _menhir_action_484 () in
          _menhir_run_0484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0481 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0006 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 6: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> VARIANT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_320 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> VARIANT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_363 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_full_identifier : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1195 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1184 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1179 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1174 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1166 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1154 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0937 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0942 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0929 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0922 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0857 ->
          _menhir_run_0872 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0876 ->
          _menhir_run_0848 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0849 ->
          _menhir_run_0848 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0845 ->
          _menhir_run_0848 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1163 ->
          _menhir_run_0844 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0760 ->
          _menhir_run_0844 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0822 ->
          _menhir_run_0824 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0832 ->
          _menhir_run_0824 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0823 ->
          _menhir_run_0824 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0132 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0139 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0337 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0348 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0349 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0350 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0710 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0462 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0562 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0476 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0553 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0551 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0549 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0545 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0547 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0543 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0479 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0497 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0804 ->
          _menhir_run_0382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0386 ->
          _menhir_run_0382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0369 ->
          _menhir_run_0382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0370 ->
          _menhir_run_0382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0380 ->
          _menhir_run_0382 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0359 ->
          _menhir_run_0362 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0372 ->
          _menhir_run_0238 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0236 ->
          _menhir_run_0238 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1173 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0920 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0881 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0860 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0862 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0763 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0812 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0819 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0798 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0776 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0774 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0670 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0654 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0646 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0644 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0603 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0541 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0539 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0526 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0533 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0323 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0284 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0262 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0259 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0228 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0206 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0204 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0154 ->
          _menhir_run_0199 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0872 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 872: *)
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LT) to state 845 *)
          _menhir_run_0845 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LBRACE ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LBRACE) to state 873 *)
          (* State 873: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LBRACE (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0873 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | COLON | EQUAL | LPAR | READS | SEMICOLON ->
          (* Reducing production poly_id_type -> full_identifier *)
          let _1 = _v in
          let _v = _menhir_action_595 _1 in
          _menhir_goto_poly_id_type _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0845 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_full_identifier -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 845: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_LT (_menhir_stack, _startpos) in
      let _menhir_s = MenhirState0845 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0133 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 133: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> VARIANT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_320 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0134 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 134: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> TYPE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_319 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0135 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 135: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> TERMINATES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_318 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0140 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 140: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> SLICE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_317 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0156 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 156: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> RETURNS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_316 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0157 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 157: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> REQUIRES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_315 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0024 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 24: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production identifier -> READS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_328 () in
      _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0158 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 158: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> PREDICATE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_314 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0159 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 159: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> PRAGMA *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_313 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0160 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 160: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> MODULE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_312 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0161 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 161: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> MODEL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_311 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0162 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 162: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> LOOP *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_310 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0163 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 163: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> LOGIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_309 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0164 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 164: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> LEMMA *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_307 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0033 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 33: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production identifier -> LABEL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_327 () in
      _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0165 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 165: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> INVARIANT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_306 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0166 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 166: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> INDUCTIVE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_304 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0167 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 167: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> INCLUDE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_305 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0168 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 168: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> IMPACT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_303 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0041 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 41: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production identifier -> IDENTIFIER *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_325 _1 in
      _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0169 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 169: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> GLOBAL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_302 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0170 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 170: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> FUNCTION *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_301 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0171 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 171: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> FREES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_300 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0172 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 172: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXT_LET *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_308 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0173 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 173: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXT_GLOBAL_BLOCK *)
      let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_324 id in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
  
  and _menhir_run_0174 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 174: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXT_GLOBAL *)
      let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_323 id in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
  
  and _menhir_run_0175 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 175: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXT_CONTRACT *)
      let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_322 id in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
  
  and _menhir_run_0176 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 176: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXT_CODE_ANNOT *)
      let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_321 id in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
  
  and _menhir_run_0177 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 177: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXT_AT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_287 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0178 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 178: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> EXITS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_299 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0179 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 179: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> ENSURES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_298 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0180 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 180: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> DISJOINT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_297 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0181 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 181: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> DECREASES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_296 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0182 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 182: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> CONTRACT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_295 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0183 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 183: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> CONTINUES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_294 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0184 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 184: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> COMPLETE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_293 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0185 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 185: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> CHECK *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_292 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0186 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 186: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> BREAKS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_291 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0079 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 79: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production identifier -> BEHAVIORS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_326 () in
      _menhir_goto_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0187 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 187: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> BEHAVIOR *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_290 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0188 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 188: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> AXIOMATIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_289 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0189 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 189: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> AXIOM *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_288 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0190 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 190: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> ASSUMES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_286 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0191 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 191: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> ASSIGNS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_285 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0192 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 192: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> ASSERT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_284 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0193 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 193: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> ALLOCATES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_283 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0194 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 194: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production full_identifier -> ADMIT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_282 () in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0022 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 22: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> REQUIRES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_371 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0023 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 23: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_typename -> REAL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_379 () in
      _menhir_goto_is_acsl_typename _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_is_acsl_typename : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0359 ->
          _menhir_run_0361 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _menhir_s _tok
      | MenhirState0798 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0776 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0774 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0670 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0654 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0646 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0644 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0603 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0541 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0539 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0533 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0526 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0323 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0284 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0262 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0259 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0228 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0206 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0204 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0154 ->
          _menhir_run_0195 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1365 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1360 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1353 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1357 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1349 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1342 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1337 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1220 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1314 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1160 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1143 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1116 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1086 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1001 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0957 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0951 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0894 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0892 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0873 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0852 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0761 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0753 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0751 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0574 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0008 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0102 ->
          _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0361 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LET as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _menhir_s _tok ->
      (* State 361: *)
      (* Reducing production bounded_var -> is_acsl_typename *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_091 _endpos__1_ _startpos__1_ in
      _menhir_goto_bounded_var _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_bounded_var : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LET as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 363: *)
      let _menhir_stack = MenhirCell1_bounded_var (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          (* Shifting (EQUAL) to state 364 *)
          (* State 364: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState0364 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0007 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 7: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VALID_READ (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0007
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0007 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0008 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 8: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0008 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0025 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 25: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> PREDICATE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_358 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 26: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> PRAGMA *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_357 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0027 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 27: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_ext_spec -> MODULE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_382 () in
      _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_is_ext_spec : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 105: *)
      (* Reducing production non_logic_keyword -> is_ext_spec *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_575 _1 in
      _menhir_goto_non_logic_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0028 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 28: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> MODEL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_361 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0029 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 29: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> LOOP *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_354 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 30: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> LONG *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_141 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0031 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 31: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production keyword -> LOGIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_386 () in
      _menhir_goto_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0032 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 32: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> LEMMA *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_351 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0034 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 34: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> INVARIANT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_348 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0035 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 35: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_typename -> INTEGER *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_378 () in
      _menhir_goto_is_acsl_typename _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0036 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 36: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> INT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_140 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0037 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 37: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> INDUCTIVE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_347 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0038 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 38: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_ext_spec -> INCLUDE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_383 () in
      _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0039 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 39: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> IMPACT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_346 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0040 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 40: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> IF *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_139 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0042 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 42: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> GLOBAL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_345 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0043 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 43: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_ext_spec -> FUNCTION *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_381 () in
      _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0044 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 44: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> FREES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_369 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0045 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 45: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production acsl_c_keyword -> FOR *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_033 () in
      _menhir_goto_acsl_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0046 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 46: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> FLOAT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_138 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0047 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 47: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_ext_spec -> EXT_LET *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_385 () in
      _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 48: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> EXT_GLOBAL_BLOCK *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_340 _1 in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0049 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 49: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> EXT_GLOBAL *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_339 _1 in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0050 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 50: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> EXT_CONTRACT *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_366 _1 in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0051 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 51: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> EXT_CODE_ANNOT *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_338 _1 in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0052 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 52: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_ext_spec -> EXT_AT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_384 () in
      _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0053 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 53: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> EXITS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_599 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0054 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 54: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> ENUM *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_136 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0055 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 55: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> ENSURES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_598 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0056 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 56: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> ELSE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_137 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0057 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 57: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> DOUBLE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_135 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0058 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 58: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> DISJOINT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_377 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0059 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 59: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> DECREASES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_376 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0060 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 60: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_ext_spec -> CONTRACT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_380 () in
      _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0061 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 61: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> CONTINUES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_601 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0062 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 62: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> CONST *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_134 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0063 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 63: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> COMPLETE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_375 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0064 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 64: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> CHECK_RETURNS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_607 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0065 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 65: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> CHECK_REQUIRES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_372 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0066 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 66: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> CHECK_LOOP *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_356 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0067 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 67: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> CHECK_LEMMA *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_353 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0068 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 68: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> CHECK_INVARIANT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_350 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0069 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 69: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> CHECK_EXITS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_604 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0070 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 70: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> CHECK_ENSURES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_603 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0071 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 71: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> CHECK_CONTINUES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_606 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0072 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 72: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> CHECK_BREAKS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_605 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0073 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 73: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> CHECK *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_343 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0074 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 74: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> CHAR *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_131 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0075 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 75: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production acsl_c_keyword -> CASE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_032 () in
      _menhir_goto_acsl_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0076 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 76: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> BREAKS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_600 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0077 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 77: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> BOOLEAN *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_132 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0078 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 78: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production c_keyword -> BOOL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_133 () in
      _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0080 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 80: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> BEHAVIOR *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_370 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0081 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 81: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> AXIOMATIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_364 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0082 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 82: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> AXIOM *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_362 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0083 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 83: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> ASSUMES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_341 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0084 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 84: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> ASSIGNS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_367 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0085 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 85: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> ASSERT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_342 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0086 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 86: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> ALLOCATES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_368 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0087 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 87: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> ADMIT_RETURNS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_612 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0088 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 88: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_spec -> ADMIT_REQUIRES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_373 () in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 89: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> ADMIT_LOOP *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_355 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0090 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 90: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> ADMIT_LEMMA *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_352 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0091 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 91: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> ADMIT_INVARIANT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_349 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0092 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 92: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> ADMIT_EXITS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_609 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0093 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 93: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> ADMIT_ENSURES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_608 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0094 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 94: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> ADMIT_CONTINUES *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_611 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0095 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 95: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production post_cond -> ADMIT_BREAKS *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_610 () in
      _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0096 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 96: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production is_acsl_decl_or_code_annot -> ADMIT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_344 () in
      _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0113 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 113: *)
      (* Reducing production opt_label_1 -> opt_label_list *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_578 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_opt_label_1 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_opt_label_1 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0467 ->
          _menhir_run_0468 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0463 ->
          _menhir_run_0464 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0451 ->
          _menhir_run_0452 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0447 ->
          _menhir_run_0448 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0431 ->
          _menhir_run_0432 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0408 ->
          _menhir_run_0409 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0395 ->
          _menhir_run_0396 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0344 ->
          _menhir_run_0345 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0341 ->
          _menhir_run_0342 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0124 ->
          _menhir_run_0125 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0119 ->
          _menhir_run_0120 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0116 ->
          _menhir_run_0117 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0007 ->
          _menhir_run_0114 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0468 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ALLOCABLE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 468: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 469 *)
          (* State 469: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0469 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0116 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 116: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VALID_RANGE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0116
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0116 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0119 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 119: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VALID_INDEX (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0119
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0119 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0122 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 122: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_VALID_FUNCTION (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 123 *)
          (* State 123: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0123 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0124 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 124: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VALID (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0124
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0124 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0127 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 127: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> UNALLOCATED *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_435 _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0128 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 128: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_TYPEOF (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 129 *)
          (* State 129: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0129 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0130 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 130: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> TYPE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_319 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> TYPE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_360 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0131 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 131: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> TRUE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_414 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0132 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 132: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_TILDE (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0132 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0136 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 136: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production string -> STRING_LITERAL *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_652 _1 in
      _menhir_goto_string _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_string : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1333 ->
          _menhir_run_1334 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0132 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0139 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0337 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0348 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0349 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0350 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0710 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0462 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0562 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0553 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0551 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0549 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0547 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0545 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0543 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0479 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0476 ->
          _menhir_run_0477 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1402 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0471 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1334 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_INCLUDE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1334: *)
      match (_tok : MenhirBasics.token) with
      | STRING_LITERAL _v_0 ->
          let _menhir_stack = MenhirCell1_string (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_LITERAL) to state 472 *)
          _menhir_run_0472 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1335 *)
          (* State 1335: *)
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_INCLUDE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production ext_global_clause -> INCLUDE string SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_1) in
          let _v = _menhir_action_250 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_ext_global_clause _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0472 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_string -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 472: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_string (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production string -> string STRING_LITERAL *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_653 _1 _2 in
      _menhir_goto_string _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ext_global_clause : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1332 ->
          _menhir_run_1389 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1389 ->
          _menhir_run_1389 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1368 ->
          _menhir_run_1389 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1374 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1389 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1389: *)
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VOLATILE) to state 2 *)
          _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | TYPE ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPE) to state 760 *)
          _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PREDICATE) to state 857 *)
          _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | MODEL ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODEL) to state 879 *)
          _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | LOGIC ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LOGIC) to state 920 *)
          _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | LEMMA ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LEMMA) to state 929 *)
          _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INDUCTIVE) to state 937 *)
          _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INCLUDE) to state 1333 *)
          _menhir_run_1333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GLOBAL) to state 1336 *)
          _menhir_run_1336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_LET) to state 1342 *)
          _menhir_run_1342 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | EXT_GLOBAL_BLOCK _v_0 ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
          _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1389
      | EXT_GLOBAL _v_1 ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL) to state 1146 *)
          _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1389
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_LEMMA) to state 1154 *)
          _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOMATIC) to state 1160 *)
          _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | AXIOM ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOM) to state 1195 *)
          _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_LEMMA) to state 1184 *)
          _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1389
      | CONTRACT | EOF | EXT_AT | FUNCTION | MODULE ->
          (* Reducing production ext_global_clauses -> ext_global_clause *)
          let _1 = _v in
          let _v = _menhir_action_251 _1 in
          _menhir_goto_ext_global_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0002 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 2: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_VOLATILE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0002 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0322 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 322: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> TERMINATES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_318 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> TERMINATES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_374 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0137 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 137: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production constant -> STRING_CONSTANT *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_182 _1 in
      _menhir_goto_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0324 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 324: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> STATIC *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_145 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production lexpr_inner -> STATIC *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_434 _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0139 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 139: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0139 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0138 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 138: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> STATIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_434 _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0141 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 141: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_SIZEOF (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 142 *)
          _menhir_run_0142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0142 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIZEOF -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 142: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
      let _menhir_s = MenhirState0142 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 143 *)
          _menhir_run_0143 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 144 *)
          _menhir_run_0144 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 145 *)
          _menhir_run_0145 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 154 *)
          _menhir_run_0154 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 200 *)
          _menhir_run_0200 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 323 *)
          _menhir_run_0323 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 327 *)
          _menhir_run_0327 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 328 *)
          _menhir_run_0328 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 355 *)
          _menhir_run_0355 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 357 *)
          _menhir_run_0357 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 667 *)
          _menhir_run_0667 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 668 *)
          _menhir_run_0668 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 669 *)
          _menhir_run_0669 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 670 *)
          _menhir_run_0670 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 671 *)
          _menhir_run_0671 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 672 *)
          _menhir_run_0672 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 673 *)
          _menhir_run_0673 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 674 *)
          _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 675 *)
          _menhir_run_0675 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 676 *)
          _menhir_run_0676 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0143 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 143: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production acsl_c_keyword -> VOLATILE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_034 () in
          _menhir_goto_acsl_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BOOL | BOOLEAN | BSGHOST | CHAR | CONST | DOUBLE | ENUM | FLOAT | INT | INTEGER | LONG | REAL | SHORT | SIGNED | STRUCT | TYPENAME _ | UNION | UNSIGNED | VOID | VOLATILE ->
          (* Reducing production cv -> VOLATILE *)
          let _v = _menhir_action_204 () in
          _menhir_goto_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_cv : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0142 ->
          _menhir_run_0707 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0707 ->
          _menhir_run_0707 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0707 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0701 ->
          _menhir_run_0701 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0699 ->
          _menhir_run_0701 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0685 ->
          _menhir_run_0686 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0678 ->
          _menhir_run_0681 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0707 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 707: *)
      let _menhir_stack = MenhirCell1_cv (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 679 *)
          _menhir_run_0679 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | VOID ->
          (* Shifting (VOID) to state 202 *)
          _menhir_run_0202 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 203 *)
          _menhir_run_0203 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | UNION ->
          (* Shifting (UNION) to state 204 *)
          _menhir_run_0204 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | TYPENAME _v_0 ->
          (* Shifting (TYPENAME) to state 205 *)
          _menhir_run_0205 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0707
      | STRUCT ->
          (* Shifting (STRUCT) to state 206 *)
          _menhir_run_0206 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | SIGNED ->
          (* Shifting (SIGNED) to state 208 *)
          _menhir_run_0208 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | SHORT ->
          (* Shifting (SHORT) to state 217 *)
          _menhir_run_0217 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | REAL ->
          (* Shifting (REAL) to state 219 *)
          _menhir_run_0219 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | LONG ->
          (* Shifting (LONG) to state 220 *)
          _menhir_run_0220 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | INTEGER ->
          (* Shifting (INTEGER) to state 225 *)
          _menhir_run_0225 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | INT ->
          (* Shifting (INT) to state 226 *)
          _menhir_run_0226 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | FLOAT ->
          (* Shifting (FLOAT) to state 227 *)
          _menhir_run_0227 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | ENUM ->
          (* Shifting (ENUM) to state 228 *)
          _menhir_run_0228 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 230 *)
          _menhir_run_0230 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | CONST ->
          (* Shifting (CONST) to state 680 *)
          _menhir_run_0680 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | CHAR ->
          (* Shifting (CHAR) to state 231 *)
          _menhir_run_0231 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 674 *)
          _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 232 *)
          _menhir_run_0232 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | BOOL ->
          (* Shifting (BOOL) to state 233 *)
          _menhir_run_0233 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0707
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0679 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 679: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production cv -> VOLATILE *)
      let _v = _menhir_action_204 () in
      _menhir_goto_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0202 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 202: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> VOID *)
      let _v = _menhir_action_662 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_type_spec_TYPENAME_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0142 ->
          _menhir_run_0699 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0707 ->
          _menhir_run_0699 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0699 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0320 ->
          _menhir_run_0234 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0201 ->
          _menhir_run_0234 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0699 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 699: *)
      let _menhir_stack = MenhirCell1_type_spec_TYPENAME_ (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 679 *)
          _menhir_run_0679 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0699
      | CONST ->
          (* Shifting (CONST) to state 680 *)
          _menhir_run_0680 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0699
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 674 *)
          _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0699
      | LPAR | LSQUARE | RPAR | STAR ->
          (* Reducing production cv_after -> *)
          let _v_0 = _menhir_action_206 () in
          _menhir_run_0700 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0680 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 680: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production cv -> CONST *)
      let _v = _menhir_action_203 () in
      _menhir_goto_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0674 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 674: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production cv -> BSGHOST *)
      let _v = _menhir_action_205 () in
      _menhir_goto_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0700 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_TYPENAME_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 700: *)
      let MenhirCell1_type_spec_TYPENAME_ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production type_spec_cv(TYPENAME) -> type_spec(TYPENAME) cv_after *)
      let _2 = _v in
      let _v = _menhir_action_773 _1 _2 in
      _menhir_goto_type_spec_cv_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_type_spec_cv_TYPENAME_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0707 ->
          _menhir_run_0708 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0142 ->
          _menhir_run_0677 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0677 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0708 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_cv -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 708: *)
      let MenhirCell1_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production type_spec_cv(TYPENAME) -> cv type_spec_cv(TYPENAME) *)
      let _2 = _v in
      let _v = _menhir_action_774 _1 _2 in
      _menhir_goto_type_spec_cv_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0677 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 677: *)
      let _menhir_stack = MenhirCell1_type_spec_cv_TYPENAME_ (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 678 *)
          _menhir_run_0678 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0677
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0677
      | LPAR ->
          (* Shifting (LPAR) to state 682 *)
          _menhir_run_0682 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0677
      | RPAR ->
          (* Reducing production abs_spec_cv_option -> *)
          let _v = _menhir_action_028 () in
          _menhir_goto_abs_spec_cv_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0678 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 678: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s, _startpos) in
          (* Shifting (VOLATILE) to state 679 *)
          _menhir_run_0679 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0678
      | CONST ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s, _startpos) in
          (* Shifting (CONST) to state 680 *)
          _menhir_run_0680 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0678
      | BSGHOST ->
          let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s, _startpos) in
          (* Shifting (BSGHOST) to state 674 *)
          _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0678
      | LPAR | LSQUARE | RPAR | STAR ->
          (* Reducing production stars_cv -> STAR *)
          let _v = _menhir_action_644 () in
          _menhir_goto_stars_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_stars_cv : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 684: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 685 *)
          (* State 685: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOLATILE ->
              let _menhir_stack = MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, MenhirState0684, _startpos) in
              (* Shifting (VOLATILE) to state 679 *)
              _menhir_run_0679 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0685
          | CONST ->
              let _menhir_stack = MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, MenhirState0684, _startpos) in
              (* Shifting (CONST) to state 680 *)
              _menhir_run_0680 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0685
          | BSGHOST ->
              let _menhir_stack = MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell1_STAR (_menhir_stack, MenhirState0684, _startpos) in
              (* Shifting (BSGHOST) to state 674 *)
              _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0685
          | LPAR | LSQUARE | RPAR | STAR ->
              (* Reducing production stars_cv -> stars_cv STAR *)
              let _1 = _v in
              let _v = _menhir_action_646 _1 in
              _menhir_goto_stars_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0684
      | LPAR ->
          let _menhir_stack = MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 682 *)
          _menhir_run_0682 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0684
      | RPAR ->
          (* Reducing production abs_spec_cv -> stars_cv *)
          let _1 = _v in
          let _v = _menhir_action_022 _1 in
          _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0236 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 236: *)
      let _menhir_stack = MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 237 *)
          _menhir_run_0237 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0236
      | RSQUARE ->
          (* Reducing production array_size -> *)
          let _v = _menhir_action_059 () in
          _menhir_run_0239 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0236 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0237 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 237: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production array_size -> INT_CONSTANT *)
      let _1 = _v in
      let _v = _menhir_action_057 _1 in
      _menhir_goto_array_size _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_array_size : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0372 ->
          _menhir_run_0373 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0236 ->
          _menhir_run_0239 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0373 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_var_spec_bis -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 373: *)
      match (_tok : MenhirBasics.token) with
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 374 *)
          (* State 374: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_var_spec_bis (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production var_spec_bis -> var_spec_bis LSQUARE array_size RSQUARE *)
          let _3 = _v in
          let _v = _menhir_action_785 _1 _3 in
          _menhir_goto_var_spec_bis _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_var_spec_bis : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0380 ->
          _menhir_run_0381 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0804 ->
          _menhir_run_0371 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0386 ->
          _menhir_run_0371 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0369 ->
          _menhir_run_0371 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0370 ->
          _menhir_run_0371 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0381 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_stars as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 381: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_var_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 372 *)
          _menhir_run_0372 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LPAR ->
          let _menhir_stack = MenhirCell1_var_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 375 *)
          _menhir_run_0375 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RBRACE | RPAR | SEMICOLON ->
          let MenhirCell1_stars (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production var_spec -> stars var_spec_bis *)
          let _2 = _v in
          let _v = _menhir_action_783 _1 _2 in
          _menhir_goto_var_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0372 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_var_spec_bis -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 372: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 237 *)
          _menhir_run_0237 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0372
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0372
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0372
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0372
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0372
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0372
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0372
      | RSQUARE ->
          (* Reducing production array_size -> *)
          let _v = _menhir_action_059 () in
          _menhir_run_0373 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0375 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_var_spec_bis -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 375: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0375
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0375
      | RPAR ->
          (* Reducing production abs_param_type_list -> *)
          let _v = _menhir_action_007 () in
          _menhir_run_0376 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0249 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 249: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> VOID *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_738 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_type_spec_typename_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0879 ->
          _menhir_run_0880 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0441 ->
          _menhir_run_0442 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0423 ->
          _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0411 ->
          _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0386 ->
          _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0368 ->
          _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0822 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0829 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0825 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0689 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0375 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0308 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0248 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0301 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0291 ->
          _menhir_run_0292 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0880 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MODEL as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 880: *)
      let _menhir_stack = MenhirCell1_type_spec_typename_ (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 881 *)
          (* State 881: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LBRACE (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0881 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 764 *)
              _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 765 *)
              _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 774 *)
              _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 776 *)
              _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 778 *)
              _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 787 *)
              _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 789 *)
              _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 790 *)
              _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 795 *)
              _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 796 *)
              _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 797 *)
              _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 798 *)
              _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 800 *)
              _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 801 *)
              _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 802 *)
              _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 803 *)
              _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0764 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 764: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> VOID *)
      let _v = _menhir_action_700 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_type_spec_identifier_or_typename_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1173 ->
          _menhir_run_0813 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0920 ->
          _menhir_run_0813 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0819 ->
          _menhir_run_0813 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0812 ->
          _menhir_run_0813 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0881 ->
          _menhir_run_0804 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0862 ->
          _menhir_run_0804 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0860 ->
          _menhir_run_0804 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0763 ->
          _menhir_run_0804 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0813 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 813: *)
      let _menhir_stack = MenhirCell1_type_spec_identifier_or_typename_ (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0813
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0813
      | LPAR ->
          (* Shifting (LPAR) to state 242 *)
          _menhir_run_0242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0813
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production abs_spec_option -> *)
          let _v_0 = _menhir_action_030 () in
          _menhir_run_0814 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0235 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 235: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production stars -> STAR *)
      let _v = _menhir_action_642 () in
      _menhir_goto_stars _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_stars : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0442 ->
          _menhir_run_0444 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0804 ->
          _menhir_run_0380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0386 ->
          _menhir_run_0380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0369 ->
          _menhir_run_0380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0370 ->
          _menhir_run_0380 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0813 ->
          _menhir_run_0244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0234 ->
          _menhir_run_0244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0292 ->
          _menhir_run_0244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0242 ->
          _menhir_run_0244 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0444 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_BSTYPE _menhir_cell0_LPAR, ttv_result) _menhir_cell1_type_spec_typename_ as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 444: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_stars (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STAR) to state 245 *)
          _menhir_run_0245 _menhir_stack _menhir_lexbuf _menhir_lexer
      | RPAR ->
          (* Shifting (RPAR) to state 445 *)
          (* State 445: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_type_spec_typename_ (_menhir_stack, _, _3, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_BSTYPE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> BSTYPE LPAR type_spec(typename) stars RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_472 _3 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0245 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_stars -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 245: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_stars (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production stars -> stars STAR *)
      let _v = _menhir_action_643 _1 in
      _menhir_goto_stars _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0380 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 380: *)
      let _menhir_stack = MenhirCell1_stars (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | STAR ->
          (* Shifting (STAR) to state 245 *)
          _menhir_run_0245 _menhir_stack _menhir_lexbuf _menhir_lexer
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | LPAR ->
          (* Shifting (LPAR) to state 370 *)
          _menhir_run_0370 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | IDENTIFIER _v_0 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0380
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | EXT_GLOBAL_BLOCK _v_1 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0380
      | EXT_GLOBAL _v_2 ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0380
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0380
      | EXT_CODE_ANNOT _v_4 ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0380
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0380
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0370 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 370: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0370 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 370 *)
          _menhir_run_0370 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0244 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 244: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_stars (_menhir_stack, _menhir_s, _v) in
          (* Shifting (STAR) to state 245 *)
          _menhir_run_0245 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_stars (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0244
      | LPAR ->
          let _menhir_stack = MenhirCell1_stars (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 242 *)
          _menhir_run_0242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0244
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production abs_spec -> stars *)
          let _1 = _v in
          let _v = _menhir_action_011 _1 in
          _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0242 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 242: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0242 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 242 *)
          _menhir_run_0242 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_abs_spec : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0242 ->
          _menhir_run_0313 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0813 ->
          _menhir_run_0296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0234 ->
          _menhir_run_0296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0292 ->
          _menhir_run_0296 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0313 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 313: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 314 *)
          (* State 314: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          (* Reducing production abs_spec_bis -> LPAR abs_spec RPAR *)
          let _2 = _v in
          let _v = _menhir_action_017 _2 in
          _menhir_goto_abs_spec_bis _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_abs_spec_bis : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0813 ->
          _menhir_run_0294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0234 ->
          _menhir_run_0294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0242 ->
          _menhir_run_0294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0292 ->
          _menhir_run_0294 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0244 ->
          _menhir_run_0247 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0294 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 294: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_abs_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0294
      | LPAR ->
          let _menhir_stack = MenhirCell1_abs_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 248 *)
          _menhir_run_0248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0294
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production abs_spec -> abs_spec_bis *)
          let _1 = _v in
          let _v = _menhir_action_016 _1 in
          _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0248 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_abs_spec_bis as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 248: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0248
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0248
      | RPAR ->
          (* Reducing production abs_param_type_list -> *)
          let _v = _menhir_action_007 () in
          _menhir_run_0305 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0250 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 250: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SHORT) to state 251 *)
          _menhir_run_0251 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LONG ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 253 *)
          _menhir_run_0253 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 257 *)
          _menhir_run_0257 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CHAR ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHAR) to state 258 *)
          _menhir_run_0258 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(typename) -> UNSIGNED *)
          let _startpos__1_ = _startpos in
          let _v = _menhir_action_746 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0251 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 251: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 252 *)
          (* State 252: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> UNSIGNED SHORT INT *)
          let _v = _menhir_action_752 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> UNSIGNED SHORT *)
          let _v = _menhir_action_749 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0253 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 253: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          (* Shifting (LONG) to state 254 *)
          (* State 254: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 255 *)
              (* State 255: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
              (* Reducing production type_spec(typename) -> UNSIGNED LONG LONG INT *)
              let _v = _menhir_action_764 () in
              _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
              (* Reducing production type_spec(typename) -> UNSIGNED LONG LONG *)
              let _v = _menhir_action_761 () in
              _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 256 *)
          (* State 256: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> UNSIGNED LONG INT *)
          let _v = _menhir_action_758 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> UNSIGNED LONG *)
          let _v = _menhir_action_755 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0257 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 257: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> UNSIGNED INT *)
      let _v = _menhir_action_745 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0258 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 258: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> UNSIGNED CHAR *)
      let _v = _menhir_action_742 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0259 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 259: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0259 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0155 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 155: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production identifier_or_typename -> TYPENAME *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_330 _1 in
      _menhir_goto_identifier_or_typename _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_identifier_or_typename : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1173 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0920 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0881 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0860 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0862 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0812 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0819 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0763 ->
          _menhir_run_0811 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0798 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0776 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0774 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0670 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0654 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0646 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0644 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0603 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0541 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0539 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0526 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0533 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0323 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0284 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0262 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0259 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0228 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0206 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0204 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0154 ->
          _menhir_run_0197 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0811 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 811: *)
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_identifier_or_typename (_menhir_stack, _menhir_s, _v, _endpos) in
          (* Shifting (LT) to state 812 *)
          (* State 812: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LT (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0812 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 764 *)
              _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 765 *)
              _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 774 *)
              _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 776 *)
              _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 778 *)
              _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 787 *)
              _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 789 *)
              _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 790 *)
              _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 795 *)
              _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 796 *)
              _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 797 *)
              _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 798 *)
              _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 800 *)
              _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 801 *)
              _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 802 *)
              _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 803 *)
              _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(identifier_or_typename) -> identifier_or_typename *)
          let name = _v in
          let _v = _menhir_action_733 name in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0765 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 765: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          (* Shifting (SHORT) to state 766 *)
          (* State 766: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 767 *)
              (* State 767: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED SHORT INT *)
              let _v = _menhir_action_714 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED SHORT *)
              let _v = _menhir_action_711 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | LONG ->
          (* Shifting (LONG) to state 768 *)
          (* State 768: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LONG ->
              (* Shifting (LONG) to state 769 *)
              (* State 769: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | INT ->
                  (* Shifting (INT) to state 770 *)
                  (* State 770: *)
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED LONG LONG INT *)
                  let _v = _menhir_action_726 () in
                  _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED LONG LONG *)
                  let _v = _menhir_action_723 () in
                  _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | INT ->
              (* Shifting (INT) to state 771 *)
              (* State 771: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED LONG INT *)
              let _v = _menhir_action_720 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED LONG *)
              let _v = _menhir_action_717 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 772 *)
          (* State 772: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED INT *)
          let _v = _menhir_action_707 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR ->
          (* Shifting (CHAR) to state 773 *)
          (* State 773: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED CHAR *)
          let _v = _menhir_action_704 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(identifier_or_typename) -> UNSIGNED *)
          let _v = _menhir_action_708 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0774 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 774: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0774 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0776 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 776: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0776 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0778 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 778: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          (* Shifting (SHORT) to state 779 *)
          (* State 779: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 780 *)
              (* State 780: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (* Reducing production type_spec(identifier_or_typename) -> SIGNED SHORT INT *)
              let _v = _menhir_action_713 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              (* Reducing production type_spec(identifier_or_typename) -> SIGNED SHORT *)
              let _v = _menhir_action_710 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | LONG ->
          (* Shifting (LONG) to state 781 *)
          (* State 781: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LONG ->
              (* Shifting (LONG) to state 782 *)
              (* State 782: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | INT ->
                  (* Shifting (INT) to state 783 *)
                  (* State 783: *)
                  let _tok = _menhir_lexer _menhir_lexbuf in
                  (* Reducing production type_spec(identifier_or_typename) -> SIGNED LONG LONG INT *)
                  let _v = _menhir_action_725 () in
                  _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(identifier_or_typename) -> SIGNED LONG LONG *)
                  let _v = _menhir_action_722 () in
                  _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | INT ->
              (* Shifting (INT) to state 784 *)
              (* State 784: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (* Reducing production type_spec(identifier_or_typename) -> SIGNED LONG INT *)
              let _v = _menhir_action_718 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              (* Reducing production type_spec(identifier_or_typename) -> SIGNED LONG *)
              let _v = _menhir_action_716 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 785 *)
          (* State 785: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> SIGNED INT *)
          let _v = _menhir_action_706 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | CHAR ->
          (* Shifting (CHAR) to state 786 *)
          (* State 786: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> SIGNED CHAR *)
          let _v = _menhir_action_703 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0787 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 787: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 788 *)
          (* State 788: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> SHORT INT *)
          let _v = _menhir_action_712 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(identifier_or_typename) -> SHORT *)
          let _v = _menhir_action_709 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0789 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 789: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> REAL *)
      let _v = _menhir_action_698 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0790 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 790: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          (* Shifting (LONG) to state 791 *)
          (* State 791: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 792 *)
              (* State 792: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (* Reducing production type_spec(identifier_or_typename) -> LONG LONG INT *)
              let _v = _menhir_action_724 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              (* Reducing production type_spec(identifier_or_typename) -> LONG LONG *)
              let _v = _menhir_action_721 () in
              _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 793 *)
          (* State 793: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> LONG INT *)
          let _v = _menhir_action_719 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 794 *)
          (* State 794: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production type_spec(identifier_or_typename) -> LONG DOUBLE *)
          let _v = _menhir_action_729 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(identifier_or_typename) -> LONG *)
          let _v = _menhir_action_715 () in
          _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0795 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 795: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> INTEGER *)
      let _v = _menhir_action_697 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0796 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 796: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> INT *)
      let _v = _menhir_action_705 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0797 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 797: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> FLOAT *)
      let _v = _menhir_action_727 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0798 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 798: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0798 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0800 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 800: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> DOUBLE *)
      let _v = _menhir_action_728 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0801 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 801: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> CHAR *)
      let _v = _menhir_action_702 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0802 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 802: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> BOOLEAN *)
      let _v = _menhir_action_699 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0803 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 803: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(identifier_or_typename) -> BOOL *)
      let _v = _menhir_action_701 () in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0197 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 197: *)
      (* Reducing production identifier_or_typename_full -> identifier_or_typename *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_333 _1 in
      _menhir_goto_identifier_or_typename_full _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_identifier_or_typename_full : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0798 ->
          _menhir_run_0799 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0776 ->
          _menhir_run_0777 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0774 ->
          _menhir_run_0775 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0603 ->
          _menhir_run_0604 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0541 ->
          _menhir_run_0542 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0539 ->
          _menhir_run_0540 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0533 ->
          _menhir_run_0532 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0526 ->
          _menhir_run_0532 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState0654 ->
          _menhir_run_0285 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0284 ->
          _menhir_run_0285 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0646 ->
          _menhir_run_0263 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0262 ->
          _menhir_run_0263 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0644 ->
          _menhir_run_0260 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0259 ->
          _menhir_run_0260 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0670 ->
          _menhir_run_0229 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0228 ->
          _menhir_run_0229 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0323 ->
          _menhir_run_0207 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0206 ->
          _menhir_run_0207 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0204 ->
          _menhir_run_0196 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0154 ->
          _menhir_run_0196 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0799 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENUM -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 799: *)
      let MenhirCell1_ENUM (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(identifier_or_typename) -> ENUM identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_731 id in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0777 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STRUCT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 777: *)
      let MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(identifier_or_typename) -> STRUCT identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_730 id in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0775 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNION -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 775: *)
      let MenhirCell1_UNION (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(identifier_or_typename) -> UNION identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_732 id in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0604 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_DOT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 604: *)
      let MenhirCell1_DOT (_menhir_stack, _menhir_s) = _menhir_stack in
      (* Reducing production field_path_elt -> DOT identifier_or_typename_full *)
      let _2 = _v in
      let _v = _menhir_action_280 _2 in
      _menhir_goto_field_path_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_field_path_elt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0366 ->
          _menhir_run_0622 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0626 ->
          _menhir_run_0622 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0622 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0608 ->
          _menhir_run_0614 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0610 ->
          _menhir_run_0614 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0619 ->
          _menhir_run_0614 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0612 ->
          _menhir_run_0614 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0622 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 622: *)
      let _menhir_stack = MenhirCell1_field_path_elt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          (* Shifting (EQUAL) to state 623 *)
          (* State 623: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState0623 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0325 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 325: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> SLICE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_317 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> SLICE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_359 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0326 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 326: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_SIZEOF (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LPAR) to state 142 *)
          _menhir_run_0142 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          (* Reducing production c_keyword -> SIZEOF *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_144 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0329 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 329: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_SEPARATED (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 330 *)
          (* State 330: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0330 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0331 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 331: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> RETURNS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_316 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production post_cond -> RETURNS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_602 () in
          _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0332 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 332: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> RESULT *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_458 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0333 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 333: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> REQUIRES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_315 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> REQUIRES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_371 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0334 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 334: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> REGISTER *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_433 _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0335 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 335: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> PREDICATE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_314 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> PREDICATE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_358 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0336 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 336: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> PRAGMA *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_313 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> PRAGMA *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_357 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0337 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 337: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_PLUS (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0337 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0338 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 338: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> PI *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_464 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0339 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 339: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_OLD (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 340 *)
          (* State 340: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0340 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0341 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 341: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_OFFSET (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0341
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0341 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0344 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 344: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_OBJECT_POINTER (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0344
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0344 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0347 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 347: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> NULL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_436 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0348 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 348: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0348 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0349 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 349: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0349 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0350 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 350: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0350 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0351 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 351: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LSQUAREPIPE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0351
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0351
      | RSQUAREPIPE ->
          (* Reducing production lexpr_list -> *)
          let _v = _menhir_action_482 () in
          _menhir_run_0712 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0352 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 352: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> MODULE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_312 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_ext_spec -> MODULE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_382 () in
          _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0353 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 353: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> MODEL *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_311 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> MODEL *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_361 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0354 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 354: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 143 *)
          _menhir_run_0143 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VOID ->
          (* Shifting (VOID) to state 144 *)
          _menhir_run_0144 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 145 *)
          _menhir_run_0145 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | UNION ->
          (* Shifting (UNION) to state 154 *)
          _menhir_run_0154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 200 *)
          _menhir_run_0200 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | STRUCT ->
          (* Shifting (STRUCT) to state 323 *)
          _menhir_run_0323 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | SIGNED ->
          (* Shifting (SIGNED) to state 327 *)
          _menhir_run_0327 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | SHORT ->
          (* Shifting (SHORT) to state 328 *)
          _menhir_run_0328 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | REAL ->
          (* Shifting (REAL) to state 355 *)
          _menhir_run_0355 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LONG ->
          (* Shifting (LONG) to state 357 *)
          _menhir_run_0357 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INTEGER ->
          (* Shifting (INTEGER) to state 667 *)
          _menhir_run_0667 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INT ->
          (* Shifting (INT) to state 668 *)
          _menhir_run_0668 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | FLOAT ->
          (* Shifting (FLOAT) to state 669 *)
          _menhir_run_0669 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0354
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ENUM ->
          (* Shifting (ENUM) to state 670 *)
          _menhir_run_0670 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 671 *)
          _menhir_run_0671 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CONST ->
          (* Shifting (CONST) to state 672 *)
          _menhir_run_0672 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CHAR ->
          (* Shifting (CHAR) to state 673 *)
          _menhir_run_0673 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 674 *)
          _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 675 *)
          _menhir_run_0675 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BOOL ->
          (* Shifting (BOOL) to state 676 *)
          _menhir_run_0676 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0354
      | DOTDOT ->
          (* Reducing production lexpr_option -> *)
          let _v = _menhir_action_484 () in
          _menhir_run_0484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0354 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0144 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 144: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> VOID *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_149 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> VOID *)
          let _v = _menhir_action_662 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0145 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 145: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SHORT) to state 146 *)
          _menhir_run_0146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LONG ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 148 *)
          _menhir_run_0148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 152 *)
          _menhir_run_0152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CHAR ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHAR) to state 153 *)
          _menhir_run_0153 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          (* Reducing production c_keyword -> UNSIGNED *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_148 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> UNSIGNED *)
          let _v = _menhir_action_670 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0146 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 146: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 147 *)
          (* State 147: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> UNSIGNED SHORT INT *)
          let _v = _menhir_action_676 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> UNSIGNED SHORT *)
          let _v = _menhir_action_673 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0148 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 148: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          (* Shifting (LONG) to state 149 *)
          (* State 149: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 150 *)
              (* State 150: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
              (* Reducing production type_spec(TYPENAME) -> UNSIGNED LONG LONG INT *)
              let _v = _menhir_action_688 () in
              _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
              let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
              (* Reducing production type_spec(TYPENAME) -> UNSIGNED LONG LONG *)
              let _v = _menhir_action_685 () in
              _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 151 *)
          (* State 151: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> UNSIGNED LONG INT *)
          let _v = _menhir_action_682 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> UNSIGNED LONG *)
          let _v = _menhir_action_679 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0152 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 152: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> UNSIGNED INT *)
      let _v = _menhir_action_669 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0153 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNSIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 153: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> UNSIGNED CHAR *)
      let _v = _menhir_action_666 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0154 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 154: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | VARIANT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | TYPENAME _v ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0154
      | TYPE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | SLICE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | RETURNS ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | REAL ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | READS ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | MODULE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | MODEL ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | LOOP ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | LOGIC ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | LEMMA ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | LABEL ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | INTEGER ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | IMPACT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | IDENTIFIER _v ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0154
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | FREES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | EXT_GLOBAL_BLOCK _v ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0154
      | EXT_GLOBAL _v ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0154
      | EXT_CONTRACT _v ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0154
      | EXT_CODE_ANNOT _v ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0154
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | EXITS ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | ENSURES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | DECREASES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | CHECK ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | BREAKS ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | AXIOM ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | ASSERT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | ADMIT ->
          let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0154
      | COLON ->
          (* Reducing production c_keyword -> UNION *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_147 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0200 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 200: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_TYPENAME (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LT) to state 201 *)
          _menhir_run_0201 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          (* Reducing production any_identifier -> TYPENAME *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_050 _1 in
          _menhir_goto_any_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> TYPENAME *)
          let name = _v in
          let _v = _menhir_action_695 name in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0201 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TYPENAME -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 201: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell0_LT (_menhir_stack, _startpos) in
      let _menhir_s = MenhirState0201 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 202 *)
          _menhir_run_0202 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 203 *)
          _menhir_run_0203 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 204 *)
          _menhir_run_0204 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 205 *)
          _menhir_run_0205 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 206 *)
          _menhir_run_0206 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 208 *)
          _menhir_run_0208 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 217 *)
          _menhir_run_0217 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 219 *)
          _menhir_run_0219 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 220 *)
          _menhir_run_0220 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 225 *)
          _menhir_run_0225 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 226 *)
          _menhir_run_0226 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 227 *)
          _menhir_run_0227 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 228 *)
          _menhir_run_0228 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 230 *)
          _menhir_run_0230 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 231 *)
          _menhir_run_0231 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 232 *)
          _menhir_run_0232 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 233 *)
          _menhir_run_0233 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0203 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 203: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SHORT) to state 146 *)
          _menhir_run_0146 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LONG ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 148 *)
          _menhir_run_0148 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 152 *)
          _menhir_run_0152 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CHAR ->
          let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHAR) to state 153 *)
          _menhir_run_0153 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> UNSIGNED *)
          let _v = _menhir_action_670 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0204 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 204: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0204 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0205 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 205: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_TYPENAME (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LT) to state 201 *)
          _menhir_run_0201 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> TYPENAME *)
          let name = _v in
          let _v = _menhir_action_695 name in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0206 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 206: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0206 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0208 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 208: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          (* Shifting (SHORT) to state 209 *)
          _menhir_run_0209 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LONG ->
          (* Shifting (LONG) to state 211 *)
          _menhir_run_0211 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          (* Shifting (INT) to state 215 *)
          _menhir_run_0215 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CHAR ->
          (* Shifting (CHAR) to state 216 *)
          _menhir_run_0216 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0209 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 209: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 210 *)
          (* State 210: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> SIGNED SHORT INT *)
          let _v = _menhir_action_675 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> SIGNED SHORT *)
          let _v = _menhir_action_672 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0211 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 211: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          (* Shifting (LONG) to state 212 *)
          (* State 212: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 213 *)
              (* State 213: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
              (* Reducing production type_spec(TYPENAME) -> SIGNED LONG LONG INT *)
              let _v = _menhir_action_687 () in
              _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
              let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
              (* Reducing production type_spec(TYPENAME) -> SIGNED LONG LONG *)
              let _v = _menhir_action_684 () in
              _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 214 *)
          (* State 214: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> SIGNED LONG INT *)
          let _v = _menhir_action_680 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> SIGNED LONG *)
          let _v = _menhir_action_678 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0215 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 215: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> SIGNED INT *)
      let _v = _menhir_action_668 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0216 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 216: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> SIGNED CHAR *)
      let _v = _menhir_action_665 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0217 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 217: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          let _menhir_stack = MenhirCell1_SHORT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 218 *)
          _menhir_run_0218 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> SHORT *)
          let _v = _menhir_action_671 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0218 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SHORT -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 218: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_SHORT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> SHORT INT *)
      let _v = _menhir_action_674 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0219 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 219: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> REAL *)
      let _v = _menhir_action_660 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0220 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 220: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 221 *)
          _menhir_run_0221 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 223 *)
          _menhir_run_0223 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DOUBLE) to state 224 *)
          _menhir_run_0224 _menhir_stack _menhir_lexbuf _menhir_lexer
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> LONG *)
          let _v = _menhir_action_677 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0221 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LONG -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 221: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 222 *)
          (* State 222: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LONG (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> LONG LONG INT *)
          let _v = _menhir_action_686 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | BSGHOST | COMMA | CONST | GT | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          let MenhirCell1_LONG (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production type_spec(TYPENAME) -> LONG LONG *)
          let _v = _menhir_action_683 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0223 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LONG -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 223: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LONG (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> LONG INT *)
      let _v = _menhir_action_681 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0224 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LONG -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 224: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LONG (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> LONG DOUBLE *)
      let _v = _menhir_action_691 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0225 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 225: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> INTEGER *)
      let _v = _menhir_action_659 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0226 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 226: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> INT *)
      let _v = _menhir_action_667 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0227 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 227: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> FLOAT *)
      let _v = _menhir_action_689 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0228 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 228: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0228 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0230 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 230: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> DOUBLE *)
      let _v = _menhir_action_690 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0231 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 231: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> CHAR *)
      let _v = _menhir_action_664 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0232 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 232: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> BOOLEAN *)
      let _v = _menhir_action_661 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0233 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 233: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(TYPENAME) -> BOOL *)
      let _v = _menhir_action_663 () in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0323 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 323: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | VARIANT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | TYPENAME _v ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0323
      | TYPE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | SLICE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | RETURNS ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | REAL ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | READS ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | MODULE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | MODEL ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | LOOP ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | LOGIC ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | LEMMA ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | LABEL ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | INTEGER ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | IMPACT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | IDENTIFIER _v ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0323
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | FREES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | EXT_GLOBAL_BLOCK _v ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0323
      | EXT_GLOBAL _v ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0323
      | EXT_CONTRACT _v ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0323
      | EXT_CODE_ANNOT _v ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0323
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | EXITS ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | ENSURES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | DECREASES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | CHECK ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | BREAKS ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | AXIOM ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | ASSERT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | ADMIT ->
          let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0323
      | COLON ->
          (* Reducing production c_keyword -> STRUCT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_146 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0327 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 327: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SHORT) to state 209 *)
          _menhir_run_0209 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LONG ->
          let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 211 *)
          _menhir_run_0211 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 215 *)
          _menhir_run_0215 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CHAR ->
          let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHAR) to state 216 *)
          _menhir_run_0216 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          (* Reducing production c_keyword -> SIGNED *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_143 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0328 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 328: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          let _menhir_stack = MenhirCell1_SHORT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 218 *)
          _menhir_run_0218 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          (* Reducing production c_keyword -> SHORT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_142 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> SHORT *)
          let _v = _menhir_action_671 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0355 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 355: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production is_acsl_typename -> REAL *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_379 () in
          _menhir_goto_is_acsl_typename _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> REAL *)
          let _v = _menhir_action_660 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0356 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 356: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> LOOP *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_310 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> LOOP *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_354 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0357 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 357: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 221 *)
          _menhir_run_0221 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 223 *)
          _menhir_run_0223 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DOUBLE) to state 224 *)
          _menhir_run_0224 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COLON ->
          (* Reducing production c_keyword -> LONG *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_141 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> LONG *)
          let _v = _menhir_action_677 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0358 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 358: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> LOGIC *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_309 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production keyword -> LOGIC *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_386 () in
          _menhir_goto_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0359 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 359: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LET (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | TYPENAME _ ->
          (* Shifting (TYPENAME) to state 360 *)
          (* State 360: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production bounded_var -> TYPENAME *)
          let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0359, _endpos, _startpos_0) in
          let _v = _menhir_action_092 _endpos__1_ _startpos__1_ in
          _menhir_goto_bounded_var _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0359
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0359
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0359
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0359
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0359
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0359
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0365 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 365: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> LEMMA *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_307 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> LEMMA *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_351 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0366 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 366: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 367 *)
          _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0366
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | DOT ->
          (* Shifting (DOT) to state 603 *)
          _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0366
      | RBRACE ->
          (* Reducing production lexpr_list -> *)
          let _v = _menhir_action_482 () in
          _menhir_run_0605 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0367 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 367: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0367
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0367
      | DOTDOT ->
          (* Reducing production lexpr_option -> *)
          let _v = _menhir_action_484 () in
          _menhir_run_0484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0367 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0368 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 368: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LAMBDA (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0368 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0261 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 261: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production typename -> TYPENAME *)
      let (_startpos_name_, name) = (_startpos, _v) in
      let _v = _menhir_action_777 name in
      _menhir_goto_typename _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_name_ _v _menhir_s _tok
  
  and _menhir_goto_typename : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 290: *)
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_typename (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (LT) to state 291 *)
          (* State 291: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LT (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0291 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(typename) -> typename *)
          let (_startpos_name_, name) = (_startpos, _v) in
          let _v = _menhir_action_771 name in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_name_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0262 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 262: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0262 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0264 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 264: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | SHORT ->
          (* Shifting (SHORT) to state 265 *)
          _menhir_run_0265 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LONG ->
          (* Shifting (LONG) to state 267 *)
          _menhir_run_0267 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          (* Shifting (INT) to state 271 *)
          _menhir_run_0271 _menhir_stack _menhir_lexbuf _menhir_lexer
      | CHAR ->
          (* Shifting (CHAR) to state 272 *)
          _menhir_run_0272 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0265 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 265: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 266 *)
          (* State 266: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> SIGNED SHORT INT *)
          let _v = _menhir_action_751 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> SIGNED SHORT *)
          let _v = _menhir_action_748 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0267 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 267: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          (* Shifting (LONG) to state 268 *)
          (* State 268: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | INT ->
              (* Shifting (INT) to state 269 *)
              (* State 269: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
              (* Reducing production type_spec(typename) -> SIGNED LONG LONG INT *)
              let _v = _menhir_action_763 () in
              _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
              let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
              (* Reducing production type_spec(typename) -> SIGNED LONG LONG *)
              let _v = _menhir_action_760 () in
              _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INT ->
          (* Shifting (INT) to state 270 *)
          (* State 270: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> SIGNED LONG INT *)
          let _v = _menhir_action_756 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> SIGNED LONG *)
          let _v = _menhir_action_754 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0271 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 271: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> SIGNED INT *)
      let _v = _menhir_action_744 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0272 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIGNED -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 272: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_SIGNED (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> SIGNED CHAR *)
      let _v = _menhir_action_741 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0273 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 273: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          let _menhir_stack = MenhirCell1_SHORT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 274 *)
          _menhir_run_0274 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(typename) -> SHORT *)
          let _startpos__1_ = _startpos in
          let _v = _menhir_action_747 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0274 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SHORT -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 274: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_SHORT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> SHORT INT *)
      let _v = _menhir_action_750 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0275 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 275: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> REAL *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_736 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0276 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 276: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LONG ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LONG) to state 277 *)
          _menhir_run_0277 _menhir_stack _menhir_lexbuf _menhir_lexer
      | INT ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INT) to state 279 *)
          _menhir_run_0279 _menhir_stack _menhir_lexbuf _menhir_lexer
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DOUBLE) to state 280 *)
          _menhir_run_0280 _menhir_stack _menhir_lexbuf _menhir_lexer
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          (* Reducing production type_spec(typename) -> LONG *)
          let _startpos__1_ = _startpos in
          let _v = _menhir_action_753 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0277 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LONG -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 277: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INT ->
          (* Shifting (INT) to state 278 *)
          (* State 278: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> LONG LONG INT *)
          let _v = _menhir_action_762 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LBRACE | LEMMA | LOGIC | LOOP | LPAR | LSQUARE | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
          let MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_spec(typename) -> LONG LONG *)
          let _v = _menhir_action_759 () in
          _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0279 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LONG -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 279: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> LONG INT *)
      let _v = _menhir_action_757 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0280 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LONG -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 280: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LONG (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> LONG DOUBLE *)
      let _v = _menhir_action_767 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0281 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 281: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> INTEGER *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_735 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0282 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 282: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> INT *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_743 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0283 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 283: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> FLOAT *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_765 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0284 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 284: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0284 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0286 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 286: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> DOUBLE *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_766 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0287 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 287: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> CHAR *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_740 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0288 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 288: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> BOOLEAN *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_737 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0289 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 289: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production type_spec(typename) -> BOOL *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_739 () in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0391 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 391: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> INVARIANT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_306 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> INVARIANT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_348 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0392 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 392: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production constant -> INT_CONSTANT *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_180 _1 in
      _menhir_goto_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0393 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 393: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_INTER (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 394 *)
          (* State 394: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0394
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0394
          | RPAR ->
              (* Reducing production lexpr_list -> *)
              let _v = _menhir_action_482 () in
              _menhir_run_0596 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0395 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 395: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_INITIALIZED (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0395
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0395 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0398 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 398: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> INDUCTIVE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_304 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> INDUCTIVE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_347 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0399 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 399: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> INCLUDE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_305 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_ext_spec -> INCLUDE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_383 () in
          _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0400 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 400: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> IMPACT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_303 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> IMPACT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_346 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0401 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 401: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> GLOBAL *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_302 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> GLOBAL *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_345 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0402 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 402: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> FUNCTION *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_301 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_ext_spec -> FUNCTION *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_381 () in
          _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0403 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 403: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FRESH (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0403
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0404 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0403 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0404 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FRESH as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 404: *)
      (* Reducing production opt_label_2 -> opt_label_list *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_579 _1 _endpos__1_ _startpos__1_ in
      (* State 405: *)
      let _menhir_stack = MenhirCell1_opt_label_2 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 406 *)
          (* State 406: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0406 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0407 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 407: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> FREES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_300 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> FREES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_369 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0408 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 408: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FREEABLE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0408
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0408 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0411 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 411: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_FORALL (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0411 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0414 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 414: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production constant -> FLOAT_CONSTANT *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_181 _1 in
      _menhir_goto_constant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0415 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 415: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> FALSE *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_415 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0416 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 416: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXT_LET *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_308 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_ext_spec -> EXT_LET *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_385 () in
          _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0417 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 417: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXT_GLOBAL_BLOCK *)
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_324 id in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> EXT_GLOBAL_BLOCK *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_340 _1 in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0418 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 418: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXT_GLOBAL *)
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_323 id in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> EXT_GLOBAL *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_339 _1 in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0419 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 419: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXT_CONTRACT *)
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_322 id in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> EXT_CONTRACT *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_366 _1 in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0420 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 420: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXT_CODE_ANNOT *)
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_321 id in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> EXT_CODE_ANNOT *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_338 _1 in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0421 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 421: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXT_AT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_287 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_ext_spec -> EXT_AT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_384 () in
          _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0422 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 422: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> EXITS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_299 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production post_cond -> EXITS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_599 () in
          _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0423 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 423: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_EXISTS (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0423 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0426 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 426: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> ENSURES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_298 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production post_cond -> ENSURES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_598 () in
          _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0427 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 427: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> EMPTY *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_473 _endpos__1_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0428 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 428: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> DYNAMIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_432 _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0429 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 429: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> DISJOINT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_297 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> DISJOINT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_377 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0430 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 430: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> DECREASES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_296 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> DECREASES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_376 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0431 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 431: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_DANGLING (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0431
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0431 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0434 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 434: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> CONTRACT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_295 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_ext_spec -> CONTRACT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_380 () in
          _menhir_goto_is_ext_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0435 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 435: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> CONTINUES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_294 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production post_cond -> CONTINUES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_601 () in
          _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0436 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 436: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> COMPLETE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_293 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> COMPLETE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_375 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0437 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 437: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> CHECK *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_292 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> CHECK *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_343 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0438 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 438: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_BSUNION (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 439 *)
          (* State 439: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0439
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0439
          | RPAR ->
              (* Reducing production lexpr_list -> *)
              let _v = _menhir_action_482 () in
              _menhir_run_0582 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0440 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 440: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_BSTYPE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 441 *)
          (* State 441: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0441 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0446 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 446: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> BREAKS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_291 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production post_cond -> BREAKS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_600 () in
          _menhir_goto_post_cond _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0447 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 447: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BLOCK_LENGTH (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0447
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0447 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0450 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 450: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> BEHAVIOR *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_290 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> BEHAVIOR *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_370 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0451 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 451: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BASE_ADDR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0451
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0451 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0454 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 454: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> AXIOMATIC *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_289 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> AXIOMATIC *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_364 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0455 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 455: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> AXIOM *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_288 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> AXIOM *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_362 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0456 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 456: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production lexpr_inner -> AUTOMATIC *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_431 _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0457 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 457: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_AT (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 458 *)
          (* State 458: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0458 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0459 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 459: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> ASSUMES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_286 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> ASSUMES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_341 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0460 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 460: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> ASSIGNS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_285 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> ASSIGNS *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_367 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0461 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 461: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> ASSERT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_284 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> ASSERT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_342 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0462 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 462: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_AMP (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0462 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0463 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 463: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ALLOCATION (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0463
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0463 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0467 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 467: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ALLOCABLE (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 8 *)
          _menhir_run_0008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0467
      | LPAR ->
          (* Reducing production opt_label_list -> *)
          let _v = _menhir_action_580 () in
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState0467 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0466 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 466: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> ALLOCATES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_283 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_spec -> ALLOCATES *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_368 () in
          _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0470 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 470: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> ADMIT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_282 () in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | COLON ->
          (* Reducing production is_acsl_decl_or_code_annot -> ADMIT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_344 () in
          _menhir_goto_is_acsl_decl_or_code_annot _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0582 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_BSUNION _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 582: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 583 *)
          (* State 583: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_BSUNION (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> BSUNION LPAR lexpr_list RPAR *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_474 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0596 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_INTER _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 596: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 597 *)
          (* State 597: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_INTER (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> INTER LPAR lexpr_list RPAR *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_475 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0484 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 484: *)
      let _menhir_stack = MenhirCell1_lexpr_option (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DOTDOT ->
          (* Shifting (DOTDOT) to state 485 *)
          (* State 485: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_DOTDOT (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v_2 ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0485
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | TYPENAME _v_3 ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0485
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | STRING_LITERAL _v_4 ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0485
          | STRING_CONSTANT _v_5 ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState0485
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INT_CONSTANT _v_6 ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState0485
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | IDENTIFIER _v_7 ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState0485
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FLOAT_CONSTANT _v_8 ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0485
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | EXT_GLOBAL_BLOCK _v_9 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0485
          | EXT_GLOBAL _v_10 ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState0485
          | EXT_CONTRACT _v_11 ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState0485
          | EXT_CODE_ANNOT _v_12 ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState0485
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0485
          | RPAR | RSQUARE ->
              (* Reducing production lexpr_option -> *)
              let _v_13 = _menhir_action_484 () in
              _menhir_run_0486 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_1 _v_13 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0486 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr_option _menhir_cell0_DOTDOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 486: *)
      let MenhirCell0_DOTDOT (_menhir_stack, _startpos__2_) = _menhir_stack in
      let MenhirCell1_lexpr_option (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      (* Reducing production range -> lexpr_option DOTDOT lexpr_option *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_617 _1 _3 _endpos__1_ _endpos__3_ _startpos__1_ _startpos__2_ in
      _menhir_goto_range _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_range : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0354 ->
          _menhir_run_0703 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0367 ->
          _menhir_run_0599 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0481 ->
          _menhir_run_0482 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0703 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 703: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 704 *)
          (* State 704: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LPAR range RPAR *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_468 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0599 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LSQUARE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 599: *)
      match (_tok : MenhirBasics.token) with
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 600 *)
          (* State 600: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) = _menhir_stack in
          (* Reducing production array_path_elt -> LSQUARE range RSQUARE *)
          let _2 = _v in
          let _v = _menhir_action_056 _2 in
          _menhir_goto_array_path_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_array_path_elt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0366 ->
          _menhir_run_0630 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0634 ->
          _menhir_run_0630 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0630 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0608 ->
          _menhir_run_0615 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0610 ->
          _menhir_run_0615 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0619 ->
          _menhir_run_0615 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0612 ->
          _menhir_run_0615 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0630 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 630: *)
      let _menhir_stack = MenhirCell1_array_path_elt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          (* Shifting (EQUAL) to state 631 *)
          (* State 631: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState0631 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0615 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 615: *)
      (* Reducing production path_elt -> array_path_elt *)
      let _1 = _v in
      let _v = _menhir_action_591 _1 in
      _menhir_goto_path_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_path_elt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 612: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_path_elt (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 367 *)
          _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0612
      | DOT ->
          let _menhir_stack = MenhirCell1_path_elt (_menhir_stack, _menhir_s, _v) in
          (* Shifting (DOT) to state 603 *)
          _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0612
      | EQUAL ->
          (* Reducing production path -> path_elt *)
          let _1 = _v in
          let _v = _menhir_action_588 _1 in
          _menhir_goto_path _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0603 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 603: *)
      let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0603 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_path : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0608 ->
          _menhir_run_0616 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState0619 ->
          _menhir_run_0616 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState0610 ->
          _menhir_run_0616 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState0612 ->
          _menhir_run_0613 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0616 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 616: *)
      let _menhir_stack = MenhirCell1_path (_menhir_stack, _menhir_s, _v) in
      (* The current token is EQUAL. *)
      (* Shifting (EQUAL) to state 617 *)
      (* State 617: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0617
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0617
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | STRING_LITERAL _v_2 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0617
      | STRING_CONSTANT _v_3 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0617
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LBRACE ->
          (* Shifting (LBRACE) to state 618 *)
          (* State 618: *)
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell1_LBRACE (_menhir_stack, MenhirState0617, _startpos_4) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v_5 ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState0618
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | WITH ->
              (* Shifting (WITH) to state 619 *)
              (* State 619: *)
              let _menhir_stack = MenhirCell1_WITH (_menhir_stack, MenhirState0618) in
              let _menhir_s = MenhirState0619 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LSQUARE ->
                  (* Shifting (LSQUARE) to state 367 *)
                  _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | DOT ->
                  (* Shifting (DOT) to state 603 *)
                  _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | TYPENAME _v_6 ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState0618
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | STRING_LITERAL _v_7 ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState0618
          | STRING_CONSTANT _v_8 ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0618
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LSQUARE ->
              (* Shifting (LSQUARE) to state 367 *)
              _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INT_CONSTANT _v_9 ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0618
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | IDENTIFIER _v_10 ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState0618
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FLOAT_CONSTANT _v_11 ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState0618
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | EXT_GLOBAL_BLOCK _v_12 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState0618
          | EXT_GLOBAL _v_13 ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState0618
          | EXT_CONTRACT _v_14 ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState0618
          | EXT_CODE_ANNOT _v_15 ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState0618
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | DOT ->
              (* Shifting (DOT) to state 603 *)
              _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0618
          | RBRACE ->
              (* Reducing production lexpr_list -> *)
              let _v_16 = _menhir_action_482 () in
              _menhir_run_0605 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INT_CONSTANT _v_17 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState0617
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | IDENTIFIER _v_18 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState0617
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FLOAT_CONSTANT _v_19 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 MenhirState0617
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | EXT_GLOBAL_BLOCK _v_20 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_20 MenhirState0617
      | EXT_GLOBAL _v_21 ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_21 MenhirState0617
      | EXT_CONTRACT _v_22 ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_22 MenhirState0617
      | EXT_CODE_ANNOT _v_23 ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_23 MenhirState0617
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0617
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0605 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRACE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 605: *)
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          (* Shifting (RBRACE) to state 606 *)
          (* State 606: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LBRACE lexpr_list RBRACE *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_476 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0613 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_path_elt -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 613: *)
      let MenhirCell1_path_elt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production path -> path_elt path *)
      let _2 = _v in
      let _v = _menhir_action_589 _1 _2 in
      _menhir_goto_path _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0482 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_LSQUARE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 482: *)
      match (_tok : MenhirBasics.token) with
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 483 *)
          (* State 483: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LSQUARE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner LSQUARE range RSQUARE *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_446 _1 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0667 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 667: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production is_acsl_typename -> INTEGER *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_378 () in
          _menhir_goto_is_acsl_typename _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> INTEGER *)
          let _v = _menhir_action_659 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0668 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 668: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> INT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_140 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> INT *)
          let _v = _menhir_action_667 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0669 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 669: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> FLOAT *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_138 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> FLOAT *)
          let _v = _menhir_action_689 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0670 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 670: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | VARIANT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | TYPENAME _v ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0670
      | TYPE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | SLICE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | RETURNS ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | REAL ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | READS ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | MODULE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | MODEL ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | LOOP ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | LOGIC ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | LEMMA ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | LABEL ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | INTEGER ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | IMPACT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | IDENTIFIER _v ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0670
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | FREES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | EXT_GLOBAL_BLOCK _v ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0670
      | EXT_GLOBAL _v ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0670
      | EXT_CONTRACT _v ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0670
      | EXT_CODE_ANNOT _v ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0670
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | EXITS ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | ENSURES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | DECREASES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | CHECK ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | BREAKS ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | AXIOM ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | ASSERT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | ADMIT ->
          let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos, _endpos) in
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0670
      | COLON ->
          (* Reducing production c_keyword -> ENUM *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_136 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0671 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 671: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> DOUBLE *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_135 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> DOUBLE *)
          let _v = _menhir_action_690 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0672 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 672: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> CONST *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_134 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BOOL | BOOLEAN | BSGHOST | CHAR | CONST | DOUBLE | ENUM | FLOAT | INT | INTEGER | LONG | REAL | SHORT | SIGNED | STRUCT | TYPENAME _ | UNION | UNSIGNED | VOID | VOLATILE ->
          (* Reducing production cv -> CONST *)
          let _v = _menhir_action_203 () in
          _menhir_goto_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0673 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 673: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> CHAR *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_131 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> CHAR *)
          let _v = _menhir_action_664 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0675 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 675: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> BOOLEAN *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_132 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> BOOLEAN *)
          let _v = _menhir_action_661 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0676 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 676: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production c_keyword -> BOOL *)
          let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
          let _v = _menhir_action_133 () in
          _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | BSGHOST | CONST | LPAR | LSQUARE | RPAR | STAR | VOLATILE ->
          (* Reducing production type_spec(TYPENAME) -> BOOL *)
          let _v = _menhir_action_663 () in
          _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0712 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LSQUAREPIPE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 712: *)
      match (_tok : MenhirBasics.token) with
      | RSQUAREPIPE ->
          (* Shifting (RSQUAREPIPE) to state 713 *)
          (* State 713: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LSQUAREPIPE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LSQUAREPIPE lexpr_list RSQUAREPIPE *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_448 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0614 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 614: *)
      (* Reducing production path_elt -> field_path_elt *)
      let _1 = _v in
      let _v = _menhir_action_590 _1 in
      _menhir_goto_path_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0542 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_ARROW -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 542: *)
      let MenhirCell1_ARROW (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production lexpr_inner -> lexpr_inner ARROW identifier_or_typename_full *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_444 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0540 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_DOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 540: *)
      let MenhirCell1_DOT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production lexpr_inner -> lexpr_inner DOT identifier_or_typename_full *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_445 _1 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0532 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 532: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_identifier_or_typename_full (_menhir_stack, _menhir_s, _v, _endpos) in
          (* Shifting (COMMA) to state 533 *)
          (* State 533: *)
          let _menhir_s = MenhirState0533 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RBRACE ->
          (* Reducing production ne_label_args -> identifier_or_typename_full *)
          let _1 = _v in
          let _v = _menhir_action_541 _1 in
          _menhir_goto_ne_label_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_label_args : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0533 ->
          _menhir_run_0534 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0526 ->
          _menhir_run_0527 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0534 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_identifier_or_typename_full -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 534: *)
      let MenhirCell1_identifier_or_typename_full (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      (* Reducing production ne_label_args -> identifier_or_typename_full COMMA ne_label_args *)
      let _3 = _v in
      let _v = _menhir_action_542 _1 _3 in
      _menhir_goto_ne_label_args _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0527 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LBRACE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 527: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 528 *)
      (* State 528: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_ne_label_args (_menhir_stack, _menhir_s, _v) in
          let _menhir_stack = MenhirCell0_RBRACE (_menhir_stack, _endpos) in
          (* Shifting (LPAR) to state 529 *)
          (* State 529: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0529 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> full_identifier LBRACE ne_label_args RBRACE *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_462 _1 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0285 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENUM -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 285: *)
      let MenhirCell1_ENUM (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> ENUM identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_769 id in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0263 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STRUCT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 263: *)
      let MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> STRUCT identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_768 id in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0260 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNION -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 260: *)
      let MenhirCell1_UNION (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production type_spec(typename) -> UNION identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_770 id in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0229 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ENUM -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 229: *)
      let MenhirCell1_ENUM (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> ENUM identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_693 id in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0207 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STRUCT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 207: *)
      let MenhirCell1_STRUCT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> STRUCT identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_692 id in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0196 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_UNION -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 196: *)
      let MenhirCell1_UNION (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> UNION identifier_or_typename_full *)
      let id = _v in
      let _v = _menhir_action_694 id in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0305 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_abs_spec_bis, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 305: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 306 *)
          (* State 306: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_abs_spec_bis (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production abs_spec_bis -> abs_spec_bis LPAR abs_param_type_list RPAR *)
          let _3 = _v in
          let _v = _menhir_action_018 _1 _3 in
          _menhir_goto_abs_spec_bis _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0247 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_stars as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 247: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_abs_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0247
      | LPAR ->
          let _menhir_stack = MenhirCell1_abs_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 248 *)
          _menhir_run_0248 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0247
      | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | TERMINATES | TYPE | VARIANT | WRITES ->
          let MenhirCell1_stars (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production abs_spec -> stars abs_spec_bis *)
          let _2 = _v in
          let _v = _menhir_action_013 _1 _2 in
          _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0296 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 296: *)
      (* Reducing production abs_spec_option -> abs_spec *)
      let _1 = _v in
      let _v = _menhir_action_031 _1 in
      _menhir_goto_abs_spec_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_abs_spec_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0813 ->
          _menhir_run_0814 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0234 ->
          _menhir_run_0315 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0292 ->
          _menhir_run_0293 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0814 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_identifier_or_typename_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 814: *)
      let MenhirCell1_type_spec_identifier_or_typename_ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production logic_type_gen(identifier_or_typename) -> type_spec(identifier_or_typename) abs_spec_option *)
      let _2 = _v in
      let _v = _menhir_action_507 _1 _2 in
      _menhir_goto_logic_type_gen_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_logic_type_gen_identifier_or_typename_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1173 ->
          _menhir_run_0921 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0920 ->
          _menhir_run_0921 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0819 ->
          _menhir_run_0818 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0812 ->
          _menhir_run_0818 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0921 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOGIC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 921: *)
      (* Reducing production logic_rt_type -> logic_type_gen(identifier_or_typename) *)
      let _1 = _v in
      let _v = _menhir_action_504 _1 in
      _menhir_goto_logic_rt_type _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_logic_rt_type : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOGIC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1173 ->
          _menhir_run_1174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0920 ->
          _menhir_run_0922 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1174 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOGIC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1174: *)
      let _menhir_stack = MenhirCell1_logic_rt_type (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | IDENTIFIER _v_0 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1174
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | EXT_GLOBAL_BLOCK _v_1 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1174
      | EXT_GLOBAL _v_2 ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1174
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1174
      | EXT_CODE_ANNOT _v_4 ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState1174
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1174
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0922 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOGIC as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 922: *)
      let _menhir_stack = MenhirCell1_logic_rt_type (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | IDENTIFIER _v_0 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0922
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | EXT_GLOBAL_BLOCK _v_1 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0922
      | EXT_GLOBAL _v_2 ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0922
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0922
      | EXT_CODE_ANNOT _v_4 ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0922
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0922
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0818 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 818: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_logic_type_gen_identifier_or_typename_ (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 819 *)
          (* State 819: *)
          let _menhir_s = MenhirState0819 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 764 *)
              _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 765 *)
              _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 774 *)
              _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 776 *)
              _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 778 *)
              _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 787 *)
              _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 789 *)
              _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 790 *)
              _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 795 *)
              _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 796 *)
              _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 797 *)
              _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 798 *)
              _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 800 *)
              _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 801 *)
              _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 802 *)
              _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 803 *)
              _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | GT ->
          (* Reducing production separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) -> logic_type_gen(identifier_or_typename) *)
          let x = _v in
          let _v = _menhir_action_633 x in
          _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_identifier_or_typename__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_identifier_or_typename__ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0819 ->
          _menhir_run_0820 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0812 ->
          _menhir_run_0815 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0820 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_logic_type_gen_identifier_or_typename_ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 820: *)
      let MenhirCell1_logic_type_gen_identifier_or_typename_ (_menhir_stack, _menhir_s, x) = _menhir_stack in
      (* Reducing production separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) -> logic_type_gen(identifier_or_typename) COMMA separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) *)
      let xs = _v in
      let _v = _menhir_action_634 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_identifier_or_typename__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0815 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_identifier_or_typename _menhir_cell0_LT -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 815: *)
      (* Reducing production ne_logic_type_list(identifier_or_typename) -> separated_nonempty_list(COMMA,logic_type_gen(identifier_or_typename)) *)
      let l = _v in
      let _v = _menhir_action_548 l in
      (* State 816: *)
      (* The current token is GT. *)
      (* Shifting (GT) to state 817 *)
      (* State 817: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_identifier_or_typename (_menhir_stack, _menhir_s, name, _) = _menhir_stack in
      (* Reducing production type_spec(identifier_or_typename) -> identifier_or_typename LT ne_logic_type_list(identifier_or_typename) GT *)
      let prms = _v in
      let _v = _menhir_action_734 name prms in
      _menhir_goto_type_spec_identifier_or_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0315 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_TYPENAME_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 315: *)
      let MenhirCell1_type_spec_TYPENAME_ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production logic_type_gen(TYPENAME) -> type_spec(TYPENAME) abs_spec_option *)
      let _2 = _v in
      let _v = _menhir_action_506 _1 _2 in
      (* State 319: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_logic_type_gen_TYPENAME_ (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 320 *)
          (* State 320: *)
          let _menhir_s = MenhirState0320 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              (* Shifting (VOID) to state 202 *)
              _menhir_run_0202 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 203 *)
              _menhir_run_0203 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 204 *)
              _menhir_run_0204 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 205 *)
              _menhir_run_0205 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 206 *)
              _menhir_run_0206 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 208 *)
              _menhir_run_0208 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 217 *)
              _menhir_run_0217 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 219 *)
              _menhir_run_0219 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 220 *)
              _menhir_run_0220 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 225 *)
              _menhir_run_0225 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 226 *)
              _menhir_run_0226 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 227 *)
              _menhir_run_0227 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 228 *)
              _menhir_run_0228 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 230 *)
              _menhir_run_0230 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 231 *)
              _menhir_run_0231 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 232 *)
              _menhir_run_0232 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 233 *)
              _menhir_run_0233 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | GT ->
          (* Reducing production separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) -> logic_type_gen(TYPENAME) *)
          let x = _v in
          let _v = _menhir_action_631 x in
          _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_TYPENAME__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_TYPENAME__ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0320 ->
          _menhir_run_0321 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0201 ->
          _menhir_run_0316 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0321 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_logic_type_gen_TYPENAME_ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 321: *)
      let MenhirCell1_logic_type_gen_TYPENAME_ (_menhir_stack, _menhir_s, x) = _menhir_stack in
      (* Reducing production separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) -> logic_type_gen(TYPENAME) COMMA separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) *)
      let xs = _v in
      let _v = _menhir_action_632 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_TYPENAME__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0316 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_TYPENAME _menhir_cell0_LT -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 316: *)
      (* Reducing production ne_logic_type_list(TYPENAME) -> separated_nonempty_list(COMMA,logic_type_gen(TYPENAME)) *)
      let l = _v in
      let _v = _menhir_action_547 l in
      (* State 317: *)
      (* The current token is GT. *)
      (* Shifting (GT) to state 318 *)
      (* State 318: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_TYPENAME (_menhir_stack, _menhir_s, name, _, _) = _menhir_stack in
      (* Reducing production type_spec(TYPENAME) -> TYPENAME LT ne_logic_type_list(TYPENAME) GT *)
      let prms = _v in
      let _v = _menhir_action_696 name prms in
      _menhir_goto_type_spec_TYPENAME_ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0293 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_typename_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 293: *)
      let MenhirCell1_type_spec_typename_ (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production logic_type_gen(typename) -> type_spec(typename) abs_spec_option *)
      let _2 = _v in
      let _v = _menhir_action_508 _1 _2 in
      _menhir_goto_logic_type_gen_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_logic_type_gen_typename_ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0822 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0829 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0825 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0689 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0375 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0308 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0248 ->
          _menhir_run_0303 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0301 ->
          _menhir_run_0300 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0291 ->
          _menhir_run_0300 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0303 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 303: *)
      (* Reducing production logic_type -> logic_type_gen(typename) *)
      let (_startpos__1_, _1) = (_startpos, _v) in
      let _v = _menhir_action_505 _1 in
      _menhir_goto_logic_type _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_logic_type : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0822 ->
          _menhir_run_0839 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0829 ->
          _menhir_run_0828 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0825 ->
          _menhir_run_0828 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0689 ->
          _menhir_run_0304 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0375 ->
          _menhir_run_0304 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0308 ->
          _menhir_run_0304 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0248 ->
          _menhir_run_0304 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0839 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 839: *)
      (* Reducing production typedef -> logic_type *)
      let _1 = _v in
      let _v = _menhir_action_776 _1 in
      _menhir_goto_typedef _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_typedef : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 836: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 837 *)
          (* State 837: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_poly_id_type_add_typename (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_def -> TYPE poly_id_type_add_typename EQUAL typedef SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_503 _2 _4 in
          _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_logic_def : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1389 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1368 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1332 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1326 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_1219 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1192 ->
          _menhir_run_1189 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1162 ->
          _menhir_run_1189 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1219 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1219: *)
      (* Reducing production decl -> logic_def *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_216 _1 in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_decl : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1332 ->
          _menhir_run_1387 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1368 ->
          _menhir_run_1387 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1389 ->
          _menhir_run_1387 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1387 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1387 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1326 ->
          _menhir_run_1326 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_1326 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1387 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1387: *)
      (* Reducing production ext_global_clause -> decl *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_247 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_ext_global_clause _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1326 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _ -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1326: *)
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VOLATILE) to state 2 *)
          _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | TYPE ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPE) to state 760 *)
          _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PREDICATE) to state 857 *)
          _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | MODEL ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MODEL) to state 879 *)
          _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | LOGIC ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LOGIC) to state 920 *)
          _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | LEMMA ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LEMMA) to state 929 *)
          _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INDUCTIVE) to state 937 *)
          _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GLOBAL) to state 956 *)
          _menhir_run_0956 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | EXT_GLOBAL_BLOCK _v_0 ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
          _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1326
      | EXT_GLOBAL _v_1 ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL) to state 1146 *)
          _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1326
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 1154 *)
          _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AXIOMATIC) to state 1160 *)
          _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | AXIOM ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AXIOM) to state 1195 *)
          _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_decl (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 1184 *)
          _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1326
      | EOF ->
          (* Reducing production decl_list -> decl *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_219 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_decl_list _menhir_stack _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0760 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 760: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 761 *)
          (* State 761: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | VOLATILE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | VOID ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | VARIANT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | UNSIGNED ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | UNION ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | TYPENAME _v ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0761
          | TYPE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | TERMINATES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | STRUCT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | STATIC ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | SLICE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | SIZEOF ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | SIGNED ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | SHORT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | RETURNS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | REQUIRES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | REAL ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | READS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | PREDICATE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | PRAGMA ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | MODULE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | MODEL ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | LOOP ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | LONG ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | LOGIC ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | LEMMA ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | LABEL ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | INVARIANT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | INTEGER ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | INT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | INDUCTIVE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | INCLUDE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | IMPACT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | IF ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | IDENTIFIER _v ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0761
          | GLOBAL ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | FUNCTION ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | FREES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | FOR ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | FLOAT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | EXT_LET ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | EXT_GLOBAL_BLOCK _v ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0761
          | EXT_GLOBAL _v ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0761
          | EXT_CONTRACT _v ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0761
          | EXT_CODE_ANNOT _v ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0761
          | EXT_AT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | EXITS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ENUM ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ENSURES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ELSE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | DOUBLE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | DISJOINT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | DECREASES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CONTRACT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CONTINUES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CONST ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | COMPLETE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_RETURNS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_REQUIRES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_LOOP ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_LEMMA ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_INVARIANT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_EXITS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_ENSURES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_CONTINUES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK_BREAKS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHECK ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CHAR ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | CASE ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | BREAKS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | BOOLEAN ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | BOOL ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | BEHAVIORS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | BEHAVIOR ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | AXIOMATIC ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | AXIOM ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ASSUMES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ASSIGNS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ASSERT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ALLOCATES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_RETURNS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_REQUIRES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_LOOP ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_LEMMA ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_INVARIANT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_EXITS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_ENSURES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_CONTINUES ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT_BREAKS ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | ADMIT ->
              let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, MenhirState0760, _startpos_0, _endpos_1) in
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0761
          | EQUAL | LT | SEMICOLON ->
              (* Reducing production full_identifier -> INVARIANT *)
              let _v = _menhir_action_306 () in
              _menhir_run_0844 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_1 _startpos_0 _v MenhirState0760 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0760
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0760
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0760
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0760
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0760
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0760
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0844 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 844: *)
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LT) to state 845 *)
          _menhir_run_0845 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EQUAL | SEMICOLON ->
          (* Reducing production poly_id_type -> full_identifier *)
          let _1 = _v in
          let _v = _menhir_action_595 _1 in
          _menhir_goto_poly_id_type _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_poly_id_type : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1163 ->
          _menhir_run_1164 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1195 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1184 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1179 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1174 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1166 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1154 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0942 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0937 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0929 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0922 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0857 ->
          _menhir_run_0858 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0760 ->
          _menhir_run_0842 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1164 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1164: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1165 *)
          (* State 1165: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_decl -> TYPE poly_id_type SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_491 _2 in
          _menhir_goto_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | EQUAL ->
          (* Reducing production poly_id_type_add_typename -> poly_id_type *)
          let _1 = _v in
          let _v = _menhir_action_597 _1 in
          _menhir_goto_poly_id_type_add_typename _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_logic_decl : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1194: *)
      (* Reducing production logic_decl_loc -> logic_decl *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_493 _1 _endpos__1_ _startpos__1_ in
      (* State 1192: *)
      let _menhir_stack = MenhirCell1_logic_decl_loc (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | TYPE ->
          (* Shifting (TYPE) to state 1163 *)
          _menhir_run_1163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 1166 *)
          _menhir_run_1166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | LOGIC ->
          (* Shifting (LOGIC) to state 1173 *)
          _menhir_run_1173 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | LEMMA ->
          (* Shifting (LEMMA) to state 929 *)
          _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 937 *)
          _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 1154 *)
          _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 1160 *)
          _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | AXIOM ->
          (* Shifting (AXIOM) to state 1179 *)
          _menhir_run_1179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 1184 *)
          _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1192
      | RBRACE ->
          (* Reducing production logic_decls -> *)
          let _v_0 = _menhir_action_494 () in
          _menhir_run_1193 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1163 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1163: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1163 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1166 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1166: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_PREDICATE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1166 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1173 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1173: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1173 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 764 *)
          _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 765 *)
          _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 774 *)
          _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 776 *)
          _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 778 *)
          _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 787 *)
          _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 789 *)
          _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 790 *)
          _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 795 *)
          _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 796 *)
          _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 797 *)
          _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 798 *)
          _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 800 *)
          _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 801 *)
          _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 802 *)
          _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 803 *)
          _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0929 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 929: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LEMMA (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0929 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0937 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 937: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_INDUCTIVE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0937 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1154 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1154: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CHECK_LEMMA (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1154 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1160 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1160: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_AXIOMATIC (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1160 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1179 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1179: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1179 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1184 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1184: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ADMIT_LEMMA (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1184 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1193 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_logic_decl_loc -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 1193: *)
      let MenhirCell1_logic_decl_loc (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production logic_decls -> logic_decl_loc logic_decls *)
      let _2 = _v in
      let _v = _menhir_action_495 _1 _2 in
      _menhir_goto_logic_decls _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_logic_decls : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState1192 ->
          _menhir_run_1193 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState1162 ->
          _menhir_run_1190 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1190 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AXIOMATIC, ttv_result) _menhir_cell1_any_identifier _menhir_cell0_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 1190: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 1191 *)
      (* State 1191: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_any_identifier (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_AXIOMATIC (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production logic_def -> AXIOMATIC any_identifier LBRACE logic_decls RBRACE *)
      let (_4, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_502 _2 _4 in
      _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_poly_id_type_add_typename : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 821: *)
      let _menhir_stack = MenhirCell1_poly_id_type_add_typename (_menhir_stack, _menhir_s, _v) in
      (* The current token is EQUAL. *)
      (* Shifting (EQUAL) to state 822 *)
      (* State 822: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
      let _menhir_s = MenhirState0822 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PIPE ->
          (* Shifting (PIPE) to state 823 *)
          (* State 823: *)
          let _menhir_stack = MenhirCell1_PIPE (_menhir_stack, _menhir_s) in
          let _menhir_s = MenhirState0823 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0858 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 858: *)
      (* Reducing production poly_id -> poly_id_type *)
      let _1 = _v in
      let _v = _menhir_action_592 _1 in
      _menhir_goto_poly_id _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_poly_id : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1195 ->
          _menhir_run_1196 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1184 ->
          _menhir_run_1185 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1179 ->
          _menhir_run_1180 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1174 ->
          _menhir_run_1175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1166 ->
          _menhir_run_1167 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1154 ->
          _menhir_run_1155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0942 ->
          _menhir_run_0943 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0937 ->
          _menhir_run_0938 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0929 ->
          _menhir_run_0930 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0922 ->
          _menhir_run_0923 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0857 ->
          _menhir_run_0859 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1196 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AXIOM as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1196: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1197 *)
          (* State 1197: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState1197 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1185 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADMIT_LEMMA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1185: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1186 *)
          (* State 1186: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState1186 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1180 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AXIOM as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1180: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1181 *)
          (* State 1181: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState1181 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1175 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1175: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 860 *)
          _menhir_run_0860 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1175
      | EQUAL | READS | SEMICOLON ->
          (* Reducing production opt_parameters -> *)
          let _v_0 = _menhir_action_582 () in
          _menhir_run_1176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1175 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0860 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 860: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0860 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 764 *)
          _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 765 *)
          _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 774 *)
          _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 776 *)
          _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 778 *)
          _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 787 *)
          _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 789 *)
          _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 790 *)
          _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 795 *)
          _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 796 *)
          _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 797 *)
          _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 798 *)
          _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 800 *)
          _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 801 *)
          _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 802 *)
          _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 803 *)
          _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1176 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1176: *)
      let _menhir_stack = MenhirCell1_opt_parameters (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | READS ->
          (* Shifting (READS) to state 1169 *)
          _menhir_run_1169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1176
      | EQUAL ->
          (* Shifting (EQUAL) to state 926 *)
          _menhir_run_0926 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1176
      | SEMICOLON ->
          (* Reducing production reads_clause -> *)
          let _v_0 = _menhir_action_618 () in
          _menhir_run_1177 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1169 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1169: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_READS (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1169 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0902 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 902: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production zones -> NOTHING *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_851 () in
      _menhir_goto_zones _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_zones : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1169 ->
          _menhir_run_1170 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1062 ->
          _menhir_run_1063 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0917 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0912 ->
          _menhir_run_0913 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1068 ->
          _menhir_run_0910 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0910 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0906 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0906 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0906 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0903 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1170 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters, ttv_result) _menhir_cell1_READS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1170: *)
      let MenhirCell1_READS (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production reads_clause -> READS zones *)
      let _2 = _v in
      let _v = _menhir_action_619 _2 in
      _menhir_goto_reads_clause _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_reads_clause : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1176 ->
          _menhir_run_1177 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1168 ->
          _menhir_run_1171 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1177 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1177: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1178 *)
          (* State 1178: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_opt_parameters (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_logic_rt_type (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_decl -> LOGIC logic_rt_type poly_id opt_parameters reads_clause SEMICOLON *)
          let (_endpos__6_, _5) = (_endpos, _v) in
          let _v = _menhir_action_489 _2 _3 _4 _5 in
          _menhir_goto_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1171 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_PREDICATE, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1171: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1172 *)
          (* State 1172: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_opt_parameters (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_PREDICATE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_decl -> PREDICATE poly_id opt_parameters reads_clause SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_490 _2 _3 _4 in
          _menhir_goto_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1063 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT_CONTRACT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1063: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Reducing production extension_content -> zones *)
          let _1 = _v in
          let _v = _menhir_action_276 _1 in
          _menhir_goto_extension_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COMPLETE | CONTINUES | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FREES | REQUIRES | RETURNS ->
          (* Reducing production ne_grammar_extension -> zones *)
          let _1 = _v in
          let _v = _menhir_action_540 _1 in
          (* State 1064: *)
          let _menhir_stack = MenhirCell1_ne_grammar_extension (_menhir_stack, _menhir_s, _v) in
          (match (_tok : MenhirBasics.token) with
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 976 *)
              _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | FREES ->
              (* Shifting (FREES) to state 977 *)
              _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | EXT_CONTRACT _v_0 ->
              (* Shifting (EXT_CONTRACT) to state 978 *)
              _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1064
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | EOF ->
              (* Shifting (EOF) to state 979 *)
              _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 980 *)
              _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | DECREASES ->
              (* Shifting (DECREASES) to state 981 *)
              _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 982 *)
              _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 983 *)
              _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 984 *)
              _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 985 *)
              _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 986 *)
              _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 987 *)
              _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 988 *)
              _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 989 *)
              _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 990 *)
              _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 991 *)
              _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 992 *)
              _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 993 *)
              _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 994 *)
              _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1064
          | _ ->
              _menhir_fail ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_extension_content : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1146 ->
          _menhir_run_1147 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1062 ->
          _menhir_run_1066 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_1031 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0905 ->
          _menhir_run_0907 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1147 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_EXT_GLOBAL -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1147: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1148 *)
          (* State 1148: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_EXT_GLOBAL (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production ext_decl -> EXT_GLOBAL extension_content SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_230 _1 _2 in
          _menhir_goto_ext_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_decl : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1332 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1368 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1389 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1326 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_1322 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1145 ->
          _menhir_run_1153 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1151 ->
          _menhir_run_1153 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1322 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1322: *)
      (* Reducing production decl -> ext_decl *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_217 _1 in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1153 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1153: *)
      (* Reducing production ext_decl_loc -> ext_decl *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_232 _1 _endpos__1_ _startpos__1_ in
      (* State 1151: *)
      let _menhir_stack = MenhirCell1_ext_decl_loc (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | EXT_GLOBAL_BLOCK _v_0 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
          _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1151
      | EXT_GLOBAL _v_1 ->
          (* Shifting (EXT_GLOBAL) to state 1146 *)
          _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1151
      | RBRACE ->
          (* Reducing production ext_decls -> *)
          let _v_2 = _menhir_action_233 () in
          _menhir_run_1152 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1143 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1143: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EXT_GLOBAL_BLOCK (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _menhir_s = MenhirState1143 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1146 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1146: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EXT_GLOBAL (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1146
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1146
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | STRING_LITERAL _v_2 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1146
      | STRING_CONSTANT _v_3 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1146
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INT_CONSTANT _v_4 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState1146
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | IDENTIFIER _v_5 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1146
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FLOAT_CONSTANT _v_6 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState1146
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | EXT_GLOBAL_BLOCK _v_7 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState1146
      | EXT_GLOBAL _v_8 ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState1146
      | EXT_CONTRACT _v_9 ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState1146
      | EXT_CODE_ANNOT _v_10 ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState1146
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1146
      | SEMICOLON ->
          (* Reducing production extension_content -> *)
          let _v_11 = _menhir_action_275 () in
          _menhir_run_1147 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1152 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ext_decl_loc -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 1152: *)
      let MenhirCell1_ext_decl_loc (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_decls -> ext_decl_loc ext_decls *)
      let _2 = _v in
      let _v = _menhir_action_234 _1 _2 in
      _menhir_goto_ext_decls _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_ext_decls : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState1151 ->
          _menhir_run_1152 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState1145 ->
          _menhir_run_1149 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1149 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT_GLOBAL_BLOCK, ttv_result) _menhir_cell1_any_identifier _menhir_cell0_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 1149: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 1150 *)
      (* State 1150: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_any_identifier (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_EXT_GLOBAL_BLOCK (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ext_decl -> EXT_GLOBAL_BLOCK any_identifier LBRACE ext_decls RBRACE *)
      let (_4, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_231 _1 _2 _4 in
      _menhir_goto_ext_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1066 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT_CONTRACT as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1066: *)
      let _menhir_stack = MenhirCell1_extension_content (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1067 *)
          (* State 1067: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | FREES ->
              (* Shifting (FREES) to state 901 *)
              _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | EXT_CONTRACT _v_0 ->
              (* Shifting (EXT_CONTRACT) to state 1062 *)
              _menhir_run_1062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1067
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 1068 *)
              _menhir_run_1068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 916 *)
              _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1067
          | ADMIT_LEMMA | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production simple_clauses -> *)
              let _v_1 = _menhir_action_637 () in
              _menhir_run_1084 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_1 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0901 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 901: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FREES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0901 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1062 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1062: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EXT_CONTRACT (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1062
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1062
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | STRING_LITERAL _v_2 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1062
      | STRING_CONSTANT _v_3 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1062
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INT_CONSTANT _v_4 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState1062
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | IDENTIFIER _v_5 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1062
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FLOAT_CONSTANT _v_6 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState1062
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | EXT_GLOBAL_BLOCK _v_7 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState1062
      | EXT_GLOBAL _v_8 ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState1062
      | EXT_CONTRACT _v_9 ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState1062
      | EXT_CODE_ANNOT _v_10 ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState1062
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1062
      | SEMICOLON ->
          (* Reducing production extension_content -> *)
          let _v_11 = _menhir_action_275 () in
          _menhir_run_1066 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState1062 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1068 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1068: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ASSIGNS (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1068 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0916 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 916: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ALLOCATES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0916 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1084 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT_CONTRACT, ttv_result) _menhir_cell1_extension_content _menhir_cell0_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1084: *)
      let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_extension_content (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_EXT_CONTRACT (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> EXT_CONTRACT extension_content SEMICOLON simple_clauses *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_561 _1 _2 _4 in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ne_simple_clauses : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1061 ->
          _menhir_run_1134 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1098 ->
          _menhir_run_1100 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1067 ->
          _menhir_run_1077 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1070 ->
          _menhir_run_1077 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1079 ->
          _menhir_run_1077 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1074 ->
          _menhir_run_1077 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1134 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1134: *)
      match (_tok : MenhirBasics.token) with
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 1135 *)
          (* State 1135: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases ne_simple_clauses TERMINATES *)
          let (_endpos__5_, _startpos__5_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_189 _endpos__5_ _startpos__5_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 1136 *)
          (* State 1136: *)
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases ne_simple_clauses REQUIRES *)
          let (_endpos__5_, _startpos__5_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_188 _endpos__5_ _startpos__5_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
      | DECREASES ->
          (* Shifting (DECREASES) to state 1137 *)
          (* State 1137: *)
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases ne_simple_clauses DECREASES *)
          let (_endpos__5_, _startpos__5_) = (_endpos_5, _startpos_4) in
          let _v = _menhir_action_190 _endpos__5_ _startpos__5_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _v _menhir_s _tok
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production simple_clauses -> ne_simple_clauses *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_638 _1 in
          _menhir_goto_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_simple_clauses : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1098 ->
          _menhir_run_1099 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1061 ->
          _menhir_run_1085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1067 ->
          _menhir_run_1084 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1079 ->
          _menhir_run_1080 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1074 ->
          _menhir_run_1075 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1070 ->
          _menhir_run_1071 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1099 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON, ttv_result) _menhir_cell1_assumes, ttv_result) _menhir_cell1_requires -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1099: *)
      let MenhirCell1_requires (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_assumes (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production behavior_body -> assumes requires simple_clauses *)
      let _3 = _v in
      let _v = _menhir_action_077 _1 _2 _3 in
      _menhir_goto_behavior_body _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
  
  and _menhir_goto_behavior_body : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 1094: *)
      let _menhir_stack = MenhirCell1_behavior_body (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 1086 *)
          _menhir_run_1086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1094
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production behaviors -> *)
          let _v_0 = _menhir_action_084 () in
          _menhir_run_1096 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1086 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1086: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_BEHAVIOR (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1086 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1096 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON, ttv_result) _menhir_cell1_behavior_body -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1096: *)
      let MenhirCell1_behavior_body (_menhir_stack, _, _4) = _menhir_stack in
      let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_behavior_name (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_BEHAVIOR (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_behaviors -> BEHAVIOR behavior_name COLON behavior_body behaviors *)
      let (_endpos__5_, _5) = (_endpos, _v) in
      let _v = _menhir_action_531 _2 _4 _5 in
      _menhir_goto_ne_behaviors _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ne_behaviors : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1085 ->
          _menhir_run_1105 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1094 ->
          _menhir_run_1095 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1105 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, ttv_result) _menhir_cell1_simple_clauses as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1105: *)
      match (_tok : MenhirBasics.token) with
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 1106 *)
          (* State 1106: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses ne_behaviors TERMINATES *)
          let (_endpos__6_, _startpos__6_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_191 _endpos__6_ _startpos__6_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _v _menhir_s _tok
      | DECREASES ->
          (* Shifting (DECREASES) to state 1107 *)
          (* State 1107: *)
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses ne_behaviors DECREASES *)
          let (_endpos__6_, _startpos__6_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_192 _endpos__6_ _startpos__6_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _v _menhir_s _tok
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | COMPLETE | CONTRACT | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production behaviors -> ne_behaviors *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_085 _1 in
          _menhir_goto_behaviors _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_behaviors : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1085 ->
          _menhir_run_1108 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1094 ->
          _menhir_run_1096 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1108 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, ttv_result) _menhir_cell1_simple_clauses as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1108: *)
      let _menhir_stack = MenhirCell1_behaviors (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 1109 *)
          _menhir_run_1109 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1108
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 1115 *)
          _menhir_run_1115 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1108
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production complete_or_disjoint -> *)
          let _v_0 = _menhir_action_178 () in
          _menhir_run_1133 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1109 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1109: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_DISJOINT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 1110 *)
          (* State 1110: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_BEHAVIORS (_menhir_stack, _startpos_0, _endpos_1) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1110
          | SEMICOLON ->
              (* Reducing production behavior_name_list -> *)
              let _v = _menhir_action_082 () in
              _menhir_run_1113 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1110
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1113 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1113: *)
      let _menhir_stack = MenhirCell1_behavior_name_list (_menhir_stack, _menhir_s, _v) in
      (* The current token is SEMICOLON. *)
      (* Shifting (SEMICOLON) to state 1114 *)
      (* State 1114: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 1109 *)
          _menhir_run_1109 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1114
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 1115 *)
          _menhir_run_1115 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1114
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | CONTINUES | CONTRACT | DECREASES | ENSURES | EOF | EXITS | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | RETURNS | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production complete_or_disjoint -> *)
          let _v_0 = _menhir_action_178 () in
          _menhir_run_1123 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1115 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1115: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_COMPLETE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 1116 *)
          (* State 1116: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_BEHAVIORS (_menhir_stack, _startpos_0, _endpos_1) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1116
          | SEMICOLON ->
              (* Reducing production behavior_name_list -> *)
              let _v = _menhir_action_082 () in
              _menhir_run_1119 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1116
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1119 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1119: *)
      let _menhir_stack = MenhirCell1_behavior_name_list (_menhir_stack, _menhir_s, _v) in
      (* The current token is SEMICOLON. *)
      (* Shifting (SEMICOLON) to state 1120 *)
      (* State 1120: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 1109 *)
          _menhir_run_1109 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1120
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 1115 *)
          _menhir_run_1115 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1120
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | CONTINUES | CONTRACT | DECREASES | ENSURES | EOF | EXITS | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | RETURNS | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production complete_or_disjoint -> *)
          let _v_0 = _menhir_action_178 () in
          _menhir_run_1122 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1122 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS, ttv_result) _menhir_cell1_behavior_name_list _menhir_cell0_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1122: *)
      let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_behavior_name_list (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell0_BEHAVIORS (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_COMPLETE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_complete_or_disjoint -> COMPLETE BEHAVIORS behavior_name_list SEMICOLON complete_or_disjoint *)
      let (_endpos__5_, _5) = (_endpos, _v) in
      let _v = _menhir_action_532 _3 _5 in
      _menhir_goto_ne_complete_or_disjoint _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ne_complete_or_disjoint : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1108 ->
          _menhir_run_1124 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1114 ->
          _menhir_run_1121 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1120 ->
          _menhir_run_1121 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1124 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, ttv_result) _menhir_cell1_simple_clauses, ttv_result) _menhir_cell1_behaviors as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1124: *)
      match (_tok : MenhirBasics.token) with
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 1125 *)
          (* State 1125: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint TERMINATES *)
          let (_endpos__7_, _startpos__7_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_194 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | RETURNS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 1126 *)
          (* State 1126: *)
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint REQUIRES *)
          let (_endpos__7_, _startpos__7_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_193 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | FREES ->
          (* Shifting (FREES) to state 1127 *)
          (* State 1127: *)
          let _startpos_4 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_5 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint FREES *)
          let (_endpos__7_, _startpos__7_) = (_endpos_5, _startpos_4) in
          let _v = _menhir_action_199 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | EXITS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | ENSURES ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | DECREASES ->
          (* Shifting (DECREASES) to state 1128 *)
          (* State 1128: *)
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint DECREASES *)
          let (_endpos__7_, _startpos__7_) = (_endpos_7, _startpos_6) in
          let _v = _menhir_action_195 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | BREAKS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 1129 *)
          (* State 1129: *)
          let _startpos_8 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_9 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint BEHAVIOR *)
          let (_endpos__7_, _startpos__7_) = (_endpos_9, _startpos_8) in
          let _v = _menhir_action_196 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 1130 *)
          (* State 1130: *)
          let _startpos_10 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_11 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint ASSIGNS *)
          let (_endpos__7_, _startpos__7_) = (_endpos_11, _startpos_10) in
          let _v = _menhir_action_197 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 1131 *)
          (* State 1131: *)
          let _startpos_12 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_13 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_behaviors (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_simple_clauses (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell0_decreases (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates decreases simple_clauses behaviors ne_complete_or_disjoint ALLOCATES *)
          let (_endpos__7_, _startpos__7_) = (_endpos_13, _startpos_12) in
          let _v = _menhir_action_198 _endpos__7_ _startpos__7_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _v _menhir_s _tok
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_ne_complete_or_disjoint (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1124
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production complete_or_disjoint -> ne_complete_or_disjoint *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_179 _1 in
          _menhir_goto_complete_or_disjoint _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_complete_or_disjoint : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1108 ->
          _menhir_run_1133 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | MenhirState1114 ->
          _menhir_run_1123 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1120 ->
          _menhir_run_1122 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1133 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases, ttv_result) _menhir_cell1_simple_clauses, ttv_result) _menhir_cell1_behaviors -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      (* State 1133: *)
      let MenhirCell1_behaviors (_menhir_stack, _, _5, _startpos__5_, _endpos__5_) = _menhir_stack in
      let MenhirCell1_simple_clauses (_menhir_stack, _, _4, _startpos__4_, _endpos__4_) = _menhir_stack in
      let MenhirCell0_decreases (_menhir_stack, _3, _startpos__3_, _endpos__3_) = _menhir_stack in
      let MenhirCell0_terminates (_menhir_stack, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_requires (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
      (* Reducing production contract -> requires terminates decreases simple_clauses behaviors complete_or_disjoint *)
      let (_endpos__6_, _startpos__6_, _6) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_184 _1 _2 _3 _4 _5 _6 _endpos__1_ _endpos__2_ _endpos__3_ _endpos__4_ _endpos__5_ _endpos__6_ _startpos__1_ _startpos__2_ _startpos__3_ _startpos__4_ _startpos__5_ _startpos__6_ in
      _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _v _menhir_s _tok
  
  and _menhir_run_1123 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS, ttv_result) _menhir_cell1_behavior_name_list _menhir_cell0_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1123: *)
      let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_behavior_name_list (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell0_BEHAVIORS (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_DISJOINT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_complete_or_disjoint -> DISJOINT BEHAVIORS behavior_name_list SEMICOLON complete_or_disjoint *)
      let (_endpos__5_, _5) = (_endpos, _v) in
      let _v = _menhir_action_533 _3 _5 in
      _menhir_goto_ne_complete_or_disjoint _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1121 : type  ttv_stack ttv_result. ((ttv_stack _menhir_cell0_BEHAVIORS, ttv_result) _menhir_cell1_behavior_name_list _menhir_cell0_SEMICOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1121: *)
      (* Reducing production complete_or_disjoint -> ne_complete_or_disjoint *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_179 _1 in
      _menhir_goto_complete_or_disjoint _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1095 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON, ttv_result) _menhir_cell1_behavior_body as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1095: *)
      (* Reducing production behaviors -> ne_behaviors *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_085 _1 in
      _menhir_goto_behaviors _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1085 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_decreases as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1085: *)
      let _menhir_stack = MenhirCell1_simple_clauses (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 1086 *)
          _menhir_run_1086 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1085
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | COMPLETE | CONTRACT | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production behaviors -> *)
          let _v_0 = _menhir_action_084 () in
          _menhir_run_1108 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v_0 MenhirState1085 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1080 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_allocation, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1080: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_allocation (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> allocation SEMICOLON simple_clauses *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_559 _1 _3 in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1075 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_post_cond_kind, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1075: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_post_cond_kind (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> post_cond_kind lexpr SEMICOLON simple_clauses *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_558 _1 _2 _4 in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1071 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS, ttv_result) _menhir_cell1_assigns, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1071: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_assigns (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_ASSIGNS (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> ASSIGNS assigns SEMICOLON simple_clauses *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_560 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1100 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON, ttv_result) _menhir_cell1_assumes, ttv_result) _menhir_cell1_requires as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1100: *)
      match (_tok : MenhirBasics.token) with
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 1101 *)
          (* State 1101: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_requires (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_assumes (_menhir_stack, _menhir_s, _) = _menhir_stack in
          (* Reducing production behavior_body -> assumes requires ne_simple_clauses REQUIRES *)
          let (_endpos, _endpos__4_, _startpos__4_) = (_endpos_1, _endpos_1, _startpos_0) in
          let _v = _menhir_action_080 _endpos__4_ _startpos__4_ in
          _menhir_goto_behavior_body _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 1102 *)
          (* State 1102: *)
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_requires (_menhir_stack, _, _, _, _) = _menhir_stack in
          let MenhirCell1_assumes (_menhir_stack, _menhir_s, _) = _menhir_stack in
          (* Reducing production behavior_body -> assumes requires ne_simple_clauses ASSUMES *)
          let (_endpos, _endpos__4_, _startpos__4_) = (_endpos_3, _endpos_3, _startpos_2) in
          let _v = _menhir_action_079 _endpos__4_ _startpos__4_ in
          _menhir_goto_behavior_body _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production simple_clauses -> ne_simple_clauses *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_638 _1 in
          _menhir_goto_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1077 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1077: *)
      (* Reducing production simple_clauses -> ne_simple_clauses *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_638 _1 in
      _menhir_goto_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1031 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_EXT_CODE_ANNOT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1031: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1032 *)
          (* State 1032: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_EXT_CODE_ANNOT (_menhir_stack, _menhir_s, _1, _startpos__1_, _endpos__1_) = _menhir_stack in
          (* Reducing production code_annotation -> EXT_CODE_ANNOT extension_content SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_177 _1 _2 _endpos__1_ _startpos__1_ in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_code_annotation : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1401 ->
          _menhir_run_1328 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1382 ->
          _menhir_run_1328 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_1328 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0964 ->
          _menhir_run_1142 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1328 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1328: *)
      (* Reducing production pragma_or_code_annotation -> code_annotation *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_616 _1 in
      _menhir_goto_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_pragma_or_code_annotation : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1202: *)
      match (_tok : MenhirBasics.token) with
      | SLICE ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLICE) to state 1203 *)
          (* State 1203: *)
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> SLICE *)
          let _endpos__1_ = _endpos_1 in
          let _ = _menhir_action_066 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INVARIANT) to state 1204 *)
          (* State 1204: *)
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> INVARIANT *)
          let _endpos__1_ = _endpos_4 in
          let _ = _menhir_action_071 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | IMPACT ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPACT) to state 1205 *)
          (* State 1205: *)
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> IMPACT *)
          let _endpos__1_ = _endpos_7 in
          let _ = _menhir_action_065 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | FOR ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FOR) to state 1206 *)
          (* State 1206: *)
          let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> FOR *)
          let _endpos__1_ = _endpos_10 in
          let _ = _menhir_action_067 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | EXT_CODE_ANNOT _ ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 1207 *)
          (* State 1207: *)
          let _endpos_14 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> EXT_CODE_ANNOT *)
          let _endpos__1_ = _endpos_14 in
          let _ = _menhir_action_076 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 1208 *)
          (* State 1208: *)
          let _endpos_17 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> CHECK_LOOP *)
          let _endpos__1_ = _endpos_17 in
          let _ = _menhir_action_074 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 1209 *)
          (* State 1209: *)
          let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> CHECK_INVARIANT *)
          let _endpos__1_ = _endpos_20 in
          let _ = _menhir_action_072 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | CHECK ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK) to state 1210 *)
          (* State 1210: *)
          let _endpos_23 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> CHECK *)
          let _endpos__1_ = _endpos_23 in
          let _ = _menhir_action_069 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | ASSERT ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSERT) to state 1211 *)
          (* State 1211: *)
          let _endpos_26 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> ASSERT *)
          let _endpos__1_ = _endpos_26 in
          let _ = _menhir_action_068 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 1212 *)
          (* State 1212: *)
          let _endpos_29 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> ADMIT_LOOP *)
          let _endpos__1_ = _endpos_29 in
          let _ = _menhir_action_075 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 1213 *)
          (* State 1213: *)
          let _endpos_32 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> ADMIT_INVARIANT *)
          let _endpos__1_ = _endpos_32 in
          let _ = _menhir_action_073 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | ADMIT ->
          let _menhir_stack = MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT) to state 1214 *)
          (* State 1214: *)
          let _endpos_35 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production beg_pragma_or_code_annotation -> ADMIT *)
          let _endpos__1_ = _endpos_35 in
          let _ = _menhir_action_070 () in
          _menhir_goto_beg_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _tok
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production annotation -> pragma_or_code_annotation *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_042 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_beg_pragma_or_code_annotation : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_pragma_or_code_annotation -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _tok ->
      (* State 1215: *)
      let MenhirCell1_pragma_or_code_annotation (_menhir_stack, _menhir_s, _, _startpos__1_, _) = _menhir_stack in
      (* Reducing production annotation -> pragma_or_code_annotation beg_pragma_or_code_annotation *)
      let _endpos__2_ = _endpos in
      let _v = _menhir_action_043 _endpos__2_ _startpos__1_ in
      _menhir_goto_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
  
  and _menhir_run_1142 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_ne_behavior_name_list _menhir_cell0_COLON -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      (* State 1142: *)
      (* Reducing production contract_or_code_annotation -> code_annotation *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_202 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_contract_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _tok
  
  and _menhir_run_0907 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOOP, ttv_result) _menhir_cell1_EXT_CODE_ANNOT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 907: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 908 *)
          (* State 908: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_EXT_CODE_ANNOT (_menhir_stack, _, _2, _startpos__2_, _endpos__2_) = _menhir_stack in
          let MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_grammar_extension -> LOOP EXT_CODE_ANNOT extension_content SEMICOLON *)
          let _3 = _v in
          let _v = _menhir_action_521 _2 _3 _endpos__2_ _startpos__2_ in
          let _startpos = _startpos__1_ in
          (* State 1015: *)
          let _menhir_stack = MenhirCell1_loop_grammar_extension (_menhir_stack, _menhir_s, _v, _startpos) in
          (match (_tok : MenhirBasics.token) with
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1015
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1015
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1015
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1015
          | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
              (* Reducing production loop_annot_opt -> *)
              let _v_0 = _menhir_action_510 () in
              _menhir_run_1021 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0887 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 887: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VARIANT ->
          (* Shifting (VARIANT) to state 888 *)
          (* State 888: *)
          let _menhir_s = MenhirState0887 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_VARIANT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState0888 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 894 *)
          (* State 894: *)
          let _menhir_s = MenhirState0887 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_PRAGMA (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState0894 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 898 *)
          (* State 898: *)
          let _menhir_s = MenhirState0887 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState0898 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | FREES ->
          (* Shifting (FREES) to state 901 *)
          _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0887
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 905 *)
          (* State 905: *)
          let _startpos_6 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_7 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_EXT_CODE_ANNOT (_menhir_stack, MenhirState0887, _v, _startpos_6, _endpos_7) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v_8 ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0905
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | TYPENAME _v_9 ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0905
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | STRING_LITERAL _v_10 ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState0905
          | STRING_CONSTANT _v_11 ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState0905
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | NOTHING ->
              (* Shifting (NOTHING) to state 902 *)
              _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INT_CONSTANT _v_12 ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState0905
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | IDENTIFIER _v_13 ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState0905
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FLOAT_CONSTANT _v_14 ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState0905
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | EXT_GLOBAL_BLOCK _v_15 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState0905
          | EXT_GLOBAL _v_16 ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState0905
          | EXT_CONTRACT _v_17 ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_17 MenhirState0905
          | EXT_CODE_ANNOT _v_18 ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_18 MenhirState0905
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0905
          | SEMICOLON ->
              (* Reducing production extension_content -> *)
              let _v_19 = _menhir_action_275 () in
              _menhir_run_0907 _menhir_stack _menhir_lexbuf _menhir_lexer _v_19 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 909 *)
          (* State 909: *)
          let _menhir_s = MenhirState0887 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_ASSIGNS (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState0909 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOTHING ->
              (* Shifting (NOTHING) to state 902 *)
              _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 916 *)
          _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0887
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1001 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1001: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1001 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1004 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1004: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CHECK_LOOP (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 1005 *)
          (* State 1005: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_INVARIANT (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1005 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1008 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1008: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ADMIT_LOOP (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 1009 *)
          (* State 1009: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_INVARIANT (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1009 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1021 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_loop_grammar_extension -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1021: *)
      let MenhirCell1_loop_grammar_extension (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production loop_annot_stack -> loop_grammar_extension loop_annot_opt *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_518 _1 _2 in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_loop_annot_stack : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1401 ->
          _menhir_run_1218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1382 ->
          _menhir_run_1218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0000 ->
          _menhir_run_1218 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0964 ->
          _menhir_run_1025 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1003 ->
          _menhir_run_1025 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1012 ->
          _menhir_run_1017 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1013 ->
          _menhir_run_1017 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1014 ->
          _menhir_run_1017 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1015 ->
          _menhir_run_1017 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1019 ->
          _menhir_run_1017 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1016 ->
          _menhir_run_1017 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1218 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1218: *)
      (* Reducing production loop_annotations -> loop_annot_stack *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_519 _1 in
      let (_endpos, _startpos) = (_endpos__1_, _startpos__1_) in
      (* State 1217: *)
      (* Reducing production annotation -> loop_annotations *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_040 _1 _endpos__1_ _startpos__1_ in
      _menhir_goto_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1025 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR, ttv_result) _menhir_cell1_ne_behavior_name_list _menhir_cell0_COLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1025: *)
      let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ne_behavior_name_list (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production loop_annot_stack -> FOR ne_behavior_name_list COLON loop_annot_stack *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_515 _2 _4 _endpos__4_ _startpos__1_ in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1017 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 1017: *)
      (* Reducing production loop_annot_opt -> loop_annot_stack *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_511 _1 in
      _menhir_goto_loop_annot_opt _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_loop_annot_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1012 ->
          _menhir_run_1024 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1013 ->
          _menhir_run_1023 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1014 ->
          _menhir_run_1022 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1015 ->
          _menhir_run_1021 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1019 ->
          _menhir_run_1020 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1016 ->
          _menhir_run_1018 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1024 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_loop_variant -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1024: *)
      let MenhirCell1_loop_variant (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production loop_annot_stack -> loop_variant loop_annot_opt *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_516 _1 _2 in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1023 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_loop_pragma -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1023: *)
      let MenhirCell1_loop_pragma (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production loop_annot_stack -> loop_pragma loop_annot_opt *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_517 _1 _2 in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1022 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_loop_invariant -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1022: *)
      let MenhirCell1_loop_invariant (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production loop_annot_stack -> loop_invariant loop_annot_opt *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_512 _1 _2 in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1020 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_loop_allocation -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1020: *)
      let MenhirCell1_loop_allocation (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production loop_annot_stack -> loop_allocation loop_annot_opt *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_514 _1 _2 in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1018 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_loop_effects -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1018: *)
      let MenhirCell1_loop_effects (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production loop_annot_stack -> loop_effects loop_annot_opt *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_513 _1 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_loop_annot_stack _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0976 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 976: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> REQUIRES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_159 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_clause_kw : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1117 ->
          _menhir_run_1118 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1111 ->
          _menhir_run_1112 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1090 ->
          _menhir_run_1093 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1069 ->
          _menhir_run_1083 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1073 ->
          _menhir_run_1082 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1078 ->
          _menhir_run_1081 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1064 ->
          _menhir_run_1065 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1055 ->
          _menhir_run_1057 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1050 ->
          _menhir_run_1052 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0966 ->
          _menhir_run_1000 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0969 ->
          _menhir_run_0998 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0972 ->
          _menhir_run_0996 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1118 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS, ttv_result) _menhir_cell1_ne_behavior_name_list -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1118: *)
      let MenhirCell1_ne_behavior_name_list (_menhir_stack, _, _, _startpos__3_, _endpos__3_) = _menhir_stack in
      let MenhirCell0_BEHAVIORS (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_COMPLETE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_complete_or_disjoint -> COMPLETE BEHAVIORS ne_behavior_name_list clause_kw *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_534 _4 _endpos__3_ _startpos__3_ in
      _menhir_goto_ne_complete_or_disjoint _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1112 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS, ttv_result) _menhir_cell1_ne_behavior_name_list -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1112: *)
      let MenhirCell1_ne_behavior_name_list (_menhir_stack, _, _, _startpos__3_, _endpos__3_) = _menhir_stack in
      let MenhirCell0_BEHAVIORS (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_DISJOINT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_complete_or_disjoint -> DISJOINT BEHAVIORS ne_behavior_name_list clause_kw *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_535 _4 _endpos__3_ _startpos__3_ in
      _menhir_goto_ne_complete_or_disjoint _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1093 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSUMES, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1093: *)
      let MenhirCell1_lexpr (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_ASSUMES (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production assumes -> ASSUMES lexpr clause_kw *)
      let _3 = _v in
      let _v = _menhir_action_064 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_assumes _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
  
  and _menhir_goto_assumes : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1088 ->
          _menhir_run_1097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1091 ->
          _menhir_run_1092 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1097 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 1097: *)
      let _menhir_stack = MenhirCell1_assumes (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 965 *)
          _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1097
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 968 *)
          _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1097
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 971 *)
          _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1097
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production requires -> *)
          let _v_0 = _menhir_action_629 () in
          _menhir_run_1098 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v_0 MenhirState1097 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0965 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 965: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_REQUIRES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0965 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0968 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 968: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CHECK_REQUIRES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0968 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0971 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 971: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ADMIT_REQUIRES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0971 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1098 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON, ttv_result) _menhir_cell1_assumes as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1098: *)
      let _menhir_stack = MenhirCell1_requires (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | FREES ->
          (* Shifting (FREES) to state 901 *)
          _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | EXT_CONTRACT _v_0 ->
          (* Shifting (EXT_CONTRACT) to state 1062 *)
          _menhir_run_1062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1098
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 1068 *)
          _menhir_run_1068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 916 *)
          _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1098
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production simple_clauses -> *)
          let _v_1 = _menhir_action_637 () in
          _menhir_run_1099 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_1 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1092 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ASSUMES, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1092: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_ASSUMES (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production assumes -> ASSUMES lexpr SEMICOLON assumes *)
      let _4 = _v in
      let _v = _menhir_action_063 _2 _4 in
      _menhir_goto_assumes _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
  
  and _menhir_run_1083 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS, ttv_result) _menhir_cell1_assigns -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1083: *)
      let MenhirCell1_assigns (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_ASSIGNS (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> ASSIGNS assigns clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_564 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1082 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_post_cond_kind, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1082: *)
      let MenhirCell1_lexpr (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_post_cond_kind (_menhir_stack, _menhir_s, _, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> post_cond_kind lexpr clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_562 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1081 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_allocation -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1081: *)
      let MenhirCell1_allocation (_menhir_stack, _menhir_s, _, _startpos__1_, _endpos__1_) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> allocation clause_kw *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_563 _2 _endpos__1_ _startpos__1_ in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1065 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT_CONTRACT, ttv_result) _menhir_cell1_ne_grammar_extension -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1065: *)
      let MenhirCell1_ne_grammar_extension (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_EXT_CONTRACT (_menhir_stack, _menhir_s, _, _startpos__1_, _endpos__1_) = _menhir_stack in
      (* Reducing production ne_simple_clauses -> EXT_CONTRACT ne_grammar_extension clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_565 _3 _endpos__1_ _startpos__1_ in
      _menhir_goto_ne_simple_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1057 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_DECREASES, ttv_result) _menhir_cell1_variant -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1057: *)
      let MenhirCell1_variant (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell0_DECREASES (_menhir_stack, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_decreases -> DECREASES variant clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_539 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_decreases _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _tok
  
  and _menhir_goto_ne_decreases : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      (* State 1058: *)
      match (_tok : MenhirBasics.token) with
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 1059 *)
          (* State 1059: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates ne_decreases TERMINATES *)
          let (_endpos__4_, _startpos__4_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_187 _endpos__4_ _startpos__4_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _v _menhir_s _tok
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 1060 *)
          (* State 1060: *)
          let _startpos_2 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_3 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_terminates (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires terminates ne_decreases REQUIRES *)
          let (_endpos__4_, _startpos__4_) = (_endpos_3, _startpos_2) in
          let _v = _menhir_action_186 _endpos__4_ _startpos__4_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _v _menhir_s _tok
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TYPE | VOLATILE ->
          (* Reducing production decreases -> ne_decreases *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_223 _1 in
          _menhir_goto_decreases _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_decreases : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      (* State 1061: *)
      let _menhir_stack = MenhirCell0_decreases (_menhir_stack, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | FREES ->
          (* Shifting (FREES) to state 901 *)
          _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | EXT_CONTRACT _v_0 ->
          (* Shifting (EXT_CONTRACT) to state 1062 *)
          _menhir_run_1062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1061
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 1068 *)
          _menhir_run_1068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 916 *)
          _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1061
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production simple_clauses -> *)
          let _v_1 = _menhir_action_637 () in
          _menhir_run_1085 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v_1 MenhirState1061 _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1052 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_TERMINATES, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1052: *)
      let MenhirCell1_lexpr (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell0_TERMINATES (_menhir_stack, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_terminates -> TERMINATES lexpr clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_567 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_terminates _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _tok
  
  and _menhir_goto_ne_terminates : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_requires -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      (* State 1138: *)
      match (_tok : MenhirBasics.token) with
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 1139 *)
          (* State 1139: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_requires (_menhir_stack, _menhir_s, _, _, _) = _menhir_stack in
          (* Reducing production contract -> requires ne_terminates REQUIRES *)
          let (_endpos__3_, _startpos__3_) = (_endpos_1, _startpos_0) in
          let _v = _menhir_action_185 _endpos__3_ _startpos__3_ in
          _menhir_goto_contract _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TYPE | VOLATILE ->
          (* Reducing production terminates -> ne_terminates *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_657 _1 in
          _menhir_goto_terminates _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_terminates : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_requires -> _ -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _tok ->
      (* State 1053: *)
      let _menhir_stack = MenhirCell0_terminates (_menhir_stack, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | DECREASES ->
          (* Shifting (DECREASES) to state 1054 *)
          (* State 1054: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_DECREASES (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1054 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TYPE | VOLATILE ->
          (* Reducing production decreases -> *)
          let _v = _menhir_action_222 () in
          _menhir_goto_decreases _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1000 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_REQUIRES, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1000: *)
      let MenhirCell1_lexpr (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_REQUIRES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_requires -> REQUIRES lexpr clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_555 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ne_requires : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1097 ->
          _menhir_run_1103 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1406 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1384 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1380 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0964 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0967 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0970 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0973 ->
          _menhir_run_0975 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1103 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR, ttv_result) _menhir_cell1_behavior_name _menhir_cell0_COLON, ttv_result) _menhir_cell1_assumes as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1103: *)
      match (_tok : MenhirBasics.token) with
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 1104 *)
          (* State 1104: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos_1 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_assumes (_menhir_stack, _menhir_s, _) = _menhir_stack in
          (* Reducing production behavior_body -> assumes ne_requires ASSUMES *)
          let (_endpos, _endpos__3_, _startpos__3_) = (_endpos_1, _endpos_1, _startpos_0) in
          let _v = _menhir_action_078 _endpos__3_ _startpos__3_ in
          _menhir_goto_behavior_body _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production requires -> ne_requires *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_630 _1 in
          _menhir_goto_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_requires : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1097 ->
          _menhir_run_1098 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1406 ->
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1384 ->
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1380 ->
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0964 ->
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0967 ->
          _menhir_run_0999 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0970 ->
          _menhir_run_0997 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0973 ->
          _menhir_run_0974 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1048 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1048: *)
      let _menhir_stack = MenhirCell1_requires (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 1049 *)
          (* State 1049: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_TERMINATES (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1049 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TYPE | VOLATILE ->
          (* Reducing production terminates -> *)
          let _v = _menhir_action_656 () in
          _menhir_goto_terminates _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0999 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_REQUIRES, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 999: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_REQUIRES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_requires -> REQUIRES lexpr SEMICOLON requires *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_552 _2 _4 in
      _menhir_goto_ne_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0997 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CHECK_REQUIRES, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 997: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_CHECK_REQUIRES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_requires -> CHECK_REQUIRES lexpr SEMICOLON requires *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_553 _2 _4 in
      _menhir_goto_ne_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0974 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADMIT_REQUIRES, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 974: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_ADMIT_REQUIRES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_requires -> ADMIT_REQUIRES lexpr SEMICOLON requires *)
      let (_endpos__4_, _4) = (_endpos, _v) in
      let _v = _menhir_action_554 _2 _4 in
      _menhir_goto_ne_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0975 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 975: *)
      (* Reducing production requires -> ne_requires *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_630 _1 in
      _menhir_goto_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0998 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CHECK_REQUIRES, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 998: *)
      let MenhirCell1_lexpr (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_CHECK_REQUIRES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_requires -> CHECK_REQUIRES lexpr clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_556 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0996 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADMIT_REQUIRES, ttv_result) _menhir_cell1_lexpr -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 996: *)
      let MenhirCell1_lexpr (_menhir_stack, _, _, _startpos__2_, _endpos__2_) = _menhir_stack in
      let MenhirCell1_ADMIT_REQUIRES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_requires -> ADMIT_REQUIRES lexpr clause_kw *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_557 _3 _endpos__2_ _startpos__2_ in
      _menhir_goto_ne_requires _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0977 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 977: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> FREES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_166 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0978 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 978: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> EXT_CONTRACT *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_169 _1 in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0979 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 979: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> EOF *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_170 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0980 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 980: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> DISJOINT *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_168 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0981 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 981: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> DECREASES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_163 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0982 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 982: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> COMPLETE *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_167 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0983 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 983: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> CHECK_REQUIRES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_155 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0984 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 984: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> CHECK_LOOP *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_158 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0985 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 985: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> CHECK_LEMMA *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_157 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0986 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 986: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> CHECK_INVARIANT *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_156 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0987 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 987: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> BEHAVIOR *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_164 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0988 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 988: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ASSUMES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_160 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0989 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 989: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ASSIGNS *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_161 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0990 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 990: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ALLOCATES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_165 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0991 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 991: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ADMIT_REQUIRES *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_151 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0992 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 992: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ADMIT_LOOP *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_154 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0993 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 993: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ADMIT_LEMMA *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_153 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0994 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 994: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production clause_kw -> ADMIT_INVARIANT *)
      let _endpos__1_ = _endpos in
      let _v = _menhir_action_152 () in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0917 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_ALLOCATES -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 917: *)
      let MenhirCell1_ALLOCATES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production allocation -> ALLOCATES zones *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_035 _2 in
      _menhir_goto_allocation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_allocation : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1061 ->
          _menhir_run_1078 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1098 ->
          _menhir_run_1078 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1067 ->
          _menhir_run_1078 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1070 ->
          _menhir_run_1078 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1079 ->
          _menhir_run_1078 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1074 ->
          _menhir_run_1078 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0887 ->
          _menhir_run_0918 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1078 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1078: *)
      let _menhir_stack = MenhirCell1_allocation (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1079 *)
          (* State 1079: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState1078, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | FREES ->
              (* Shifting (FREES) to state 901 *)
              _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | EXT_CONTRACT _v_1 ->
              (* Shifting (EXT_CONTRACT) to state 1062 *)
              _menhir_run_1062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1079
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 1068 *)
              _menhir_run_1068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 916 *)
              _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1079
          | ADMIT_LEMMA | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production simple_clauses -> *)
              let _v_2 = _menhir_action_637 () in
              _menhir_run_1080 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_2 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1078
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1078
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0918 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LOOP -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 918: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 919 *)
          (* State 919: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_allocation -> LOOP allocation SEMICOLON *)
          let (_endpos, _2) = (_endpos_0, _v) in
          let _v = _menhir_action_509 _2 in
          let _startpos = _startpos__1_ in
          (* State 1019: *)
          let _menhir_stack = MenhirCell1_loop_allocation (_menhir_stack, _menhir_s, _v, _startpos) in
          (match (_tok : MenhirBasics.token) with
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1019
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1019
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1019
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1019
          | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
              (* Reducing production loop_annot_opt -> *)
              let _v_0 = _menhir_action_510 () in
              _menhir_run_1020 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0913 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS, ttv_result) _menhir_cell1_ne_zones -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 913: *)
      let MenhirCell1_ne_zones (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production assigns -> ne_zones FROM zones *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_061 _1 _3 in
      _menhir_goto_assigns _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_assigns : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1068 ->
          _menhir_run_1069 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0914 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1069 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1069: *)
      let _menhir_stack = MenhirCell1_assigns (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1070 *)
          (* State 1070: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState1069, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | FREES ->
              (* Shifting (FREES) to state 901 *)
              _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | EXT_CONTRACT _v_1 ->
              (* Shifting (EXT_CONTRACT) to state 1062 *)
              _menhir_run_1062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1070
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 1068 *)
              _menhir_run_1068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 916 *)
              _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1070
          | ADMIT_LEMMA | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production simple_clauses -> *)
              let _v_2 = _menhir_action_637 () in
              _menhir_run_1071 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_2 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1069
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1069
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0914 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOOP, ttv_result) _menhir_cell1_ASSIGNS -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 914: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 915 *)
          (* State 915: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_ASSIGNS (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_effects -> LOOP ASSIGNS assigns SEMICOLON *)
          let (_endpos, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_520 _3 in
          let _startpos = _startpos__1_ in
          (* State 1016: *)
          let _menhir_stack = MenhirCell1_loop_effects (_menhir_stack, _menhir_s, _v, _startpos) in
          (match (_tok : MenhirBasics.token) with
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1016
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1016
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1016
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1016
          | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
              (* Reducing production loop_annot_opt -> *)
              let _v_0 = _menhir_action_510 () in
              _menhir_run_1018 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0910 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 910: *)
      (* Reducing production assigns -> zones *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_060 _1 in
      _menhir_goto_assigns _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0906 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 906: *)
      (* Reducing production extension_content -> zones *)
      let _1 = _v in
      let _v = _menhir_action_276 _1 in
      _menhir_goto_extension_content _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0903 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_FREES -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 903: *)
      let MenhirCell1_FREES (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production allocation -> FREES zones *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_036 _2 in
      _menhir_goto_allocation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0926 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 926: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EQUAL (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0926 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1167 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PREDICATE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1167: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 860 *)
          _menhir_run_0860 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1167
      | EQUAL | READS | SEMICOLON ->
          (* Reducing production opt_parameters -> *)
          let _v_0 = _menhir_action_582 () in
          _menhir_run_1168 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1167 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1168 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_PREDICATE, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1168: *)
      let _menhir_stack = MenhirCell1_opt_parameters (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | READS ->
          (* Shifting (READS) to state 1169 *)
          _menhir_run_1169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1168
      | EQUAL ->
          (* Shifting (EQUAL) to state 869 *)
          _menhir_run_0869 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1168
      | SEMICOLON ->
          (* Reducing production reads_clause -> *)
          let _v_0 = _menhir_action_618 () in
          _menhir_run_1171 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0869 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_PREDICATE, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 869: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EQUAL (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0869 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1155 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CHECK_LEMMA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1155: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1156 *)
          (* State 1156: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState1156 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0943 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CASE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 943: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 944 *)
          (* State 944: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0944 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0938 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_INDUCTIVE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 938: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 860 *)
          _menhir_run_0860 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0938
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0930 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LEMMA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 930: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 931 *)
          (* State 931: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0931 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0923 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 923: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 860 *)
          _menhir_run_0860 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0923
      | EQUAL | SEMICOLON ->
          (* Reducing production opt_parameters -> *)
          let _v_0 = _menhir_action_582 () in
          _menhir_run_0924 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0923 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0924 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 924: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 925 *)
          (* State 925: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_poly_id (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_logic_rt_type (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production deprecated_logic_decl -> LOGIC logic_rt_type poly_id opt_parameters SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_224 _2 _3 _4 _startpos__1_ in
          _menhir_goto_deprecated_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | EQUAL ->
          let _menhir_stack = MenhirCell1_opt_parameters (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EQUAL) to state 926 *)
          _menhir_run_0926 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0924
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_deprecated_logic_decl : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1323: *)
      (* Reducing production decl -> deprecated_logic_decl *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_218 _1 in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0859 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PREDICATE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 859: *)
      let _menhir_stack = MenhirCell1_poly_id (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 860 *)
          _menhir_run_0860 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0859
      | EQUAL | SEMICOLON ->
          (* Reducing production opt_parameters -> *)
          let _v_0 = _menhir_action_582 () in
          _menhir_run_0867 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0859 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0867 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_PREDICATE, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 867: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 868 *)
          (* State 868: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_PREDICATE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production deprecated_logic_decl -> PREDICATE poly_id opt_parameters SEMICOLON *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_225 _2 _3 _startpos__1_ in
          _menhir_goto_deprecated_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | EQUAL ->
          let _menhir_stack = MenhirCell1_opt_parameters (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EQUAL) to state 869 *)
          _menhir_run_0869 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0867
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0842 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 842: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 843 *)
          (* State 843: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production deprecated_logic_decl -> TYPE poly_id_type SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_226 _2 _startpos__1_ in
          _menhir_goto_deprecated_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | EQUAL ->
          (* Reducing production poly_id_type_add_typename -> poly_id_type *)
          let _1 = _v in
          let _v = _menhir_action_597 _1 in
          _menhir_goto_poly_id_type_add_typename _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0857 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 857: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_PREDICATE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0857 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0879 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 879: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_MODEL (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0879 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0920 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 920: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0920 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 764 *)
          _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 765 *)
          _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 774 *)
          _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 776 *)
          _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 778 *)
          _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 787 *)
          _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 789 *)
          _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 790 *)
          _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 795 *)
          _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 796 *)
          _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 797 *)
          _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 798 *)
          _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 800 *)
          _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 801 *)
          _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 802 *)
          _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 803 *)
          _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0956 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 956: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_GLOBAL (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 957 *)
          _menhir_run_0957 _menhir_stack _menhir_lexbuf _menhir_lexer
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0957 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_GLOBAL -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 957: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell0_INVARIANT (_menhir_stack, _startpos, _endpos) in
      let _menhir_s = MenhirState0957 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1195 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1195: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1195 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1189 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1189: *)
      (* Reducing production logic_decl -> logic_def *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_488 _1 in
      _menhir_goto_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0828 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 828: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_logic_type (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (COMMA) to state 829 *)
          (* State 829: *)
          let _menhir_s = MenhirState0829 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RPAR ->
          (* Reducing production ne_type_list -> logic_type *)
          let _1 = _v in
          let _v = _menhir_action_570 _1 in
          _menhir_goto_ne_type_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_type_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0829 ->
          _menhir_run_0830 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0825 ->
          _menhir_run_0826 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0830 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_logic_type -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 830: *)
      let MenhirCell1_logic_type (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      (* Reducing production ne_type_list -> logic_type COMMA ne_type_list *)
      let _3 = _v in
      let _v = _menhir_action_571 _1 _3 in
      _menhir_goto_ne_type_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0826 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 826: *)
      (* The current token is RPAR. *)
      (* Shifting (RPAR) to state 827 *)
      (* State 827: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      (* Reducing production datacons -> full_identifier LPAR ne_type_list RPAR *)
      let _3 = _v in
      let _v = _menhir_action_209 _1 _3 in
      _menhir_goto_datacons _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_datacons : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0822 ->
          _menhir_run_0840 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0832 ->
          _menhir_run_0833 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0823 ->
          _menhir_run_0831 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0840 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 840: *)
      let _menhir_stack = MenhirCell1_datacons (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          (* Shifting (PIPE) to state 832 *)
          _menhir_run_0832 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0840
      | SEMICOLON ->
          (* Reducing production datacons_list -> *)
          let _v_0 = _menhir_action_210 () in
          _menhir_run_0841 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0832 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_datacons as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 832: *)
      let _menhir_stack = MenhirCell1_PIPE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0832 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0841 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, ttv_result) _menhir_cell1_datacons -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 841: *)
      let MenhirCell1_datacons (_menhir_stack, _, _1) = _menhir_stack in
      (* Reducing production ne_datacons_list -> datacons datacons_list *)
      let _2 = _v in
      let _v = _menhir_action_536 _1 _2 in
      _menhir_goto_ne_datacons_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_ne_datacons_list : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 838: *)
      (* Reducing production typedef -> ne_datacons_list *)
      let _1 = _v in
      let _v = _menhir_action_775 _1 in
      _menhir_goto_typedef _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_0833 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_datacons, ttv_result) _menhir_cell1_PIPE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 833: *)
      let _menhir_stack = MenhirCell1_datacons (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          (* Shifting (PIPE) to state 832 *)
          _menhir_run_0832 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0833
      | SEMICOLON ->
          (* Reducing production datacons_list -> *)
          let _v_0 = _menhir_action_210 () in
          _menhir_run_0834 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0834 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_datacons, ttv_result) _menhir_cell1_PIPE, ttv_result) _menhir_cell1_datacons -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 834: *)
      let MenhirCell1_datacons (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_PIPE (_menhir_stack, _menhir_s) = _menhir_stack in
      (* Reducing production datacons_list -> PIPE datacons datacons_list *)
      let _3 = _v in
      let _v = _menhir_action_211 _2 _3 in
      _menhir_goto_datacons_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_datacons_list : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_datacons as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0840 ->
          _menhir_run_0841 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0831 ->
          _menhir_run_0835 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0833 ->
          _menhir_run_0834 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0835 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, ttv_result) _menhir_cell1_PIPE, ttv_result) _menhir_cell1_datacons -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 835: *)
      let MenhirCell1_datacons (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_PIPE (_menhir_stack, _) = _menhir_stack in
      (* Reducing production ne_datacons_list -> PIPE datacons datacons_list *)
      let _3 = _v in
      let _v = _menhir_action_537 _2 _3 in
      _menhir_goto_ne_datacons_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_0831 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_poly_id_type_add_typename _menhir_cell0_EQUAL, ttv_result) _menhir_cell1_PIPE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 831: *)
      let _menhir_stack = MenhirCell1_datacons (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          (* Shifting (PIPE) to state 832 *)
          _menhir_run_0832 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0831
      | SEMICOLON ->
          (* Reducing production datacons_list -> *)
          let _v_0 = _menhir_action_210 () in
          _menhir_run_0835 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0304 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 304: *)
      (* Reducing production abs_param -> logic_type *)
      let (_startpos__1_, _1) = (_startpos, _v) in
      let _v = _menhir_action_004 _1 in
      _menhir_goto_abs_param _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_abs_param : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0689 ->
          _menhir_run_0311 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0375 ->
          _menhir_run_0311 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0248 ->
          _menhir_run_0311 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState0308 ->
          _menhir_run_0310 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0311 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 311: *)
      (* Reducing production abs_param_list -> abs_param *)
      let (_startpos__1_, _1) = (_startpos, _v) in
      let _v = _menhir_action_005 _1 in
      _menhir_goto_abs_param_list _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_abs_param_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 307: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          (* Shifting (COMMA) to state 308 *)
          (* State 308: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | UNSIGNED ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | UNION ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | TYPENAME _v_0 ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0308
          | STRUCT ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | SIGNED ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | SHORT ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | REAL ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | LONG ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | INTEGER ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | INT ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | FLOAT ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | ENUM ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | DOUBLE ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | DOTDOTDOT ->
              (* Shifting (DOTDOTDOT) to state 309 *)
              (* State 309: *)
              let _tok = _menhir_lexer _menhir_lexbuf in
              (* Reducing production abs_param_type_list -> abs_param_list COMMA DOTDOTDOT *)
              let _startpos__1_ = _startpos in
              let _v = _menhir_action_009 _startpos__1_ in
              _menhir_goto_abs_param_type_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | CHAR ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | BOOLEAN ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | BOOL ->
              let _menhir_stack = MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _v, _startpos) in
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0308
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RPAR ->
          (* Reducing production abs_param_type_list -> abs_param_list *)
          let _1 = _v in
          let _v = _menhir_action_008 _1 in
          _menhir_goto_abs_param_type_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_abs_param_type_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0689 ->
          _menhir_run_0690 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0375 ->
          _menhir_run_0376 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0248 ->
          _menhir_run_0305 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0690 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_abs_spec_bis_cv, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 690: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 691 *)
          (* State 691: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_abs_spec_bis_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production abs_spec_bis_cv -> abs_spec_bis_cv LPAR abs_param_type_list RPAR *)
          let _3 = _v in
          let _v = _menhir_action_020 _1 _3 in
          _menhir_goto_abs_spec_bis_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_abs_spec_bis_cv : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0677 ->
          _menhir_run_0695 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0682 ->
          _menhir_run_0695 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0684 ->
          _menhir_run_0688 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0695 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 695: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_abs_spec_bis_cv (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0695
      | LPAR ->
          let _menhir_stack = MenhirCell1_abs_spec_bis_cv (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 689 *)
          _menhir_run_0689 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0695
      | RPAR ->
          (* Reducing production abs_spec_cv -> abs_spec_bis_cv *)
          let _1 = _v in
          let _v = _menhir_action_027 _1 in
          _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0689 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_abs_spec_bis_cv as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 689: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOID ->
          (* Shifting (VOID) to state 249 *)
          _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 250 *)
          _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | UNION ->
          (* Shifting (UNION) to state 259 *)
          _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 261 *)
          _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState0689
      | STRUCT ->
          (* Shifting (STRUCT) to state 262 *)
          _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | SIGNED ->
          (* Shifting (SIGNED) to state 264 *)
          _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | SHORT ->
          (* Shifting (SHORT) to state 273 *)
          _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | REAL ->
          (* Shifting (REAL) to state 275 *)
          _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | LONG ->
          (* Shifting (LONG) to state 276 *)
          _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | INTEGER ->
          (* Shifting (INTEGER) to state 281 *)
          _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | INT ->
          (* Shifting (INT) to state 282 *)
          _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | FLOAT ->
          (* Shifting (FLOAT) to state 283 *)
          _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | ENUM ->
          (* Shifting (ENUM) to state 284 *)
          _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 286 *)
          _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | CHAR ->
          (* Shifting (CHAR) to state 287 *)
          _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 288 *)
          _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | BOOL ->
          (* Shifting (BOOL) to state 289 *)
          _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0689
      | RPAR ->
          (* Reducing production abs_param_type_list -> *)
          let _v = _menhir_action_007 () in
          _menhir_run_0690 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_abs_spec_cv : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0677 ->
          _menhir_run_0698 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0682 ->
          _menhir_run_0693 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0698 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_cv_TYPENAME_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 698: *)
      (* Reducing production abs_spec_cv_option -> abs_spec_cv *)
      let _1 = _v in
      let _v = _menhir_action_029 _1 in
      _menhir_goto_abs_spec_cv_option _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_abs_spec_cv_option : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_cv_TYPENAME_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 697: *)
      let MenhirCell1_type_spec_cv_TYPENAME_ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production cast_logic_type -> type_spec_cv(TYPENAME) abs_spec_cv_option *)
      let _2 = _v in
      let _v = _menhir_action_150 _1 _2 in
      _menhir_goto_cast_logic_type _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_cast_logic_type : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0142 ->
          _menhir_run_0728 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0354 ->
          _menhir_run_0709 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0728 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SIZEOF _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 728: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 729 *)
          (* State 729: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_SIZEOF (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> SIZEOF LPAR cast_logic_type RPAR *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_455 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0709 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 709: *)
      let _menhir_stack = MenhirCell1_cast_logic_type (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 710 *)
          (* State 710: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0710 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 138 *)
              _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 141 *)
              _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 349 *)
              _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0693 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 693: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 694 *)
          (* State 694: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          (* Reducing production abs_spec_bis_cv -> LPAR abs_spec_cv RPAR *)
          let _2 = _v in
          let _v = _menhir_action_019 _2 in
          _menhir_goto_abs_spec_bis_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0688 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_stars_cv as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 688: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_abs_spec_bis_cv (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0688
      | LPAR ->
          let _menhir_stack = MenhirCell1_abs_spec_bis_cv (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 689 *)
          _menhir_run_0689 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0688
      | RPAR ->
          let MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production abs_spec_cv -> stars_cv abs_spec_bis_cv *)
          let _2 = _v in
          let _v = _menhir_action_024 _1 _2 in
          _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0376 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_var_spec_bis _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 376: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 377 *)
          (* State 377: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_var_spec_bis (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production var_spec_bis -> var_spec_bis LPAR abs_param_type_list RPAR *)
          let _3 = _v in
          let _v = _menhir_action_787 _1 _3 in
          _menhir_goto_var_spec_bis _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0310 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_abs_param_list -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 310: *)
      let MenhirCell1_abs_param_list (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production abs_param_list -> abs_param_list COMMA abs_param *)
      let _3 = _v in
      let _v = _menhir_action_006 _1 _3 in
      _menhir_goto_abs_param_list _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0300 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 300: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_logic_type_gen_typename_ (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (COMMA) to state 301 *)
          (* State 301: *)
          let _menhir_s = MenhirState0301 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | GT ->
          (* Reducing production separated_nonempty_list(COMMA,logic_type_gen(typename)) -> logic_type_gen(typename) *)
          let x = _v in
          let _v = _menhir_action_635 x in
          _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_typename__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_typename__ : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0301 ->
          _menhir_run_0302 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0291 ->
          _menhir_run_0297 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0302 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_logic_type_gen_typename_ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 302: *)
      let MenhirCell1_logic_type_gen_typename_ (_menhir_stack, _menhir_s, x, _) = _menhir_stack in
      (* Reducing production separated_nonempty_list(COMMA,logic_type_gen(typename)) -> logic_type_gen(typename) COMMA separated_nonempty_list(COMMA,logic_type_gen(typename)) *)
      let xs = _v in
      let _v = _menhir_action_636 x xs in
      _menhir_goto_separated_nonempty_list_COMMA_logic_type_gen_typename__ _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0297 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_typename _menhir_cell0_LT -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 297: *)
      (* Reducing production ne_logic_type_list(typename) -> separated_nonempty_list(COMMA,logic_type_gen(typename)) *)
      let l = _v in
      let _v = _menhir_action_549 l in
      (* State 298: *)
      (* The current token is GT. *)
      (* Shifting (GT) to state 299 *)
      (* State 299: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_typename (_menhir_stack, _menhir_s, name, _startpos_name_) = _menhir_stack in
      (* Reducing production type_spec(typename) -> typename LT ne_logic_type_list(typename) GT *)
      let prms = _v in
      let _v = _menhir_action_772 name prms in
      _menhir_goto_type_spec_typename_ _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_name_ _v _menhir_s _tok
  
  and _menhir_run_0804 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 804: *)
      let _menhir_stack = MenhirCell1_type_spec_identifier_or_typename_ (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | LPAR ->
          (* Shifting (LPAR) to state 370 *)
          _menhir_run_0370 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | IDENTIFIER _v_0 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0804
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | EXT_GLOBAL_BLOCK _v_1 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0804
      | EXT_GLOBAL _v_2 ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0804
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0804
      | EXT_CODE_ANNOT _v_4 ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0804
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0804
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0442 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BSTYPE _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 442: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_type_spec_typename_ (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0442
      | RPAR ->
          (* Shifting (RPAR) to state 443 *)
          (* State 443: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_BSTYPE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> BSTYPE LPAR type_spec(typename) RPAR *)
          let (_endpos__4_, _3) = (_endpos, _v) in
          let _v = _menhir_action_471 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0369 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 369: *)
      let _menhir_stack = MenhirCell1_type_spec_typename_ (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | LPAR ->
          (* Shifting (LPAR) to state 370 *)
          _menhir_run_0370 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | IDENTIFIER _v_0 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0369
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | EXT_GLOBAL_BLOCK _v_1 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0369
      | EXT_GLOBAL _v_2 ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0369
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0369
      | EXT_CODE_ANNOT _v_4 ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0369
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0369
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0292 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 292: *)
      let _menhir_stack = MenhirCell1_type_spec_typename_ (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0292
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0292
      | LPAR ->
          (* Shifting (LPAR) to state 242 *)
          _menhir_run_0242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0292
      | COMMA | GT | RPAR | SEMICOLON ->
          (* Reducing production abs_spec_option -> *)
          let _v_0 = _menhir_action_030 () in
          _menhir_run_0293 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_var_spec : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0804 ->
          _menhir_run_0805 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0386 ->
          _menhir_run_0387 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0369 ->
          _menhir_run_0383 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0370 ->
          _menhir_run_0378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0805 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_identifier_or_typename_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 805: *)
      let MenhirCell1_type_spec_identifier_or_typename_ (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production parameter -> type_spec(identifier_or_typename) var_spec *)
      let _2 = _v in
      let _v = _menhir_action_586 _1 _2 in
      _menhir_goto_parameter _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_parameter : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0881 ->
          _menhir_run_0882 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0862 ->
          _menhir_run_0861 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0860 ->
          _menhir_run_0861 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0763 ->
          _menhir_run_0806 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0882 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MODEL, ttv_result) _menhir_cell1_type_spec_typename_ _menhir_cell0_LBRACE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 882: *)
      let _menhir_stack = MenhirCell1_parameter (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 883 *)
          (* State 883: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (* Reducing production opt_semicolon -> SEMICOLON *)
          let _ = _menhir_action_585 () in
          _menhir_goto_opt_semicolon _menhir_stack _menhir_lexbuf _menhir_lexer _tok
      | RBRACE ->
          (* Reducing production opt_semicolon -> *)
          let _ = _menhir_action_584 () in
          _menhir_goto_opt_semicolon _menhir_stack _menhir_lexbuf _menhir_lexer _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_opt_semicolon : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_MODEL, ttv_result) _menhir_cell1_type_spec_typename_ _menhir_cell0_LBRACE, ttv_result) _menhir_cell1_parameter -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _tok ->
      (* State 884: *)
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          (* Shifting (RBRACE) to state 885 *)
          (* State 885: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | SEMICOLON ->
              (* Shifting (SEMICOLON) to state 886 *)
              (* State 886: *)
              let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              let MenhirCell1_parameter (_menhir_stack, _, _4) = _menhir_stack in
              let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
              let MenhirCell1_type_spec_typename_ (_menhir_stack, _, _2, _) = _menhir_stack in
              let MenhirCell1_MODEL (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
              (* Reducing production model_annot -> MODEL type_spec(typename) LBRACE parameter opt_semicolon RBRACE SEMICOLON *)
              let _endpos__7_ = _endpos_0 in
              let _v = _menhir_action_528 _2 _4 in
              let (_endpos, _startpos) = (_endpos__7_, _startpos__1_) in
              (* State 1216: *)
              (* Reducing production decl -> model_annot *)
              let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
              let _v = _menhir_action_215 _1 in
              _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0861 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 861: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_parameter (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 862 *)
          (* State 862: *)
          let _menhir_s = MenhirState0862 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 764 *)
              _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 765 *)
              _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 774 *)
              _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 776 *)
              _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 778 *)
              _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 787 *)
              _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 789 *)
              _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 790 *)
              _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 795 *)
              _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 796 *)
              _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 797 *)
              _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 798 *)
              _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 800 *)
              _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 801 *)
              _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 802 *)
              _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 803 *)
              _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RPAR ->
          (* Reducing production ne_parameters -> parameter *)
          let _1 = _v in
          let _v = _menhir_action_550 _1 in
          _menhir_goto_ne_parameters _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_parameters : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0860 ->
          _menhir_run_0864 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0862 ->
          _menhir_run_0863 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0864 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 864: *)
      (* The current token is RPAR. *)
      (* Shifting (RPAR) to state 865 *)
      (* State 865: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      (* Reducing production parameters -> LPAR ne_parameters RPAR *)
      let _2 = _v in
      let _v = _menhir_action_587 _2 in
      _menhir_goto_parameters _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_parameters : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0938 ->
          _menhir_run_0939 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1175 ->
          _menhir_run_0866 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1167 ->
          _menhir_run_0866 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0923 ->
          _menhir_run_0866 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0859 ->
          _menhir_run_0866 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0939 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_INDUCTIVE, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 939: *)
      let _menhir_stack = MenhirCell1_parameters (_menhir_stack, _menhir_s, _v) in
      (* Reducing production midrule(__anonymous_0) -> *)
      let _v = _menhir_action_527 () in
      (* State 940: *)
      let _menhir_stack = MenhirCell0_midrule___anonymous_0_ (_menhir_stack, _v) in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 941 *)
          (* State 941: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LBRACE (_menhir_stack, _startpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | CASE ->
              (* Shifting (CASE) to state 942 *)
              _menhir_run_0942 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0941
          | RBRACE ->
              (* Reducing production indcases -> *)
              let _v_0 = _menhir_action_336 () in
              _menhir_run_0948 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0942 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 942: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CASE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0942 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0948 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_INDUCTIVE, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_parameters _menhir_cell0_midrule___anonymous_0_ _menhir_cell0_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 948: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 949 *)
      (* State 949: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
      let MenhirCell0_midrule___anonymous_0_ (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_parameters (_menhir_stack, _, params) = _menhir_stack in
      let MenhirCell1_poly_id (_menhir_stack, _, pred) = _menhir_stack in
      let MenhirCell1_INDUCTIVE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production logic_def -> INDUCTIVE poly_id parameters midrule(__anonymous_0) LBRACE indcases RBRACE *)
      let (_endpos__7_, cases) = (_endpos, _v) in
      let _v = _menhir_action_498 cases params pred in
      _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0866 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 866: *)
      (* Reducing production opt_parameters -> parameters *)
      let _1 = _v in
      let _v = _menhir_action_583 _1 in
      _menhir_goto_opt_parameters _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_opt_parameters : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_poly_id as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1175 ->
          _menhir_run_1176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1167 ->
          _menhir_run_1168 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0923 ->
          _menhir_run_0924 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0859 ->
          _menhir_run_0867 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0863 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_parameter -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 863: *)
      let MenhirCell1_parameter (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ne_parameters -> parameter COMMA ne_parameters *)
      let _3 = _v in
      let _v = _menhir_action_551 _1 _3 in
      _menhir_goto_ne_parameters _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0806 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_INVARIANT, ttv_result) _menhir_cell1_any_identifier _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 806: *)
      let _menhir_stack = MenhirCell1_parameter (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 807 *)
          (* State 807: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_RPAR (_menhir_stack, _endpos) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | EQUAL ->
              (* Shifting (EQUAL) to state 808 *)
              (* State 808: *)
              let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
              let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
              let _menhir_s = MenhirState0808 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WSTRING_CONSTANT _v ->
                  (* Shifting (WSTRING_CONSTANT) to state 3 *)
                  _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | WRITES ->
                  (* Shifting (WRITES) to state 1 *)
                  _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VOLATILE ->
                  (* Shifting (VOLATILE) to state 4 *)
                  _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VOID ->
                  (* Shifting (VOID) to state 5 *)
                  _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VARIANT ->
                  (* Shifting (VARIANT) to state 6 *)
                  _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VALID_READ ->
                  (* Shifting (VALID_READ) to state 7 *)
                  _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VALID_RANGE ->
                  (* Shifting (VALID_RANGE) to state 116 *)
                  _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VALID_INDEX ->
                  (* Shifting (VALID_INDEX) to state 119 *)
                  _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VALID_FUNCTION ->
                  (* Shifting (VALID_FUNCTION) to state 122 *)
                  _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | VALID ->
                  (* Shifting (VALID) to state 124 *)
                  _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNSIGNED ->
                  (* Shifting (UNSIGNED) to state 10 *)
                  _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNION ->
                  (* Shifting (UNION) to state 11 *)
                  _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | UNALLOCATED ->
                  (* Shifting (UNALLOCATED) to state 127 *)
                  _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TYPEOF ->
                  (* Shifting (TYPEOF) to state 128 *)
                  _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TYPENAME _v ->
                  (* Shifting (TYPENAME) to state 12 *)
                  _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | TYPE ->
                  (* Shifting (TYPE) to state 130 *)
                  _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TRUE ->
                  (* Shifting (TRUE) to state 131 *)
                  _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TILDE ->
                  (* Shifting (TILDE) to state 132 *)
                  _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | TERMINATES ->
                  (* Shifting (TERMINATES) to state 322 *)
                  _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | STRUCT ->
                  (* Shifting (STRUCT) to state 15 *)
                  _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | STRING_LITERAL _v ->
                  (* Shifting (STRING_LITERAL) to state 136 *)
                  _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | STRING_CONSTANT _v ->
                  (* Shifting (STRING_CONSTANT) to state 137 *)
                  _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | STATIC ->
                  (* Shifting (STATIC) to state 324 *)
                  _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | STAR ->
                  (* Shifting (STAR) to state 139 *)
                  _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SLICE ->
                  (* Shifting (SLICE) to state 325 *)
                  _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SIZEOF ->
                  (* Shifting (SIZEOF) to state 326 *)
                  _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SIGNED ->
                  (* Shifting (SIGNED) to state 19 *)
                  _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SHORT ->
                  (* Shifting (SHORT) to state 20 *)
                  _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | SEPARATED ->
                  (* Shifting (SEPARATED) to state 329 *)
                  _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | RETURNS ->
                  (* Shifting (RETURNS) to state 331 *)
                  _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | RESULT ->
                  (* Shifting (RESULT) to state 332 *)
                  _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | REQUIRES ->
                  (* Shifting (REQUIRES) to state 333 *)
                  _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | REGISTER ->
                  (* Shifting (REGISTER) to state 334 *)
                  _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | REAL ->
                  (* Shifting (REAL) to state 23 *)
                  _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | READS ->
                  (* Shifting (READS) to state 24 *)
                  _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | PREDICATE ->
                  (* Shifting (PREDICATE) to state 335 *)
                  _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | PRAGMA ->
                  (* Shifting (PRAGMA) to state 336 *)
                  _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | PLUS ->
                  (* Shifting (PLUS) to state 337 *)
                  _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | PI ->
                  (* Shifting (PI) to state 338 *)
                  _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | OLD ->
                  (* Shifting (OLD) to state 339 *)
                  _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | OFFSET ->
                  (* Shifting (OFFSET) to state 341 *)
                  _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | OBJECT_POINTER ->
                  (* Shifting (OBJECT_POINTER) to state 344 *)
                  _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | NULL ->
                  (* Shifting (NULL) to state 347 *)
                  _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | NOT ->
                  (* Shifting (NOT) to state 348 *)
                  _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | MODULE ->
                  (* Shifting (MODULE) to state 352 *)
                  _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | MODEL ->
                  (* Shifting (MODEL) to state 353 *)
                  _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | MINUS ->
                  (* Shifting (MINUS) to state 350 *)
                  _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LSQUAREPIPE ->
                  (* Shifting (LSQUAREPIPE) to state 351 *)
                  _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LPAR ->
                  (* Shifting (LPAR) to state 354 *)
                  _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LOOP ->
                  (* Shifting (LOOP) to state 356 *)
                  _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LONG ->
                  (* Shifting (LONG) to state 30 *)
                  _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LOGIC ->
                  (* Shifting (LOGIC) to state 358 *)
                  _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LET ->
                  (* Shifting (LET) to state 359 *)
                  _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LEMMA ->
                  (* Shifting (LEMMA) to state 365 *)
                  _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LBRACE ->
                  (* Shifting (LBRACE) to state 366 *)
                  _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LAMBDA ->
                  (* Shifting (LAMBDA) to state 368 *)
                  _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | LABEL ->
                  (* Shifting (LABEL) to state 33 *)
                  _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INVARIANT ->
                  (* Shifting (INVARIANT) to state 391 *)
                  _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INT_CONSTANT _v ->
                  (* Shifting (INT_CONSTANT) to state 392 *)
                  _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | INTER ->
                  (* Shifting (INTER) to state 393 *)
                  _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INTEGER ->
                  (* Shifting (INTEGER) to state 35 *)
                  _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INT ->
                  (* Shifting (INT) to state 36 *)
                  _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INITIALIZED ->
                  (* Shifting (INITIALIZED) to state 395 *)
                  _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INDUCTIVE ->
                  (* Shifting (INDUCTIVE) to state 398 *)
                  _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | INCLUDE ->
                  (* Shifting (INCLUDE) to state 399 *)
                  _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | IMPACT ->
                  (* Shifting (IMPACT) to state 400 *)
                  _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | IF ->
                  (* Shifting (IF) to state 40 *)
                  _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | IDENTIFIER _v ->
                  (* Shifting (IDENTIFIER) to state 41 *)
                  _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | GLOBAL ->
                  (* Shifting (GLOBAL) to state 401 *)
                  _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FUNCTION ->
                  (* Shifting (FUNCTION) to state 402 *)
                  _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FRESH ->
                  (* Shifting (FRESH) to state 403 *)
                  _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FREES ->
                  (* Shifting (FREES) to state 407 *)
                  _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FREEABLE ->
                  (* Shifting (FREEABLE) to state 408 *)
                  _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FORALL ->
                  (* Shifting (FORALL) to state 411 *)
                  _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FOR ->
                  (* Shifting (FOR) to state 45 *)
                  _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FLOAT_CONSTANT _v ->
                  (* Shifting (FLOAT_CONSTANT) to state 414 *)
                  _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | FLOAT ->
                  (* Shifting (FLOAT) to state 46 *)
                  _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | FALSE ->
                  (* Shifting (FALSE) to state 415 *)
                  _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EXT_LET ->
                  (* Shifting (EXT_LET) to state 416 *)
                  _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EXT_GLOBAL_BLOCK _v ->
                  (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
                  _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | EXT_GLOBAL _v ->
                  (* Shifting (EXT_GLOBAL) to state 418 *)
                  _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | EXT_CONTRACT _v ->
                  (* Shifting (EXT_CONTRACT) to state 419 *)
                  _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | EXT_CODE_ANNOT _v ->
                  (* Shifting (EXT_CODE_ANNOT) to state 420 *)
                  _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
              | EXT_AT ->
                  (* Shifting (EXT_AT) to state 421 *)
                  _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EXITS ->
                  (* Shifting (EXITS) to state 422 *)
                  _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EXISTS ->
                  (* Shifting (EXISTS) to state 423 *)
                  _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ENUM ->
                  (* Shifting (ENUM) to state 54 *)
                  _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ENSURES ->
                  (* Shifting (ENSURES) to state 426 *)
                  _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | EMPTY ->
                  (* Shifting (EMPTY) to state 427 *)
                  _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ELSE ->
                  (* Shifting (ELSE) to state 56 *)
                  _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | DYNAMIC ->
                  (* Shifting (DYNAMIC) to state 428 *)
                  _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | DOUBLE ->
                  (* Shifting (DOUBLE) to state 57 *)
                  _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | DISJOINT ->
                  (* Shifting (DISJOINT) to state 429 *)
                  _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | DECREASES ->
                  (* Shifting (DECREASES) to state 430 *)
                  _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | DANGLING ->
                  (* Shifting (DANGLING) to state 431 *)
                  _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CONTRACT ->
                  (* Shifting (CONTRACT) to state 434 *)
                  _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CONTINUES ->
                  (* Shifting (CONTINUES) to state 435 *)
                  _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CONST ->
                  (* Shifting (CONST) to state 62 *)
                  _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | COMPLETE ->
                  (* Shifting (COMPLETE) to state 436 *)
                  _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_RETURNS ->
                  (* Shifting (CHECK_RETURNS) to state 64 *)
                  _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_REQUIRES ->
                  (* Shifting (CHECK_REQUIRES) to state 65 *)
                  _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_LOOP ->
                  (* Shifting (CHECK_LOOP) to state 66 *)
                  _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_LEMMA ->
                  (* Shifting (CHECK_LEMMA) to state 67 *)
                  _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_INVARIANT ->
                  (* Shifting (CHECK_INVARIANT) to state 68 *)
                  _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_EXITS ->
                  (* Shifting (CHECK_EXITS) to state 69 *)
                  _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_ENSURES ->
                  (* Shifting (CHECK_ENSURES) to state 70 *)
                  _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_CONTINUES ->
                  (* Shifting (CHECK_CONTINUES) to state 71 *)
                  _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK_BREAKS ->
                  (* Shifting (CHECK_BREAKS) to state 72 *)
                  _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHECK ->
                  (* Shifting (CHECK) to state 437 *)
                  _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CHAR ->
                  (* Shifting (CHAR) to state 74 *)
                  _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | CASE ->
                  (* Shifting (CASE) to state 75 *)
                  _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BSUNION ->
                  (* Shifting (BSUNION) to state 438 *)
                  _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BSTYPE ->
                  (* Shifting (BSTYPE) to state 440 *)
                  _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BREAKS ->
                  (* Shifting (BREAKS) to state 446 *)
                  _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BOOLEAN ->
                  (* Shifting (BOOLEAN) to state 77 *)
                  _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BOOL ->
                  (* Shifting (BOOL) to state 78 *)
                  _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BLOCK_LENGTH ->
                  (* Shifting (BLOCK_LENGTH) to state 447 *)
                  _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BEHAVIORS ->
                  (* Shifting (BEHAVIORS) to state 79 *)
                  _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BEHAVIOR ->
                  (* Shifting (BEHAVIOR) to state 450 *)
                  _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | BASE_ADDR ->
                  (* Shifting (BASE_ADDR) to state 451 *)
                  _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | AXIOMATIC ->
                  (* Shifting (AXIOMATIC) to state 454 *)
                  _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | AXIOM ->
                  (* Shifting (AXIOM) to state 455 *)
                  _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | AUTOMATIC ->
                  (* Shifting (AUTOMATIC) to state 456 *)
                  _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | AT ->
                  (* Shifting (AT) to state 457 *)
                  _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ASSUMES ->
                  (* Shifting (ASSUMES) to state 459 *)
                  _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ASSIGNS ->
                  (* Shifting (ASSIGNS) to state 460 *)
                  _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ASSERT ->
                  (* Shifting (ASSERT) to state 461 *)
                  _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | AMP ->
                  (* Shifting (AMP) to state 462 *)
                  _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ALLOCATION ->
                  (* Shifting (ALLOCATION) to state 463 *)
                  _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ALLOCATES ->
                  (* Shifting (ALLOCATES) to state 466 *)
                  _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ALLOCABLE ->
                  (* Shifting (ALLOCABLE) to state 467 *)
                  _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_RETURNS ->
                  (* Shifting (ADMIT_RETURNS) to state 87 *)
                  _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_REQUIRES ->
                  (* Shifting (ADMIT_REQUIRES) to state 88 *)
                  _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_LOOP ->
                  (* Shifting (ADMIT_LOOP) to state 89 *)
                  _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_LEMMA ->
                  (* Shifting (ADMIT_LEMMA) to state 90 *)
                  _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_INVARIANT ->
                  (* Shifting (ADMIT_INVARIANT) to state 91 *)
                  _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_EXITS ->
                  (* Shifting (ADMIT_EXITS) to state 92 *)
                  _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_ENSURES ->
                  (* Shifting (ADMIT_ENSURES) to state 93 *)
                  _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_CONTINUES ->
                  (* Shifting (ADMIT_CONTINUES) to state 94 *)
                  _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT_BREAKS ->
                  (* Shifting (ADMIT_BREAKS) to state 95 *)
                  _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | ADMIT ->
                  (* Shifting (ADMIT) to state 470 *)
                  _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0387 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_binders_reentrance -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 387: *)
      let MenhirCell1_binders_reentrance (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production binders_reentrance -> binders_reentrance COMMA var_spec *)
      let _3 = _v in
      let _v = _menhir_action_089 _1 _3 in
      _menhir_goto_binders_reentrance _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_binders_reentrance : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 385: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_binders_reentrance (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 386 *)
          (* State 386: *)
          let _menhir_s = MenhirState0386 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 235 *)
              _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 370 *)
              _menhir_run_0370 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RBRACE | SEMICOLON ->
          (* Reducing production binders -> binders_reentrance *)
          let _1 = _v in
          let _v = _menhir_action_086 _1 in
          _menhir_goto_binders _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_binders : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0641 ->
          _menhir_run_0659 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0423 ->
          _menhir_run_0424 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0411 ->
          _menhir_run_0412 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0368 ->
          _menhir_run_0389 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0659 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_LBRACE, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_PIPE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 659: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          let _menhir_stack = MenhirCell1_binders (_menhir_stack, _menhir_s, _v) in
          (* Shifting (SEMICOLON) to state 660 *)
          (* State 660: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0660 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RBRACE ->
          (* Shifting (RBRACE) to state 663 *)
          (* State 663: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_PIPE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LBRACE lexpr PIPE binders RBRACE *)
          let (_4, _endpos__5_) = (_v, _endpos) in
          let _v = _menhir_action_477 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0424 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXISTS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 424: *)
      let _menhir_stack = MenhirCell1_binders (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 425 *)
          (* State 425: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0425 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0412 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FORALL as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 412: *)
      let _menhir_stack = MenhirCell1_binders (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 413 *)
          (* State 413: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0413 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0389 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LAMBDA as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 389: *)
      let _menhir_stack = MenhirCell1_binders (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 390 *)
          (* State 390: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_SEMICOLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0390 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0383 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_type_spec_typename_ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 383: *)
      let MenhirCell1_type_spec_typename_ (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      (* Reducing production decl_spec -> type_spec(typename) var_spec *)
      let _2 = _v in
      let _v = _menhir_action_221 _1 _2 in
      _menhir_goto_decl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_decl_spec : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0386 ->
          _menhir_run_0388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0641 ->
          _menhir_run_0384 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0423 ->
          _menhir_run_0384 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0411 ->
          _menhir_run_0384 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0368 ->
          _menhir_run_0384 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0388 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_binders_reentrance -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 388: *)
      let MenhirCell1_binders_reentrance (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production binders_reentrance -> binders_reentrance COMMA decl_spec *)
      let _3 = _v in
      let _v = _menhir_action_088 _1 _3 in
      _menhir_goto_binders_reentrance _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0384 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 384: *)
      (* Reducing production binders_reentrance -> decl_spec *)
      let _1 = _v in
      let _v = _menhir_action_087 _1 in
      _menhir_goto_binders_reentrance _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0378 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 378: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 379 *)
          (* State 379: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
          (* Reducing production var_spec_bis -> LPAR var_spec RPAR *)
          let _2 = _v in
          let _v = _menhir_action_786 _2 in
          _menhir_goto_var_spec_bis _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0371 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 371: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_var_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LSQUARE) to state 372 *)
          _menhir_run_0372 _menhir_stack _menhir_lexbuf _menhir_lexer
      | LPAR ->
          let _menhir_stack = MenhirCell1_var_spec_bis (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LPAR) to state 375 *)
          _menhir_run_0375 _menhir_stack _menhir_lexbuf _menhir_lexer
      | COMMA | RBRACE | RPAR | SEMICOLON ->
          (* Reducing production var_spec -> var_spec_bis *)
          let _1 = _v in
          let _v = _menhir_action_782 _1 in
          _menhir_goto_var_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0239 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LSQUARE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 239: *)
      match (_tok : MenhirBasics.token) with
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 240 *)
          (* State 240: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LSQUARE ->
              let _menhir_stack = MenhirCell1_array_size (_menhir_stack, _menhir_s, _v) in
              let _menhir_stack = MenhirCell0_RSQUARE (_menhir_stack, _endpos) in
              (* Shifting (LSQUARE) to state 236 *)
              _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0240
          | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMMA | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | GT | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | RPAR | SEMICOLON | SLICE | TERMINATES | TYPE | VARIANT | WRITES ->
              let MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) = _menhir_stack in
              (* Reducing production tabs -> LSQUARE array_size RSQUARE *)
              let _2 = _v in
              let _v = _menhir_action_654 _2 in
              _menhir_goto_tabs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_tabs : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0695 ->
          _menhir_run_0696 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0688 ->
          _menhir_run_0692 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0684 ->
          _menhir_run_0687 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0677 ->
          _menhir_run_0683 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0682 ->
          _menhir_run_0683 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0247 ->
          _menhir_run_0312 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0294 ->
          _menhir_run_0295 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0244 ->
          _menhir_run_0246 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0813 ->
          _menhir_run_0243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0234 ->
          _menhir_run_0243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0292 ->
          _menhir_run_0243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0242 ->
          _menhir_run_0243 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0240 ->
          _menhir_run_0241 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0696 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_abs_spec_bis_cv -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 696: *)
      let MenhirCell1_abs_spec_bis_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production abs_spec_cv -> abs_spec_bis_cv tabs *)
      let _2 = _v in
      let _v = _menhir_action_026 _1 _2 in
      _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0692 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_stars_cv, ttv_result) _menhir_cell1_abs_spec_bis_cv -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 692: *)
      let MenhirCell1_abs_spec_bis_cv (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production abs_spec_cv -> stars_cv abs_spec_bis_cv tabs *)
      let _3 = _v in
      let _v = _menhir_action_025 _1 _2 _3 in
      _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0687 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_stars_cv -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 687: *)
      let MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production abs_spec_cv -> stars_cv tabs *)
      let _2 = _v in
      let _v = _menhir_action_023 _1 _2 in
      _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0683 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 683: *)
      (* Reducing production abs_spec_cv -> tabs *)
      let _1 = _v in
      let _v = _menhir_action_021 _1 in
      _menhir_goto_abs_spec_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0312 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_stars, ttv_result) _menhir_cell1_abs_spec_bis -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 312: *)
      let MenhirCell1_abs_spec_bis (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_stars (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production abs_spec -> stars abs_spec_bis tabs *)
      let _3 = _v in
      let _v = _menhir_action_014 _1 _2 _3 in
      _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0295 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_abs_spec_bis -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 295: *)
      let MenhirCell1_abs_spec_bis (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production abs_spec -> abs_spec_bis tabs *)
      let _2 = _v in
      let _v = _menhir_action_015 _1 _2 in
      _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0246 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_stars -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 246: *)
      let MenhirCell1_stars (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production abs_spec -> stars tabs *)
      let _2 = _v in
      let _v = _menhir_action_012 _1 _2 in
      _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0243 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 243: *)
      (* Reducing production abs_spec -> tabs *)
      let _1 = _v in
      let _v = _menhir_action_010 _1 in
      _menhir_goto_abs_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0241 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LSQUARE, ttv_result) _menhir_cell1_array_size _menhir_cell0_RSQUARE -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 241: *)
      let MenhirCell0_RSQUARE (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_array_size (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) = _menhir_stack in
      (* Reducing production tabs -> LSQUARE array_size RSQUARE tabs *)
      let _4 = _v in
      let _v = _menhir_action_655 _2 _4 in
      _menhir_goto_tabs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0682 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 682: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0682 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 678 *)
          _menhir_run_0678 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 682 *)
          _menhir_run_0682 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0234 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 234: *)
      let _menhir_stack = MenhirCell1_type_spec_TYPENAME_ (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | STAR ->
          (* Shifting (STAR) to state 235 *)
          _menhir_run_0235 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0234
      | LSQUARE ->
          (* Shifting (LSQUARE) to state 236 *)
          _menhir_run_0236 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0234
      | LPAR ->
          (* Shifting (LPAR) to state 242 *)
          _menhir_run_0242 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0234
      | COMMA | GT ->
          (* Reducing production abs_spec_option -> *)
          let _v_0 = _menhir_action_030 () in
          _menhir_run_0315 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0701 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 701: *)
      let _menhir_stack = MenhirCell1_cv (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 679 *)
          _menhir_run_0679 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0701
      | CONST ->
          (* Shifting (CONST) to state 680 *)
          _menhir_run_0680 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0701
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 674 *)
          _menhir_run_0674 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0701
      | LPAR | LSQUARE | RPAR | STAR ->
          (* Reducing production cv_after -> *)
          let _v_0 = _menhir_action_206 () in
          _menhir_run_0702 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0702 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_cv -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 702: *)
      let MenhirCell1_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production cv_after -> cv cv_after *)
      let _2 = _v in
      let _v = _menhir_action_207 _1 _2 in
      _menhir_goto_cv_after _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_cv_after : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0701 ->
          _menhir_run_0702 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0699 ->
          _menhir_run_0700 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0686 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_stars_cv, ttv_result) _menhir_cell1_STAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 686: *)
      let MenhirCell1_STAR (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_stars_cv (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production stars_cv -> stars_cv STAR cv *)
      let _3 = _v in
      let _v = _menhir_action_647 _1 _3 in
      _menhir_goto_stars_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0681 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_STAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 681: *)
      let MenhirCell1_STAR (_menhir_stack, _menhir_s, _) = _menhir_stack in
      (* Reducing production stars_cv -> STAR cv *)
      let _2 = _v in
      let _v = _menhir_action_645 _2 in
      _menhir_goto_stars_cv _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1333 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1333: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_INCLUDE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1333 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1336 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1336: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_GLOBAL (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 957 *)
          _menhir_run_0957 _menhir_stack _menhir_lexbuf _menhir_lexer
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 1337 *)
          (* State 1337: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_EXT_LET (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1337 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1342 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1342: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EXT_LET (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1342 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_global_clauses : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1389 ->
          _menhir_run_1390 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1332 ->
          _menhir_run_1388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1368 ->
          _menhir_run_1388 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1390 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clause -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1390: *)
      let MenhirCell1_ext_global_clause (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_global_clauses -> ext_global_clause ext_global_clauses *)
      let _2 = _v in
      let _v = _menhir_action_252 _1 _2 in
      _menhir_goto_ext_global_clauses _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1388 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1388: *)
      (* Reducing production ext_global_clauses_opt -> ext_global_clauses *)
      let _1 = _v in
      let _v = _menhir_action_254 _1 in
      _menhir_goto_ext_global_clauses_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ext_global_clauses_opt : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1368 ->
          _menhir_run_1369 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1332 ->
          _menhir_run_1348 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1369 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_module_markup as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1369: *)
      match (_tok : MenhirBasics.token) with
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_ext_global_clauses_opt (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FUNCTION) to state 1349 *)
          _menhir_run_1349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1369
      | EOF | MODULE ->
          let MenhirCell1_ext_module_markup (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production ext_global_spec -> ext_module_markup ext_global_clauses_opt *)
          let _2 = _v in
          let _v = _menhir_action_256 _1 _2 in
          _menhir_goto_ext_global_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1349 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1349: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FUNCTION (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1349 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_global_spec : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1394: *)
      match (_tok : MenhirBasics.token) with
      | MODULE ->
          let _menhir_stack = MenhirCell1_ext_global_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODULE) to state 1365 *)
          _menhir_run_1365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1394
      | EOF ->
          (* Reducing production ext_global_specs -> ext_global_spec *)
          let _1 = _v in
          let _v = _menhir_action_257 _1 in
          _menhir_goto_ext_global_specs _menhir_stack _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1365 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1365: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_MODULE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1365 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1348 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1348: *)
      let _menhir_stack = MenhirCell1_ext_global_clauses_opt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 1349 *)
          _menhir_run_1349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1348
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 1353 *)
          _menhir_run_1353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1348
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 1360 *)
          _menhir_run_1360 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1348
      | EOF | MODULE ->
          (* Reducing production ext_module_specs_opt -> *)
          let _menhir_s = MenhirState1348 in
          let _v = _menhir_action_268 () in
          _menhir_goto_ext_module_specs_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1360 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1360: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CONTRACT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1360 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COLON ->
          (* Reducing production ext_identifier_opt -> *)
          let _v = _menhir_action_262 () in
          _menhir_goto_ext_identifier_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_identifier_opt : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_CONTRACT -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1361: *)
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1362 *)
          (* State 1362: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_CONTRACT (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production ext_contract_markup -> CONTRACT ext_identifier_opt COLON *)
          let _2 = _v in
          let _v = _menhir_action_229 _2 in
          _menhir_goto_ext_contract_markup _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_contract_markup : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1401 ->
          _menhir_run_1384 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1382 ->
          _menhir_run_1384 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1348 ->
          _menhir_run_1380 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1399 ->
          _menhir_run_1380 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1380 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1380 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1384 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_at_stmt_markup as 'stack) -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 1384: *)
      let _menhir_stack = MenhirCell1_ext_contract_markup (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 965 *)
          _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1384
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 968 *)
          _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1384
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 971 *)
          _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1384
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production requires -> *)
          let _v_0 = _menhir_action_629 () in
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v_0 MenhirState1384 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1380 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 1380: *)
      let _menhir_stack = MenhirCell1_ext_contract_markup (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 965 *)
          _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1380
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 968 *)
          _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1380
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 971 *)
          _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1380
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
          (* Reducing production requires -> *)
          let _v_0 = _menhir_action_629 () in
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v_0 MenhirState1380 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_module_specs_opt : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1364: *)
      let _menhir_stack = MenhirCell1_ext_module_specs_opt (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | MODULE ->
          (* Shifting (MODULE) to state 1365 *)
          _menhir_run_1365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1364
      | EOF ->
          (* Reducing production ext_global_specs_opt -> *)
          let _v = _menhir_action_259 () in
          _menhir_goto_ext_global_specs_opt _menhir_stack _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1374 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1374: *)
      (* Reducing production ext_function_spec -> ext_global_clause *)
      let _1 = _v in
      let _v = _menhir_action_240 _1 in
      _menhir_goto_ext_function_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ext_function_spec : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1377: *)
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (VOLATILE) to state 2 *)
          _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | TYPE ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (TYPE) to state 760 *)
          _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (PREDICATE) to state 857 *)
          _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | MODEL ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (MODEL) to state 879 *)
          _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | LOGIC ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LOGIC) to state 920 *)
          _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | LEMMA ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (LEMMA) to state 929 *)
          _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INDUCTIVE) to state 937 *)
          _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (INCLUDE) to state 1333 *)
          _menhir_run_1333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (GLOBAL) to state 1336 *)
          _menhir_run_1336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_LET) to state 1342 *)
          _menhir_run_1342 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | EXT_GLOBAL_BLOCK _v_0 ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
          _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1377
      | EXT_GLOBAL _v_1 ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_GLOBAL) to state 1146 *)
          _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1377
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (EXT_AT) to state 1353 *)
          _menhir_run_1353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CONTRACT) to state 1360 *)
          _menhir_run_1360 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (CHECK_LEMMA) to state 1154 *)
          _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOMATIC) to state 1160 *)
          _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | AXIOM ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (AXIOM) to state 1195 *)
          _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (ADMIT_LEMMA) to state 1184 *)
          _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1377
      | EOF | FUNCTION | MODULE ->
          (* Reducing production ext_function_specs -> ext_function_spec *)
          let _1 = _v in
          let _v = _menhir_action_243 _1 in
          _menhir_goto_ext_function_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ext_function_specs : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1377 ->
          _menhir_run_1378 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1373 ->
          _menhir_run_1376 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1378 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_function_spec -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1378: *)
      let MenhirCell1_ext_function_spec (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_function_specs -> ext_function_spec ext_function_specs *)
      let _2 = _v in
      let _v = _menhir_action_244 _1 _2 in
      _menhir_goto_ext_function_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1376 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_function_markup -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1376: *)
      (* Reducing production ext_function_specs_opt -> ext_function_specs *)
      let _1 = _v in
      let _v = _menhir_action_246 _1 in
      _menhir_goto_ext_function_specs_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_goto_ext_function_specs_opt : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_function_markup -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1375: *)
      let MenhirCell1_ext_function_markup (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_module_spec -> ext_function_markup ext_function_specs_opt *)
      let _2 = _v in
      let _v = _menhir_action_265 _1 _2 in
      (* State 1371: *)
      match (_tok : MenhirBasics.token) with
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_ext_module_spec (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FUNCTION) to state 1349 *)
          _menhir_run_1349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1371
      | EOF | MODULE ->
          (* Reducing production ext_module_specs -> ext_module_spec *)
          let _1 = _v in
          let _v = _menhir_action_266 _1 in
          _menhir_goto_ext_module_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_ext_module_specs : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1397 ->
          _menhir_run_1398 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1348 ->
          _menhir_run_1396 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState1371 ->
          _menhir_run_1372 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1369 ->
          _menhir_run_1370 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1398 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt, _menhir_box_ext_spec) _menhir_cell1_ext_fun_specs -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1398: *)
      let MenhirCell1_ext_fun_specs (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_module_specs_opt -> ext_fun_specs ext_module_specs *)
      let _2 = _v in
      let _v = _menhir_action_271 _1 _2 in
      _menhir_goto_ext_module_specs_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1396 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1396: *)
      (* Reducing production ext_module_specs_opt -> ext_module_specs *)
      let _1 = _v in
      let _v = _menhir_action_269 _1 in
      _menhir_goto_ext_module_specs_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1372 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_module_spec -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1372: *)
      let MenhirCell1_ext_module_spec (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_module_specs -> ext_module_spec ext_module_specs *)
      let _2 = _v in
      let _v = _menhir_action_267 _1 _2 in
      _menhir_goto_ext_module_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1370 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_module_markup, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1370: *)
      let MenhirCell1_ext_global_clauses_opt (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_ext_module_markup (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_global_spec -> ext_module_markup ext_global_clauses_opt ext_module_specs *)
      let _3 = _v in
      let _v = _menhir_action_255 _1 _2 _3 in
      _menhir_goto_ext_global_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0477 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 477: *)
      match (_tok : MenhirBasics.token) with
      | STRING_LITERAL _v_0 ->
          let _menhir_stack = MenhirCell1_string (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_LITERAL) to state 472 *)
          _menhir_run_0472 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production lexpr_inner -> string *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_412 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0471 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 471: *)
      match (_tok : MenhirBasics.token) with
      | STRING_LITERAL _v_0 ->
          let _menhir_stack = MenhirCell1_string (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_LITERAL) to state 472 *)
          _menhir_run_0472 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | COLON ->
          let _menhir_stack = MenhirCell1_string (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COLON) to state 473 *)
          (* State 473: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0473 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production lexpr_inner -> string *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_412 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0464 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ALLOCATION as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 464: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 465 *)
          (* State 465: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0465 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0452 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BASE_ADDR as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 452: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 453 *)
          (* State 453: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0453 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0448 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BLOCK_LENGTH as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 448: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 449 *)
          (* State 449: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0449 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0432 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DANGLING as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 432: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 433 *)
          (* State 433: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0433 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0409 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FREEABLE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 409: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 410 *)
          (* State 410: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0410 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0396 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_INITIALIZED as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 396: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 397 *)
          (* State 397: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0397 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0345 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OBJECT_POINTER as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 345: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 346 *)
          (* State 346: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0346 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0342 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OFFSET as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 342: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 343 *)
          (* State 343: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0343 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0125 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VALID as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 125: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 126 *)
          (* State 126: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0126 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0120 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VALID_INDEX as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 120: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 121 *)
          (* State 121: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0121 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0117 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VALID_RANGE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 117: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 118 *)
          (* State 118: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0118 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0114 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VALID_READ as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 114: *)
      let _menhir_stack = MenhirCell1_opt_label_1 (_menhir_stack, _menhir_s, _v) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 115 *)
          (* State 115: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0115 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0195 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 195: *)
      (* Reducing production identifier_or_typename_full -> is_acsl_typename *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_332 _1 in
      _menhir_goto_identifier_or_typename_full _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0106 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 106: *)
      (* Reducing production any_identifier -> is_acsl_typename *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_049 _1 in
      _menhir_goto_any_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0848 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 848: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMMA) to state 849 *)
          (* State 849: *)
          let _menhir_s = MenhirState0849 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | GT ->
          (* Reducing production ne_tvar_list -> full_identifier *)
          let _1 = _v in
          let _v = _menhir_action_568 _1 in
          _menhir_goto_ne_tvar_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_tvar_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0876 ->
          _menhir_run_0877 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0849 ->
          _menhir_run_0850 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0845 ->
          _menhir_run_0846 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0877 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LBRACE, ttv_result) _menhir_cell1_ne_label_list _menhir_cell0_RBRACE _menhir_cell0_LT -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 877: *)
      (* The current token is GT. *)
      (* Shifting (GT) to state 878 *)
      (* State 878: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell0_RBRACE (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_ne_label_list (_menhir_stack, _, _3) = _menhir_stack in
      let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      (* Reducing production poly_id -> full_identifier LBRACE ne_label_list RBRACE LT ne_tvar_list GT *)
      let _6 = _v in
      let _v = _menhir_action_594 _1 _3 _6 in
      _menhir_goto_poly_id _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0850 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_full_identifier -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 850: *)
      let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      (* Reducing production ne_tvar_list -> full_identifier COMMA ne_tvar_list *)
      let _3 = _v in
      let _v = _menhir_action_569 _1 _3 in
      _menhir_goto_ne_tvar_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0846 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LT -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 846: *)
      (* The current token is GT. *)
      (* Shifting (GT) to state 847 *)
      (* State 847: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell0_LT (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
      (* Reducing production poly_id_type -> full_identifier LT ne_tvar_list GT *)
      let _3 = _v in
      let _v = _menhir_action_596 _1 _3 in
      _menhir_goto_poly_id_type _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0824 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 824: *)
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LPAR) to state 825 *)
          (* State 825: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0825 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | VOID ->
              (* Shifting (VOID) to state 249 *)
              _menhir_run_0249 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 250 *)
              _menhir_run_0250 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 259 *)
              _menhir_run_0259 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 261 *)
              _menhir_run_0261 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 262 *)
              _menhir_run_0262 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 264 *)
              _menhir_run_0264 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 273 *)
              _menhir_run_0273 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 275 *)
              _menhir_run_0275 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 276 *)
              _menhir_run_0276 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 281 *)
              _menhir_run_0281 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 282 *)
              _menhir_run_0282 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 283 *)
              _menhir_run_0283 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 284 *)
              _menhir_run_0284 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 286 *)
              _menhir_run_0286 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 287 *)
              _menhir_run_0287 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 288 *)
              _menhir_run_0288 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 289 *)
              _menhir_run_0289 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | PIPE | SEMICOLON ->
          (* Reducing production datacons -> full_identifier *)
          let _1 = _v in
          let _v = _menhir_action_208 _1 in
          _menhir_goto_datacons _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0497 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 497: *)
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LPAR) to state 498 *)
          (* State 498: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0498 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | LBRACE ->
          let _menhir_stack = MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LBRACE) to state 526 *)
          (* State 526: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LBRACE (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0526 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production lexpr_inner -> full_identifier *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_463 _1 _endpos__1_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0382 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 382: *)
      (* Reducing production var_spec_bis -> full_identifier *)
      let _1 = _v in
      let _v = _menhir_action_784 _1 in
      _menhir_goto_var_spec_bis _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0362 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LET as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 362: *)
      (* Reducing production bounded_var -> full_identifier *)
      let _1 = _v in
      let _v = _menhir_action_090 _1 in
      _menhir_goto_bounded_var _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0238 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 238: *)
      (* Reducing production array_size -> full_identifier *)
      let _1 = _v in
      let _v = _menhir_action_058 _1 in
      _menhir_goto_array_size _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0199 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 199: *)
      (* Reducing production identifier_or_typename -> full_identifier *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_331 _1 in
      _menhir_goto_identifier_or_typename _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0539 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 539: *)
      let _menhir_stack = MenhirCell1_DOT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0539 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0541 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 541: *)
      let _menhir_stack = MenhirCell1_ARROW (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0541 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 155 *)
          _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0730 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 730: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0730
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0730
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0730
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_STAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> STAR lexpr_inner *)
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_452 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0723 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_PLUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 723: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0723
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0723
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0723
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_PLUS (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> PLUS lexpr_inner *)
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_450 _2 in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0715 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_NOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 715: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0715
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0715
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0715
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> NOT lexpr_inner *)
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_413 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0714 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_MINUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 714: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0714
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0714
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0714
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> MINUS lexpr_inner *)
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_449 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0711 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LPAR, ttv_result) _menhir_cell1_cast_logic_type _menhir_cell0_RPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 711: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0711
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0711
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0711
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_cast_logic_type (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LPAR cast_logic_type RPAR lexpr_inner *)
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_469 _2 _4 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0572 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AMP as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 572: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0572
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0572
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0572
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_AMP (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> AMP lexpr_inner *)
          let (_endpos__2_, _2) = (_endpos, _v) in
          let _v = _menhir_action_453 _2 _endpos__2_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0563 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_relation as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 563: *)
      match (_tok : MenhirBasics.token) with
      | STARHAT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STARHAT) to state 476 *)
          _menhir_run_0476 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 545 *)
          _menhir_run_0545 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | NE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (NE) to state 555 *)
          _menhir_run_0555 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 549 *)
          _menhir_run_0549 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | LTLT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LTLT) to state 551 *)
          _menhir_run_0551 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LT) to state 556 *)
          _menhir_run_0556 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LE) to state 557 *)
          _menhir_run_0557 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | GTGT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GTGT) to state 553 *)
          _menhir_run_0553 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GT) to state 558 *)
          _menhir_run_0558 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GE) to state 559 *)
          _menhir_run_0559 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EQUAL) to state 560 *)
          _menhir_run_0560 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | EQ ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EQ) to state 561 *)
          _menhir_run_0561 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0563
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HAT | HATHAT | IFF | IMPLIES | IN | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          (* Reducing production lexpr_end_rel -> lexpr_inner *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_408 _1 in
          _menhir_goto_lexpr_end_rel _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0476 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 476: *)
      let _menhir_stack = MenhirCell1_STARHAT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0476 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0479 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 479: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_STAR (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0479 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0543 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 543: *)
      let _menhir_stack = MenhirCell1_SLASH (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0543 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0545 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 545: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_PLUS (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0545 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0547 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 547: *)
      let _menhir_stack = MenhirCell1_PERCENT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0547 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0555 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 555: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> NE *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_627 () in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_relation : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 562: *)
      let _menhir_stack = MenhirCell1_relation (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0562
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | STRING_LITERAL _v_1 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0562
      | STRING_CONSTANT _v_2 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0562
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | INT_CONSTANT _v_3 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0562
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | IDENTIFIER _v_4 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0562
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | FLOAT_CONSTANT _v_5 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState0562
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | EXT_GLOBAL_BLOCK _v_6 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState0562
      | EXT_GLOBAL _v_7 ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState0562
      | EXT_CONTRACT _v_8 ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0562
      | EXT_CODE_ANNOT _v_9 ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0562
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0562
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0549 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 549: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_MINUS (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0549 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0551 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 551: *)
      let _menhir_stack = MenhirCell1_LTLT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0551 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0556 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 556: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> LT *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_622 () in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0557 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 557: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> LE *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_624 () in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0553 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 553: *)
      let _menhir_stack = MenhirCell1_GTGT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0553 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 133 *)
          _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 134 *)
          _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 135 *)
          _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 138 *)
          _menhir_run_0138 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 140 *)
          _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 141 *)
          _menhir_run_0141 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 156 *)
          _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 157 *)
          _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 158 *)
          _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 159 *)
          _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 349 *)
          _menhir_run_0349 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 160 *)
          _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 161 *)
          _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 162 *)
          _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 163 *)
          _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 164 *)
          _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 165 *)
          _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 166 *)
          _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 167 *)
          _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 168 *)
          _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 169 *)
          _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 170 *)
          _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 171 *)
          _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 172 *)
          _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
          _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 174 *)
          _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 175 *)
          _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 176 *)
          _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 177 *)
          _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 178 *)
          _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 179 *)
          _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 180 *)
          _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 181 *)
          _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 182 *)
          _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 183 *)
          _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 184 *)
          _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 185 *)
          _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 186 *)
          _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 187 *)
          _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 188 *)
          _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 189 *)
          _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 190 *)
          _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 191 *)
          _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 192 *)
          _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 193 *)
          _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 194 *)
          _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0558 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 558: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> GT *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_623 () in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0559 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 559: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> GE *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_625 () in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0560 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 560: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> EQUAL *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_628 _endpos__1_ _startpos__1_ in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0561 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 561: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production relation -> EQ *)
      let _startpos__1_ = _startpos in
      let _v = _menhir_action_626 () in
      _menhir_goto_relation _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_lexpr_end_rel : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0562 ->
          _menhir_run_0565 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1402 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0487 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0565 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_relation -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 565: *)
      let MenhirCell1_relation (_menhir_stack, _menhir_s, _1, _) = _menhir_stack in
      (* Reducing production rel_list -> relation lexpr_end_rel *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_620 _1 _2 in
      _menhir_goto_rel_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _v _menhir_s _tok
  
  and _menhir_goto_rel_list : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner as 'stack) -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0475 ->
          _menhir_run_0566 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0563 ->
          _menhir_run_0564 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0566 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_lexpr_inner -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 566: *)
      let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production lexpr_rel -> lexpr_inner rel_list *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_487 _1 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_lexpr_rel _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_lexpr_rel : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 474: *)
      (* Reducing production lexpr -> lexpr_rel *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_403 _1 in
      _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_lexpr : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1402 ->
          _menhir_run_1404 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_1345 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_1340 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_1198 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_1187 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_1182 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_1157 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_1090 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_1073 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_1050 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_1046 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_1043 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_1040 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_1037 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_1034 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_1010 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_1006 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0972 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0969 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0966 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0960 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0954 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0945 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0935 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0932 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0927 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0899 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0891 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0891 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0870 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0855 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0809 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0748 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0746 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0744 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0742 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0740 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0738 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0736 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0734 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0732 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0726 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0721 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0719 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0717 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0705 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0666 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0664 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0661 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0638 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0632 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0624 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0607 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0607 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0601 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0598 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0594 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0592 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0590 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0588 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0587 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0586 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0584 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0579 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0577 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0573 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0570 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0568 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0567 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0537 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0536 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0523 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0521 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0519 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0517 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0515 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0513 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0509 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0507 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0505 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0503 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0501 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0495 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0641 ->
          _menhir_run_0493 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0493 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0491 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0489 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1404 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_lexpr_eof) _menhir_state -> _ -> _menhir_box_lexpr_eof =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1404: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | EOF ->
          (* Shifting (EOF) to state 1405 *)
          (* State 1405: *)
          (* Reducing production lexpr_eof -> lexpr EOF *)
          let _1 = _v in
          let _v = _menhir_action_411 _1 in
          (* State 1403: *)
          (* Accepting *)
          MenhirBox_lexpr_eof _v
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1404
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0490 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 490: *)
      let _menhir_stack = MenhirCell1_QUESTION (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0490 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0492 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 492: *)
      let _menhir_stack = MenhirCell1_PIPE (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0492 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0502 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 502: *)
      let _menhir_stack = MenhirCell1_OR (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0502 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0494 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 494: *)
      let _menhir_stack = MenhirCell1_IN (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0494 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0514 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 514: *)
      let _menhir_stack = MenhirCell1_IMPLIES (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0514 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0522 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 522: *)
      let _menhir_stack = MenhirCell1_IFF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0522 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0504 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 504: *)
      let _menhir_stack = MenhirCell1_HATHAT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0504 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0506 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 506: *)
      let _menhir_stack = MenhirCell1_HAT (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0506 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0516 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 516: *)
      let _menhir_stack = MenhirCell1_BIMPLIES (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0516 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0518 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 518: *)
      let _menhir_stack = MenhirCell1_BIFF (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0518 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0520 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 520: *)
      let _menhir_stack = MenhirCell1_AND (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0520 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0508 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 508: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _menhir_stack = MenhirCell1_AMP (_menhir_stack, _menhir_s, _startpos) in
      let _menhir_s = MenhirState0508 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1345 : type  ttv_stack. (((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_EXT_LET, _menhir_box_ext_spec) _menhir_cell1_any_identifier _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1345: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1346 *)
          (* State 1346: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_any_identifier (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_EXT_LET (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production ext_global_clause -> EXT_LET any_identifier EQUAL lexpr SEMICOLON *)
          let _4 = _v in
          let _v = _menhir_action_248 _2 _4 in
          _menhir_goto_ext_global_clause _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1345
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1340 : type  ttv_stack. (((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_GLOBAL _menhir_cell0_EXT_LET, _menhir_box_ext_spec) _menhir_cell1_any_identifier _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1340: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1341 *)
          (* State 1341: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_any_identifier (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_EXT_LET (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_GLOBAL (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production ext_global_clause -> GLOBAL EXT_LET any_identifier EQUAL lexpr SEMICOLON *)
          let _5 = _v in
          let _v = _menhir_action_249 _3 _5 in
          _menhir_goto_ext_global_clause _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1340
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1198 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AXIOM, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1198: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1199 *)
          (* State 1199: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production deprecated_logic_decl -> AXIOM poly_id COLON lexpr SEMICOLON *)
          let _endpos__5_ = _endpos_0 in
          let _v = _menhir_action_227 _2 _endpos__5_ _startpos__1_ in
          _menhir_goto_deprecated_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1198
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1187 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ADMIT_LEMMA, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1187: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1188 *)
          (* State 1188: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_ADMIT_LEMMA (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_def -> ADMIT_LEMMA poly_id COLON lexpr SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_501 _2 _4 in
          _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1187
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1182 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AXIOM, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1182: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1183 *)
          (* State 1183: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_AXIOM (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_decl -> AXIOM poly_id COLON lexpr SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_492 _2 _4 in
          _menhir_goto_logic_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1182
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1157 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CHECK_LEMMA, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1157: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1158 *)
          (* State 1158: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_CHECK_LEMMA (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_def -> CHECK_LEMMA poly_id COLON lexpr SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_500 _2 _4 in
          _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1157
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1090 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSUMES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1090: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1091 *)
          (* State 1091: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState1090, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 1089 *)
              _menhir_run_1089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1091
          | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_REQUIRES | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | RETURNS | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production assumes -> *)
              let _v_1 = _menhir_action_062 () in
              _menhir_run_1092 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_1 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | EXT_CONTRACT _v_2 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1090
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1090
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1089 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1089: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ASSUMES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1089 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1073 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_post_cond_kind as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1073: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1074 *)
          (* State 1074: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState1073, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | FREES ->
              (* Shifting (FREES) to state 901 *)
              _menhir_run_0901 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | EXT_CONTRACT _v_1 ->
              (* Shifting (EXT_CONTRACT) to state 1062 *)
              _menhir_run_1062 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1074
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 1068 *)
              _menhir_run_1068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 916 *)
              _menhir_run_0916 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1074
          | ADMIT_LEMMA | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | CHECK_LEMMA | COMPLETE | CONTRACT | DECREASES | DISJOINT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production simple_clauses -> *)
              let _v_2 = _menhir_action_637 () in
              _menhir_run_1075 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_2 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | EXT_CONTRACT _v_3 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1073
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1073
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1050 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_TERMINATES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1050: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1051 *)
          (* State 1051: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_TERMINATES (_menhir_stack, _startpos__1_, _) = _menhir_stack in
          (* Reducing production ne_terminates -> TERMINATES lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_566 _2 in
          _menhir_goto_ne_terminates _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _tok
      | RETURNS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | FREES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | EXT_CONTRACT _v_1 ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1050
      | EXITS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | EOF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ENSURES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | DECREASES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | BREAKS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1050
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1046 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADMIT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1046: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1047 *)
          (* State 1047: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_ADMIT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production code_annotation -> ADMIT lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_173 _2 in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1046
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1043 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADMIT_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1043: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1044 *)
          (* State 1044: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_ADMIT_INVARIANT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production code_annotation -> ADMIT_INVARIANT lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_176 _2 in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1043
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1040 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSERT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1040: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1041 *)
          (* State 1041: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_ASSERT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production code_annotation -> ASSERT lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_171 _2 in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1040
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1037 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CHECK as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1037: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1038 *)
          (* State 1038: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_CHECK (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production code_annotation -> CHECK lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_172 _2 in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1037
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1034 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CHECK_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1034: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1035 *)
          (* State 1035: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_CHECK_INVARIANT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production code_annotation -> CHECK_INVARIANT lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_175 _2 in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1034
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1010 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADMIT_LOOP _menhir_cell0_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1010: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1011 *)
          (* State 1011: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_INVARIANT (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_ADMIT_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_invariant -> ADMIT_LOOP INVARIANT lexpr SEMICOLON *)
          let (_endpos, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_524 _3 in
          _menhir_goto_loop_invariant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1010
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_loop_invariant : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1014: *)
      let _menhir_stack = MenhirCell1_loop_invariant (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | LOOP ->
          (* Shifting (LOOP) to state 887 *)
          _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1014
      | FOR ->
          (* Shifting (FOR) to state 1001 *)
          _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1014
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 1004 *)
          _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1014
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 1008 *)
          _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1014
      | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
          (* Reducing production loop_annot_opt -> *)
          let _v_0 = _menhir_action_510 () in
          _menhir_run_1022 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1006 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CHECK_LOOP _menhir_cell0_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1006: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1007 *)
          (* State 1007: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_INVARIANT (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_CHECK_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_invariant -> CHECK_LOOP INVARIANT lexpr SEMICOLON *)
          let (_endpos, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_523 _3 in
          _menhir_goto_loop_invariant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1006
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0972 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ADMIT_REQUIRES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 972: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 973 *)
          (* State 973: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState0972, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 965 *)
              _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0973
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 968 *)
              _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0973
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 971 *)
              _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0973
          | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production requires -> *)
              let _v_1 = _menhir_action_629 () in
              _menhir_run_0974 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_1 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | EXT_CONTRACT _v_2 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0972
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0972
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0969 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_CHECK_REQUIRES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 969: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 970 *)
          (* State 970: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState0969, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 965 *)
              _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0970
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 968 *)
              _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0970
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 971 *)
              _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0970
          | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production requires -> *)
              let _v_1 = _menhir_action_629 () in
              _menhir_run_0997 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_1 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | EXT_CONTRACT _v_2 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0969
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0969
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0966 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_REQUIRES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 966: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 967 *)
          (* State 967: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState0966, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 965 *)
              _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0967
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 968 *)
              _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0967
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 971 *)
              _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0967
          | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production requires -> *)
              let _v_1 = _menhir_action_629 () in
              _menhir_run_0999 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_1 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | FREES ->
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | EXT_CONTRACT _v_2 ->
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0966
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | EOF ->
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | DECREASES ->
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0966
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0960 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_GLOBAL _menhir_cell0_INVARIANT, ttv_result) _menhir_cell1_any_identifier _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 960: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 961 *)
          (* State 961: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_any_identifier (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_INVARIANT (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_GLOBAL (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production decl -> GLOBAL INVARIANT any_identifier COLON lexpr SEMICOLON *)
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_212 _3 _5 in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0960
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0954 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_IMPACT _menhir_cell0_PRAGMA, ttv_result) _menhir_cell1_any_identifier as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 954: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 955 *)
          (* State 955: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_identifier (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_PRAGMA (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_IMPACT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production impact_pragma -> IMPACT PRAGMA any_identifier lexpr SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_334 _3 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_impact_pragma _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0954
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_impact_pragma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1320: *)
      (* Reducing production pragma_or_code_annotation -> impact_pragma *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_615 _1 in
      _menhir_goto_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0945 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_CASE, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 945: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 946 *)
          (* State 946: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, MenhirState0945, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | CASE ->
              (* Shifting (CASE) to state 942 *)
              _menhir_run_0942 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0946
          | RBRACE ->
              (* Reducing production indcases -> *)
              let _v_1 = _menhir_action_336 () in
              _menhir_run_0947 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0945
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0947 : type  ttv_stack ttv_result. ((((ttv_stack, ttv_result) _menhir_cell1_CASE, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 947: *)
      let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _4, _, _) = _menhir_stack in
      let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
      let MenhirCell1_CASE (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production indcases -> CASE poly_id COLON lexpr SEMICOLON indcases *)
      let _6 = _v in
      let _v = _menhir_action_337 _2 _4 _6 in
      _menhir_goto_indcases _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_indcases : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0941 ->
          _menhir_run_0948 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0946 ->
          _menhir_run_0947 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0935 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 935: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 936 *)
          (* State 936: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_INVARIANT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production code_annotation -> INVARIANT lexpr SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_174 _2 in
          _menhir_goto_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0935
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0932 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LEMMA, ttv_result) _menhir_cell1_poly_id _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 932: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 933 *)
          (* State 933: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LEMMA (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_def -> LEMMA poly_id COLON lexpr SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_499 _2 _4 in
          _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0932
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0927 : type  ttv_stack ttv_result. ((((((ttv_stack, ttv_result) _menhir_cell1_LOGIC, ttv_result) _menhir_cell1_logic_rt_type, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters, ttv_result) _menhir_cell1_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 927: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 928 *)
          (* State 928: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_EQUAL (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_opt_parameters (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_logic_rt_type (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LOGIC (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_def -> LOGIC logic_rt_type poly_id opt_parameters EQUAL lexpr SEMICOLON *)
          let (_endpos__7_, _6) = (_endpos_0, _v) in
          let _v = _menhir_action_496 _2 _3 _4 _6 in
          _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0927
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0899 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOOP, ttv_result) _menhir_cell1_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 899: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 900 *)
          (* State 900: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_INVARIANT (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_invariant -> LOOP INVARIANT lexpr SEMICOLON *)
          let (_endpos, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_522 _3 in
          _menhir_goto_loop_invariant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0899
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0891 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 891: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | FOR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FOR) to state 892 *)
          (* State 892: *)
          let _menhir_s = MenhirState0891 in
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos, _endpos) in
          let _menhir_s = MenhirState0892 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0891
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COMPLETE | CONTINUES | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FREES | REQUIRES | RETURNS | SEMICOLON ->
          (* Reducing production variant -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_789 _1 in
          _menhir_goto_variant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_variant : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1054 ->
          _menhir_run_1055 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0889 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1055 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_requires _menhir_cell0_terminates _menhir_cell0_DECREASES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1055: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 1056 *)
          (* State 1056: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_DECREASES (_menhir_stack, _startpos__1_, _) = _menhir_stack in
          (* Reducing production ne_decreases -> DECREASES variant SEMICOLON *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_538 _2 in
          _menhir_goto_ne_decreases _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _tok
      | RETURNS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | FREES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | EXT_CONTRACT _v_1 ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1055
      | EXITS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | EOF ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ENSURES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | DECREASES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | BREAKS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_variant (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1055
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0889 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LOOP, ttv_result) _menhir_cell1_VARIANT -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 889: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 890 *)
          (* State 890: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_VARIANT (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_variant -> LOOP VARIANT variant SEMICOLON *)
          let (_endpos, _endpos__4_, _3) = (_endpos_0, _endpos_0, _v) in
          let _v = _menhir_action_526 _3 _endpos__4_ _startpos__1_ in
          let _startpos = _startpos__1_ in
          (* State 1012: *)
          let _menhir_stack = MenhirCell1_loop_variant (_menhir_stack, _menhir_s, _v, _startpos) in
          (match (_tok : MenhirBasics.token) with
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1012
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1012
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1012
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1012
          | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
              (* Reducing production loop_annot_opt -> *)
              let _v_0 = _menhir_action_510 () in
              _menhir_run_1024 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0870 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_PREDICATE, ttv_result) _menhir_cell1_poly_id, ttv_result) _menhir_cell1_opt_parameters, ttv_result) _menhir_cell1_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 870: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 871 *)
          (* State 871: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_EQUAL (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_opt_parameters (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell1_poly_id (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_PREDICATE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production logic_def -> PREDICATE poly_id opt_parameters EQUAL lexpr SEMICOLON *)
          let (_endpos__6_, _5) = (_endpos_0, _v) in
          let _v = _menhir_action_497 _2 _3 _5 in
          _menhir_goto_logic_def _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0870
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0855 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_SLICE _menhir_cell0_PRAGMA, ttv_result) _menhir_cell1_any_identifier as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 855: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 856 *)
          (* State 856: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_identifier (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_PRAGMA (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_SLICE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production slice_pragma -> SLICE PRAGMA any_identifier lexpr SEMICOLON *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_639 _3 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_slice_pragma _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0855
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_slice_pragma : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1201: *)
      (* Reducing production pragma_or_code_annotation -> slice_pragma *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_614 _1 in
      _menhir_goto_pragma_or_code_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0809 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_INVARIANT, ttv_result) _menhir_cell1_any_identifier _menhir_cell0_LPAR, ttv_result) _menhir_cell1_parameter _menhir_cell0_RPAR _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 809: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 810 *)
          (* State 810: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell0_RPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_parameter (_menhir_stack, _, _5) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_any_identifier (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell1_INVARIANT (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_TYPE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production type_annot -> TYPE INVARIANT any_identifier LPAR parameter RPAR EQUAL lexpr SEMICOLON *)
          let (_endpos__9_, _8) = (_endpos_0, _v) in
          let _v = _menhir_action_658 _3 _5 _8 in
          let (_endpos, _startpos) = (_endpos__9_, _startpos__1_) in
          (* State 1200: *)
          (* Reducing production decl -> type_annot *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_214 _1 in
          _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0809
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0748 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_VALID_READ, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 748: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 749 *)
          (* State 749: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_VALID_READ (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> VALID_READ opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_418 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0748
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0746 : type  ttv_stack ttv_result. (((((((ttv_stack, ttv_result) _menhir_cell1_VALID_RANGE, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 746: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 747 *)
          (* State 747: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _6, _, _) = _menhir_stack in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_VALID_RANGE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> VALID_RANGE opt_label_1 LPAR lexpr COMMA lexpr COMMA lexpr RPAR *)
          let (_endpos__9_, _8) = (_endpos_0, _v) in
          let _v = _menhir_action_421 _2 _4 _6 _8 _endpos__9_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__9_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0746
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0744 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_VALID_RANGE, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 744: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | COMMA ->
          (* Shifting (COMMA) to state 745 *)
          (* State 745: *)
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, MenhirState0744) in
          let _menhir_s = MenhirState0745 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0744
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0742 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_VALID_RANGE, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 742: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | COMMA ->
          (* Shifting (COMMA) to state 743 *)
          (* State 743: *)
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, MenhirState0742) in
          let _menhir_s = MenhirState0743 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0742
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0740 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_VALID_INDEX, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 740: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 741 *)
          (* State 741: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_VALID_INDEX (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> VALID_INDEX opt_label_1 LPAR lexpr COMMA lexpr RPAR *)
          let (_endpos__7_, _6) = (_endpos_0, _v) in
          let _v = _menhir_action_420 _2 _4 _6 _endpos__7_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0740
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0738 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_VALID_INDEX, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 738: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | COMMA ->
          (* Shifting (COMMA) to state 739 *)
          (* State 739: *)
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, MenhirState0738) in
          let _menhir_s = MenhirState0739 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0738
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0736 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VALID_FUNCTION _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 736: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 737 *)
          (* State 737: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_VALID_FUNCTION (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> VALID_FUNCTION LPAR lexpr RPAR *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_419 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0736
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0734 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_VALID, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 734: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 735 *)
          (* State 735: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_VALID (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> VALID opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_417 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0734
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0732 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_TYPEOF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 732: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 733 *)
          (* State 733: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_TYPEOF (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> TYPEOF LPAR lexpr RPAR *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_470 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0732
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0726 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SIZEOF _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 726: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 727 *)
          (* State 727: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_SIZEOF (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> SIZEOF LPAR lexpr RPAR *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_454 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0726
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0721 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_OLD _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 721: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 722 *)
          (* State 722: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_OLD (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> OLD LPAR lexpr RPAR *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_456 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0721
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0719 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OFFSET, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 719: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 720 *)
          (* State 720: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_OFFSET (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> OFFSET opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_427 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0719
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0717 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_OBJECT_POINTER, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 717: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 718 *)
          (* State 718: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_OBJECT_POINTER (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> OBJECT_POINTER opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_416 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0717
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0705 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 705: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 706 *)
          (* State 706: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LPAR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LPAR lexpr RPAR *)
          let (_2, _endpos__3_) = (_v, _endpos_0) in
          let _v = _menhir_action_467 _2 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0705
      | DOTDOT ->
          (* Reducing production lexpr_option -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_485 _1 in
          _menhir_goto_lexpr_option _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_lexpr_option : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0485 ->
          _menhir_run_0486 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0354 ->
          _menhir_run_0484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0484 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0666 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_LET, ttv_result) _menhir_cell1_bounded_var _menhir_cell0_EQUAL, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_SEMICOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 666: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0666
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_SEMICOLON (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_bounded_var (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LET (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_binder -> LET bounded_var EQUAL lexpr SEMICOLON lexpr *)
          let (_endpos__6_, _6) = (_endpos, _v) in
          let _v = _menhir_action_404 _2 _4 _6 _endpos__6_ _startpos__1_ in
          _menhir_goto_lexpr_binder _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_lexpr_binder : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0348 ->
          _menhir_run_0716 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1402 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1344 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1339 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1197 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1186 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1181 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1156 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1089 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1072 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1054 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1049 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1045 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1042 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1039 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1036 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1033 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1009 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1005 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0971 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0968 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0965 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0959 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0952 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0944 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0934 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0931 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0926 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0898 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0895 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0888 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0869 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0853 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0808 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0115 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0745 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0743 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0118 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0739 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0121 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0123 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0126 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0129 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0142 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0340 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0343 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0346 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0351 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0354 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0665 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0364 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0660 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0641 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0617 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0631 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0623 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0367 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0390 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0397 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0591 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0406 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0410 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0413 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0425 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0433 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0449 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0453 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0458 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0465 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0469 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0473 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0562 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0481 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0535 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0524 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0522 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0520 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0518 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0516 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0514 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0512 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0508 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0506 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0504 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0502 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0498 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0494 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0492 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0490 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0485 ->
          _menhir_run_0488 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0716 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_NOT -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 716: *)
      let MenhirCell1_NOT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      (* Reducing production lexpr_end_rel -> NOT lexpr_binder *)
      let (_endpos__2_, _2) = (_endpos, _v) in
      let _v = _menhir_action_410 _2 _endpos__2_ _startpos__1_ in
      _menhir_goto_lexpr_end_rel _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__2_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0488 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 488: *)
      (* Reducing production lexpr_end_rel -> lexpr_binder *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_409 _1 in
      _menhir_goto_lexpr_end_rel _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0664 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LET, ttv_result) _menhir_cell1_bounded_var _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 664: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 665 *)
          (* State 665: *)
          let _menhir_s = MenhirState0664 in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell1_SEMICOLON (_menhir_stack, _menhir_s, _endpos) in
          let _menhir_s = MenhirState0665 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0664
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0661 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_LBRACE, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_PIPE, ttv_result) _menhir_cell1_binders _menhir_cell0_SEMICOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 661: *)
      match (_tok : MenhirBasics.token) with
      | RBRACE ->
          (* Shifting (RBRACE) to state 662 *)
          (* State 662: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_binders (_menhir_stack, _, _4) = _menhir_stack in
          let MenhirCell1_PIPE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
          let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> LBRACE lexpr PIPE binders SEMICOLON lexpr RBRACE *)
          let (_endpos__7_, _6) = (_endpos_0, _v) in
          let _v = _menhir_action_478 _2 _4 _6 _endpos__7_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0661
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0638 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_path _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 638: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0638
      | COMMA | RBRACE ->
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_path (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production update_elt -> path EQUAL lexpr *)
          let _3 = _v in
          let _v = _menhir_action_780 _1 _3 in
          _menhir_goto_update_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_update_elt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 609: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_update_elt (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 610 *)
          (* State 610: *)
          let _menhir_s = MenhirState0610 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LSQUARE ->
              (* Shifting (LSQUARE) to state 367 *)
              _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOT ->
              (* Shifting (DOT) to state 603 *)
              _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RBRACE ->
          (* Reducing production update -> update_elt *)
          let _1 = _v in
          let _v = _menhir_action_778 _1 in
          _menhir_goto_update _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_update : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0608 ->
          _menhir_run_0639 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0619 ->
          _menhir_run_0620 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0610 ->
          _menhir_run_0611 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0639 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LBRACE, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_WITH -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 639: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 640 *)
      (* State 640: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_WITH (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      (* Reducing production lexpr_inner -> LBRACE lexpr WITH update RBRACE *)
      let (_4, _endpos__5_) = (_v, _endpos) in
      let _v = _menhir_action_481 _2 _4 _endpos__5_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0620 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_path _menhir_cell0_EQUAL, ttv_result) _menhir_cell1_LBRACE, ttv_result) _menhir_cell1_WITH -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 620: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 621 *)
      (* State 621: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_WITH (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_LBRACE (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
      let MenhirCell1_path (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production update_elt -> path EQUAL LBRACE WITH update RBRACE *)
      let _5 = _v in
      let _v = _menhir_action_781 _1 _5 in
      _menhir_goto_update_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0611 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_update_elt -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 611: *)
      let MenhirCell1_update_elt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production update -> update_elt COMMA update *)
      let _3 = _v in
      let _v = _menhir_action_779 _1 _3 in
      _menhir_goto_update _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0632 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_array_path_elt _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 632: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0632
      | COMMA | RBRACE ->
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_array_path_elt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production array_init_elt -> array_path_elt EQUAL lexpr *)
          let _3 = _v in
          let _v = _menhir_action_054 _1 _3 in
          (* State 633: *)
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_array_init_elt (_menhir_stack, _menhir_s, _v) in
              (* Shifting (COMMA) to state 634 *)
              (* State 634: *)
              let _menhir_s = MenhirState0634 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LSQUARE ->
                  (* Shifting (LSQUARE) to state 367 *)
                  _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | RBRACE ->
              (* Reducing production array_init -> array_init_elt *)
              let _1 = _v in
              let _v = _menhir_action_052 _1 in
              _menhir_goto_array_init _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _menhir_fail ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_array_init : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0366 ->
          _menhir_run_0636 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0618 ->
          _menhir_run_0636 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0634 ->
          _menhir_run_0635 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0636 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 636: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 637 *)
      (* State 637: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      (* Reducing production lexpr_inner -> LBRACE array_init RBRACE *)
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_480 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0635 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_array_init_elt -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 635: *)
      let MenhirCell1_array_init_elt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production array_init -> array_init_elt COMMA array_init *)
      let _3 = _v in
      let _v = _menhir_action_053 _1 _3 in
      _menhir_goto_array_init _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0624 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_field_path_elt _menhir_cell0_EQUAL as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 624: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0624
      | COMMA | RBRACE ->
          let MenhirCell0_EQUAL (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_field_path_elt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
          (* Reducing production field_init_elt -> field_path_elt EQUAL lexpr *)
          let _3 = _v in
          let _v = _menhir_action_279 _1 _3 in
          (* State 625: *)
          (match (_tok : MenhirBasics.token) with
          | COMMA ->
              let _menhir_stack = MenhirCell1_field_init_elt (_menhir_stack, _menhir_s, _v) in
              (* Shifting (COMMA) to state 626 *)
              (* State 626: *)
              let _menhir_s = MenhirState0626 in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | DOT ->
                  (* Shifting (DOT) to state 603 *)
                  _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | RBRACE ->
              (* Reducing production field_init -> field_init_elt *)
              let _1 = _v in
              let _v = _menhir_action_277 _1 in
              _menhir_goto_field_init _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | _ ->
              _menhir_fail ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_field_init : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0366 ->
          _menhir_run_0628 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0618 ->
          _menhir_run_0628 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0626 ->
          _menhir_run_0627 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0628 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 628: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 629 *)
      (* State 629: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      (* Reducing production lexpr_inner -> LBRACE field_init RBRACE *)
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_479 _2 _endpos__3_ _startpos__1_ in
      _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0627 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_field_init_elt -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 627: *)
      let MenhirCell1_field_init_elt (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production field_init -> field_init_elt COMMA field_init *)
      let _3 = _v in
      let _v = _menhir_action_278 _1 _3 in
      _menhir_goto_field_init _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0607 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LBRACE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 607: *)
      match (_tok : MenhirBasics.token) with
      | WITH ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (WITH) to state 608 *)
          (* State 608: *)
          let _menhir_stack = MenhirCell1_WITH (_menhir_stack, MenhirState0607) in
          let _menhir_s = MenhirState0608 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LSQUARE ->
              (* Shifting (LSQUARE) to state 367 *)
              _menhir_run_0367 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOT ->
              (* Shifting (DOT) to state 603 *)
              _menhir_run_0603 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 641 *)
          (* State 641: *)
          let _menhir_stack = MenhirCell1_PIPE (_menhir_stack, MenhirState0607) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v_0 ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0641
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VOID ->
              (* Shifting (VOID) to state 642 *)
              (* State 642: *)
              let _startpos_1 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_2 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> VOID *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_2, _startpos_1) in
                  let _v = _menhir_action_149 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> VOID *)
                  let _v_4 = _menhir_action_738 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_1 _v_4 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 643 *)
              (* State 643: *)
              let _startpos_5 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_6 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SHORT ->
                  let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, MenhirState0641, _startpos_5, _endpos_6) in
                  (* Shifting (SHORT) to state 251 *)
                  _menhir_run_0251 _menhir_stack _menhir_lexbuf _menhir_lexer
              | LONG ->
                  let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, MenhirState0641, _startpos_5, _endpos_6) in
                  (* Shifting (LONG) to state 253 *)
                  _menhir_run_0253 _menhir_stack _menhir_lexbuf _menhir_lexer
              | INT ->
                  let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, MenhirState0641, _startpos_5, _endpos_6) in
                  (* Shifting (INT) to state 257 *)
                  _menhir_run_0257 _menhir_stack _menhir_lexbuf _menhir_lexer
              | CHAR ->
                  let _menhir_stack = MenhirCell1_UNSIGNED (_menhir_stack, MenhirState0641, _startpos_5, _endpos_6) in
                  (* Shifting (CHAR) to state 258 *)
                  _menhir_run_0258 _menhir_stack _menhir_lexbuf _menhir_lexer
              | COLON ->
                  (* Reducing production c_keyword -> UNSIGNED *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_6, _startpos_5) in
                  let _v = _menhir_action_148 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> UNSIGNED *)
                  let _v_8 = _menhir_action_746 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_5 _v_8 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | UNION ->
              (* Shifting (UNION) to state 644 *)
              (* State 644: *)
              let _startpos_9 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_10 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WRITES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (WRITES) to state 1 *)
                  _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | VARIANT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (VARIANT) to state 133 *)
                  _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | TYPENAME _v_11 ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (TYPENAME) to state 155 *)
                  _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState0644
              | TYPE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (TYPE) to state 134 *)
                  _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | TERMINATES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (TERMINATES) to state 135 *)
                  _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | SLICE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (SLICE) to state 140 *)
                  _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | RETURNS ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (RETURNS) to state 156 *)
                  _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | REQUIRES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (REQUIRES) to state 157 *)
                  _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | REAL ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (REAL) to state 23 *)
                  _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | READS ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (READS) to state 24 *)
                  _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | PREDICATE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (PREDICATE) to state 158 *)
                  _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | PRAGMA ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (PRAGMA) to state 159 *)
                  _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | MODULE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (MODULE) to state 160 *)
                  _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | MODEL ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (MODEL) to state 161 *)
                  _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | LOOP ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (LOOP) to state 162 *)
                  _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | LOGIC ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (LOGIC) to state 163 *)
                  _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | LEMMA ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (LEMMA) to state 164 *)
                  _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | LABEL ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (LABEL) to state 33 *)
                  _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | INVARIANT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (INVARIANT) to state 165 *)
                  _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | INTEGER ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (INTEGER) to state 35 *)
                  _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | INDUCTIVE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (INDUCTIVE) to state 166 *)
                  _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | INCLUDE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (INCLUDE) to state 167 *)
                  _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | IMPACT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (IMPACT) to state 168 *)
                  _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | IDENTIFIER _v_12 ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (IDENTIFIER) to state 41 *)
                  _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_12 MenhirState0644
              | GLOBAL ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (GLOBAL) to state 169 *)
                  _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | FUNCTION ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (FUNCTION) to state 170 *)
                  _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | FREES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (FREES) to state 171 *)
                  _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | EXT_LET ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXT_LET) to state 172 *)
                  _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | EXT_GLOBAL_BLOCK _v_13 ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
                  _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_13 MenhirState0644
              | EXT_GLOBAL _v_14 ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXT_GLOBAL) to state 174 *)
                  _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_14 MenhirState0644
              | EXT_CONTRACT _v_15 ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXT_CONTRACT) to state 175 *)
                  _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_15 MenhirState0644
              | EXT_CODE_ANNOT _v_16 ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXT_CODE_ANNOT) to state 176 *)
                  _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_16 MenhirState0644
              | EXT_AT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXT_AT) to state 177 *)
                  _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | EXITS ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (EXITS) to state 178 *)
                  _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | ENSURES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (ENSURES) to state 179 *)
                  _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | DISJOINT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (DISJOINT) to state 180 *)
                  _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | DECREASES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (DECREASES) to state 181 *)
                  _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | CONTRACT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (CONTRACT) to state 182 *)
                  _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | CONTINUES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (CONTINUES) to state 183 *)
                  _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | COMPLETE ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (COMPLETE) to state 184 *)
                  _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | CHECK ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (CHECK) to state 185 *)
                  _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | BREAKS ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (BREAKS) to state 186 *)
                  _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | BEHAVIORS ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (BEHAVIORS) to state 79 *)
                  _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | BEHAVIOR ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (BEHAVIOR) to state 187 *)
                  _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | AXIOMATIC ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (AXIOMATIC) to state 188 *)
                  _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | AXIOM ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (AXIOM) to state 189 *)
                  _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | ASSUMES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (ASSUMES) to state 190 *)
                  _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | ASSIGNS ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (ASSIGNS) to state 191 *)
                  _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | ASSERT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (ASSERT) to state 192 *)
                  _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | ALLOCATES ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (ALLOCATES) to state 193 *)
                  _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | ADMIT ->
                  let _menhir_stack = MenhirCell1_UNION (_menhir_stack, MenhirState0641, _startpos_9, _endpos_10) in
                  (* Shifting (ADMIT) to state 194 *)
                  _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0644
              | COLON ->
                  (* Reducing production c_keyword -> UNION *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_10, _startpos_9) in
                  let _v = _menhir_action_147 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | TYPENAME _v_18 ->
              (* Shifting (TYPENAME) to state 645 *)
              (* State 645: *)
              let _startpos_19 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_20 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production any_identifier -> TYPENAME *)
                  let _v_21 =
                    let _1 = _v_18 in
                    _menhir_action_050 _1
                  in
                  _menhir_run_0511 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_20 _startpos_19 _v_21 MenhirState0641 _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | LT | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production typename -> TYPENAME *)
                  let (_menhir_s, _startpos_name_, name) = (MenhirState0641, _startpos_19, _v_18) in
                  let _v = _menhir_action_777 name in
                  _menhir_goto_typename _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_name_ _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | STRUCT ->
              (* Shifting (STRUCT) to state 646 *)
              (* State 646: *)
              let _startpos_23 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_24 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WRITES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (WRITES) to state 1 *)
                  _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | VARIANT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (VARIANT) to state 133 *)
                  _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | TYPENAME _v_25 ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (TYPENAME) to state 155 *)
                  _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v_25 MenhirState0646
              | TYPE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (TYPE) to state 134 *)
                  _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | TERMINATES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (TERMINATES) to state 135 *)
                  _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | SLICE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (SLICE) to state 140 *)
                  _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | RETURNS ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (RETURNS) to state 156 *)
                  _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | REQUIRES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (REQUIRES) to state 157 *)
                  _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | REAL ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (REAL) to state 23 *)
                  _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | READS ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (READS) to state 24 *)
                  _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | PREDICATE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (PREDICATE) to state 158 *)
                  _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | PRAGMA ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (PRAGMA) to state 159 *)
                  _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | MODULE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (MODULE) to state 160 *)
                  _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | MODEL ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (MODEL) to state 161 *)
                  _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | LOOP ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (LOOP) to state 162 *)
                  _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | LOGIC ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (LOGIC) to state 163 *)
                  _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | LEMMA ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (LEMMA) to state 164 *)
                  _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | LABEL ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (LABEL) to state 33 *)
                  _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | INVARIANT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (INVARIANT) to state 165 *)
                  _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | INTEGER ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (INTEGER) to state 35 *)
                  _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | INDUCTIVE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (INDUCTIVE) to state 166 *)
                  _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | INCLUDE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (INCLUDE) to state 167 *)
                  _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | IMPACT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (IMPACT) to state 168 *)
                  _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | IDENTIFIER _v_26 ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (IDENTIFIER) to state 41 *)
                  _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_26 MenhirState0646
              | GLOBAL ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (GLOBAL) to state 169 *)
                  _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | FUNCTION ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (FUNCTION) to state 170 *)
                  _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | FREES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (FREES) to state 171 *)
                  _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | EXT_LET ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXT_LET) to state 172 *)
                  _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | EXT_GLOBAL_BLOCK _v_27 ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
                  _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_27 MenhirState0646
              | EXT_GLOBAL _v_28 ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXT_GLOBAL) to state 174 *)
                  _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_28 MenhirState0646
              | EXT_CONTRACT _v_29 ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXT_CONTRACT) to state 175 *)
                  _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_29 MenhirState0646
              | EXT_CODE_ANNOT _v_30 ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXT_CODE_ANNOT) to state 176 *)
                  _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_30 MenhirState0646
              | EXT_AT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXT_AT) to state 177 *)
                  _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | EXITS ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (EXITS) to state 178 *)
                  _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | ENSURES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (ENSURES) to state 179 *)
                  _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | DISJOINT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (DISJOINT) to state 180 *)
                  _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | DECREASES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (DECREASES) to state 181 *)
                  _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | CONTRACT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (CONTRACT) to state 182 *)
                  _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | CONTINUES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (CONTINUES) to state 183 *)
                  _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | COMPLETE ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (COMPLETE) to state 184 *)
                  _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | CHECK ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (CHECK) to state 185 *)
                  _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | BREAKS ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (BREAKS) to state 186 *)
                  _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | BEHAVIORS ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (BEHAVIORS) to state 79 *)
                  _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | BEHAVIOR ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (BEHAVIOR) to state 187 *)
                  _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | AXIOMATIC ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (AXIOMATIC) to state 188 *)
                  _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | AXIOM ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (AXIOM) to state 189 *)
                  _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | ASSUMES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (ASSUMES) to state 190 *)
                  _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | ASSIGNS ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (ASSIGNS) to state 191 *)
                  _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | ASSERT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (ASSERT) to state 192 *)
                  _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | ALLOCATES ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (ALLOCATES) to state 193 *)
                  _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | ADMIT ->
                  let _menhir_stack = MenhirCell1_STRUCT (_menhir_stack, MenhirState0641, _startpos_23, _endpos_24) in
                  (* Shifting (ADMIT) to state 194 *)
                  _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0646
              | COLON ->
                  (* Reducing production c_keyword -> STRUCT *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_24, _startpos_23) in
                  let _v = _menhir_action_146 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | STRING_LITERAL _v_32 ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_32 MenhirState0641
          | STRING_CONSTANT _v_33 ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_33 MenhirState0641
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | SIGNED ->
              (* Shifting (SIGNED) to state 647 *)
              (* State 647: *)
              let _startpos_34 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_35 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | SHORT ->
                  let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, MenhirState0641, _startpos_34, _endpos_35) in
                  (* Shifting (SHORT) to state 265 *)
                  _menhir_run_0265 _menhir_stack _menhir_lexbuf _menhir_lexer
              | LONG ->
                  let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, MenhirState0641, _startpos_34, _endpos_35) in
                  (* Shifting (LONG) to state 267 *)
                  _menhir_run_0267 _menhir_stack _menhir_lexbuf _menhir_lexer
              | INT ->
                  let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, MenhirState0641, _startpos_34, _endpos_35) in
                  (* Shifting (INT) to state 271 *)
                  _menhir_run_0271 _menhir_stack _menhir_lexbuf _menhir_lexer
              | CHAR ->
                  let _menhir_stack = MenhirCell1_SIGNED (_menhir_stack, MenhirState0641, _startpos_34, _endpos_35) in
                  (* Shifting (CHAR) to state 272 *)
                  _menhir_run_0272 _menhir_stack _menhir_lexbuf _menhir_lexer
              | COLON ->
                  (* Reducing production c_keyword -> SIGNED *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_35, _startpos_34) in
                  let _v = _menhir_action_143 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | SHORT ->
              (* Shifting (SHORT) to state 648 *)
              (* State 648: *)
              let _startpos_37 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_38 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | INT ->
                  let _menhir_stack = MenhirCell1_SHORT (_menhir_stack, MenhirState0641, _startpos_37, _endpos_38) in
                  (* Shifting (INT) to state 274 *)
                  _menhir_run_0274 _menhir_stack _menhir_lexbuf _menhir_lexer
              | COLON ->
                  (* Reducing production c_keyword -> SHORT *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_38, _startpos_37) in
                  let _v = _menhir_action_142 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> SHORT *)
                  let _v_40 = _menhir_action_747 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_37 _v_40 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | REAL ->
              (* Shifting (REAL) to state 649 *)
              (* State 649: *)
              let _startpos_41 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_42 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production is_acsl_typename -> REAL *)
                  let _v_43 = _menhir_action_379 () in
                  _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_42 _startpos_41 _v_43 MenhirState0641 _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> REAL *)
                  let _v_44 = _menhir_action_736 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_41 _v_44 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LONG ->
              (* Shifting (LONG) to state 650 *)
              (* State 650: *)
              let _startpos_45 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_46 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | LONG ->
                  let _menhir_stack = MenhirCell1_LONG (_menhir_stack, MenhirState0641, _startpos_45, _endpos_46) in
                  (* Shifting (LONG) to state 277 *)
                  _menhir_run_0277 _menhir_stack _menhir_lexbuf _menhir_lexer
              | INT ->
                  let _menhir_stack = MenhirCell1_LONG (_menhir_stack, MenhirState0641, _startpos_45, _endpos_46) in
                  (* Shifting (INT) to state 279 *)
                  _menhir_run_0279 _menhir_stack _menhir_lexbuf _menhir_lexer
              | DOUBLE ->
                  let _menhir_stack = MenhirCell1_LONG (_menhir_stack, MenhirState0641, _startpos_45, _endpos_46) in
                  (* Shifting (DOUBLE) to state 280 *)
                  _menhir_run_0280 _menhir_stack _menhir_lexbuf _menhir_lexer
              | COLON ->
                  (* Reducing production c_keyword -> LONG *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_46, _startpos_45) in
                  let _v = _menhir_action_141 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> LONG *)
                  let _v_48 = _menhir_action_753 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_45 _v_48 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | INT_CONSTANT _v_49 ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_49 MenhirState0641
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | INTEGER ->
              (* Shifting (INTEGER) to state 651 *)
              (* State 651: *)
              let _startpos_50 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_51 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production is_acsl_typename -> INTEGER *)
                  let _v_52 = _menhir_action_378 () in
                  _menhir_run_0106 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_51 _startpos_50 _v_52 MenhirState0641 _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> INTEGER *)
                  let _v_53 = _menhir_action_735 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_50 _v_53 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | INT ->
              (* Shifting (INT) to state 652 *)
              (* State 652: *)
              let _startpos_54 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_55 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> INT *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_55, _startpos_54) in
                  let _v = _menhir_action_140 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> INT *)
                  let _v_57 = _menhir_action_743 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_54 _v_57 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | IDENTIFIER _v_58 ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_58 MenhirState0641
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | FLOAT_CONSTANT _v_59 ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_59 MenhirState0641
          | FLOAT ->
              (* Shifting (FLOAT) to state 653 *)
              (* State 653: *)
              let _startpos_60 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_61 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> FLOAT *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_61, _startpos_60) in
                  let _v = _menhir_action_138 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> FLOAT *)
                  let _v_63 = _menhir_action_765 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_60 _v_63 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | EXT_GLOBAL_BLOCK _v_64 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_64 MenhirState0641
          | EXT_GLOBAL _v_65 ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_65 MenhirState0641
          | EXT_CONTRACT _v_66 ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_66 MenhirState0641
          | EXT_CODE_ANNOT _v_67 ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_67 MenhirState0641
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ENUM ->
              (* Shifting (ENUM) to state 654 *)
              (* State 654: *)
              let _startpos_68 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_69 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | WRITES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (WRITES) to state 1 *)
                  _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | VARIANT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (VARIANT) to state 133 *)
                  _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | TYPENAME _v_70 ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (TYPENAME) to state 155 *)
                  _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v_70 MenhirState0654
              | TYPE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (TYPE) to state 134 *)
                  _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | TERMINATES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (TERMINATES) to state 135 *)
                  _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | SLICE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (SLICE) to state 140 *)
                  _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | RETURNS ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (RETURNS) to state 156 *)
                  _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | REQUIRES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (REQUIRES) to state 157 *)
                  _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | REAL ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (REAL) to state 23 *)
                  _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | READS ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (READS) to state 24 *)
                  _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | PREDICATE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (PREDICATE) to state 158 *)
                  _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | PRAGMA ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (PRAGMA) to state 159 *)
                  _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | MODULE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (MODULE) to state 160 *)
                  _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | MODEL ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (MODEL) to state 161 *)
                  _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | LOOP ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (LOOP) to state 162 *)
                  _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | LOGIC ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (LOGIC) to state 163 *)
                  _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | LEMMA ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (LEMMA) to state 164 *)
                  _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | LABEL ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (LABEL) to state 33 *)
                  _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | INVARIANT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (INVARIANT) to state 165 *)
                  _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | INTEGER ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (INTEGER) to state 35 *)
                  _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | INDUCTIVE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (INDUCTIVE) to state 166 *)
                  _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | INCLUDE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (INCLUDE) to state 167 *)
                  _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | IMPACT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (IMPACT) to state 168 *)
                  _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | IDENTIFIER _v_71 ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (IDENTIFIER) to state 41 *)
                  _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_71 MenhirState0654
              | GLOBAL ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (GLOBAL) to state 169 *)
                  _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | FUNCTION ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (FUNCTION) to state 170 *)
                  _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | FREES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (FREES) to state 171 *)
                  _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | EXT_LET ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXT_LET) to state 172 *)
                  _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | EXT_GLOBAL_BLOCK _v_72 ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
                  _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v_72 MenhirState0654
              | EXT_GLOBAL _v_73 ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXT_GLOBAL) to state 174 *)
                  _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v_73 MenhirState0654
              | EXT_CONTRACT _v_74 ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXT_CONTRACT) to state 175 *)
                  _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v_74 MenhirState0654
              | EXT_CODE_ANNOT _v_75 ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXT_CODE_ANNOT) to state 176 *)
                  _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v_75 MenhirState0654
              | EXT_AT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXT_AT) to state 177 *)
                  _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | EXITS ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (EXITS) to state 178 *)
                  _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | ENSURES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (ENSURES) to state 179 *)
                  _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | DISJOINT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (DISJOINT) to state 180 *)
                  _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | DECREASES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (DECREASES) to state 181 *)
                  _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | CONTRACT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (CONTRACT) to state 182 *)
                  _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | CONTINUES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (CONTINUES) to state 183 *)
                  _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | COMPLETE ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (COMPLETE) to state 184 *)
                  _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | CHECK ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (CHECK) to state 185 *)
                  _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | BREAKS ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (BREAKS) to state 186 *)
                  _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | BEHAVIORS ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (BEHAVIORS) to state 79 *)
                  _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | BEHAVIOR ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (BEHAVIOR) to state 187 *)
                  _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | AXIOMATIC ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (AXIOMATIC) to state 188 *)
                  _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | AXIOM ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (AXIOM) to state 189 *)
                  _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | ASSUMES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (ASSUMES) to state 190 *)
                  _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | ASSIGNS ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (ASSIGNS) to state 191 *)
                  _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | ASSERT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (ASSERT) to state 192 *)
                  _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | ALLOCATES ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (ALLOCATES) to state 193 *)
                  _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | ADMIT ->
                  let _menhir_stack = MenhirCell1_ENUM (_menhir_stack, MenhirState0641, _startpos_68, _endpos_69) in
                  (* Shifting (ADMIT) to state 194 *)
                  _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0654
              | COLON ->
                  (* Reducing production c_keyword -> ENUM *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_69, _startpos_68) in
                  let _v = _menhir_action_136 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 655 *)
              (* State 655: *)
              let _startpos_77 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_78 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> DOUBLE *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_78, _startpos_77) in
                  let _v = _menhir_action_135 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> DOUBLE *)
                  let _v_80 = _menhir_action_766 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_77 _v_80 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | CHAR ->
              (* Shifting (CHAR) to state 656 *)
              (* State 656: *)
              let _startpos_81 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_82 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> CHAR *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_82, _startpos_81) in
                  let _v = _menhir_action_131 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> CHAR *)
                  let _v_84 = _menhir_action_740 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_81 _v_84 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 657 *)
              (* State 657: *)
              let _startpos_85 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_86 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> BOOLEAN *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_86, _startpos_85) in
                  let _v = _menhir_action_132 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> BOOLEAN *)
                  let _v_88 = _menhir_action_737 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_85 _v_88 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | BOOL ->
              (* Shifting (BOOL) to state 658 *)
              (* State 658: *)
              let _startpos_89 = _menhir_lexbuf.Lexing.lex_start_p in
              let _endpos_90 = _menhir_lexbuf.Lexing.lex_curr_p in
              let _tok = _menhir_lexer _menhir_lexbuf in
              (match (_tok : MenhirBasics.token) with
              | COLON ->
                  (* Reducing production c_keyword -> BOOL *)
                  let (_menhir_s, _endpos__1_, _startpos__1_) = (MenhirState0641, _endpos_90, _startpos_89) in
                  let _v = _menhir_action_133 () in
                  _menhir_goto_c_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
              | ADMIT | ALLOCATES | ASSERT | ASSIGNS | ASSUMES | AXIOM | AXIOMATIC | BEHAVIOR | BEHAVIORS | BREAKS | CHECK | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EXITS | EXT_AT | EXT_CODE_ANNOT _ | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | IDENTIFIER _ | IMPACT | INCLUDE | INDUCTIVE | INVARIANT | LABEL | LEMMA | LOGIC | LOOP | LPAR | MODEL | MODULE | PRAGMA | PREDICATE | READS | REQUIRES | RETURNS | SLICE | STAR | TERMINATES | TYPE | VARIANT | WRITES ->
                  (* Reducing production type_spec(typename) -> BOOL *)
                  let _v_92 = _menhir_action_739 () in
                  _menhir_run_0369 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos_89 _v_92 MenhirState0641 _tok
              | _ ->
                  (* Initiating error handling *)
                  _eRR ())
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0641
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMMA) to state 524 *)
          _menhir_run_0524 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0607
      | RBRACE ->
          (* Reducing production ne_lexpr_list -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_545 _1 in
          _menhir_goto_ne_lexpr_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0511 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 511: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 512 *)
          (* State 512: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0512 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0524 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr as 'stack) -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 524: *)
      let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, _menhir_s) in
      let _menhir_s = MenhirState0524 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_lexpr_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0895 ->
          _menhir_run_0896 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1169 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1068 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0759 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0330 ->
          _menhir_run_0724 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0351 ->
          _menhir_run_0581 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0618 ->
          _menhir_run_0581 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0366 ->
          _menhir_run_0581 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0394 ->
          _menhir_run_0581 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0439 ->
          _menhir_run_0581 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0529 ->
          _menhir_run_0530 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0524 ->
          _menhir_run_0525 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState0498 ->
          _menhir_run_0499 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0896 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOOP, ttv_result) _menhir_cell1_PRAGMA, ttv_result) _menhir_cell1_any_identifier -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 896: *)
      match (_tok : MenhirBasics.token) with
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 897 *)
          (* State 897: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_any_identifier (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell1_PRAGMA (_menhir_stack, _, _, _) = _menhir_stack in
          let MenhirCell1_LOOP (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production loop_pragma -> LOOP PRAGMA any_identifier ne_lexpr_list SEMICOLON *)
          let (_endpos, _4, _endpos__5_) = (_endpos_0, _v, _endpos_0) in
          let _v = _menhir_action_525 _3 _4 _endpos__5_ _startpos__1_ in
          let _startpos = _startpos__1_ in
          (* State 1013: *)
          let _menhir_stack = MenhirCell1_loop_pragma (_menhir_stack, _menhir_s, _v, _startpos) in
          (match (_tok : MenhirBasics.token) with
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1013
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1013
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1013
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1013
          | ADMIT_LEMMA | AXIOM | AXIOMATIC | CHECK_LEMMA | CONTRACT | EOF | EXT_AT | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | TYPE | VOLATILE ->
              (* Reducing production loop_annot_opt -> *)
              let _v_0 = _menhir_action_510 () in
              _menhir_run_1023 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v_0 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0759 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 759: *)
      (* Reducing production ne_zones -> ne_lexpr_list *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_572 _1 in
      _menhir_goto_ne_zones _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ne_zones : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1068 ->
          _menhir_run_0911 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0909 ->
          _menhir_run_0911 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1169 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1146 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1062 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1030 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0916 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0912 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0905 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0901 ->
          _menhir_run_0904 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0002 ->
          _menhir_run_0750 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0911 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_ASSIGNS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 911: *)
      match (_tok : MenhirBasics.token) with
      | FROM ->
          let _menhir_stack = MenhirCell1_ne_zones (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FROM) to state 912 *)
          (* State 912: *)
          let _menhir_s = MenhirState0912 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOTHING ->
              (* Shifting (NOTHING) to state 902 *)
              _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COMPLETE | CONTINUES | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FREES | REQUIRES | RETURNS | SEMICOLON ->
          (* Reducing production zones -> ne_zones *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_850 _1 in
          _menhir_goto_zones _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0904 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 904: *)
      (* Reducing production zones -> ne_zones *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_850 _1 in
      _menhir_goto_zones _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0750 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VOLATILE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 750: *)
      let _menhir_stack = MenhirCell1_ne_zones (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 751 *)
          _menhir_run_0751 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0750
      | READS ->
          (* Shifting (READS) to state 753 *)
          _menhir_run_0753 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0750
      | SEMICOLON ->
          (* Reducing production volatile_opt -> *)
          let _v_0 = _menhir_action_790 () in
          _menhir_run_0757 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0751 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 751: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_WRITES (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0751 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0753 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 753: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_READS (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0753 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0757 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_VOLATILE, ttv_result) _menhir_cell1_ne_zones -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 757: *)
      (* The current token is SEMICOLON. *)
      (* Shifting (SEMICOLON) to state 758 *)
      (* State 758: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_ne_zones (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_VOLATILE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production decl -> VOLATILE ne_zones volatile_opt SEMICOLON *)
      let (_endpos__4_, _3) = (_endpos, _v) in
      let _v = _menhir_action_213 _2 _3 in
      _menhir_goto_decl _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0724 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_SEPARATED _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 724: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 725 *)
          (* State 725: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_SEPARATED (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> SEPARATED LPAR ne_lexpr_list RPAR *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_459 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0581 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 581: *)
      (* Reducing production lexpr_list -> ne_lexpr_list *)
      let _1 = _v in
      let _v = _menhir_action_483 _1 in
      _menhir_goto_lexpr_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_lexpr_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0351 ->
          _menhir_run_0712 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0618 ->
          _menhir_run_0605 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0366 ->
          _menhir_run_0605 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0394 ->
          _menhir_run_0596 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0439 ->
          _menhir_run_0582 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0530 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LBRACE, ttv_result) _menhir_cell1_ne_label_args _menhir_cell0_RBRACE _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 530: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 531 *)
          (* State 531: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell0_RBRACE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_ne_label_args (_menhir_stack, _, _3) = _menhir_stack in
          let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> full_identifier LBRACE ne_label_args RBRACE LPAR ne_lexpr_list RPAR *)
          let (_endpos__7_, _6) = (_endpos_0, _v) in
          let _v = _menhir_action_461 _1 _3 _6 _endpos__7_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0525 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 525: *)
      let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_lexpr_list -> lexpr COMMA ne_lexpr_list *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_546 _1 _3 in
      _menhir_goto_ne_lexpr_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0499 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LPAR -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 499: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 500 *)
          (* State 500: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> full_identifier LPAR ne_lexpr_list RPAR *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_460 _1 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0601 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_LSQUARE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 601: *)
      match (_tok : MenhirBasics.token) with
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 602 *)
          (* State 602: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LSQUARE (_menhir_stack, _menhir_s) = _menhir_stack in
          (* Reducing production array_path_elt -> LSQUARE lexpr RSQUARE *)
          let _2 = _v in
          let _v = _menhir_action_055 _2 in
          _menhir_goto_array_path_elt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0601
      | DOTDOT ->
          (* Reducing production lexpr_option -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_485 _1 in
          _menhir_goto_lexpr_option _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0598 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LAMBDA, ttv_result) _menhir_cell1_binders _menhir_cell0_SEMICOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 598: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0598
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_binders (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_LAMBDA (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_binder -> LAMBDA binders SEMICOLON lexpr *)
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_407 _2 _4 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_binder _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0594 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_INITIALIZED, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 594: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 595 *)
          (* State 595: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_INITIALIZED (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> INITIALIZED opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_422 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0594
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0592 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_FRESH, ttv_result) _menhir_cell1_opt_label_2 _menhir_cell0_LPAR, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 592: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 593 *)
          (* State 593: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _4, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_2 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_FRESH (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> FRESH opt_label_2 LPAR lexpr COMMA lexpr RPAR *)
          let (_endpos__7_, _6) = (_endpos_0, _v) in
          let _v = _menhir_action_424 _2 _4 _6 _endpos__7_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__7_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0592
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0590 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FRESH, ttv_result) _menhir_cell1_opt_label_2 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 590: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | COMMA ->
          (* Shifting (COMMA) to state 591 *)
          (* State 591: *)
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, MenhirState0590) in
          let _menhir_s = MenhirState0591 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0590
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0588 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FREEABLE, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 588: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 589 *)
          (* State 589: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_FREEABLE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> FREEABLE opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_429 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0588
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0587 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_FORALL, ttv_result) _menhir_cell1_binders _menhir_cell0_SEMICOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 587: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0587
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_binders (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_FORALL (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_binder -> FORALL binders SEMICOLON lexpr *)
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_405 _2 _4 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_binder _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0586 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_EXISTS, ttv_result) _menhir_cell1_binders _menhir_cell0_SEMICOLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 586: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0586
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell0_SEMICOLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_binders (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_EXISTS (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_binder -> EXISTS binders SEMICOLON lexpr *)
          let (_endpos__4_, _4) = (_endpos, _v) in
          let _v = _menhir_action_406 _2 _4 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_binder _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0584 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_DANGLING, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 584: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 585 *)
          (* State 585: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_DANGLING (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> DANGLING opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_423 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0584
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0579 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_BLOCK_LENGTH, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 579: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 580 *)
          (* State 580: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_BLOCK_LENGTH (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> BLOCK_LENGTH opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_426 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0579
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0577 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_BASE_ADDR, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 577: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 578 *)
          (* State 578: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_BASE_ADDR (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> BASE_ADDR opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_425 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0577
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0573 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AT _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 573: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | COMMA ->
          (* Shifting (COMMA) to state 574 *)
          (* State 574: *)
          let _menhir_stack = MenhirCell1_COMMA (_menhir_stack, MenhirState0573) in
          let _menhir_s = MenhirState0574 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0573
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0570 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ALLOCATION, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 570: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 571 *)
          (* State 571: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_ALLOCATION (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> ALLOCATION opt_label_1 LPAR lexpr RPAR *)
          let _endpos__5_ = _endpos_0 in
          let _v = _menhir_action_430 _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0570
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0568 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_ALLOCABLE, ttv_result) _menhir_cell1_opt_label_1 _menhir_cell0_LPAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 568: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 569 *)
          (* State 569: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_opt_label_1 (_menhir_stack, _, _2) = _menhir_stack in
          let MenhirCell1_ALLOCABLE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> ALLOCABLE opt_label_1 LPAR lexpr RPAR *)
          let (_4, _endpos__5_) = (_v, _endpos_0) in
          let _v = _menhir_action_428 _2 _4 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0568
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0567 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_string _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 567: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0567
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_string (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> string COLON lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_402 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0537 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_LSQUARE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 537: *)
      match (_tok : MenhirBasics.token) with
      | RSQUARE ->
          (* Shifting (RSQUARE) to state 538 *)
          (* State 538: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_LSQUARE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner LSQUARE lexpr RSQUARE *)
          let (_endpos__4_, _3) = (_endpos_0, _v) in
          let _v = _menhir_action_447 _1 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0537
      | DOTDOT ->
          (* Reducing production lexpr_option -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_485 _1 in
          _menhir_goto_lexpr_option _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0536 : type  ttv_stack ttv_result. (((((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_QUESTION, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COLON2 as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 536: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0536
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_COLON2 (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell1_QUESTION (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr QUESTION lexpr COLON2 lexpr *)
          let (_endpos__5_, _5) = (_endpos, _v) in
          let _v = _menhir_action_400 _1 _3 _5 _endpos__5_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__5_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0523 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_IFF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 523: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0523
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | IFF | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_IFF (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr IFF lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_390 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0521 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_AND as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 521: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0521
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0521
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0521
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0521
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0521
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0521
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AND | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HATHAT | IFF | IMPLIES | OR | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_AND (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr AND lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_392 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0519 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_BIFF as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 519: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0519
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0519
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0519
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0519
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0519
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HATHAT | IFF | IMPLIES | OR | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_BIFF (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr BIFF lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_398 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0517 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_BIMPLIES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 517: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0517
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0517
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0517
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0517
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0517
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HATHAT | IFF | IMPLIES | OR | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_BIMPLIES (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr BIMPLIES lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_397 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0515 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_IMPLIES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 515: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0515
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | IFF | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_IMPLIES (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr IMPLIES lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_389 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0513 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_any_identifier _menhir_cell0_COLON as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 513: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0513
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell0_COLON (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> any_identifier COLON lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_401 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0509 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_AMP as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 509: *)
      match (_tok : MenhirBasics.token) with
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0509
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HAT | HATHAT | IFF | IMPLIES | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_AMP (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr AMP lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_394 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0507 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_HAT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 507: *)
      match (_tok : MenhirBasics.token) with
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0507
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0507
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HAT | HATHAT | IFF | IMPLIES | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_HAT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr HAT lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_396 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0505 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_HATHAT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 505: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0505
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HATHAT | IFF | IMPLIES | OR | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_HATHAT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr HATHAT lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_393 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0503 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_OR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 503: *)
      match (_tok : MenhirBasics.token) with
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0503
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | IFF | IMPLIES | OR | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_OR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr OR lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_391 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0501 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 501: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | COMMA ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMMA) to state 524 *)
          _menhir_run_0524 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0501
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COMPLETE | CONTINUES | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FREES | FROM | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUAREPIPE | SEMICOLON | WRITES ->
          (* Reducing production ne_lexpr_list -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_545 _1 in
          _menhir_goto_ne_lexpr_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0495 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_IN -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 495: *)
      match (_tok : MenhirBasics.token) with
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HAT | HATHAT | IFF | IMPLIES | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_IN (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr IN lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_399 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0493 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_PIPE as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 493: *)
      match (_tok : MenhirBasics.token) with
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0493
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0493
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0493
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HATHAT | IFF | IMPLIES | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          let MenhirCell1_PIPE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr -> lexpr PIPE lexpr *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_395 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0491 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_QUESTION as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 491: *)
      let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | PIPE ->
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | OR ->
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | IN ->
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | IMPLIES ->
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | IFF ->
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | HATHAT ->
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | HAT ->
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | COLON2 ->
          (* Shifting (COLON2) to state 535 *)
          (* State 535: *)
          let _menhir_stack = MenhirCell1_COLON2 (_menhir_stack, MenhirState0491) in
          let _menhir_s = MenhirState0535 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | BIMPLIES ->
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | BIFF ->
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | AND ->
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | AMP ->
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0491
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0489 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr_option _menhir_cell0_DOTDOT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 489: *)
      match (_tok : MenhirBasics.token) with
      | QUESTION ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (QUESTION) to state 490 *)
          _menhir_run_0490 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | PIPE ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PIPE) to state 492 *)
          _menhir_run_0492 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | OR ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OR) to state 502 *)
          _menhir_run_0502 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | IN ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IN) to state 494 *)
          _menhir_run_0494 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | IMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPLIES) to state 514 *)
          _menhir_run_0514 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | IFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IFF) to state 522 *)
          _menhir_run_0522 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | HATHAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HATHAT) to state 504 *)
          _menhir_run_0504 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | HAT ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (HAT) to state 506 *)
          _menhir_run_0506 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | BIMPLIES ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIMPLIES) to state 516 *)
          _menhir_run_0516 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | BIFF ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BIFF) to state 518 *)
          _menhir_run_0518 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | AND ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AND) to state 520 *)
          _menhir_run_0520 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | AMP ->
          let _menhir_stack = MenhirCell1_lexpr (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 508 *)
          _menhir_run_0508 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0489
      | RPAR | RSQUARE ->
          (* Reducing production lexpr_option -> lexpr *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_485 _1 in
          _menhir_goto_lexpr_option _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0564 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_relation, ttv_result) _menhir_cell1_lexpr_inner -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 564: *)
      let MenhirCell1_lexpr_inner (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_relation (_menhir_stack, _menhir_s, _1, _startpos__1_) = _menhir_stack in
      (* Reducing production rel_list -> relation lexpr_inner rel_list *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_621 _1 _2 _3 _endpos__3_ _startpos__1_ in
      _menhir_goto_rel_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _v _menhir_s _tok
  
  and _menhir_run_0487 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 487: *)
      (* Reducing production lexpr_rel -> lexpr_end_rel *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_486 _1 in
      _menhir_goto_lexpr_rel _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0554 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_GTGT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 554: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 545 *)
          _menhir_run_0545 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 549 *)
          _menhir_run_0549 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0554
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | NE | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | STARHAT | WITH | WRITES ->
          let MenhirCell1_GTGT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner GTGT lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_465 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0552 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_LTLT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 552: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 545 *)
          _menhir_run_0545 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 549 *)
          _menhir_run_0549 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0552
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | NE | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | STARHAT | WITH | WRITES ->
          let MenhirCell1_LTLT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner LTLT lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_466 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0550 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_MINUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 550: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0550
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0550
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0550
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0550
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0550
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0550
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | STARHAT | WITH | WRITES ->
          let MenhirCell1_MINUS (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner MINUS lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_439 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0548 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_PERCENT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 548: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0548
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0548
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0548
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_PERCENT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner PERCENT lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_442 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0546 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_PLUS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 546: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0546
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0546
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0546
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0546
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0546
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0546
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | STARHAT | WITH | WRITES ->
          let MenhirCell1_PLUS (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner PLUS lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_438 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0544 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_SLASH as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 544: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0544
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0544
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0544
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_SLASH (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner SLASH lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_441 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0480 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_STAR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 480: *)
      match (_tok : MenhirBasics.token) with
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0480
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0480
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0480
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          let MenhirCell1_STAR (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner STAR lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_440 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0478 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_lexpr_inner, ttv_result) _menhir_cell1_STARHAT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 478: *)
      match (_tok : MenhirBasics.token) with
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 545 *)
          _menhir_run_0545 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 549 *)
          _menhir_run_0549 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | LTLT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LTLT) to state 551 *)
          _menhir_run_0551 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | GTGT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GTGT) to state 553 *)
          _menhir_run_0553 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0478
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | HAT | HATHAT | IFF | IMPLIES | IN | LE | LT | NE | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | STARHAT | WITH | WRITES ->
          let MenhirCell1_STARHAT (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
          (* Reducing production lexpr_inner -> lexpr_inner STARHAT lexpr_inner *)
          let (_endpos__3_, _3) = (_endpos, _v) in
          let _v = _menhir_action_443 _1 _3 _endpos__3_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0475 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 475: *)
      match (_tok : MenhirBasics.token) with
      | STARHAT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STARHAT) to state 476 *)
          _menhir_run_0476 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | STAR ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 479 *)
          _menhir_run_0479 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | SLASH ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLASH) to state 543 *)
          _menhir_run_0543 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | PLUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 545 *)
          _menhir_run_0545 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | PERCENT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PERCENT) to state 547 *)
          _menhir_run_0547 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | NE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (NE) to state 555 *)
          _menhir_run_0555 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | MINUS ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 549 *)
          _menhir_run_0549 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | LTLT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LTLT) to state 551 *)
          _menhir_run_0551 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | LT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LT) to state 556 *)
          _menhir_run_0556 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | LSQUARE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUARE) to state 481 *)
          _menhir_run_0481 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | LE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LE) to state 557 *)
          _menhir_run_0557 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | GTGT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GTGT) to state 553 *)
          _menhir_run_0553 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | GT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GT) to state 558 *)
          _menhir_run_0558 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | GE ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GE) to state 559 *)
          _menhir_run_0559 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | EQUAL ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EQUAL) to state 560 *)
          _menhir_run_0560 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | EQ ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EQ) to state 561 *)
          _menhir_run_0561 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | DOT ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOT) to state 539 *)
          _menhir_run_0539 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | ARROW ->
          let _menhir_stack = MenhirCell1_lexpr_inner (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ARROW) to state 541 *)
          _menhir_run_0541 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0475
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOTDOT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | HAT | HATHAT | IFF | IMPLIES | IN | OR | PIPE | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | WITH | WRITES ->
          (* Reducing production lexpr_end_rel -> lexpr_inner *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_408 _1 in
          _menhir_goto_lexpr_end_rel _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0995 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _menhir_s _tok ->
      (* State 995: *)
      (* Reducing production clause_kw -> post_cond *)
      let (_endpos__1_, _1) = (_endpos, _v) in
      let _v = _menhir_action_162 _1 in
      _menhir_goto_clause_kw _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0097 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 97: *)
      (* Reducing production is_acsl_spec -> post_cond *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_365 _1 in
      _menhir_goto_is_acsl_spec _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1242 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1242: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> RESULT *)
      let _ = _menhir_action_115 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1243 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1243: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> REGISTER *)
      let _ = _menhir_action_114 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1244 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1244: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> RBRACE *)
      let _v = _menhir_action_839 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1245 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1245: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> QUESTION *)
      let _v = _menhir_action_838 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1246 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1246: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> PLUS *)
      let _v = _menhir_action_837 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1247 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1247: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> PIPE *)
      let _v = _menhir_action_836 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1248 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1248: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> PI *)
      let _v = _menhir_action_835 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1249 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1249: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> PERCENT *)
      let _v = _menhir_action_834 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1250 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1250: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> OR *)
      let _v = _menhir_action_833 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1251 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1251: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> OLD *)
      let _ = _menhir_action_112 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1252 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1252: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> OFFSET *)
      let _ = _menhir_action_113 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1253 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1253: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> OBJECT_POINTER *)
      let _ = _menhir_action_122 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1254 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1254: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> NULL *)
      let _ = _menhir_action_111 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1255 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1255: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> NOTHING *)
      let _ = _menhir_action_110 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1256 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1256: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> NOT *)
      let _v = _menhir_action_832 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1257 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1257: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> NE *)
      let _v = _menhir_action_831 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1258 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1258: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> MINUS *)
      let _v = _menhir_action_830 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1259 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1259: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LTLT *)
      let _v = _menhir_action_829 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1260 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1260: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LT *)
      let _v = _menhir_action_828 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1261 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1261: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LSQUAREPIPE *)
      let _v = _menhir_action_827 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1262 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1262: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LSQUARE *)
      let _v = _menhir_action_826 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1263 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1263: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LPAR *)
      let _v = _menhir_action_825 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1264 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1264: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> LET *)
      let _ = _menhir_action_109 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1265 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1265: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LE *)
      let _v = _menhir_action_824 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1266 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1266: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> LBRACE *)
      let _v = _menhir_action_823 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1267 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1267: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> LAMBDA *)
      let _ = _menhir_action_108 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1268 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1268: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> INT_CONSTANT *)
      let _v = _menhir_action_804 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1269 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1269: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> INTER *)
      let _ = _menhir_action_107 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1270 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1270: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> INITIALIZED *)
      let _ = _menhir_action_128 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1271 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1271: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> IN *)
      let _v = _menhir_action_849 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1272 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1272: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> IMPLIES *)
      let _v = _menhir_action_822 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1273 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1273: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> IFF *)
      let _v = _menhir_action_821 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1274 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1274: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> HATHAT *)
      let _v = _menhir_action_820 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1275 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1275: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> HAT *)
      let _v = _menhir_action_819 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1276 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1276: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> GTGT *)
      let _v = _menhir_action_818 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1277 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1277: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> GT *)
      let _v = _menhir_action_817 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1278 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1278: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> GHOST *)
      let _v = _menhir_action_816 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1279 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1279: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> GE *)
      let _v = _menhir_action_815 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1280 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1280: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> FROM *)
      let _ = _menhir_action_106 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1281 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1281: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> FRESH *)
      let _ = _menhir_action_105 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1282 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1282: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> FREEABLE *)
      let _ = _menhir_action_104 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1283 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1283: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> FORALL *)
      let _ = _menhir_action_103 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1284 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1284: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> FLOAT_CONSTANT *)
      let _v = _menhir_action_805 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1285 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1285: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> FALSE *)
      let _ = _menhir_action_102 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1286 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1286: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> EXISTS *)
      let _v = _menhir_action_814 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1287 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1287: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> EQUAL *)
      let _v = _menhir_action_813 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1288 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1288: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> EQ *)
      let _v = _menhir_action_812 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1289 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1289: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> EMPTY *)
      let _ = _menhir_action_101 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1290 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1290: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> DYNAMIC *)
      let _ = _menhir_action_100 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1291 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1291: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> DOTDOTDOT *)
      let _v = _menhir_action_811 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1292 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1292: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> DOTDOT *)
      let _v = _menhir_action_810 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1293 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1293: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> DOT *)
      let _v = _menhir_action_809 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1294 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1294: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> DOLLAR *)
      let _v = _menhir_action_808 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1295 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1295: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> DANGLING *)
      let _ = _menhir_action_129 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1296 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1296: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> COMMA *)
      let _v = _menhir_action_803 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1297 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1297: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> COLONCOLON *)
      let _v = _menhir_action_802 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1298 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1298: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> COLON2 *)
      let _v = _menhir_action_801 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1299 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1299: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> COLON *)
      let _v = _menhir_action_800 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1300 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1300: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> BSUNION *)
      let _ = _menhir_action_120 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1301 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1301: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> BSTYPE *)
      let _ = _menhir_action_118 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1302 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1302: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> BSGHOST *)
      let _ = _menhir_action_099 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1303 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1303: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> BLOCK_LENGTH *)
      let _ = _menhir_action_098 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1304 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1304: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> BIMPLIES *)
      let _v = _menhir_action_799 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1305 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1305: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> BIFF *)
      let _v = _menhir_action_798 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1306 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1306: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> BASE_ADDR *)
      let _ = _menhir_action_097 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1307 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1307: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> AUTOMATIC *)
      let _ = _menhir_action_095 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1308 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1308: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> AT *)
      let _ = _menhir_action_096 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1309 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1309: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> ARROW *)
      let _v = _menhir_action_797 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1310 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1310: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> AND *)
      let _v = _menhir_action_796 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1311 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1311: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production wildcard -> AMP *)
      let _v = _menhir_action_795 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1312 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1312: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> ALLOCATION *)
      let _ = _menhir_action_094 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_1313 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1313: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production bs_keyword -> ALLOCABLE *)
      let _ = _menhir_action_093 () in
      _menhir_goto_bs_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok
  
  and _menhir_run_0107 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 107: *)
      (* Reducing production non_logic_keyword -> is_acsl_spec *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_576 _1 in
      _menhir_goto_non_logic_keyword _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1354 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1354: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production stmt_markup -> INT_CONSTANT *)
      let _1 = _v in
      let _v = _menhir_action_649 _1 in
      _menhir_goto_stmt_markup _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_stmt_markup_attr : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState1357 ->
          _menhir_run_1358 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState1353 ->
          _menhir_run_1355 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1358 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_stmt_markup -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 1358: *)
      let MenhirCell1_stmt_markup (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production stmt_markup_attr -> stmt_markup stmt_markup_attr *)
      let _2 = _v in
      let _v = _menhir_action_651 _1 _2 in
      _menhir_goto_stmt_markup_attr _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_1355 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_EXT_AT -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 1355: *)
      (* The current token is COLON. *)
      (* Shifting (COLON) to state 1356 *)
      (* State 1356: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_EXT_AT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ext_at_stmt_markup -> EXT_AT stmt_markup_attr COLON *)
      let _2 = _v in
      let _v = _menhir_action_228 _2 in
      _menhir_goto_ext_at_stmt_markup _menhir_stack _menhir_lexbuf _menhir_lexer _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_ext_at_stmt_markup : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1348 ->
          _menhir_run_1401 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState1399 ->
          _menhir_run_1401 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState1373 ->
          _menhir_run_1382 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | MenhirState1377 ->
          _menhir_run_1382 _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1401 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 1401: *)
      let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | SLICE ->
          (* Shifting (SLICE) to state 851 *)
          _menhir_run_0851 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | LOOP ->
          (* Shifting (LOOP) to state 887 *)
          _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 934 *)
          _menhir_run_0934 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | IMPACT ->
          (* Shifting (IMPACT) to state 950 *)
          _menhir_run_0950 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | IDENTIFIER _v_0 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1401
      | FOR ->
          (* Shifting (FOR) to state 962 *)
          _menhir_run_0962 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | EXT_CODE_ANNOT _v_1 ->
          (* Shifting (EXT_CODE_ANNOT) to state 1030 *)
          _menhir_run_1030 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1401
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 1360 *)
          _menhir_run_1360 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 1004 *)
          _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 1033 *)
          _menhir_run_1033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | CHECK ->
          (* Shifting (CHECK) to state 1036 *)
          _menhir_run_1036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 1159 *)
          _menhir_run_1159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | ASSERT ->
          (* Shifting (ASSERT) to state 1039 *)
          _menhir_run_1039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 1008 *)
          _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 1042 *)
          _menhir_run_1042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | ADMIT ->
          (* Shifting (ADMIT) to state 1045 *)
          _menhir_run_1045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1401
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0851 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 851: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_SLICE (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 852 *)
          (* State 852: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_PRAGMA (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState0852 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0934 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 934: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_INVARIANT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0934 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0950 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 950: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_IMPACT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 951 *)
          (* State 951: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_PRAGMA (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState0951 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0962 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 962: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_FOR (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState0962 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 9 *)
          _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 13 *)
          _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 16 *)
          _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 17 *)
          _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 18 *)
          _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 25 *)
          _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 26 *)
          _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 27 *)
          _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 28 *)
          _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 29 *)
          _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 31 *)
          _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 32 *)
          _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 34 *)
          _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 37 *)
          _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 38 *)
          _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 39 *)
          _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 42 *)
          _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 43 *)
          _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 47 *)
          _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
          _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 49 *)
          _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 51 *)
          _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 52 *)
          _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 60 *)
          _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 73 *)
          _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 81 *)
          _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 82 *)
          _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 83 *)
          _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 85 *)
          _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 96 *)
          _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1030 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 1030: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_EXT_CODE_ANNOT (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1030
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1030
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | STRING_LITERAL _v_2 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1030
      | STRING_CONSTANT _v_3 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState1030
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | NOTHING ->
          (* Shifting (NOTHING) to state 902 *)
          _menhir_run_0902 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INT_CONSTANT _v_4 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState1030
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | IDENTIFIER _v_5 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState1030
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FLOAT_CONSTANT _v_6 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState1030
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | EXT_GLOBAL_BLOCK _v_7 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState1030
      | EXT_GLOBAL _v_8 ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState1030
      | EXT_CONTRACT _v_9 ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState1030
      | EXT_CODE_ANNOT _v_10 ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState1030
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1030
      | SEMICOLON ->
          (* Reducing production extension_content -> *)
          let _v_11 = _menhir_action_275 () in
          _menhir_run_1031 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1033 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1033: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CHECK_INVARIANT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1033 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1036 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1036: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_CHECK (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1036 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1159 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1159: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      (* Reducing production annotation -> BSGHOST *)
      let (_endpos__1_, _startpos__1_) = (_endpos, _startpos) in
      let _v = _menhir_action_045 _endpos__1_ _startpos__1_ in
      _menhir_goto_annotation _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1039 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1039: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ASSERT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1039 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1042 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1042: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ADMIT_INVARIANT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1042 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1045 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s ->
      (* State 1045: *)
      let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _menhir_stack = MenhirCell1_ADMIT (_menhir_stack, _menhir_s, _startpos, _endpos) in
      let _menhir_s = MenhirState1045 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1382 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _startpos _v _menhir_s _tok ->
      (* State 1382: *)
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | SLICE ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (SLICE) to state 851 *)
          _menhir_run_0851 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | READS ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | LOOP ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (LOOP) to state 887 *)
          _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | LABEL ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (INVARIANT) to state 934 *)
          _menhir_run_0934 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | IMPACT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (IMPACT) to state 950 *)
          _menhir_run_0950 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | IDENTIFIER _v_0 ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1382
      | FOR ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (FOR) to state 962 *)
          _menhir_run_0962 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | EXT_CODE_ANNOT _v_1 ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 1030 *)
          _menhir_run_1030 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1382
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (CONTRACT) to state 1360 *)
          _menhir_run_1360 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (CHECK_LOOP) to state 1004 *)
          _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (CHECK_INVARIANT) to state 1033 *)
          _menhir_run_1033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | CHECK ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (CHECK) to state 1036 *)
          _menhir_run_1036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | BSGHOST ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (BSGHOST) to state 1159 *)
          _menhir_run_1159 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | ASSERT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (ASSERT) to state 1039 *)
          _menhir_run_1039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (ADMIT_LOOP) to state 1008 *)
          _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (ADMIT_INVARIANT) to state 1042 *)
          _menhir_run_1042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | ADMIT ->
          let _menhir_stack = MenhirCell1_ext_at_stmt_markup (_menhir_stack, _menhir_s, _v, _startpos) in
          (* Shifting (ADMIT) to state 1045 *)
          _menhir_run_1045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1382
      | EOF | FUNCTION | MODULE ->
          (* Reducing production ext_function_specs -> ext_at_stmt_markup *)
          let _v = _menhir_action_242 () in
          _menhir_goto_ext_function_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1352 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1352: *)
      (* Reducing production ext_identifier -> any_identifier *)
      let _1 = _v in
      let _v = _menhir_action_261 _1 in
      _menhir_goto_ext_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_ext_identifier : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1365 ->
          _menhir_run_1366 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1360 ->
          _menhir_run_1363 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1349 ->
          _menhir_run_1350 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1366 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_MODULE -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1366: *)
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1367 *)
          (* State 1367: *)
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_MODULE (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
          (* Reducing production ext_module_markup -> MODULE ext_identifier COLON *)
          let _2 = _v in
          let _v = _menhir_action_264 _2 in
          (* State 1368: *)
          let _menhir_stack = MenhirCell1_ext_module_markup (_menhir_stack, _menhir_s, _v) in
          (match (_tok : MenhirBasics.token) with
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 2 *)
              _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | TYPE ->
              (* Shifting (TYPE) to state 760 *)
              _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 857 *)
              _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | MODEL ->
              (* Shifting (MODEL) to state 879 *)
              _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | LOGIC ->
              (* Shifting (LOGIC) to state 920 *)
              _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | LEMMA ->
              (* Shifting (LEMMA) to state 929 *)
              _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 937 *)
              _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 1333 *)
              _menhir_run_1333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 1336 *)
              _menhir_run_1336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 1342 *)
              _menhir_run_1342 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | EXT_GLOBAL_BLOCK _v_0 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
              _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1368
          | EXT_GLOBAL _v_1 ->
              (* Shifting (EXT_GLOBAL) to state 1146 *)
              _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1368
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 1154 *)
              _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 1160 *)
              _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | AXIOM ->
              (* Shifting (AXIOM) to state 1195 *)
              _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 1184 *)
              _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1368
          | EOF | FUNCTION | MODULE ->
              (* Reducing production ext_global_clauses_opt -> *)
              let _v_2 = _menhir_action_253 () in
              _menhir_run_1369 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1368 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1363 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_CONTRACT -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1363: *)
      (* Reducing production ext_identifier_opt -> ext_identifier *)
      let _1 = _v in
      let _v = _menhir_action_263 _1 in
      _menhir_goto_ext_identifier_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
  
  and _menhir_run_1350 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_FUNCTION -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1350: *)
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1351 *)
          (* State 1351: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_FUNCTION (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production ext_function_markup -> FUNCTION ext_identifier COLON *)
          let (_2, _endpos__3_) = (_v, _endpos) in
          let _v = _menhir_action_239 _2 _endpos__3_ _startpos__1_ in
          (* State 1373: *)
          let _menhir_stack = MenhirCell1_ext_function_markup (_menhir_stack, _menhir_s, _v) in
          (match (_tok : MenhirBasics.token) with
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 2 *)
              _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | TYPE ->
              (* Shifting (TYPE) to state 760 *)
              _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 857 *)
              _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | MODEL ->
              (* Shifting (MODEL) to state 879 *)
              _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | LOGIC ->
              (* Shifting (LOGIC) to state 920 *)
              _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | LEMMA ->
              (* Shifting (LEMMA) to state 929 *)
              _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 937 *)
              _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 1333 *)
              _menhir_run_1333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 1336 *)
              _menhir_run_1336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 1342 *)
              _menhir_run_1342 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | EXT_GLOBAL_BLOCK _v_0 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
              _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1373
          | EXT_GLOBAL _v_1 ->
              (* Shifting (EXT_GLOBAL) to state 1146 *)
              _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1373
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 1353 *)
              _menhir_run_1353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 1360 *)
              _menhir_run_1360 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 1154 *)
              _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 1160 *)
              _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | AXIOM ->
              (* Shifting (AXIOM) to state 1195 *)
              _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 1184 *)
              _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1373
          | EOF | FUNCTION | MODULE ->
              (* Reducing production ext_function_specs_opt -> *)
              let _v = _menhir_action_245 () in
              _menhir_goto_ext_function_specs_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1343 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_EXT_LET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1343: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          (* Shifting (EQUAL) to state 1344 *)
          (* State 1344: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1344 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1338 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_GLOBAL _menhir_cell0_EXT_LET as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1338: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | EQUAL ->
          (* Shifting (EQUAL) to state 1339 *)
          (* State 1339: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_EQUAL (_menhir_stack, _startpos, _endpos) in
          let _menhir_s = MenhirState1339 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1316 : type  ttv_stack. ttv_stack -> _ -> _ -> (ttv_stack, _menhir_box_annot) _menhir_state -> _ -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s _tok ->
      (* State 1316: *)
      (* Reducing production wildcard -> any_identifier *)
      let _v = _menhir_action_793 () in
      _menhir_goto_wildcard _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1161 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_AXIOMATIC as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1161: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 1162 *)
          (* State 1162: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LBRACE (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | TYPE ->
              (* Shifting (TYPE) to state 1163 *)
              _menhir_run_1163 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 1166 *)
              _menhir_run_1166 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | LOGIC ->
              (* Shifting (LOGIC) to state 1173 *)
              _menhir_run_1173 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | LEMMA ->
              (* Shifting (LEMMA) to state 929 *)
              _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 937 *)
              _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 1154 *)
              _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 1160 *)
              _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | AXIOM ->
              (* Shifting (AXIOM) to state 1179 *)
              _menhir_run_1179 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 1184 *)
              _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1162
          | RBRACE ->
              (* Reducing production logic_decls -> *)
              let _v_1 = _menhir_action_494 () in
              _menhir_run_1190 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1144 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_EXT_GLOBAL_BLOCK as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1144: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | LBRACE ->
          (* Shifting (LBRACE) to state 1145 *)
          (* State 1145: *)
          let _startpos_0 = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LBRACE (_menhir_stack, _startpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | EXT_GLOBAL_BLOCK _v_1 ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
              _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState1145
          | EXT_GLOBAL _v_2 ->
              (* Shifting (EXT_GLOBAL) to state 1146 *)
              _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState1145
          | RBRACE ->
              (* Reducing production ext_decls -> *)
              let _v_3 = _menhir_action_233 () in
              _menhir_run_1149 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1029 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1029: *)
      (* Reducing production behavior_name -> any_identifier *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_081 _1 in
      _menhir_goto_behavior_name _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_behavior_name : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1086 ->
          _menhir_run_1087 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_1026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_1026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1116 ->
          _menhir_run_1026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_1026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1001 ->
          _menhir_run_1026 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1087 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_BEHAVIOR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1087: *)
      let _menhir_stack = MenhirCell1_behavior_name (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1088 *)
          (* State 1088: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 1089 *)
              _menhir_run_1089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1088
          | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_REQUIRES | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | REQUIRES | RETURNS | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production assumes -> *)
              let _v_1 = _menhir_action_062 () in
              _menhir_run_1097 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _v_1 MenhirState1088 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1026 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1026: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_behavior_name (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMMA) to state 1027 *)
          (* State 1027: *)
          let _menhir_s = MenhirState1027 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | ASSIGNS | ASSUMES | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON | COMPLETE | CONTINUES | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FREES | REQUIRES | RETURNS | SEMICOLON ->
          (* Reducing production ne_behavior_name_list -> behavior_name *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_529 _1 in
          _menhir_goto_ne_behavior_name_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_behavior_name_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1116 ->
          _menhir_run_1117 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1110 ->
          _menhir_run_1111 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState1027 ->
          _menhir_run_1028 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok
      | MenhirState1001 ->
          _menhir_run_1002 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0962 ->
          _menhir_run_0963 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1117 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_COMPLETE _menhir_cell0_BEHAVIORS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1117: *)
      match (_tok : MenhirBasics.token) with
      | RETURNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | FREES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | EXT_CONTRACT _v_0 ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1117
      | EXITS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | EOF ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ENSURES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | DECREASES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | BREAKS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1117
      | SEMICOLON ->
          (* Reducing production behavior_name_list -> ne_behavior_name_list *)
          let _1 = _v in
          let _v = _menhir_action_083 _1 in
          _menhir_goto_behavior_name_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_behavior_name_list : type  ttv_stack ttv_result. (ttv_stack _menhir_cell0_BEHAVIORS as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState1116 ->
          _menhir_run_1119 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState1110 ->
          _menhir_run_1113 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1111 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_DISJOINT _menhir_cell0_BEHAVIORS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1111: *)
      match (_tok : MenhirBasics.token) with
      | RETURNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 976 *)
          _menhir_run_0976 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | FREES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREES) to state 977 *)
          _menhir_run_0977 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | EXT_CONTRACT _v_0 ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 978 *)
          _menhir_run_0978 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState1111
      | EXITS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | EOF ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EOF) to state 979 *)
          _menhir_run_0979 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ENSURES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 980 *)
          _menhir_run_0980 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | DECREASES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 981 *)
          _menhir_run_0981 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 982 *)
          _menhir_run_0982 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_REQUIRES) to state 983 *)
          _menhir_run_0983 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 984 *)
          _menhir_run_0984 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 985 *)
          _menhir_run_0985 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 986 *)
          _menhir_run_0986 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | BREAKS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 987 *)
          _menhir_run_0987 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 988 *)
          _menhir_run_0988 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 989 *)
          _menhir_run_0989 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 990 *)
          _menhir_run_0990 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_REQUIRES) to state 991 *)
          _menhir_run_0991 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 992 *)
          _menhir_run_0992 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 993 *)
          _menhir_run_0993 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 994 *)
          _menhir_run_0994 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1111
      | SEMICOLON ->
          (* Reducing production behavior_name_list -> ne_behavior_name_list *)
          let _1 = _v in
          let _v = _menhir_action_083 _1 in
          _menhir_goto_behavior_name_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_1028 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_behavior_name -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 1028: *)
      let MenhirCell1_behavior_name (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production ne_behavior_name_list -> behavior_name COMMA ne_behavior_name_list *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_530 _1 _3 in
      _menhir_goto_ne_behavior_name_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_1002 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 1002: *)
      let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 1003 *)
          (* State 1003: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState1003 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0963 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_FOR as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 963: *)
      let _menhir_stack = MenhirCell1_ne_behavior_name_list (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 964 *)
          (* State 964: *)
          let _endpos_0 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos_0) in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 965 *)
              _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | LOOP ->
              (* Shifting (LOOP) to state 887 *)
              _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 934 *)
              _menhir_run_0934 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | FOR ->
              (* Shifting (FOR) to state 1001 *)
              _menhir_run_1001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | EXT_CODE_ANNOT _v_1 ->
              (* Shifting (EXT_CODE_ANNOT) to state 1030 *)
              _menhir_run_1030 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0964
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 968 *)
              _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 1004 *)
              _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 1033 *)
              _menhir_run_1033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | CHECK ->
              (* Shifting (CHECK) to state 1036 *)
              _menhir_run_1036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | ASSERT ->
              (* Shifting (ASSERT) to state 1039 *)
              _menhir_run_1039 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 971 *)
              _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 1008 *)
              _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 1042 *)
              _menhir_run_1042 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | ADMIT ->
              (* Shifting (ADMIT) to state 1045 *)
              _menhir_run_1045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0964
          | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_LEMMA | ADMIT_RETURNS | ALLOCATES | ASSIGNS | AXIOM | AXIOMATIC | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_LEMMA | CHECK_RETURNS | COMPLETE | CONTINUES | CONTRACT | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_AT | EXT_CONTRACT _ | EXT_GLOBAL _ | EXT_GLOBAL_BLOCK _ | EXT_LET | FREES | FUNCTION | GLOBAL | INCLUDE | INDUCTIVE | LEMMA | LOGIC | MODEL | MODULE | PREDICATE | RETURNS | TERMINATES | TYPE | VOLATILE ->
              (* Reducing production requires -> *)
              let _v_2 = _menhir_action_629 () in
              _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_0 _endpos_0 _v_2 MenhirState0964 _tok
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0958 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_GLOBAL _menhir_cell0_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 958: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Shifting (COLON) to state 959 *)
          (* State 959: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _menhir_stack = MenhirCell0_COLON (_menhir_stack, _endpos) in
          let _menhir_s = MenhirState0959 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WSTRING_CONSTANT _v ->
              (* Shifting (WSTRING_CONSTANT) to state 3 *)
              _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 6 *)
              _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_READ ->
              (* Shifting (VALID_READ) to state 7 *)
              _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_RANGE ->
              (* Shifting (VALID_RANGE) to state 116 *)
              _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_INDEX ->
              (* Shifting (VALID_INDEX) to state 119 *)
              _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID_FUNCTION ->
              (* Shifting (VALID_FUNCTION) to state 122 *)
              _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VALID ->
              (* Shifting (VALID) to state 124 *)
              _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNALLOCATED ->
              (* Shifting (UNALLOCATED) to state 127 *)
              _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPEOF ->
              (* Shifting (TYPEOF) to state 128 *)
              _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 130 *)
              _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TRUE ->
              (* Shifting (TRUE) to state 131 *)
              _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TILDE ->
              (* Shifting (TILDE) to state 132 *)
              _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 322 *)
              _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRING_LITERAL _v ->
              (* Shifting (STRING_LITERAL) to state 136 *)
              _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STRING_CONSTANT _v ->
              (* Shifting (STRING_CONSTANT) to state 137 *)
              _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 324 *)
              _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STAR ->
              (* Shifting (STAR) to state 139 *)
              _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 325 *)
              _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 326 *)
              _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SEPARATED ->
              (* Shifting (SEPARATED) to state 329 *)
              _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 331 *)
              _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RESULT ->
              (* Shifting (RESULT) to state 332 *)
              _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 333 *)
              _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REGISTER ->
              (* Shifting (REGISTER) to state 334 *)
              _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 335 *)
              _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 336 *)
              _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PLUS ->
              (* Shifting (PLUS) to state 337 *)
              _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PI ->
              (* Shifting (PI) to state 338 *)
              _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OLD ->
              (* Shifting (OLD) to state 339 *)
              _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OFFSET ->
              (* Shifting (OFFSET) to state 341 *)
              _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | OBJECT_POINTER ->
              (* Shifting (OBJECT_POINTER) to state 344 *)
              _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NULL ->
              (* Shifting (NULL) to state 347 *)
              _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | NOT ->
              (* Shifting (NOT) to state 348 *)
              _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 352 *)
              _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 353 *)
              _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MINUS ->
              (* Shifting (MINUS) to state 350 *)
              _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LSQUAREPIPE ->
              (* Shifting (LSQUAREPIPE) to state 351 *)
              _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LPAR ->
              (* Shifting (LPAR) to state 354 *)
              _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 356 *)
              _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 358 *)
              _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LET ->
              (* Shifting (LET) to state 359 *)
              _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 365 *)
              _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LBRACE ->
              (* Shifting (LBRACE) to state 366 *)
              _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LAMBDA ->
              (* Shifting (LAMBDA) to state 368 *)
              _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 391 *)
              _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT_CONSTANT _v ->
              (* Shifting (INT_CONSTANT) to state 392 *)
              _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | INTER ->
              (* Shifting (INTER) to state 393 *)
              _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INITIALIZED ->
              (* Shifting (INITIALIZED) to state 395 *)
              _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 398 *)
              _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 399 *)
              _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 400 *)
              _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 401 *)
              _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 402 *)
              _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FRESH ->
              (* Shifting (FRESH) to state 403 *)
              _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 407 *)
              _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREEABLE ->
              (* Shifting (FREEABLE) to state 408 *)
              _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FORALL ->
              (* Shifting (FORALL) to state 411 *)
              _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT_CONSTANT _v ->
              (* Shifting (FLOAT_CONSTANT) to state 414 *)
              _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FALSE ->
              (* Shifting (FALSE) to state 415 *)
              _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 416 *)
              _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
              _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 418 *)
              _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 419 *)
              _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 420 *)
              _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 421 *)
              _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 422 *)
              _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXISTS ->
              (* Shifting (EXISTS) to state 423 *)
              _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 426 *)
              _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EMPTY ->
              (* Shifting (EMPTY) to state 427 *)
              _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DYNAMIC ->
              (* Shifting (DYNAMIC) to state 428 *)
              _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 429 *)
              _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 430 *)
              _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DANGLING ->
              (* Shifting (DANGLING) to state 431 *)
              _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 434 *)
              _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 435 *)
              _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 436 *)
              _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 437 *)
              _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSUNION ->
              (* Shifting (BSUNION) to state 438 *)
              _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BSTYPE ->
              (* Shifting (BSTYPE) to state 440 *)
              _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 446 *)
              _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BLOCK_LENGTH ->
              (* Shifting (BLOCK_LENGTH) to state 447 *)
              _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 450 *)
              _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BASE_ADDR ->
              (* Shifting (BASE_ADDR) to state 451 *)
              _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 454 *)
              _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 455 *)
              _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AUTOMATIC ->
              (* Shifting (AUTOMATIC) to state 456 *)
              _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AT ->
              (* Shifting (AT) to state 457 *)
              _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 459 *)
              _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 460 *)
              _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 461 *)
              _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AMP ->
              (* Shifting (AMP) to state 462 *)
              _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATION ->
              (* Shifting (ALLOCATION) to state 463 *)
              _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 466 *)
              _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCABLE ->
              (* Shifting (ALLOCABLE) to state 467 *)
              _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 470 *)
              _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0952 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_IMPACT _menhir_cell0_PRAGMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 952: *)
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0952
      | WRITES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VOID ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VALID_READ ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VALID_RANGE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VALID_INDEX ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VALID_FUNCTION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | VALID ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | UNSIGNED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | UNION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | UNALLOCATED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | TYPEOF ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | TYPENAME _v_1 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0952
      | TYPE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | TRUE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | TILDE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | STRUCT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | STRING_LITERAL _v_2 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0952
      | STRING_CONSTANT _v_3 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0952
      | STATIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | STAR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | SLICE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | SIZEOF ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | SIGNED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | SHORT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | SEPARATED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 953 *)
          (* State 953: *)
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_PRAGMA (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_IMPACT (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production impact_pragma -> IMPACT PRAGMA any_identifier SEMICOLON *)
          let (_endpos__4_, _3) = (_endpos_4, _v) in
          let _v = _menhir_action_335 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_impact_pragma _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | RETURNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | RESULT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | REGISTER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | REAL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | READS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | PLUS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | PI ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | OLD ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | OFFSET ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | OBJECT_POINTER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | NULL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | NOT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | MODULE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | MODEL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | MINUS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LSQUAREPIPE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LPAR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LOOP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LONG ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LOGIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LET ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LEMMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LBRACE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LAMBDA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | LABEL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INT_CONSTANT _v_5 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState0952
      | INTER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INTEGER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INITIALIZED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | IMPACT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | IF ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | IDENTIFIER _v_6 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState0952
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FRESH ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FREES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FREEABLE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FORALL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FOR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FLOAT_CONSTANT _v_7 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState0952
      | FLOAT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | FALSE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | EXT_GLOBAL_BLOCK _v_8 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0952
      | EXT_GLOBAL _v_9 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0952
      | EXT_CONTRACT _v_10 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState0952
      | EXT_CODE_ANNOT _v_11 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState0952
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | EXITS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | EXISTS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ENUM ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ENSURES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | EMPTY ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ELSE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | DYNAMIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | DECREASES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | DANGLING ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CONST ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHECK ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CHAR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | CASE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BSUNION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BSTYPE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BREAKS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BOOLEAN ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BOOL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BLOCK_LENGTH ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | BASE_ADDR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | AXIOM ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | AUTOMATIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | AT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ASSERT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | AMP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ALLOCATION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ALLOCABLE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | ADMIT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0952
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0895 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_LOOP, ttv_result) _menhir_cell1_PRAGMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 895: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0895
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | TYPENAME _v_1 ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0895
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | STRING_LITERAL _v_2 ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0895
      | STRING_CONSTANT _v_3 ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0895
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INT_CONSTANT _v_4 ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_4 MenhirState0895
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | IDENTIFIER _v_5 ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState0895
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FLOAT_CONSTANT _v_6 ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState0895
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | EXT_GLOBAL_BLOCK _v_7 ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState0895
      | EXT_GLOBAL _v_8 ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0895
      | EXT_CONTRACT _v_9 ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0895
      | EXT_CODE_ANNOT _v_10 ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState0895
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0895
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0893 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_FOR -> _ -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _v _tok ->
      (* State 893: *)
      let MenhirCell1_FOR (_menhir_stack, _, _, _) = _menhir_stack in
      let MenhirCell1_lexpr (_menhir_stack, _menhir_s, _1, _startpos__1_, _) = _menhir_stack in
      (* Reducing production variant -> lexpr FOR any_identifier *)
      let (_endpos__3_, _3) = (_endpos, _v) in
      let _v = _menhir_action_788 _1 _3 in
      _menhir_goto_variant _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_run_0853 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_SLICE _menhir_cell0_PRAGMA as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 853: *)
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v_0 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0 MenhirState0853
      | WRITES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VOLATILE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VOID ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VALID_READ ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VALID_RANGE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VALID_INDEX ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VALID_FUNCTION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | VALID ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | UNSIGNED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | UNION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | UNALLOCATED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | TYPEOF ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | TYPENAME _v_1 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v_1 MenhirState0853
      | TYPE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | TRUE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | TILDE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | TERMINATES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | STRUCT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | STRING_LITERAL _v_2 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v_2 MenhirState0853
      | STRING_CONSTANT _v_3 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v_3 MenhirState0853
      | STATIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | STAR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | SLICE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | SIZEOF ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | SIGNED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | SHORT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | SEPARATED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | SEMICOLON ->
          (* Shifting (SEMICOLON) to state 854 *)
          (* State 854: *)
          let _endpos_4 = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell0_PRAGMA (_menhir_stack, _, _) = _menhir_stack in
          let MenhirCell1_SLICE (_menhir_stack, _menhir_s, _startpos__1_, _) = _menhir_stack in
          (* Reducing production slice_pragma -> SLICE PRAGMA any_identifier SEMICOLON *)
          let (_endpos__4_, _3) = (_endpos_4, _v) in
          let _v = _menhir_action_640 _3 _endpos__4_ _startpos__1_ in
          _menhir_goto_slice_pragma _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__4_ _startpos__1_ _v _menhir_s _tok
      | RETURNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | RESULT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | REQUIRES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | REGISTER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | REAL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | READS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | PREDICATE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | PRAGMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | PLUS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | PI ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | OLD ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | OFFSET ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | OBJECT_POINTER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | NULL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | NOT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | MODULE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | MODEL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | MINUS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LSQUAREPIPE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LPAR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LOOP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LONG ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LOGIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LET ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LEMMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LBRACE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LAMBDA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | LABEL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INVARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INT_CONSTANT _v_5 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v_5 MenhirState0853
      | INTER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INTEGER ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INITIALIZED ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INDUCTIVE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | INCLUDE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | IMPACT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | IF ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | IDENTIFIER _v_6 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v_6 MenhirState0853
      | GLOBAL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FRESH ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FREES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FREEABLE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FORALL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FOR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FLOAT_CONSTANT _v_7 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v_7 MenhirState0853
      | FLOAT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | FALSE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | EXT_LET ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | EXT_GLOBAL_BLOCK _v_8 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v_8 MenhirState0853
      | EXT_GLOBAL _v_9 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v_9 MenhirState0853
      | EXT_CONTRACT _v_10 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v_10 MenhirState0853
      | EXT_CODE_ANNOT _v_11 ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v_11 MenhirState0853
      | EXT_AT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | EXITS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | EXISTS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ENUM ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ENSURES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | EMPTY ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ELSE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | DYNAMIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | DOUBLE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | DISJOINT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | DECREASES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | DANGLING ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CONTRACT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CONTINUES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CONST ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | COMPLETE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_RETURNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_REQUIRES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_LOOP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_LEMMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_INVARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_EXITS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_ENSURES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_CONTINUES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK_BREAKS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHECK ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CHAR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | CASE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BSUNION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BSTYPE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BREAKS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BOOLEAN ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BOOL ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BLOCK_LENGTH ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BEHAVIORS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BEHAVIOR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | BASE_ADDR ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | AXIOMATIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | AXIOM ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | AUTOMATIC ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | AT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ASSUMES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ASSIGNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ASSERT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | AMP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ALLOCATION ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ALLOCATES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ALLOCABLE ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_RETURNS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_REQUIRES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_LOOP ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_LEMMA ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_INVARIANT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_EXITS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_ENSURES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_CONTINUES ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT_BREAKS ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | ADMIT ->
          let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0853
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0762 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_TYPE, ttv_result) _menhir_cell1_INVARIANT as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 762: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | LPAR ->
          (* Shifting (LPAR) to state 763 *)
          (* State 763: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LPAR (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0763 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 764 *)
              _menhir_run_0764 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 765 *)
              _menhir_run_0765 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 774 *)
              _menhir_run_0774 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 155 *)
              _menhir_run_0155 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 776 *)
              _menhir_run_0776 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 778 *)
              _menhir_run_0778 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 787 *)
              _menhir_run_0787 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 789 *)
              _menhir_run_0789 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 790 *)
              _menhir_run_0790 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 795 *)
              _menhir_run_0795 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 796 *)
              _menhir_run_0796 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 797 *)
              _menhir_run_0797 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 798 *)
              _menhir_run_0798 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 800 *)
              _menhir_run_0800 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 801 *)
              _menhir_run_0801 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 802 *)
              _menhir_run_0802 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 803 *)
              _menhir_run_0803 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0754 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_READS as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 754: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 751 *)
          _menhir_run_0751 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0754
      | READS ->
          (* Shifting (READS) to state 753 *)
          _menhir_run_0753 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0754
      | SEMICOLON ->
          (* Reducing production volatile_opt -> *)
          let _v_0 = _menhir_action_790 () in
          _menhir_run_0755 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0755 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_READS, ttv_result) _menhir_cell1_any_identifier -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 755: *)
      let MenhirCell1_any_identifier (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_READS (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production volatile_opt -> READS any_identifier volatile_opt *)
      let _3 = _v in
      let _v = _menhir_action_791 _2 _3 in
      _menhir_goto_volatile_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_goto_volatile_opt : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0750 ->
          _menhir_run_0757 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0752 ->
          _menhir_run_0756 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0754 ->
          _menhir_run_0755 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0756 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WRITES, ttv_result) _menhir_cell1_any_identifier -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 756: *)
      let MenhirCell1_any_identifier (_menhir_stack, _, _2, _, _) = _menhir_stack in
      let MenhirCell1_WRITES (_menhir_stack, _menhir_s, _, _) = _menhir_stack in
      (* Reducing production volatile_opt -> WRITES any_identifier volatile_opt *)
      let _3 = _v in
      let _v = _menhir_action_792 _2 _3 in
      _menhir_goto_volatile_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0752 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_WRITES as 'stack) -> _ -> _ -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 752: *)
      let _menhir_stack = MenhirCell1_any_identifier (_menhir_stack, _menhir_s, _v, _startpos, _endpos) in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 751 *)
          _menhir_run_0751 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0752
      | READS ->
          (* Shifting (READS) to state 753 *)
          _menhir_run_0753 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState0752
      | SEMICOLON ->
          (* Reducing production volatile_opt -> *)
          let _v_0 = _menhir_action_790 () in
          _menhir_run_0756 _menhir_stack _menhir_lexbuf _menhir_lexer _v_0
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0111 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 111: *)
      (* Reducing production label_name -> any_identifier *)
      let _1 = _v in
      let _v = _menhir_action_388 _1 in
      _menhir_goto_label_name _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_goto_label_name : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0574 ->
          _menhir_run_0575 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState0873 ->
          _menhir_run_0101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0102 ->
          _menhir_run_0101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | MenhirState0008 ->
          _menhir_run_0101 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0575 : type  ttv_stack ttv_result. (((ttv_stack, ttv_result) _menhir_cell1_AT _menhir_cell0_LPAR, ttv_result) _menhir_cell1_lexpr, ttv_result) _menhir_cell1_COMMA -> _ -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 575: *)
      match (_tok : MenhirBasics.token) with
      | RPAR ->
          (* Shifting (RPAR) to state 576 *)
          (* State 576: *)
          let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
          let _tok = _menhir_lexer _menhir_lexbuf in
          let MenhirCell1_COMMA (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_lexpr (_menhir_stack, _, _3, _, _) = _menhir_stack in
          let MenhirCell0_LPAR (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_AT (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
          (* Reducing production lexpr_inner -> AT LPAR lexpr COMMA label_name RPAR *)
          let (_endpos__6_, _5) = (_endpos, _v) in
          let _v = _menhir_action_457 _3 _5 _endpos__6_ _startpos__1_ in
          _menhir_goto_lexpr_inner _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__6_ _startpos__1_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0101 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 101: *)
      match (_tok : MenhirBasics.token) with
      | COMMA ->
          let _menhir_stack = MenhirCell1_label_name (_menhir_stack, _menhir_s, _v) in
          (* Shifting (COMMA) to state 102 *)
          (* State 102: *)
          let _menhir_s = MenhirState0102 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOLATILE ->
              (* Shifting (VOLATILE) to state 4 *)
              _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VOID ->
              (* Shifting (VOID) to state 5 *)
              _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 9 *)
              _menhir_run_0009 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNSIGNED ->
              (* Shifting (UNSIGNED) to state 10 *)
              _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | UNION ->
              (* Shifting (UNION) to state 11 *)
              _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPENAME _v ->
              (* Shifting (TYPENAME) to state 12 *)
              _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 13 *)
              _menhir_run_0013 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 14 *)
              _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STRUCT ->
              (* Shifting (STRUCT) to state 15 *)
              _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | STATIC ->
              (* Shifting (STATIC) to state 16 *)
              _menhir_run_0016 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 17 *)
              _menhir_run_0017 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIZEOF ->
              (* Shifting (SIZEOF) to state 18 *)
              _menhir_run_0018 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SIGNED ->
              (* Shifting (SIGNED) to state 19 *)
              _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SHORT ->
              (* Shifting (SHORT) to state 20 *)
              _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 21 *)
              _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 22 *)
              _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REAL ->
              (* Shifting (REAL) to state 23 *)
              _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 25 *)
              _menhir_run_0025 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 26 *)
              _menhir_run_0026 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 27 *)
              _menhir_run_0027 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 28 *)
              _menhir_run_0028 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 29 *)
              _menhir_run_0029 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LONG ->
              (* Shifting (LONG) to state 30 *)
              _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 31 *)
              _menhir_run_0031 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 32 *)
              _menhir_run_0032 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 34 *)
              _menhir_run_0034 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INTEGER ->
              (* Shifting (INTEGER) to state 35 *)
              _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INT ->
              (* Shifting (INT) to state 36 *)
              _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 37 *)
              _menhir_run_0037 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 38 *)
              _menhir_run_0038 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 39 *)
              _menhir_run_0039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IF ->
              (* Shifting (IF) to state 40 *)
              _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 42 *)
              _menhir_run_0042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 43 *)
              _menhir_run_0043 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 44 *)
              _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FOR ->
              (* Shifting (FOR) to state 45 *)
              _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FLOAT ->
              (* Shifting (FLOAT) to state 46 *)
              _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 47 *)
              _menhir_run_0047 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 48 *)
              _menhir_run_0048 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 49 *)
              _menhir_run_0049 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 50 *)
              _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 51 *)
              _menhir_run_0051 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 52 *)
              _menhir_run_0052 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 53 *)
              _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENUM ->
              (* Shifting (ENUM) to state 54 *)
              _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 55 *)
              _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ELSE ->
              (* Shifting (ELSE) to state 56 *)
              _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DOUBLE ->
              (* Shifting (DOUBLE) to state 57 *)
              _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 58 *)
              _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 59 *)
              _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 60 *)
              _menhir_run_0060 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 61 *)
              _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONST ->
              (* Shifting (CONST) to state 62 *)
              _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 63 *)
              _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_RETURNS ->
              (* Shifting (CHECK_RETURNS) to state 64 *)
              _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_REQUIRES ->
              (* Shifting (CHECK_REQUIRES) to state 65 *)
              _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LOOP ->
              (* Shifting (CHECK_LOOP) to state 66 *)
              _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_LEMMA ->
              (* Shifting (CHECK_LEMMA) to state 67 *)
              _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_INVARIANT ->
              (* Shifting (CHECK_INVARIANT) to state 68 *)
              _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_EXITS ->
              (* Shifting (CHECK_EXITS) to state 69 *)
              _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_ENSURES ->
              (* Shifting (CHECK_ENSURES) to state 70 *)
              _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_CONTINUES ->
              (* Shifting (CHECK_CONTINUES) to state 71 *)
              _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK_BREAKS ->
              (* Shifting (CHECK_BREAKS) to state 72 *)
              _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 73 *)
              _menhir_run_0073 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHAR ->
              (* Shifting (CHAR) to state 74 *)
              _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CASE ->
              (* Shifting (CASE) to state 75 *)
              _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 76 *)
              _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOLEAN ->
              (* Shifting (BOOLEAN) to state 77 *)
              _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BOOL ->
              (* Shifting (BOOL) to state 78 *)
              _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 80 *)
              _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 81 *)
              _menhir_run_0081 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 82 *)
              _menhir_run_0082 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 83 *)
              _menhir_run_0083 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 84 *)
              _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 85 *)
              _menhir_run_0085 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 86 *)
              _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_RETURNS ->
              (* Shifting (ADMIT_RETURNS) to state 87 *)
              _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_REQUIRES ->
              (* Shifting (ADMIT_REQUIRES) to state 88 *)
              _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LOOP ->
              (* Shifting (ADMIT_LOOP) to state 89 *)
              _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_LEMMA ->
              (* Shifting (ADMIT_LEMMA) to state 90 *)
              _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_INVARIANT ->
              (* Shifting (ADMIT_INVARIANT) to state 91 *)
              _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_EXITS ->
              (* Shifting (ADMIT_EXITS) to state 92 *)
              _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_ENSURES ->
              (* Shifting (ADMIT_ENSURES) to state 93 *)
              _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_CONTINUES ->
              (* Shifting (ADMIT_CONTINUES) to state 94 *)
              _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT_BREAKS ->
              (* Shifting (ADMIT_BREAKS) to state 95 *)
              _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 96 *)
              _menhir_run_0096 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | RBRACE ->
          (* Reducing production ne_label_list -> label_name *)
          let _1 = _v in
          let _v = _menhir_action_543 _1 in
          _menhir_goto_ne_label_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_goto_ne_label_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      match _menhir_s with
      | MenhirState0873 ->
          _menhir_run_0874 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | MenhirState0102 ->
          _menhir_run_0103 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | MenhirState0008 ->
          _menhir_run_0099 _menhir_stack _menhir_lexbuf _menhir_lexer _v
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_0874 : type  ttv_stack ttv_result. ((ttv_stack, ttv_result) _menhir_cell1_full_identifier _menhir_cell0_LBRACE as 'stack) -> _ -> _ -> _ -> ('stack, ttv_result) _menhir_state -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s ->
      (* State 874: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 875 *)
      (* State 875: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | LT ->
          let _menhir_stack = MenhirCell1_ne_label_list (_menhir_stack, _menhir_s, _v) in
          let _menhir_stack = MenhirCell0_RBRACE (_menhir_stack, _endpos) in
          (* Shifting (LT) to state 876 *)
          (* State 876: *)
          let _startpos = _menhir_lexbuf.Lexing.lex_start_p in
          let _menhir_stack = MenhirCell0_LT (_menhir_stack, _startpos) in
          let _menhir_s = MenhirState0876 in
          let _tok = _menhir_lexer _menhir_lexbuf in
          (match (_tok : MenhirBasics.token) with
          | WRITES ->
              (* Shifting (WRITES) to state 1 *)
              _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | VARIANT ->
              (* Shifting (VARIANT) to state 133 *)
              _menhir_run_0133 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TYPE ->
              (* Shifting (TYPE) to state 134 *)
              _menhir_run_0134 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | TERMINATES ->
              (* Shifting (TERMINATES) to state 135 *)
              _menhir_run_0135 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | SLICE ->
              (* Shifting (SLICE) to state 140 *)
              _menhir_run_0140 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | RETURNS ->
              (* Shifting (RETURNS) to state 156 *)
              _menhir_run_0156 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | REQUIRES ->
              (* Shifting (REQUIRES) to state 157 *)
              _menhir_run_0157 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | READS ->
              (* Shifting (READS) to state 24 *)
              _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PREDICATE ->
              (* Shifting (PREDICATE) to state 158 *)
              _menhir_run_0158 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | PRAGMA ->
              (* Shifting (PRAGMA) to state 159 *)
              _menhir_run_0159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODULE ->
              (* Shifting (MODULE) to state 160 *)
              _menhir_run_0160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | MODEL ->
              (* Shifting (MODEL) to state 161 *)
              _menhir_run_0161 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOOP ->
              (* Shifting (LOOP) to state 162 *)
              _menhir_run_0162 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LOGIC ->
              (* Shifting (LOGIC) to state 163 *)
              _menhir_run_0163 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LEMMA ->
              (* Shifting (LEMMA) to state 164 *)
              _menhir_run_0164 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | LABEL ->
              (* Shifting (LABEL) to state 33 *)
              _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INVARIANT ->
              (* Shifting (INVARIANT) to state 165 *)
              _menhir_run_0165 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INDUCTIVE ->
              (* Shifting (INDUCTIVE) to state 166 *)
              _menhir_run_0166 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | INCLUDE ->
              (* Shifting (INCLUDE) to state 167 *)
              _menhir_run_0167 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IMPACT ->
              (* Shifting (IMPACT) to state 168 *)
              _menhir_run_0168 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | IDENTIFIER _v ->
              (* Shifting (IDENTIFIER) to state 41 *)
              _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | GLOBAL ->
              (* Shifting (GLOBAL) to state 169 *)
              _menhir_run_0169 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FUNCTION ->
              (* Shifting (FUNCTION) to state 170 *)
              _menhir_run_0170 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | FREES ->
              (* Shifting (FREES) to state 171 *)
              _menhir_run_0171 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_LET ->
              (* Shifting (EXT_LET) to state 172 *)
              _menhir_run_0172 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXT_GLOBAL_BLOCK _v ->
              (* Shifting (EXT_GLOBAL_BLOCK) to state 173 *)
              _menhir_run_0173 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_GLOBAL _v ->
              (* Shifting (EXT_GLOBAL) to state 174 *)
              _menhir_run_0174 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CONTRACT _v ->
              (* Shifting (EXT_CONTRACT) to state 175 *)
              _menhir_run_0175 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_CODE_ANNOT _v ->
              (* Shifting (EXT_CODE_ANNOT) to state 176 *)
              _menhir_run_0176 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
          | EXT_AT ->
              (* Shifting (EXT_AT) to state 177 *)
              _menhir_run_0177 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | EXITS ->
              (* Shifting (EXITS) to state 178 *)
              _menhir_run_0178 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ENSURES ->
              (* Shifting (ENSURES) to state 179 *)
              _menhir_run_0179 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DISJOINT ->
              (* Shifting (DISJOINT) to state 180 *)
              _menhir_run_0180 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | DECREASES ->
              (* Shifting (DECREASES) to state 181 *)
              _menhir_run_0181 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTRACT ->
              (* Shifting (CONTRACT) to state 182 *)
              _menhir_run_0182 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CONTINUES ->
              (* Shifting (CONTINUES) to state 183 *)
              _menhir_run_0183 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | COMPLETE ->
              (* Shifting (COMPLETE) to state 184 *)
              _menhir_run_0184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | CHECK ->
              (* Shifting (CHECK) to state 185 *)
              _menhir_run_0185 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BREAKS ->
              (* Shifting (BREAKS) to state 186 *)
              _menhir_run_0186 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIORS ->
              (* Shifting (BEHAVIORS) to state 79 *)
              _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | BEHAVIOR ->
              (* Shifting (BEHAVIOR) to state 187 *)
              _menhir_run_0187 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOMATIC ->
              (* Shifting (AXIOMATIC) to state 188 *)
              _menhir_run_0188 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | AXIOM ->
              (* Shifting (AXIOM) to state 189 *)
              _menhir_run_0189 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSUMES ->
              (* Shifting (ASSUMES) to state 190 *)
              _menhir_run_0190 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSIGNS ->
              (* Shifting (ASSIGNS) to state 191 *)
              _menhir_run_0191 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ASSERT ->
              (* Shifting (ASSERT) to state 192 *)
              _menhir_run_0192 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ALLOCATES ->
              (* Shifting (ALLOCATES) to state 193 *)
              _menhir_run_0193 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | ADMIT ->
              (* Shifting (ADMIT) to state 194 *)
              _menhir_run_0194 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
          | _ ->
              (* Initiating error handling *)
              _eRR ())
      | COLON | EQUAL | LPAR | READS | SEMICOLON ->
          let MenhirCell0_LBRACE (_menhir_stack, _) = _menhir_stack in
          let MenhirCell1_full_identifier (_menhir_stack, _menhir_s, _1, _, _) = _menhir_stack in
          (* Reducing production poly_id -> full_identifier LBRACE ne_label_list RBRACE *)
          let _3 = _v in
          let _v = _menhir_action_593 _1 _3 in
          _menhir_goto_poly_id _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0103 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_label_name -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 103: *)
      let MenhirCell1_label_name (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ne_label_list -> label_name COMMA ne_label_list *)
      let _3 = _v in
      let _v = _menhir_action_544 _1 _3 in
      _menhir_goto_ne_label_list _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
  
  and _menhir_run_0099 : type  ttv_stack ttv_result. (ttv_stack, ttv_result) _menhir_cell1_LBRACE -> _ -> _ -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v ->
      (* State 99: *)
      (* The current token is RBRACE. *)
      (* Shifting (RBRACE) to state 100 *)
      (* State 100: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      let MenhirCell1_LBRACE (_menhir_stack, _menhir_s, _startpos__1_) = _menhir_stack in
      (* Reducing production opt_label_list -> LBRACE ne_label_list RBRACE *)
      let (_2, _endpos__3_) = (_v, _endpos) in
      let _v = _menhir_action_581 _2 in
      _menhir_goto_opt_label_list _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__3_ _startpos__1_ _v _menhir_s _tok
  
  and _menhir_goto_opt_label_list : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState0403 ->
          _menhir_run_0404 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0467 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0463 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0451 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0447 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0431 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0408 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0395 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0344 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0341 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0124 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0119 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0116 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | MenhirState0007 ->
          _menhir_run_0113 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_goto_ext_fun_specs : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      match _menhir_s with
      | MenhirState1399 ->
          _menhir_run_1400 _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok
      | MenhirState1348 ->
          _menhir_run_1397 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1400 : type  ttv_stack. (ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_fun_spec -> _ -> _ -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _tok ->
      (* State 1400: *)
      let MenhirCell1_ext_fun_spec (_menhir_stack, _menhir_s, _1) = _menhir_stack in
      (* Reducing production ext_fun_specs -> ext_fun_spec ext_fun_specs *)
      let _2 = _v in
      let _v = _menhir_action_238 _1 _2 in
      _menhir_goto_ext_fun_specs _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_1397 : type  ttv_stack. ((ttv_stack, _menhir_box_ext_spec) _menhir_cell1_ext_global_clauses_opt as 'stack) -> _ -> _ -> _ -> ('stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1397: *)
      match (_tok : MenhirBasics.token) with
      | FUNCTION ->
          let _menhir_stack = MenhirCell1_ext_fun_specs (_menhir_stack, _menhir_s, _v) in
          (* Shifting (FUNCTION) to state 1349 *)
          _menhir_run_1349 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1397
      | EOF | MODULE ->
          (* Reducing production ext_module_specs_opt -> ext_fun_specs *)
          let _1 = _v in
          let _v = _menhir_action_270 _1 in
          _menhir_goto_ext_module_specs_opt _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
      | _ ->
          _menhir_fail ()
  
  and _menhir_run_1379 : type  ttv_stack. ttv_stack -> _ -> _ -> _ -> (ttv_stack, _menhir_box_ext_spec) _menhir_state -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok ->
      (* State 1379: *)
      (* Reducing production ext_function_spec -> ext_fun_spec *)
      let _1 = _v in
      let _v = _menhir_action_241 _1 in
      _menhir_goto_ext_function_spec _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s _tok
  
  and _menhir_run_0496 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 496: *)
      match (_tok : MenhirBasics.token) with
      | COLON ->
          (* Reducing production any_identifier -> identifier *)
          let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_048 _1 in
          _menhir_goto_any_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_INVARIANT | ADMIT_LEMMA | ADMIT_LOOP | ADMIT_REQUIRES | ADMIT_RETURNS | ALLOCATES | AMP | AND | ARROW | ASSIGNS | ASSUMES | BEHAVIOR | BIFF | BIMPLIES | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_INVARIANT | CHECK_LEMMA | CHECK_LOOP | CHECK_REQUIRES | CHECK_RETURNS | COLON2 | COMMA | COMPLETE | CONTINUES | DECREASES | DISJOINT | DOT | DOTDOT | ENSURES | EOF | EQ | EQUAL | EXITS | EXT_CONTRACT _ | FOR | FREES | FROM | GE | GT | GTGT | HAT | HATHAT | IFF | IMPLIES | IN | LBRACE | LE | LPAR | LSQUARE | LT | LTLT | MINUS | NE | OR | PERCENT | PIPE | PLUS | QUESTION | RBRACE | READS | REQUIRES | RETURNS | RPAR | RSQUARE | RSQUAREPIPE | SEMICOLON | SLASH | STAR | STARHAT | WITH | WRITES ->
          (* Reducing production full_identifier -> identifier *)
          let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
          let _v = _menhir_action_281 id in
          _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  and _menhir_run_0198 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 198: *)
      (* Reducing production full_identifier -> identifier *)
      let (_endpos_id_, _startpos_id_, id) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_281 id in
      _menhir_goto_full_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos_id_ _startpos_id_ _v _menhir_s _tok
  
  and _menhir_run_0109 : type  ttv_stack ttv_result. ttv_stack -> _ -> _ -> _ -> _ -> _ -> (ttv_stack, ttv_result) _menhir_state -> _ -> ttv_result =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _startpos _v _menhir_s _tok ->
      (* State 109: *)
      (* Reducing production any_identifier -> identifier *)
      let (_endpos__1_, _startpos__1_, _1) = (_endpos, _startpos, _v) in
      let _v = _menhir_action_048 _1 in
      _menhir_goto_any_identifier _menhir_stack _menhir_lexbuf _menhir_lexer _endpos__1_ _startpos__1_ _v _menhir_s _tok
  
  let _menhir_run_0000 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_annot =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 0: *)
      let _menhir_s = MenhirState0000 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 2 *)
          _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 760 *)
          _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 14 *)
          _menhir_run_0014 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 851 *)
          _menhir_run_0851 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 21 *)
          _menhir_run_0021 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 22 *)
          _menhir_run_0022 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 857 *)
          _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 879 *)
          _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 887 *)
          _menhir_run_0887 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 920 *)
          _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 929 *)
          _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 934 *)
          _menhir_run_0934 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 937 *)
          _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 950 *)
          _menhir_run_0950 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 956 *)
          _menhir_run_0956 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 44 *)
          _menhir_run_0044 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 962 *)
          _menhir_run_0962 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
          _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 1146 *)
          _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 50 *)
          _menhir_run_0050 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 1030 *)
          _menhir_run_1030 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 53 *)
          _menhir_run_0053 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 55 *)
          _menhir_run_0055 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 58 *)
          _menhir_run_0058 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 59 *)
          _menhir_run_0059 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 61 *)
          _menhir_run_0061 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 63 *)
          _menhir_run_0063 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 1004 *)
          _menhir_run_1004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 1154 *)
          _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 1033 *)
          _menhir_run_1033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 1036 *)
          _menhir_run_1036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSGHOST ->
          (* Shifting (BSGHOST) to state 1159 *)
          _menhir_run_1159 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 76 *)
          _menhir_run_0076 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 80 *)
          _menhir_run_0080 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 1160 *)
          _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 1195 *)
          _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 84 *)
          _menhir_run_0084 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 1039 *)
          _menhir_run_1039 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 86 *)
          _menhir_run_0086 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 1008 *)
          _menhir_run_1008 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 1184 *)
          _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 1042 *)
          _menhir_run_1042 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 1045 *)
          _menhir_run_1045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  let _menhir_run_1332 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_ext_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 1332: *)
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 2 *)
          _menhir_run_0002 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | TYPE ->
          (* Shifting (TYPE) to state 760 *)
          _menhir_run_0760 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 857 *)
          _menhir_run_0857 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | MODEL ->
          (* Shifting (MODEL) to state 879 *)
          _menhir_run_0879 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | LOGIC ->
          (* Shifting (LOGIC) to state 920 *)
          _menhir_run_0920 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | LEMMA ->
          (* Shifting (LEMMA) to state 929 *)
          _menhir_run_0929 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 937 *)
          _menhir_run_0937 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 1333 *)
          _menhir_run_1333 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 1336 *)
          _menhir_run_1336 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 1342 *)
          _menhir_run_1342 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 1143 *)
          _menhir_run_1143 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1332
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 1146 *)
          _menhir_run_1146 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1332
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 1154 *)
          _menhir_run_1154 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 1160 *)
          _menhir_run_1160 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | AXIOM ->
          (* Shifting (AXIOM) to state 1195 *)
          _menhir_run_1195 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 1184 *)
          _menhir_run_1184 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1332
      | CONTRACT | EOF | EXT_AT | FUNCTION | MODULE ->
          (* Reducing production ext_global_clauses_opt -> *)
          let _v = _menhir_action_253 () in
          _menhir_run_1348 _menhir_stack _menhir_lexbuf _menhir_lexer _v MenhirState1332 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  let _menhir_run_1402 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_lexpr_eof =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 1402: *)
      let _menhir_s = MenhirState1402 in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | WSTRING_CONSTANT _v ->
          (* Shifting (WSTRING_CONSTANT) to state 3 *)
          _menhir_run_0003 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | WRITES ->
          (* Shifting (WRITES) to state 1 *)
          _menhir_run_0001 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOLATILE ->
          (* Shifting (VOLATILE) to state 4 *)
          _menhir_run_0004 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VOID ->
          (* Shifting (VOID) to state 5 *)
          _menhir_run_0005 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VARIANT ->
          (* Shifting (VARIANT) to state 6 *)
          _menhir_run_0006 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_READ ->
          (* Shifting (VALID_READ) to state 7 *)
          _menhir_run_0007 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_RANGE ->
          (* Shifting (VALID_RANGE) to state 116 *)
          _menhir_run_0116 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_INDEX ->
          (* Shifting (VALID_INDEX) to state 119 *)
          _menhir_run_0119 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID_FUNCTION ->
          (* Shifting (VALID_FUNCTION) to state 122 *)
          _menhir_run_0122 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | VALID ->
          (* Shifting (VALID) to state 124 *)
          _menhir_run_0124 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNSIGNED ->
          (* Shifting (UNSIGNED) to state 10 *)
          _menhir_run_0010 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNION ->
          (* Shifting (UNION) to state 11 *)
          _menhir_run_0011 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | UNALLOCATED ->
          (* Shifting (UNALLOCATED) to state 127 *)
          _menhir_run_0127 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPEOF ->
          (* Shifting (TYPEOF) to state 128 *)
          _menhir_run_0128 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TYPENAME _v ->
          (* Shifting (TYPENAME) to state 12 *)
          _menhir_run_0012 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | TYPE ->
          (* Shifting (TYPE) to state 130 *)
          _menhir_run_0130 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TRUE ->
          (* Shifting (TRUE) to state 131 *)
          _menhir_run_0131 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TILDE ->
          (* Shifting (TILDE) to state 132 *)
          _menhir_run_0132 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | TERMINATES ->
          (* Shifting (TERMINATES) to state 322 *)
          _menhir_run_0322 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRUCT ->
          (* Shifting (STRUCT) to state 15 *)
          _menhir_run_0015 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STRING_LITERAL _v ->
          (* Shifting (STRING_LITERAL) to state 136 *)
          _menhir_run_0136 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STRING_CONSTANT _v ->
          (* Shifting (STRING_CONSTANT) to state 137 *)
          _menhir_run_0137 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | STATIC ->
          (* Shifting (STATIC) to state 324 *)
          _menhir_run_0324 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | STAR ->
          (* Shifting (STAR) to state 139 *)
          _menhir_run_0139 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SLICE ->
          (* Shifting (SLICE) to state 325 *)
          _menhir_run_0325 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIZEOF ->
          (* Shifting (SIZEOF) to state 326 *)
          _menhir_run_0326 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SIGNED ->
          (* Shifting (SIGNED) to state 19 *)
          _menhir_run_0019 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SHORT ->
          (* Shifting (SHORT) to state 20 *)
          _menhir_run_0020 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | SEPARATED ->
          (* Shifting (SEPARATED) to state 329 *)
          _menhir_run_0329 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RETURNS ->
          (* Shifting (RETURNS) to state 331 *)
          _menhir_run_0331 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | RESULT ->
          (* Shifting (RESULT) to state 332 *)
          _menhir_run_0332 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 333 *)
          _menhir_run_0333 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REGISTER ->
          (* Shifting (REGISTER) to state 334 *)
          _menhir_run_0334 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | REAL ->
          (* Shifting (REAL) to state 23 *)
          _menhir_run_0023 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | READS ->
          (* Shifting (READS) to state 24 *)
          _menhir_run_0024 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PREDICATE ->
          (* Shifting (PREDICATE) to state 335 *)
          _menhir_run_0335 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PRAGMA ->
          (* Shifting (PRAGMA) to state 336 *)
          _menhir_run_0336 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PLUS ->
          (* Shifting (PLUS) to state 337 *)
          _menhir_run_0337 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | PI ->
          (* Shifting (PI) to state 338 *)
          _menhir_run_0338 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OLD ->
          (* Shifting (OLD) to state 339 *)
          _menhir_run_0339 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OFFSET ->
          (* Shifting (OFFSET) to state 341 *)
          _menhir_run_0341 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | OBJECT_POINTER ->
          (* Shifting (OBJECT_POINTER) to state 344 *)
          _menhir_run_0344 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NULL ->
          (* Shifting (NULL) to state 347 *)
          _menhir_run_0347 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | NOT ->
          (* Shifting (NOT) to state 348 *)
          _menhir_run_0348 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODULE ->
          (* Shifting (MODULE) to state 352 *)
          _menhir_run_0352 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MODEL ->
          (* Shifting (MODEL) to state 353 *)
          _menhir_run_0353 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | MINUS ->
          (* Shifting (MINUS) to state 350 *)
          _menhir_run_0350 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LSQUAREPIPE ->
          (* Shifting (LSQUAREPIPE) to state 351 *)
          _menhir_run_0351 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LPAR ->
          (* Shifting (LPAR) to state 354 *)
          _menhir_run_0354 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOOP ->
          (* Shifting (LOOP) to state 356 *)
          _menhir_run_0356 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LONG ->
          (* Shifting (LONG) to state 30 *)
          _menhir_run_0030 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LOGIC ->
          (* Shifting (LOGIC) to state 358 *)
          _menhir_run_0358 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LET ->
          (* Shifting (LET) to state 359 *)
          _menhir_run_0359 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LEMMA ->
          (* Shifting (LEMMA) to state 365 *)
          _menhir_run_0365 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LBRACE ->
          (* Shifting (LBRACE) to state 366 *)
          _menhir_run_0366 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LAMBDA ->
          (* Shifting (LAMBDA) to state 368 *)
          _menhir_run_0368 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | LABEL ->
          (* Shifting (LABEL) to state 33 *)
          _menhir_run_0033 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INVARIANT ->
          (* Shifting (INVARIANT) to state 391 *)
          _menhir_run_0391 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT_CONSTANT _v ->
          (* Shifting (INT_CONSTANT) to state 392 *)
          _menhir_run_0392 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | INTER ->
          (* Shifting (INTER) to state 393 *)
          _menhir_run_0393 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INTEGER ->
          (* Shifting (INTEGER) to state 35 *)
          _menhir_run_0035 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INT ->
          (* Shifting (INT) to state 36 *)
          _menhir_run_0036 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INITIALIZED ->
          (* Shifting (INITIALIZED) to state 395 *)
          _menhir_run_0395 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INDUCTIVE ->
          (* Shifting (INDUCTIVE) to state 398 *)
          _menhir_run_0398 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | INCLUDE ->
          (* Shifting (INCLUDE) to state 399 *)
          _menhir_run_0399 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IMPACT ->
          (* Shifting (IMPACT) to state 400 *)
          _menhir_run_0400 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IF ->
          (* Shifting (IF) to state 40 *)
          _menhir_run_0040 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | IDENTIFIER _v ->
          (* Shifting (IDENTIFIER) to state 41 *)
          _menhir_run_0041 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | GLOBAL ->
          (* Shifting (GLOBAL) to state 401 *)
          _menhir_run_0401 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FUNCTION ->
          (* Shifting (FUNCTION) to state 402 *)
          _menhir_run_0402 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FRESH ->
          (* Shifting (FRESH) to state 403 *)
          _menhir_run_0403 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREES ->
          (* Shifting (FREES) to state 407 *)
          _menhir_run_0407 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FREEABLE ->
          (* Shifting (FREEABLE) to state 408 *)
          _menhir_run_0408 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FORALL ->
          (* Shifting (FORALL) to state 411 *)
          _menhir_run_0411 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FOR ->
          (* Shifting (FOR) to state 45 *)
          _menhir_run_0045 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FLOAT_CONSTANT _v ->
          (* Shifting (FLOAT_CONSTANT) to state 414 *)
          _menhir_run_0414 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | FLOAT ->
          (* Shifting (FLOAT) to state 46 *)
          _menhir_run_0046 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | FALSE ->
          (* Shifting (FALSE) to state 415 *)
          _menhir_run_0415 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_LET ->
          (* Shifting (EXT_LET) to state 416 *)
          _menhir_run_0416 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXT_GLOBAL_BLOCK _v ->
          (* Shifting (EXT_GLOBAL_BLOCK) to state 417 *)
          _menhir_run_0417 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_GLOBAL _v ->
          (* Shifting (EXT_GLOBAL) to state 418 *)
          _menhir_run_0418 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CONTRACT _v ->
          (* Shifting (EXT_CONTRACT) to state 419 *)
          _menhir_run_0419 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_CODE_ANNOT _v ->
          (* Shifting (EXT_CODE_ANNOT) to state 420 *)
          _menhir_run_0420 _menhir_stack _menhir_lexbuf _menhir_lexer _v _menhir_s
      | EXT_AT ->
          (* Shifting (EXT_AT) to state 421 *)
          _menhir_run_0421 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXITS ->
          (* Shifting (EXITS) to state 422 *)
          _menhir_run_0422 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EXISTS ->
          (* Shifting (EXISTS) to state 423 *)
          _menhir_run_0423 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENUM ->
          (* Shifting (ENUM) to state 54 *)
          _menhir_run_0054 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ENSURES ->
          (* Shifting (ENSURES) to state 426 *)
          _menhir_run_0426 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | EMPTY ->
          (* Shifting (EMPTY) to state 427 *)
          _menhir_run_0427 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ELSE ->
          (* Shifting (ELSE) to state 56 *)
          _menhir_run_0056 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DYNAMIC ->
          (* Shifting (DYNAMIC) to state 428 *)
          _menhir_run_0428 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DOUBLE ->
          (* Shifting (DOUBLE) to state 57 *)
          _menhir_run_0057 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DISJOINT ->
          (* Shifting (DISJOINT) to state 429 *)
          _menhir_run_0429 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DECREASES ->
          (* Shifting (DECREASES) to state 430 *)
          _menhir_run_0430 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | DANGLING ->
          (* Shifting (DANGLING) to state 431 *)
          _menhir_run_0431 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTRACT ->
          (* Shifting (CONTRACT) to state 434 *)
          _menhir_run_0434 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONTINUES ->
          (* Shifting (CONTINUES) to state 435 *)
          _menhir_run_0435 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CONST ->
          (* Shifting (CONST) to state 62 *)
          _menhir_run_0062 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | COMPLETE ->
          (* Shifting (COMPLETE) to state 436 *)
          _menhir_run_0436 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_RETURNS ->
          (* Shifting (CHECK_RETURNS) to state 64 *)
          _menhir_run_0064 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 65 *)
          _menhir_run_0065 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LOOP ->
          (* Shifting (CHECK_LOOP) to state 66 *)
          _menhir_run_0066 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_LEMMA ->
          (* Shifting (CHECK_LEMMA) to state 67 *)
          _menhir_run_0067 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_INVARIANT ->
          (* Shifting (CHECK_INVARIANT) to state 68 *)
          _menhir_run_0068 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_EXITS ->
          (* Shifting (CHECK_EXITS) to state 69 *)
          _menhir_run_0069 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_ENSURES ->
          (* Shifting (CHECK_ENSURES) to state 70 *)
          _menhir_run_0070 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_CONTINUES ->
          (* Shifting (CHECK_CONTINUES) to state 71 *)
          _menhir_run_0071 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK_BREAKS ->
          (* Shifting (CHECK_BREAKS) to state 72 *)
          _menhir_run_0072 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHECK ->
          (* Shifting (CHECK) to state 437 *)
          _menhir_run_0437 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CHAR ->
          (* Shifting (CHAR) to state 74 *)
          _menhir_run_0074 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | CASE ->
          (* Shifting (CASE) to state 75 *)
          _menhir_run_0075 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSUNION ->
          (* Shifting (BSUNION) to state 438 *)
          _menhir_run_0438 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BSTYPE ->
          (* Shifting (BSTYPE) to state 440 *)
          _menhir_run_0440 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BREAKS ->
          (* Shifting (BREAKS) to state 446 *)
          _menhir_run_0446 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOLEAN ->
          (* Shifting (BOOLEAN) to state 77 *)
          _menhir_run_0077 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BOOL ->
          (* Shifting (BOOL) to state 78 *)
          _menhir_run_0078 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BLOCK_LENGTH ->
          (* Shifting (BLOCK_LENGTH) to state 447 *)
          _menhir_run_0447 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIORS ->
          (* Shifting (BEHAVIORS) to state 79 *)
          _menhir_run_0079 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BEHAVIOR ->
          (* Shifting (BEHAVIOR) to state 450 *)
          _menhir_run_0450 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | BASE_ADDR ->
          (* Shifting (BASE_ADDR) to state 451 *)
          _menhir_run_0451 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOMATIC ->
          (* Shifting (AXIOMATIC) to state 454 *)
          _menhir_run_0454 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AXIOM ->
          (* Shifting (AXIOM) to state 455 *)
          _menhir_run_0455 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AUTOMATIC ->
          (* Shifting (AUTOMATIC) to state 456 *)
          _menhir_run_0456 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AT ->
          (* Shifting (AT) to state 457 *)
          _menhir_run_0457 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSUMES ->
          (* Shifting (ASSUMES) to state 459 *)
          _menhir_run_0459 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSIGNS ->
          (* Shifting (ASSIGNS) to state 460 *)
          _menhir_run_0460 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ASSERT ->
          (* Shifting (ASSERT) to state 461 *)
          _menhir_run_0461 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | AMP ->
          (* Shifting (AMP) to state 462 *)
          _menhir_run_0462 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATION ->
          (* Shifting (ALLOCATION) to state 463 *)
          _menhir_run_0463 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCATES ->
          (* Shifting (ALLOCATES) to state 466 *)
          _menhir_run_0466 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ALLOCABLE ->
          (* Shifting (ALLOCABLE) to state 467 *)
          _menhir_run_0467 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_RETURNS ->
          (* Shifting (ADMIT_RETURNS) to state 87 *)
          _menhir_run_0087 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 88 *)
          _menhir_run_0088 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LOOP ->
          (* Shifting (ADMIT_LOOP) to state 89 *)
          _menhir_run_0089 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_LEMMA ->
          (* Shifting (ADMIT_LEMMA) to state 90 *)
          _menhir_run_0090 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_INVARIANT ->
          (* Shifting (ADMIT_INVARIANT) to state 91 *)
          _menhir_run_0091 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_EXITS ->
          (* Shifting (ADMIT_EXITS) to state 92 *)
          _menhir_run_0092 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_ENSURES ->
          (* Shifting (ADMIT_ENSURES) to state 93 *)
          _menhir_run_0093 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_CONTINUES ->
          (* Shifting (ADMIT_CONTINUES) to state 94 *)
          _menhir_run_0094 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT_BREAKS ->
          (* Shifting (ADMIT_BREAKS) to state 95 *)
          _menhir_run_0095 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | ADMIT ->
          (* Shifting (ADMIT) to state 470 *)
          _menhir_run_0470 _menhir_stack _menhir_lexbuf _menhir_lexer _menhir_s
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
  let _menhir_run_1406 : type  ttv_stack. ttv_stack -> _ -> _ -> _menhir_box_spec =
    fun _menhir_stack _menhir_lexbuf _menhir_lexer ->
      (* State 1406: *)
      let _endpos = _menhir_lexbuf.Lexing.lex_curr_p in
      let _tok = _menhir_lexer _menhir_lexbuf in
      match (_tok : MenhirBasics.token) with
      | REQUIRES ->
          (* Shifting (REQUIRES) to state 965 *)
          _menhir_run_0965 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1406
      | CHECK_REQUIRES ->
          (* Shifting (CHECK_REQUIRES) to state 968 *)
          _menhir_run_0968 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1406
      | ADMIT_REQUIRES ->
          (* Shifting (ADMIT_REQUIRES) to state 971 *)
          _menhir_run_0971 _menhir_stack _menhir_lexbuf _menhir_lexer MenhirState1406
      | ADMIT_BREAKS | ADMIT_CONTINUES | ADMIT_ENSURES | ADMIT_EXITS | ADMIT_RETURNS | ALLOCATES | ASSIGNS | BEHAVIOR | BREAKS | CHECK_BREAKS | CHECK_CONTINUES | CHECK_ENSURES | CHECK_EXITS | CHECK_RETURNS | COMPLETE | CONTINUES | DECREASES | DISJOINT | ENSURES | EOF | EXITS | EXT_CONTRACT _ | FREES | RETURNS | TERMINATES ->
          (* Reducing production requires -> *)
          let _v = _menhir_action_629 () in
          _menhir_run_1048 _menhir_stack _menhir_lexbuf _menhir_lexer _endpos _endpos _v MenhirState1406 _tok
      | _ ->
          (* Initiating error handling *)
          _eRR ()
  
end

let spec =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_spec v = _menhir_run_1406 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let lexpr_eof =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_lexpr_eof v = _menhir_run_1402 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let ext_spec =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_ext_spec v = _menhir_run_1332 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

let annot =
  fun _menhir_lexer _menhir_lexbuf ->
    let _menhir_stack = () in
    let MenhirBox_annot v = _menhir_run_0000 _menhir_stack _menhir_lexbuf _menhir_lexer in
    v

# 2112 "src/kernel_internals/parsing/logic_parser.mly"
  

(*
Local Variables:
compile-command: "make -C ../../.."
End:
*)

# 108027 "src/kernel_internals/parsing/logic_parser.ml"
